pro manualFeature_event,event
    widget_control,event.id, get_uvalue = uval
    widget_control,event.top,get_uvalue=pState

    case uval of
        'crystal1':(*pState).habit = 0B
        'crystal2':(*pState).habit = 1B
        'crystal3':(*pState).habit = 2B
        'crystal4':(*pState).habit = 3B
        'crystal5':(*pState).habit = 4B
        'crystal6':(*pState).habit = 5B
        'crystal7':(*pState).habit = 6B
        'crystal8':(*pState).habit = 7B
        'crystal9':(*pState).habit = 8B
        'crystal10':(*pState).habit = 9B
        'crystal11':(*pState).habit = 10B
        'crystal12':(*pState).habit = 11B
        'crystal13':(*pState).habit = 12B
        'crystal14':(*pState).habit = 13B
        'crystal15':(*pState).habit = 14B
        'crystal16':(*pState).habit = 15B
        'crystal17':(*pState).habit = 16B
        'crystal18':(*pState).habit = 17B
        'crystal19':(*pState).habit = 18B
        'crystal20':(*pState).habit = 19B
        'crystal21':(*pState).habit = 20B
        'crystal22':(*pState).habit = 21B
        'crystal23':(*pState).habit = 22B
        'crystal24':(*pState).habit = 23B
        'crystal25':(*pState).habit = 24B
        'crystal26':(*pState).habit = 25B
        'crystal27':(*pState).habit = 26B
        'crystal28':(*pState).habit = 27B
        'crystal29':(*pState).habit = 28B
        'crystal30':(*pState).habit = 29B
        'crystal31':(*pState).habit = 30B
        'crystal32':(*pState).habit = 31B

        'UpDateFile': begin
            stop ; TAF don't think this event is ever called
            if(ptr_valid((*(*pState).pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue

                (*(*pState).pStateInfo).updateFile = !true
                ; Reopen file as read-write
                IF event.select THEN BEGIN
                    stop
                    CLOSE, (*(*pState).pStateInfo).InFileLun
                    OPENU, (*(*pState).pStateInfo).InFileLun, (*(*pState).pStateInfo).InFileName, ERROR = err, /BINARY

                    IF (err NE 0) THEN BEGIN
                        Ret = DIALOG_MESSAGE("Unable to open file for update. Check that the file is not read-only.")
                        OPENR, (*pStateInfo).InFileLun, (*(*pState).pStateInfo).InFileName, ERROR = err, /BINARY
                        IF (err NE 0) THEN BEGIN
                            PRINT, !ERR_STRING
                            (*(*pState).pStateInfo).InFileLun = -1
                            (*(*pState).pStateInfo).ImgPos = -1
                            Ret = DIALOG_MESSAGE(["Unable to re-open file.",!ERR_STRING])
                        ENDIF
                    ENDIF
                ENDIF ELSE begin
                    (*(*pState).pStateInfo).updateFile = !false
                endelse
            endif
        end


        'p1':if(event.value eq 1)then (*pState).manual = !true else(*pState).manual = !false
        'CUTOFF':begin
        widget_control,event.id,get_value=temp
        (*pState).cutoff=byte((temp<100)>0)
    end
    'FOCUS':begin
    widget_control,event.id,get_value=temp
    (*pState).focus = byte((temp<100)>0)
end
'reject all':begin
reject_all,(*pState).pStateInfo
if(ptr_valid(pState))then (*pState).ok = !false
(*pState).reject = !true
widget_control,event.top,/destroy
end
'reject':begin
(*pState).reject = !true
widget_control,event.top,/destroy
end
'ok':begin
;stop
IF(not (*(*pState).pStateInfo).updateFile )then begin
    stop
    if(ptr_valid((*(*pState).pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue

        (*(*pState).pStateInfo).updateFile = !true
        ; Reopen file as read-write


        ; TAF perhaps move the file operations out to update_obj_header1

        ;CLOSE, (*(*pState).pStateInfo).InFileLun
        ;OPENU, (*(*pState).pStateInfo).InFileLun, (*(*pState).pStateInfo).InFileName, ERROR = err, /BINARY

        ;IF (err NE 0) THEN BEGIN
        ;    Ret = DIALOG_MESSAGE("Unable to open file for update. Check that the file is not read-only.")
        ;    OPENR, (*pStateInfo).InFileLun, (*(*pState).pStateInfo).InFileName, ERROR = err, /BINARY
        ;    IF (err NE 0) THEN BEGIN
        ;       PRINT, !ERR_STRING
        ;       (*(*pState).pStateInfo).InFileLun = -1
        ;       (*(*pState).pStateInfo).ImgPos = -1
        ;       Ret = DIALOG_MESSAGE(["Unable to re-open file.",!ERR_STRING])
        ;    ENDIF
        ;ENDIF

    endif
endif

if(ptr_valid(pState))then (*pState).ok = !true
widget_control,event.top,/destroy
end
'cancel':begin
if(ptr_valid(pState))then (*pState).ok = !false
widget_control,event.top,/destroy
end
'make_tif': begin;   added on April 2006 to use Matlab for particle re-sizeing
    all_rois =   *(*(*(*pstate).Pstateinfo).pframedata).pframe; all rois in this frame.
    frameheader= (*(*(*pstate).Pstateinfo).pframedata).frameheader
    path=(*(*pstate).pstateinfo).path
    time_str=path+'RawRoi_'+strtrim(fix(frameheader.hour),2)+'_'+strtrim(fix(frameheader.minute),2)+'_'+$
        strtrim(fix(frameheader.sec),2)+'_'+strtrim(fix(frameheader.msec),2)+'_'
    nnn=n_elements(all_rois);  we will save all rois in different tif files.

    for i=0, nnn-1 do begin
        raw_image=*all_rois(i).proi;   it is a byte array(37,37)
        filename=time_str+strtrim(i,2)+'.tiff'
        WRITE_TIFF, Filename,raw_image
        filename=time_str+strtrim(i,2)+'.bmp'
        WRITE_bmp, Filename,raw_image

    endfor
    widget_control,event.top,/destroy
end

else:
endcase
end

function manualFeature,pStateInfo,x,y,Main_tlb,flags,dark,p1
    ;purpose to get info on manual features

    ; Parameters
    ;   stateInfo
    ;   x        Input     location of mouse in x
    ;   y        Input     location of mouse in y
    ;   flags     Input    status flags
    ;   dark   Input   dark value
    ;   p1         Input    status of manual setting

    widget_control,Main_tlb,tlb_get_offset=offset
    ; draw widget size
    DX = 740
    DY = 512

    ; approximate location of lower left corner of draw widget w.r.t main base
    dx = 160
    dy = dy + 80

    ; absolute location of LL corner of draw widget w.r.t. screen
    dx = dx + offset[0]
    dy = dy + offset[1]

    ; desired location of pop-up window
    dx = dx + x
    dy = dy - y - 150

    tlb = widget_base(title='Manual Featuring',/col, xOffset = dx, yOffset = dy, group_leader=Main_tlb)

    if(ptr_valid((*pStateInfo).pObjList)) then begin

        ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1
        info = GetROI(pStateInfo, x, y)
        index = info[0]

        objData = (*(*pStateInfo).pObjData)
        ; only display if data is non zero
        focus = strtrim(fix((*objData.pFrame)[index].imageheader.focus) ,2)
        cutoff = strtrim(fix((*objData.pFrame)[index].imageheader.cutoff),2)
        habit = (*objData.pFrame)[index].imageheader.crystal
        ;this corrects old crsystal type to be correct
        if(habit eq 0 and (*objData.pFrame)[index].imageheader.len gt 0)then habit = 1
    endif else begin
        cutoff = round(ishft(dark,-8)*(100./31.0))
        focus = 100-(flags and 'ff'x)
        habit = ishft(flags,-8) and '1f'x
    endelse

    base1 = widget_base(tlb,/row)
    ;now cut-off only goes to 31 and is not scaled
    CutOffSld = cw_field(base1, TITLE='Particle Cut-Off%', VALUE = cutoff,/int, UVALUE='CUTOFF',/all)
    OutFocusSld = cw_field(base1, TITLE='Focus%',VALUE = focus,/int, UVALUE='FOCUS',/all)
    base2 = widget_base(tlb,/row)
    base2a = widget_base(base2,/nonexclusive)
    ;  update = widget_button(base2a,value='Update File',uvalue='UpDateFile')
    ;if((*pStateInfo).updatefile)then widget_control,update,set_button= !true
    if((*pStateInfo).AUTOEXTRACT)then begin
        p1 = cw_bgroup(base2,['Off','On'],/exclusive,uvalue='p1',/row,label_left='P1 toggle',set_value=p1)
        widget_control,p1,set_value=(*pStateInfo).manual
    endif

    CrystalBase = WIDGET_base(tlb, col = 6, /exclusive,/frame)
    cry = lonarr(32)
    cry[0]  = widget_button(crystalBase,value=(*pStateInfo).types[0], uvalue = 'crystal1')
    cry[1]  = widget_button(crystalBase,value=(*pStateInfo).types[1], uvalue = 'crystal2')
    cry[2]  = widget_button(crystalBase,value=(*pStateInfo).types[2], uvalue = 'crystal3')
    cry[3]  = widget_button(crystalBase,value=(*pStateInfo).types[3], uvalue = 'crystal4')
    cry[4]  = widget_button(crystalBase,value=(*pStateInfo).types[4], uvalue = 'crystal5')
    cry[5]  = widget_button(crystalBase,value=(*pStateInfo).types[5], uvalue = 'crystal6')
    cry[6]  = widget_button(crystalBase,value=(*pStateInfo).types[6], uvalue = 'crystal7')
    cry[7]  = widget_button(crystalBase,value=(*pStateInfo).types[7], uvalue = 'crystal8')
    cry[8]  = widget_button(crystalBase,value=(*pStateInfo).types[8], uvalue = 'crystal9')
    cry[9]  = widget_button(crystalBase,value=(*pStateInfo).types[9], uvalue = 'crystal10')
    cry[10] = widget_button(crystalBase,value=(*pStateInfo).types[10],uvalue = 'crystal11')
    cry[11] = widget_button(crystalBase,value=(*pStateInfo).types[11],uvalue = 'crystal12')
    cry[12] = widget_button(crystalBase,value=(*pStateInfo).types[12],uvalue = 'crystal13')
    cry[13] = widget_button(crystalBase,value=(*pStateInfo).types[13],uvalue = 'crystal14')
    cry[14] = widget_button(crystalBase,value=(*pStateInfo).types[14],uvalue = 'crystal15')
    cry[15] = widget_button(crystalBase,value=(*pStateInfo).types[15],uvalue = 'crystal16')
    cry[16] = widget_button(crystalBase,value=(*pStateInfo).types[16],uvalue = 'crystal17')
    cry[17] = widget_button(crystalBase,value=(*pStateInfo).types[17],uvalue = 'crystal18')
    cry[18] = widget_button(crystalBase,value=(*pStateInfo).types[18],uvalue = 'crystal19')
    cry[19] = widget_button(crystalBase,value=(*pStateInfo).types[19],uvalue = 'crystal20')
    cry[20] = widget_button(crystalBase,value=(*pStateInfo).types[20],uvalue = 'crystal21')
    cry[21] = widget_button(crystalBase,value=(*pStateInfo).types[21],uvalue = 'crystal22')
    cry[22] = widget_button(crystalBase,value=(*pStateInfo).types[22],uvalue = 'crystal23')
    cry[23] = widget_button(crystalBase,value=(*pStateInfo).types[23],uvalue = 'crystal24')
    cry[24] = widget_button(crystalBase,value=(*pStateInfo).types[24],uvalue = 'crystal25')
    cry[25] = widget_button(crystalBase,value=(*pStateInfo).types[25],uvalue = 'crystal26')
    cry[26] = widget_button(crystalBase,value=(*pStateInfo).types[26],uvalue = 'crystal27')
    cry[27] = widget_button(crystalBase,value=(*pStateInfo).types[27],uvalue = 'crystal28')
    cry[28] = widget_button(crystalBase,value=(*pStateInfo).types[28],uvalue = 'crystal29')
    cry[29] = widget_button(crystalBase,value=(*pStateInfo).types[29],uvalue = 'crystal30')
    cry[30] = widget_button(crystalBase,value=(*pStateInfo).types[30],uvalue = 'crystal31')
    cry[31] = widget_button(crystalBase,value=(*pStateInfo).types[31],uvalue = 'crystal32')

    widget_control,cry[habit],set_button=!true

    optBase = widget_base(tlb,/row)
    proceed = widget_button(optBase,value = 'Accept', uValue='ok')
    reject  = widget_button(optBase,value = 'Reject Current ROI', uValue='reject')
    reject  = widget_button(optBase,value = 'Reject all ROI"s in frame',uvalue='reject all')
    cancel  = widget_button(optBase,value = 'Cancel',uvalue = 'cancel')
    save_raw_as_tif = widget_button(optBase,value='make_tif',uvalue = 'make_tif')

    widget_control,tlb,/realize
    pState = ptr_new({cutoff:cutoff,focus:focus,habit:habit,reject:!false,manual:(*pStateInfo).manual, ok:!false,pStateInfo:pStateInfo})
    widget_control,tlb,set_uvalue=pState


    ; reopen file for output if needed
    if(not (fstat((*pStateInfo).ObjLUN)).write )then begin
        stop ; TAF does this code ever get executed, or is the obj alway opened write?
        free_lun,(*pStateInfo).ObjLUN
        openU,lun,(*pStateInfo).ObjFile,/get
        (*pStateInfo).ObjLUN = lun
    endif

    xmanager,'manualFeature',tlb

    data = *pState
    ptr_free,pState
    return,data
end

