PRO ROIHistogram_addfssp2dc_event, event

    FORWARD_FUNCTION  WriteHistogram_addfssp2dc

    WIDGET_CONTROL, event.top, GET_UVALUE= LocalState,/no_copy
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of

        ; Handle a kill request.
        'WIDGET_KILL_REQUEST':begin
        pGroup = find_first_link(LocalState.pGroup)
        while( ptr_valid((*pGroup).next_link) ) do begin
            pNext_link = (*pGroup).next_link
            deleteGroup,pGroup
            pGroup = pNext_link
        endwhile

        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin

    ; Handle a sizing request
    'WIDGET_BASE':begin
    WIDGET_CONTROL, event.top, XSIZE =1000, YSIZE =800  ; added by mo sept 9,2004
    WIDGET_CONTROL, LocalState.MainView, XSIZE = 780, YSIZE =560
    PlotHistogram_addfssp2dc, LocalState
    WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
    return
end

else: begin

    ; a normal event

    WIDGET_CONTROL, event.id, GET_UVALUE = eventval
    CASE eventval OF    ; Note that pos  is not equal Pos, it is case_senitive
        'pos':begin
        ; widget_control,LocalState.position, get_value = pos
        ;  localState.grpNum = pos
        ; Localstate.pGroup = (*LocalState.pGroupPtr)[pos-1]
        ;  PlotHistogram_addfssp2dc, LocalState
    end ;end of eventval= pos
    'make_cmb_psd': begin
        widget_control,localstate.BinsizeID,get_value=uval
        localstate.brk1=uval
        widget_control,localstate.BincntsID,get_value=uval
        localstate.brk2=uval
        widget_control,localstate.BinsizeID2,get_value=uval
        localstate.brk3=uval
        widget_control,localstate.BincntsID2,get_value=uval
        localstate.brk4=uval
        PlotHistogram_addfssp2dc, LocalState
    end
    'BINSIZE': begin
        IF event.value NE LocalState.BinSize THEN BEGIN
            ; Save new val
            LocalState.BinSize = event.value
            PlotHistogram_addfssp2dc, LocalState
        ENDIF
    end ; end of binszie

    'MinCntsPerbin': begin
        IF event.value NE LocalState.Mincntsperbin THEN BEGIN
            ; Save new val
            LocalState.mincntsperbin = event.value
            PlotHistogram_addfssp2dc, LocalState
        ENDIF
    end ; end of eventval= mincntsperbin
    'SAF': begin
        widget_control,localstate.SAFID,get_value=uval
        ; Save new val
        if uval eq 0.0 or uval gt 1.0 then begin
            r=dialog_message('SAF should be >0 and <=1.0, try again.',/information)
            uval=0.999
            widget_control,localstate.SAFID,set_value=0.999
        endif

        LocalState.SAF = uval
        PlotHistogram_addfssp2dc, LocalState
    end ; end of FFFx

    'FFFx': begin
        widget_control,localstate.FFFxID,get_value=uval
        ; Save new val
        LocalState.FFFx = uval
        PlotHistogram_addfssp2dc, LocalState
    end ; end of FFFx

    'AdjorNot': begin
        LocalState.AdjorNot = event.value
        PlotHistogram_addfssp2dc, LocalState
    end

    'PRINT': BEGIN

        IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

        IF LocalState.PrinterSetup THEN PlotHistogram_addfssp2dc, LocalState, OutPutFlags=1
    END

    'SAVETIFF': PlotHistogram_addfssp2dc, LocalState, OutPutFlags=2

    'PRINTALL': BEGIN
        IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()
        IF LocalState.PrinterSetup THEN BEGIN
            pGroup = find_first_link(LocalState.pGroup)
            LocalState.pGroup = pGroup
            ; FOR i=1, LocalState.grpCnt DO BEGIN   changed this to following on janu 3, 2005.
            FOR i=1, 1 DO BEGIN
                PlotHistogram_addfssp2dc, LocalState, OutPutFlags=1
                LocalState.pGroup =  (*LocalState.pGroup).next_link
            ENDFOR
            ; redisplay first
            LocalState.pGroup =  pGroup
            PlotHistogram_addfssp2dc, LocalState
        ENDIF
    END  ; end of printall

    'SAVE': Ret = WriteHistogram_addfssp2dc(LocalState)

    ; 'OPEN': Ret = ReadHistogram_addfssp2dc(LocalState)

    'QUIT': BEGIN
        pGroup = find_first_link(LocalState.pGroup)
        while( ptr_valid((*pGroup).next_link) ) do begin
            pNext_link = (*pGroup).next_link
            deleteGroup,pGroup
            pGroup = pNext_link
        endwhile
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;endof quit
    ELSE:
ENDCASE ; end of event.id case
end
endcase ; end of sname case

WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
END

;============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output

PRO PlotHistogram_addfssp2dc, LocalState, OutPutFlags=OutPutFlags
    called_save_png=0
    called_print_png=0

    ; pGroup is a pointer to a structured linked list for this plot
    pGroup = localState.pGroup
    ; get cpi data 

    get_the_plotData,pGroup,Localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM,$
        pGrouppDataI,pGrouppadjI,pGrouppdataAI,pGrouppDataMI,$
        pGrouppDataL,pGrouppadjL,pGrouppdataAL,pGrouppDataML
    ;*****************************************************************************************
    ;redo the above using brad program unihist_adj.pro
    if n_elements(pgrouppdata) eq 0 then BEGIN
        ;plot out the 2dc and fssp psd data anyway
        if ptr_valid((*pgroup).ptwodc) eq 0 then return;  added Jan 5 , 2005.
        TDC_N_bar =*(*pgroup).pTWODC;  ;70 elements
        TDC_A_Bar=*(*pgroup).pTWODCA; ;70 elements   ;this is TDC_A_bar
        TDC_M_bar=*(*pgroup).pTWODCM; '70elements;   ;This is TDC_M_bar
        fsspbinhs=*(*pgroup).pfssp;     ;FSPout
        FSPout=fsspbinhs
        fsspbins =localstate.fsspbins
        fsspbwds =localstate.fsspbwds
        twodcbwds=localstate.twodcbwds;   70 elements
        x2dc=localstate.twodcbins;  ;140 elements
        ;make them horizonatl vertical
        nnnn=n_elements(TDC_N_bar);  70 elements
        y2dc =fltarr(2*nnnn);        140 elements
        A2dc=fltarr(2*nnnn)
        M2dc=fltarr(2*nnnn)
        for i=0,nnnn-1 do begin
            y2dc(2*i:2*i+1)=TDC_N_Bar(i)
            A2dc(2*i:2*i+1)=TDC_A_bar(i)
            M2dc(2*i:2*i+1)=TDC_M_bar(i)
        endfor
        ; in do_fff  if y2dc=0.0 then assign it to be 1.0e-37
        somarr=where(y2dc eq 0.0,cont0)
        if cont0 gt 0 then y2dc(somarr)=1.0e-37

        n2dcbins=n_elements(x2dc)/2
        twoDccens=fltarr(n2dcbins)
        for i=0, n2dcbins-1 do begin
            twodccens(i)=(x2dc(2*i+1)+x2dc(2*i))/2.0
        end
        no_cpi_data=1
        goto,startplot
        ;RRRRRRR=DIALOG_MESSAGE('NO DATA IN THIS TIME PERIOD, Try again.',/INFORMATION)
        ;return
    ENDIF else no_cpi_data=0

    validData = where(*pGrouppData ne 0,dataCnt)
    if dataCnt gt 0 then begin
        sizes=(*pGrouppData)[validData];   ;use_Dcor
        adjs =(*pGrouppAdj)[validData]     ;use_adj

        if localstate.AdjorNot eq 0 then begin
            indexadj=where(adjs gt 0.0,contadj)
            if contadj gt 0 then adjs(indexadj)=1.0
        endif

        Acors=(*pGrouppDataA)[validData];  ;use_Acor
        Mcors=(*pGrouppDataM)[validData];  ;use_Mcor
    endif else begin
        sizes=[1.0,1.0]
        adjs=[1.0,1.0]
        Acors=[1.0,1.0]
        Mcors=[0.00001,0.00001]
    endelse
    min_del_x=localstate.binsize;   5.0
    mincntsperbin=localstate.mincntsperbin ;  2.0;   it should be alway greater than 1. ge 2.
    cpiview_unihist_adj, sizes,mincntsperbin,min_del_x,xpts,vals,adjs
    ;***********************************************************************************
    case LocalState.TypeScaling of
        1: begin; ; this is similar using deadtime. but is not deadtiem scale. use conc=
            ; using dead time
            ; scaler = (localState.sumSecs - (*pGroup).deadtime)*LocalState.SampleVolume/localState.sumSecs + (*pGroup).TotFrmCnt*.0002
            conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
            ave_conc=float(localstate.sumsecs)*conc_norm*total(adjs );  because localstate.sampleV is SV of sumsecs.
            factor  =float(localstate.sumsecs)*conc_norm;   ;following Sizes=vector of Dcor
            sampV_IMG=1.0/factor
            FFF_i=ave_conc/total(adjs)/sampV_IMG
            cy3=vals*FFF_i*factor*1.0


            ; du_cpiview_other_psds,factor,mincntsperbin,adjs,Acors,sizes,Mcors,xpts,Lvals,Avals,Mvals
            ;           vals*factor

            ; (*(*pGroup).Lbinheights)[0:nnn-1] = Lvals*factor
            ;  (*(*pGroup).Abinheights)[0:nnn-1] = Avals*factor
            ;  (*(*pGroup).Mbinheights)[0:nnn-1] = Mvals*factor
            Conc = ave_conc; total(spectra)  ; this is no use, but keep it in case the program somewhere it is needed.
            acceptedPart = dataCnt ; this is no use to me. but keep it.
            scalingType = '#/(LT*SV)/um'
            wysiwyg_r=0
        end

        ;************************************************************************************
        3:begin   ;this is for wysisyg_r  scaling type is always 3.
        ;conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
        numfrms=max([(*pGroup).totFrmCnt, 1.0])
        DOFmax=1.411*2.54 
        IMG_SV=DOFmax*1024d*0.00023*1024d*0.00023*(numfrms)/1000d   ;liters
        factor=1.0/IMG_SV;  if localstate.typescaling eq 3 then  factor = 1.0/IMG_SV
        ave_conc=factor*total(adjs );  because localstate.sampleV is SV of sumsecs.

        cy3=vals*factor
        sampV_IMG=IMG_SV
        ;du_cpiview_other_psds,factor,mincntsperbin,adjs,Acors,sizes,Mcors,xpts,Lvals,Avals,Mvals

        ;   (*(*pGroup).Nbinheights)[0:nnn-1] = vals*factor
        ;   (*(*pGroup).Lbinheights)[0:nnn-1] = Lvals*factor
        ;   (*(*pGroup).Abinheights)[0:nnn-1] = Avals*factor
        ;   (*(*pGroup).Mbinheights)[0:nnn-1] = Mvals*factor
        Conc = ave_conc; total(spectra)  ; this is no use, but keep it in case the program somewhere it is needed.
        acceptedPart = dataCnt ; this is no use to me. but keep it.
        scalingType = 'wysiwyg_r'
        wysiwyg_r=1
        ; stop
    end
endcase
x3=xpts

;*********************************************************************************

; DOFmax=1.411*2.54
; IMG_SV=DOFmax*1024d*0.00023*1024d*0.00023*((*pgroup).totfrmcnt)/1000d   ;liters
; sampV_IMG=Img_SV
; local_conc=total(adjs)
; conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
; ave_conc=float(localstate.sumsecs)*conc_norm*total(adjs );  because localstate.sampleV is SV of sumsecs.
; FFF_i=ave_conc/(local_conc/sampV_IMG)  ;local_conc=total(adjs)

; cpiview_unihist_adj, sizes,mincntsperbin,min_del_x,x3,y3,adjs
; ; the xpts are like  1, 2, 2, 6, 6, 9.5  9.5  12.7
; and vals are like  3, 3, 5, 5, 20, 20. 11.   11.0
; they need to be put back into  bins spectra format.

;        y3=y3/IMG_SV;    sampV_IMG
;        cy3=y3*FFF_i*1.0
;  endif
;***************************************************    get FFF_i value

; stop
spectra=vals
bins=xpts

if ptr_valid((*pgroup).ptwodc) eq 0 then return;  added Jan 5 , 2005.

TDC_N_bar =*(*pgroup).pTWODC;  ;70 elements
TDC_A_Bar=*(*pgroup).pTWODCA; ;70 elements   ;this is TDC_A_bar
TDC_M_bar=*(*pgroup).pTWODCM; '70elements;   ;This is TDC_M_bar
fsspbinhs=*(*pgroup).pfssp;     ;FSPout
FSPout=fsspbinhs
fsspbins =localstate.fsspbins
fsspbwds =localstate.fsspbwds
twodcbwds=localstate.twodcbwds;   70 elements
x2dc=localstate.twodcbins;  ;140 elements
;make them horizonatl vertical
nnnn=n_elements(TDC_N_bar);  70 elements
y2dc =fltarr(2*nnnn);        140 elements
A2dc=fltarr(2*nnnn)
M2dc=fltarr(2*nnnn)
for i=0,nnnn-1 do begin
    y2dc(2*i:2*i+1)=TDC_N_Bar(i)
    A2dc(2*i:2*i+1)=TDC_A_bar(i)
    M2dc(2*i:2*i+1)=TDC_M_bar(i)
endfor
; in do_fff  if y2dc=0.0 then assign it to be 1.0e-37
somarr=where(y2dc eq 0.0,cont0)
if cont0 gt 0 then y2dc(somarr)=1.0e-37

n2dcbins=n_elements(x2dc)/2
twoDccens=fltarr(n2dcbins)
for i=0, n2dcbins-1 do begin
    twodccens(i)=(x2dc(2*i+1)+x2dc(2*i))/2.0
end

PMSbins={fssp:fsspbins,twodc:twoDccens}
PMSbwds={fssp:fsspbwds,twodc:twoDcbwds}

brk1=localstate.brk1
brk2=localstate.brk2
brk3=localstate.brk3
brk4=localstate.brk4
; Default is to send ouput to plot only
IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

t = ConvertFromSeconds((*pGroup).StartTime, LocalState.year)
Time0 = strtrim(t.month,2)+'/'+strtrim(t.day,2)+' '+strtrim(t.hour,2)+':'+strtrim(t.minute,2)+':'+strtrim(t.sec,2)
Time = STRING(FORM='("Period: ",A, " StartTime: ",A,"  Time =", I5, " sec")',strtrim(LocalState.GrpNum,2),time0,LocalState.SumSecs)
if t.month lt 10 then mm='0'+strtrim(round(t.month),2)  else mm=strtrim(round(t.month),2)
if t.day lt 10 then dd='0'+strtrim(round(t.day),2) else dd= strtrim(round(t.day),2)

strtime_str=strtrim(t.hour,2)+'-'+strtrim(t.minute,2)+'-'+strtrim(t.sec,2)

t_stop=ConvertFromSeconds((*pGroup).StartTime+localstate.sumSecs, LocalState.year)
endtime_str='_'+strtrim(t_stop.hour,2)+'-'+strtrim(t_stop.minute,2)+'-'+strtrim(t_stop.sec,2)

if localstate.typescaling eq 1 then begin
    wysiwyg_r=0;  for calling du_combPSD.pro use.
    if localstate.sizetype eq 'no_adj' then begin
        ;adjtype='scale = no_adj '
        Filename=mm+dd+'_'+strtime_str+endtime_str+'_noadj_AllcmbPSD.png'
    endif else begin
        ; adjtype='scale = adj_ed'
        Filename=mm+dd+'_'+strtime_str+endtime_str+'_adj_AllcmbPSD.png'
    endelse
endif
if localstate.typescaling eq 3 then begin
    wysiwyg_r=1
    ; adjtype='scale = wysiwyg_r'
    Filename=mm+dd+'_'+strtime_str+endtime_str+'_wysiwygr_AllcmbPSD.png
endif

ScreenFilename=Filename;             +' '+adjtype
Time1 = strtrim(localstate.year,2)+'/'+time0
png_time =STRING(FORM='("Period: ",A, " STime: ",A,"  dT =", I5, " sec")',strtrim(LocalState.GrpNum,2),time1,LocalState.SumSecs)

; Display Time info
WIDGET_CONTROL, LocalState.TopLabelID, SET_VALUE=Time

;if( max(*(*pGroup).pData) eq 0) then begin
if( not ptr_valid((*pgroup).ptwodc) ) then begin
    return
endif

; New Plot
;*****************************************************************************************
startplot: donothing=0
TopLabel = 'Particle Per Frame Distribution'
!P.multi=[0,2,1]

if no_cpi_data eq 0 then  temp=[fsspbinhs,cy3,y2dc] else temp=[fsspbinhs,y2dc]

index=where(temp gt 1.0e-37,contF)
if contF ne 0 then ymin=min(temp(index),max=ymax) else ymin=min([1.0,10.0],max=ymax)

if no_cpi_data eq 0 then begin
    ;PLOT,xpts,vals, COLOR=Color, YRANGE=[10.0^floor(Alog10(ymin)),10.0^ceil(Alog10(ymax))],$
    PLOT,x3,cy3, COLOR=Color, YRANGE=[10.0^floor(Alog10(ymin)),10.0^ceil(Alog10(ymax))],$
        /xlog,/ylog,xrange=[1.0,10000.0],title='Individual Particle Size Distributions',$
        YTITLE='Individual PSD:  #/Liter/um', Xstyle = 1,xtickn=[' ',' ',' ',' ',' '],$
        THICK=1, Ystyle=1,charsize=1.0,$  ; subtitle=png_time,$
        position=[0.12,0.55,0.97,0.96]   ;[0.07,0.12,0.45,0.96]
    plots,fsspbins,fsspbinhs,color=color,psym=2,symsize=0.5
    ny2dc=y2dc
    index37=where(ny2dc eq 1.0e-37,cont37)
    if cont37 gt 0 then ny2dc(index37)=10.0^floor(Alog10(ymin));ymin
    plots,x2dc,ny2dc,color=color,line=1
    plots,x3,cy3*localstate.FFFx,color=color,linestyle=2
    if n_elements(sizes) lt 3 then begin
        xyouts,10,0.5*ymax,'No CPI data or too few CPI data ',color=color
        !P.multi=[0,1,1]
        return
    endif
endif
if no_cpi_data eq 1 then begin ; no_cpi_data=1
    PLOT,fsspbins,fsspbinhs, COLOR=Color, YRANGE=[10.0^floor(Alog10(ymin)),10.0^ceil(Alog10(ymax))],$
        /xlog,/ylog,xrange=[1.0,10000.0],title='Individual Particle Size Distributions',$
        YTITLE='Individual PSD:  #/Liter/um', Xstyle = 1,$
        THICK=1, Ystyle=1,charsize=1.0,psym=2,symsize=0.5,$  ; subtitle=png_time,$
        position=[0.12,0.55,0.97,0.96]   ;[0.07,0.12,0.45,0.96]
    ny2dc=y2dc
    index37=where(ny2dc eq 1.0e-37,cont37)
    if cont37 gt 0 then ny2dc(index37)=10.0^floor(Alog10(ymin));ymin
    plots,x2dc,ny2dc,color=color,line=1
    xyouts,200,0.5*ymax,'No CPI data ,try again ',color=color
    !P.multi=[0,1,1]
    return
endif

;rightTitle='SSP, CPI, 2DC combined PSD '
Ylabel='combined PSD:  #/Liter/um'
xtitle_str='    size,um     '

;getcombined psd distribution
;**************************************************************************************************
use_Dcor=sizes
use_Acor=Acors
use_Mcor=Mcors
use_adj=adjs

use_wid=use_Dcor
use_len=use_Dcor
use_perim=use_Dcor

pathnm='dummmyyy'
FFF_x=localstate.FFFx
strt_date='dum'
sHH='00'
sMM='00'
sSS='00'
eHH='00'
eMM='00'
eSS='00'
cut_l=brk1
left=brk2
right=brk3
cut_r=brk4
expname='dummy'
leg='0'
uni_hist_num=mincntsperbin

du_combPSD,use_Acor,use_wid,use_len,use_perim,PMSbins,PMSbwds,FSPout,use_Dcor,sampV_IMG,use_adj,pathnm,x2dc,y2dc,A2dc,M2dc $
    ,FFF_i,FFF_x,strt_date,sHH,sMM,sSS,eHH,eMM,eSS,cut_l,left,right,cut_r,comb_PSD_x,comb_PSD_y,TDC_A_bar,TDC_M_bar $
    ,expname,leg,uni_hist_num,min_del_x,vals,mincntsperbin,use_Mcor,wysiwyg_r

;***************************************************************************************************

; PLOT,xcomb,ycomb, COLOR=Color, XRANGE=[1.0,10000.0],/xlog,/ylog,$
PLOT,comb_PSD_x,comb_PSD_y, COLOR=Color, XRANGE=[1.0,10000.0],/xlog,/ylog,$
    YTITLE=Ylabel, XTITLE=xtitle_str, Xstyle = 1,charsize=1.0,ystyle=1,$
    TITLE=rightTitle,THICK=1, YRANGE=[10.0^floor(Alog10(ymin)),10.0^ceil(Alog10(ymax))],$
    position=[0.12,0.10,0.97,0.53], subtitle=png_time+'  '+ScreenFilename

; label and plot the break points.
;***********************************************************
brkpa=localstate.brk1
brkpb=localstate.brk2
brkpc=localstate.brk3
brkpd=localstate.brk4
xmaxsize=3300.0

xbrk=[brkpa, brkpb, brkpc, brkpd]
yymax=10.0^ceil(Alog10(ymax))
y_bar=[0.5*yymax,yymax]
for i=1,n_elements(xbrk)-1 do begin
    x_bar=[xbrk(i), xbrk(i)]
    oplot,x_bar, y_bar,color=color
endfor
; xyouts,1.5,0.5*yymax,strcompress(string(round(xbrk(0)))),color=color
xyouts,brkpb,0.5*yymax,strcompress(string(round(xbrk(1)))), color=color
if (brkpc lt xmaxsize) then begin
    xyouts,brkpc,0.5*yymax,strcompress(string(round(xbrk(2)))), color=colr,charsize=0.8
endif else begin
    xyouts,1000,0.5*yymax,strcompress(string(round(xbrk(2)))), color=color,charsize=0.8
endelse
if (brkpd lt xmaxsize) then begin
    xyouts,brkpd,0.5*yymax,strcompress(string(round(xbrk(3)))), color=color,charsize=0.8
endif else begin
    xyouts,3300,0.5*yymax,strcompress(string(round(xbrk(2)))), color=color,charsize=0.8
endelse



;***********************************************************

;if called_save_png eq 1  then goto, BacktoSavePng; not need for this.
if called_print_png eq 1 then goto,BacktoPrintPng
if called_save_png eq 1 then goto,BacktosavePng

; Save image file?
IF (OutPutFlags AND 2)/2 THEN BEGIN
    ; Create a filename  in case for saving the pngs file.
    ;Get Path
    NamePos = RSTRPOS(LocalState.InFileName, '\')
    pathnm = STRMID(LocalState.InFileName, 0, NamePos)+'\'
    filename=pathnm+filename
    ; IF NamePos GE 0 THEN BEGIN
    ; FileName = STRMID(LocalState.InFileName, 0, NamePos)
    ; FileName = FileName + '_' + strtrim((*pGroup).StartTime,2)
    ; ENDIF ELSE FileName = strtrim((*pGroup).StartTime,2)

    ; FileName = FileName + '_allcmbPSD.png'
    ;*************************************************************************************************
    called_save_png=1
    goto, startplot
    BacktoSavePng: donothing=0

    ;***************************************************************************************************
    ; Read in screen
    Buf = TVRD()
    ;Invert colors
    Indx = WHERE(Buf GT 0, Count)
    Buf[*] = 255
    IF Count GT 0 THEN Buf[Indx] = 0
    ;WRITE_TIFF, FileName, Buf;, 1, RED=r, GREEN=g, BLUE=b
    buf = rotate(temporary(buf),7)
    WRITE_png, FileName, Buf, bindgen(256),bindgen(256),bindgen(256)
ENDIF 
;******************end of save imge file

; Print it?
IF OutPutFlags AND 1 THEN BEGIN
    IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()
    ; Switch to PRINTER output
    SET_PLOT, 'PRINTER'
    DEVICE, /LANDSCAPE,scale_factor=0.7
    tvlct,r,g,b,/get
    loadct,0
    ;****************************************************************************
    called_print_png=1;   not need for this part.
    goto, startplot
    BacktoPrintPng: donothing=0

    ;*****************************************************************************
    DEVICE, /CLOSE_DOCUMENT
    ; Switch back to display output
    SET_PLOT, 'WIN'
    tvlct,r,g,b
ENDIF
;reset the window for 1
!P.multi=[0,1,1]
END


;=================================================================================
;================================================================================
;===============================================================================
FUNCTION WriteHistogram_addfssp2dc, LocalState, FILENAME=FileName

    ; Get file name from user?
    IF (not keyword_set(FileName))THEN FileName = DIALOG_PICKFILE(FILTER='*.txt', TITLE="Select cond_spectra Histogram Data File")

    dotloc = rstrpos(filename,'.')
    if(dotloc eq -1)then filename = filename + '.txt'

    IF( FileName eq '') THEN RETURN, -10

    Openw, DFileUnit, FileName, /Get_lun, ERROR = err
    IF (err NE 0) THEN BEGIN
        PRINT, !ERR_STRING
        return, -2
    ENDIF

    if localstate.typescaling eq 1 then begin
        if localstate.sizetype eq 'no_adj' then adjtype=' no adj ' else adjtype='adjusted'
    endif
    if localstate.typescaling eq 3 then begin
        adjtype='wyswyg_r'
        wysiwyg_r=1
    endif
    ; stop
    PRINTF, DFileUnit,format='(A7,1x,A6,1x,A8,1x,4(A5,1x),2x,A13,1x,A9)', '#OfGrps','T_Step',' scale  ','Brkp1','Brkp2','brkp3','brkp4','mincntsperbin','min_del_x'
    PRINTF, DFileUnit,format='(A7,1x,A6,1x,A8,1x,4(A5,1x),2x,A13,1x,A9)', strtrim(LocalState.grpCnt,2),strtrim(LocalState.sumsecs,2),adjtype,$
        strtrim(LocalState.brk1,2),strtrim(LocalState.BRK2,2),strtrim(LocalState.BRK3,2),strtrim(LocalState.BRK4,2),strtrim(localstate.mincntsperbin,2),$
        strtrim(LocalState.binsize,2)
    ; Write the data  next line's pgroup is the first group. becasreful.

    FOR j=1, 1 do begin ;    LocalState.grpCnt DO BEGIN
        if j eq 1 then begin
            pGroup = find_first_link(LocalState.pGroup)   ; pgroup is a pointer, *pgroup contains a structure.
        endif else begin
            if j eq localstate.grpCnt then begin
                j=j+1  ; do nothing  so that it got stopping the the for  loop in next run
                pGroup = (*pGroup).next_link
            endif else begin
                ;start next group data
                pGroup = (*pGroup).next_link
            endelse
        endelse
        ;*************************************************   September 4, 2004
        ;calculated the PSD value for output
        ;get_the_plotData,pGroup,Localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM 
        get_the_plotData,pGroup,Localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM,$
            pGrouppDataI,pGrouppadjI,pGrouppdataAI,pGrouppDataMI,$
            pGrouppDataL,pGrouppadjL,pGrouppdataAL,pGrouppDataML
        validData = where(*pGrouppData ne 0,dataCnt)
        sizes=(*pGrouppData)[validData];   ;use_Dcor
        adjs =(*pGrouppAdj)[validData]     ;use_adj

        if localstate.AdjorNot eq 0 then begin
            indexadj=where(adjs gt 0.0,contadj)
            if contadj gt 0 then adjs(indexadj)=1.0
        endif

        Acors=(*pGrouppDataA)[validData];  ;use_Acor
        Mcors=(*pGrouppDataM)[validData];  ;use_Mcor
        min_del_x=localstate.binsize;   5.0
        mincntsperbin=localstate.mincntsperbin ;  2.0;   it should be alway greater than 1. ge 2.

        ;*********************************************************************************************
        ;DOFmax=1.411*2.54
        ;IMG_SV=DOFmax*1024d*0.00023*1024d*0.00023*((*pgroup).totfrmcnt)/1000d   ;liters
        ;sampV_IMG=Img_SV
        ;local_conc=total(adjs)
        ;conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
        ;ave_conc=float(localstate.sumsecs)*conc_norm*total(adjs );  because localstate.sampleV is SV of sumsecs.
        ;FFF_i=ave_conc/(local_conc/sampV_IMG)  ;local_conc=total(adjs)

        cpiview_unihist_adj, sizes,mincntsperbin,min_del_x,x3,y3,adjs
        ; the xpts are like  1, 2, 2, 6, 6, 9.5  9.5  12.7
        ; and vals are like  3, 3, 5, 5, 20, 20. 11.   11.0
        ; they need to be put back into  bins spectra format.
        ;if n_elements(y3) ne 0 then begin
        ;      y3=y3/IMG_SV;    sampV_IMG
        ;      cy3=y3*FFF_i*1.0
        ;endif
        ;above is comment out on dec 14 9am
        ;*******************************************************************************************

        ;above is replaced with following
        ;****************************************************************
        case LocalState.TypeScaling of
            1: begin; ; this is similar using deadtime. but is not deadtiem scale. use conc=
                ; using dead time
                ; scaler = (localState.sumSecs - (*pGroup).deadtime)*LocalState.SampleVolume/localState.sumSecs + (*pGroup).TotFrmCnt*.0002
                conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
                ave_conc=float(localstate.sumsecs)*conc_norm*total(adjs );  because localstate.sampleV is SV of sumsecs.
                factor  =float(localstate.sumsecs)*conc_norm;   ;following Sizes=vector of Dcor
                sampV_IMG=1.0/factor
                FFF_i=ave_conc/total(adjs)/sampV_IMG
                vals=y3
                cy3=vals*FFF_i*factor*1.0


                ; du_cpiview_other_psds,factor,mincntsperbin,adjs,Acors,sizes,Mcors,xpts,Lvals,Avals,Mvals
                ;           vals*factor

                ; (*(*pGroup).Lbinheights)[0:nnn-1] = Lvals*factor
                ;  (*(*pGroup).Abinheights)[0:nnn-1] = Avals*factor
                ;  (*(*pGroup).Mbinheights)[0:nnn-1] = Mvals*factor
                Conc = ave_conc; total(spectra)  ; this is no use, but keep it in case the program somewhere it is needed.
                acceptedPart = dataCnt ; this is no use to me. but keep it.
                scalingType = '#/(LT*SV)/um'
                wysiwyg_r=0
            end

            ;************************************************************************************
            3:begin   ;this is for wysisyg_r  scaling type is always 3.
            ;conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
            numfrms=max([(*pGroup).totFrmCnt, 1.0])
            DOFmax=1.411*2.54 
            IMG_SV=DOFmax*1024d*0.00023*1024d*0.00023*(numfrms)/1000d   ;liters
            factor=1.0/IMG_SV;  if localstate.typescaling eq 3 then  factor = 1.0/IMG_SV
            ave_conc=factor*total(adjs );  because localstate.sampleV is SV of sumsecs.
            vals=y3
            cy3=vals*factor
            sampV_IMG=IMG_SV
            ;du_cpiview_other_psds,factor,mincntsperbin,adjs,Acors,sizes,Mcors,xpts,Lvals,Avals,Mvals

            ;   (*(*pGroup).Nbinheights)[0:nnn-1] = vals*factor
            ;   (*(*pGroup).Lbinheights)[0:nnn-1] = Lvals*factor
            ;   (*(*pGroup).Abinheights)[0:nnn-1] = Avals*factor
            ;   (*(*pGroup).Mbinheights)[0:nnn-1] = Mvals*factor
            Conc = ave_conc; total(spectra)  ; this is no use, but keep it in case the program somewhere it is needed.
            acceptedPart = dataCnt ; this is no use to me. but keep it.
            scalingType = 'wysiwyg_r'
            wysiwyg_r=1
            ;stop
            FFF_i=1.0
        end
    endcase

    ;********************************************************************

    ;get the CPI_only results from the x3 and cy3 and Acor Mcor: extinction, Reff_a,Reff_b, IWC and conc
    FFF_x=localstate.FFFx
    ext_cpi=2.0*FFF_i*total(adjs*Acors)/IMG_SV/1000000.0  ;in /Km   difer from do_FFF because FFF_i is
    ;calc effective radii and add to plot                  ;not the same.
    num=0.0
    den=0.0
    for i=0,n_elements(x3)-1,2 do begin
        cc=(x3(i)+x3(i+1))/2.
        num=num+(x3(i+1)-x3(i))*cy3(i)*(cc/2.)^3.0
        den=den+(x3(i+1)-x3(i))*cy3(i)*(cc/2.)^2.0
    endfor
    if den ne 0 then Reff_a=num/den else Reff_a=0.0

    scale_conc=0.0
    for i=0,n_elements(x3)-1,2 do scale_conc=scale_conc+(x3(i+1)-x3(i))*cy3(i)    ;#/L
    CPI_conc=total(adjs)
    FFF=scale_conc/CPI_conc; ; is this the sam as FFF_i ????
    COMBiwc_cpi=FFF*total(adjs*Mcors);* should time a factor of FFF=total(adjs)/integration of (x3,cy3)
    cCPI_conc  =scale_conc;           ;here COMBiwc isdiffers from do_FFF because FFF_i is different.

    CPIiwc=COMBiwc_cpi
    Vol=CPIiwc*10.^9./.917               ;in um3 per Liter
    Proj_Area=2.0*FFF_i*FFF_x*total(adjs*Acors)/IMG_SV     ;in um2 per Liter
    Reff_b=0.75*Vol/Proj_Area

    ;************************************************************************************
    ;and  get CPI_gt50_only  from sizes gt 50.Acor50 Mcor50    : extinction, Reff_a,Reff_b, IWC and conc
    index50=where(sizes gt 50, contF)
    if contF gt 0 then begin
        sizes50=sizes(index50)
        Acors50=Acors(index50)
        Mcors50=Mcors(index50)
        adjs50 =adjs(index50)
        local_conc50=total(adjs50)

        ;tempary fix.
        conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume

        ave_conc50=float(localstate.sumsecs)*conc_norm*total(adjs50);  because localstate.sampleV is SV of sumsecs.
        FFF_i50=ave_conc50/(local_conc50/sampV_IMG)  ;local_conc=total(adjs)
        cpiview_unihist_adj, sizes50,mincntsperbin,min_del_x,x3g,y3g,adjs50

        if n_elements(y3g) ne 0 then begin
            y3g=y3g/IMG_SV;    sampV_IMG
            cy3g=y3g*FFF_i50*1.0
        endif
        ;get the CPI_only results from the x3 and cy3 and Acor Mcor: extinction, Reff_a,Reff_b, IWC and conc
        FFF_x=localstate.FFFx
        ext_cpi50=2.0*FFF_i50*total(adjs50*Acors50)/IMG_SV/1000000.0  ;in /Km
        ;calc effective radii and add to plot
        num=0.0
        den=0.0
        for i=0,n_elements(x3g)-1,2 do begin
            cc=(x3g(i)+x3g(i+1))/2.
            num=num+(x3g(i+1)-x3g(i))*cy3g(i)*(cc/2.)^3.0
            den=den+(x3g(i+1)-x3g(i))*cy3g(i)*(cc/2.)^2.0
        endfor
        if den ne 0 then Reff_a50=num/den else Reff_a50=0.0

        CPIiwc50=total(Mcors50)*FFF_i50
        Vol=CPIiwc50*10.^9./.917               ;in um3 per Liter
        Proj_Area=FFF_i50*total(adjs50*Acors50)/IMG_SV     ;in um2 per Liter
        Reff_b50=0.75*Vol/Proj_Area

        scale_conc50=0.0
        for i=0,n_elements(x3g)-1,2 do scale_conc50=scale_conc50+(x3g(i+1)-x3g(i))*cy3g(i)    ;#/L
        CPI_conc50=total(adjs50)
        FFF=scale_conc50/CPI_conc50  ; is this teh sam as FFF_i ????
        COMBiwc_cpi50=FFF*total(adjs50*Mcors50);* should time a factor of FFF=total(adjs)/integration of (x3,cy3)
        cCPI_conc50  =scale_conc50
    endif else begin
        ext_cpi50=0.0
        Reff_a50=0.0
        Reff_b50=0.0
        comBiwc_cpi50=0.0
        Ccpi_conc50=0.0
    endelse
    ;***************************************************    get FFF_i value
    TDC_N_bar =*(*pgroup).pTWODC;  ;70 elements
    TDC_A_Bar=*(*pgroup).pTWODCA; ;70 elements   ;this is TDC_A_bar
    TDC_M_bar=*(*pgroup).pTWODCM; '70elements;   ;This is TDC_M_bar
    fsspbinhs=*(*pgroup).pfssp;     ;FSPout
    FSPout=fsspbinhs
    fsspbins =localstate.fsspbins
    fsspbwds =localstate.fsspbwds
    xfssp=localstate.fsspbinedges
    yfssp=fltarr(n_elements(xfssp))
    for i=0,n_elements(FSPout)-1 do yfssp(2*i:2*i+1)=FSPout(i)

    twodcbwds=localstate.twodcbwds;   70 elements
    x2dc=localstate.twodcbins;  ;140 elements
    ;make them horizonatl vertical
    nnnn=n_elements(TDC_N_bar);  70 elements
    y2dc =fltarr(2*nnnn);        140 elements
    A2dc=fltarr(2*nnnn)
    M2dc=fltarr(2*nnnn)
    for i=0,nnnn-1 do begin
        y2dc(2*i:2*i+1)=TDC_N_Bar(i)
        A2dc(2*i:2*i+1)=TDC_A_bar(i)
        M2dc(2*i:2*i+1)=TDC_M_bar(i)
    endfor
    ; in do_fff  if y2dc=0.0 then assign it to be 1.0e-37
    somarr=where(y2dc eq 0.0,cont0)
    if cont0 gt 0 then y2dc(somarr)=1.0e-37

    n2dcbins=n_elements(x2dc)/2
    twoDccens=fltarr(n2dcbins)
    for i=0, n2dcbins-1 do begin
        twodccens(i)=(x2dc(2*i+1)+x2dc(2*i))/2.0
    end

    PMSbins={fssp:fsspbins,twodc:twoDccens}
    PMSbwds={fssp:fsspbwds,twodc:twoDcbwds}

    brk1=localstate.brk1
    brk2=localstate.brk2
    brk3=localstate.brk3
    brk4=localstate.brk4
    ;getcombined psd distribution
    ;**************************************************************************************************
    use_Dcor=sizes
    use_Acor=Acors
    use_Mcor=Mcors
    use_adj=adjs

    use_wid=use_Dcor
    use_len=use_Dcor
    use_perim=use_Dcor

    pathnm='dummmyyy'
    FFF_x=localstate.FFFx
    strt_date='dum'
    sHH='00'
    sMM='00'
    sSS='00'
    eHH='00'
    eMM='00'
    eSS='00'
    cut_l=brk1
    left=brk2
    right=brk3
    cut_r=brk4
    expname='dummy'
    leg='0'
    uni_hist_num=mincntsperbin
    ; stop
    du_combPSD,use_Acor,use_wid,use_len,use_perim,PMSbins,PMSbwds,FSPout,use_Dcor,sampV_IMG,use_adj,pathnm,x2dc,y2dc,A2dc,M2dc $
        ,FFF_i,FFF_x,strt_date,sHH,sMM,sSS,eHH,eMM,eSS,cut_l,left,right,cut_r,comb_PSD_x,comb_PSD_y,TDC_A_bar,TDC_M_bar $
        ,expname,leg,uni_hist_num,min_del_x,vals,mincntsperbin,use_Mcor,wysiwyg_r

    comb_PSD_L=vals[1,0,*]
    comb_PSD_A=vals[2,0,*]
    comb_PSD_M=vals[3,0,*]
    ;get the start_time
    t = ConvertFromSeconds((*pGroup).StartTime, LocalState.year)
    StrtTime = strtrim(t.month,2)+'/'+strtrim(t.day,2)+'     '+strtrim(t.hour,2)+':'+strtrim(t.minute,2)+':'+strtrim(t.sec,2)
    ;if t.month lt 10 then mm='0'+strtrim(round(t.month),2)  else mm=strtrim(round(t.month),2)
    ;if t.day lt 10 then dd='0'+strtrim(round(t.day),2) else dd= strtrim(round(t.day),2);  this for generating file names.
    t = ConvertFromSeconds((*pGroup).StartTime+localstate.sumsecs, LocalState.year)
    endtime  =' '+strtrim(t.hour,2)+':'+strtrim(t.minute,2)+':'+strtrim(t.sec,2)

    ;**********************************************************************************

    ;FOR j=1, LocalState.grpCnt DO BEGIN
    printF,DFileUnit,format='(A60)','==========================================================================='
    printF,DFileUnit,format='(A18,2x,A12,4x,A12,4x,A8)',' Date     StrtTime','end_time','FFF_i','FFF_x'
    printF,DFileUnit,format='(A18,2x,A12,4x,F12.4,4x,F8.3)', strtrim(StrtTime,2), strtrim(endtime,2), FFF_i,FFF_x
    ;write CPI only results:
    ;get the cpi_only resuts
    cpi1_only_str='CPI_all only: extinction = '+string(ext_cpi,format='(F9.5)')+$
        ' Reff_a = '+string(Reff_a,format= '(F6.1)')+' Reff_b = '+string(Reff_b,format='(F6.1)')+$
        ' IWC = '+string(combiwc_cpi,format='(F8.6)')+ ' conc = '+string(cCPI_conc,format='(F13.6)')
    printF,DFileUnit,cpi1_only_str

    ;write CPI gt 50 only results:
    ;get the cpi_gt50_only resuts
    cpi2_only_str='CPI_G50 only: extinction = '+string(ext_cpi50,format='(F9.5)')+$
        ' Reff_a = '+string(Reff_a50,format='(F6.1)')+' Reff_b = '+string(Reff_b50,format='(F6.1)')+$
        ' IWC = '+string(combiwc_cpi50,format='(F8.6)')+' conc = '+string(Ccpi_conc50,format='(F13.6)')
    printF,DFileUnit,cpi2_only_str

    ;write combined PSD results:
    comb_psd_str='Combined PSD: TWC = '+string(0.019,format='(F8.6)')+'    TWC_M = '+string(0.035,format='(F8.6)')+$
        ' conc = ' +string(2481.180,format='(F13.6)')+' Extinction = '+string(1.213,format='(F9.5)')+$
        ' Extinction_a = '+string(1.463,format='(F9.5)')+' Reff_a = '+string(69.06,format='(F6.1)')+$
        ' Reff_b = '+string(1.0,format='(F6.1)')+' Z = '+string(-12.3,format='(F6.1)')+$
        ' dB  Max size = '+string(1100.0,format='(F7.1)')
    printF,DFileUnit,comb_psd_str

    ice_psd_str ='comb_ICE PSD: IWC = '+string(0.017,format='(F8.6)')+'    IWC_M = '+string(0.033,format='(F8.6)')+$
        ' conc = '+string(66.912,format='(F13.6)')+ ' Extinction = '+string(0.835,format='(F9.5)')+$
        ' Extinction_a = '+string(1.084,format='(F9.5)')+' Reff_a = '+string(90.10,format='(F6.1)')+$
        ' Reff_b = '+ string(32.71,format='(F6.1)')+ ' Z = '+string( -12.3,format='(F6.1)')+' dB  '
    printF,DFileUnit,ice_psd_str

    Water_psd_str='CmbWater PSD: LWC = '+string(0.002,format='(F8.6)')+ ' NEVZ LWC = '+ string(0.000,format='(F8.6)')+$
        ' conc = '+string(2414.,format='(F13.6)')+ ' Extinction = '+string(0.378,format='(F9.5)')+ $
        ' Extinction_a = '+string(0.379,format='(F9.5)')+ '   Reff = '+string(8.78,format='(F6.1)')+$
        ' ----------------Z = '+string(-40.7,format='(F6.1)')+ ' dB    '
    printF,DFileUnit,water_psd_str
    ;**************************************************************
    printf,DFileUnit,format='(2(A16))','FSSP bin edges','FSSP bin heights'
    printf,DFileUnit,format='(2(A16))','um','#/L/um'
    printf,DFileUnit,n_elements(xfssp)
    for k=1,n_elements(xfssp) do printf,DFileUnit,format='(2(F16.6))',xfssp(k-1),yfssp(k-1)

    printf,DFileUnit,format='(2(A16))','2DC bin edges','2DC bin heights'
    printf,DFileUnit,format='(2(A16))','um','#/L/um'
    printf,DFileUnit,n_elements(xfssp)
    for k=1,n_elements(x2dc) do printf,DFileUnit,format='(2(F16.6))',x2dc(k-1),y2dc(k-1)

    printf,DFileUnit,format='(2(A16))','CPI bin edges','CPI bin heights'
    printf,DFileUnit,format='(2(A16))','um','#/L/um'
    printf,DFileUnit,n_elements(x3)
    for k=1,n_elements(x3) do printf,DFileUnit,format='(2(F16.6))',x3(k-1),cy3(k-1)
    printf,DFileUnit,''
    ;printf,DFileUnit,format='(2(A16))','LIQ bin edges','LIQ bin heights'
    ;printf,DFileUnit,format='(2(A16))','um','#/L/um'
    ;printf,DFileUnit,n_elements(x_liq)
    ;for k=1,n_elements(x_liq) do printf,DFileUnit,format='(2(F16.6))',x_liq(k-1),y_liq(k-1)
    ;printf,DFileUnit,''
    ;printf,DFileUnit,format='(2(A16))','ICE bin edges','ICE bin heights'
    ;printf,DFileUnit,format='(2(A16))','um','#/L/um'
    ;printf,DFileUnit,n_elements(x_ice)
    ;for k=1,n_elements(x_ice) do printf,DFileUnit,format='(2(F16.6))',x_ice(k-1),y_ice(k-1)
    ;printf,DFileUnit,''
    ;printf,DFileUnit,format='(2(A16))','WYS bin edges','WYS bin heights'
    ;printf,DFileUnit,format='(2(A16))','um','#/L/um'
    ;printf,DFileUnit,n_elements(x_wys)
    ;for k=1,n_elements(x_wys) do printf,DFileUnit,format='(2(F16.6))',x_wys(k-1),y_wys(k-1)
    ;printf,DFileUnit,''
    printf,DFileUnit,format='(5(A16))','Comb bin edges  ','Comb bin heights',' comb Length PSD','  comb Area PSD ','  comb Mass PSD '
    printf,DFileUnit,format='(5(A16))','       um       ','     #/L/um     ','     um/L/um    ','    mm2/L/um    ','     g/m3/um    '
    printf,DFileUnit,n_elements(comb_PSD_x)
    for k=1,n_elements(comb_PSD_x) do printf,DFileUnit,format='(5(F18.8))',comb_PSD_x(k-1),comb_PSD_y(k-1),comb_PSD_L(k-1),comb_PSD_A(k-1),comb_PSD_M(k-1)

    ;**************************************************************
ENDFOR
FREE_LUN, DFileUnit
RETURN, 0
END  ;end of writeHistorgram

;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output; Bit 2 set = ASCII file output

PRO ShowHistograms_addfssp2dc, pStateInfo, sumSecs, GROUP=GROUP, OutPutFlags=OutPutFlags, SAMPLEVOLUME=SampleVolume, typeSCALING=typeScaling ,sizeType = sizeType

; if typeScaling is true, then use missed, otherwise use deadtime

IF N_ELEMENTS(SampleVolume) EQ 0 THEN SampleVolume = -1
IF N_ELEMENTS(MissScaling) EQ 0 THEN MissScaling = 1

; Default is to send ouput to plot, only once
IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

pGroup = (*pStateInfo).spectra.pGroup

; mo qixu comment this following lines out on oct 25 2005.
if(not ptr_valid(pGroup))then begin
    ; r=dialog_message("Error: no data to display")
    return
endif

; take ownership of this pointer info
(*pStateInfo).spectra.pGroup = ptr_new()
groupPtr = ptrarr((*pStateInfo).spectra.groupCnt)
groupPtr[0]    = pGroup
pGrp = pGroup
for i=1,(*pStateInfo).spectra.groupCnt-1 do begin
    if(ptr_valid(pGrp))then begin
        groupPtr[i]  = (*pGrp).next_link
        pGrp = (*pGrp).next_link
    endif
endfor

; build GUI
tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, /TLB_SIZE_EVENTS, /col, TITLE='Combined PSD Histograms',mbar=menuBase)

; button bar   add options label
button_bar = widget_base(tlb,/row)
bb1 = widget_base(button_bar,/row)
;  readBut = widget_button(bb1,value='open.bmp',/bitmap,uvalue='OPEN') ;ascii
saveBut = widget_button(bb1,value='Save.bmp',/bitmap,uvalue='SAVE') ;sacii
;saveBut = widget_button(bb1,value='Save txt',/bitmap,uvalue='SAVE')

bb2 = widget_base(button_bar,/row)
printBut = widget_button(bb2,value='print.bmp',/bitmap,uvalue='PRINT') ;print one file
printallBut = widget_button(bb2,value='print1.bmp',/bitmap,uvalue='PRINTALL') ; print all

bb3 = widget_base(button_bar,/row)
tiffBut = widget_button(bb3,value='freeform.bmp',/bitmap,uvalue='SAVETIFF')  ; save png
;tiffBut = widget_button(bb3,value='save png',/bitmap,uvalue='SAVETIFF')

bb4 = widget_base(button_bar,/row)
; quitBut = widget_button(bb4,value='quit.bmp',/bitmap,uvalue='QUIT')  ; quite
quitBut = widget_button(bb4,value='quit',/bitmap,uvalue='QUIT')

topbase = widget_base(tlb,/row)
; if((*pStateInfo).spectra.groupCnt gt 1)then begin   ;changed this on dec 14 2004
if((*pStateInfo).spectra.groupCnt gt 1)then begin
    position = widget_slider(topbase,value=1,uvalue='pos',min = 1, max =(*pStateInfo).spectra.groupCnt,/suppress_value)
endif else position = -1

TopLabelID = WIDGET_LABEL(topbase, UVALUE='BottomLab', VALUE='',XSIZE=550,/align_left,font='TIMES*20*BOLD')

MAINBase = widget_base(tlb,/row)
;-----------------------------------------------------
; Image View and image-related labels
ViewBase = WIDGET_BASE(MAINBase, /COL, TITLE='ImgView', UVALUE=' ')

;MainView = WIDGET_DRAW(ViewBase, /BUTTON_EVENTS, /FRAME, /RETAIN, UVALUE='MAIN_VIEW',XSIZE=450, YSIZE=350)
MainView = WIDGET_DRAW(ViewBase, /BUTTON_EVENTS, /FRAME, /RETAIN, UVALUE='MAIN_VIEW',$
    XSIZE=820, YSIZE=560);, X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004

;-----------------------------------------------------
; Base for all buttons and radio buttons on the left side
LeftButtonsBase = WIDGET_BASE(MAINBase, /COLUMN, UVALUE='AllButtons')
;-----------------------------------------------------
; Base for options
OpsBase = WIDGET_BASE(LeftButtonsBase, /COL, /FRAME, /BASE_ALIGN_CENTER, UVALUE='ProcButtons', TITLE='Histogram Options')

; buttns=['nonAdj','Adjust']
; wfjoneID=CW_Bgroup(opsbase,buttns,/exclusive,/col,button_uvalue=[0,1],Uvalue='AdjorNot',/no_release)
; widget_control,wfjoneID, set_value=1;     above 3 added oct 27, 2004.
SAFID=CW_field(opsbase,title='SAF:',value=1.0,xsize=5,uvalue = 'SAF',/all)
BinSizeIDaa = WIDGET_SLIDER(OpsBase,MIN=1, MAX=10,  TITLE='Min.BinSz(um)', VALUE =1, UVALUE='BINSIZE')
BincntsIDbb = WIDGET_SLIDER(OpsBase,MIN=2, MAX=2000,TITLE='Min.#.Per.Bin', VALUE =2, UVALUE='MinCntsPerbin')
FFFxID= CW_field(opsbase,title='FFFx:',value=1.0,xsize=5,uvalue = 'FFFx',/all) 
;-----------------------------------------------------
;BinSizeID = WIDGET_slider(OpsBase,MIN=1, MAX=10, TITLE='Brk1', VALUE =1, UVALUE='Brk1')
; BincntsID = WIDGET_SLIDER(OpsBase,MIN=1, MAX=10, TITLE='Brk2', VALUE =1, UVALUE='Brk2')
BinSizeID  = CW_field(opsbase,title='brk1:',value=1,/int,xsize=5,uvalue = 'brk1',/all) 
BincntsID  = CW_field(opsbase,title='brk2:',value=30,/int,xsize=5,uvalue = 'brk2',/all)
BinSizeID2 = CW_field(opsbase,title='brk3:',value=300,/int,xsize=5,uvalue = 'brk3',/all) 
BincntsID2 = CW_field(opsbase,title='brk4:',value=3000,/int,xsize=5,uvalue = 'brk4',/all) 
makecmbpsd =widget_button(opsbase,value='ReDo',uvalue='make_cmb_psd')
;-----------------------------------------------------
messages=[['Note:'],$
    ['1. On first load, If'],$
    ['   Redo fails to  '],$
    ['   respond,close'],$
    ['   window,and remake'],$
    ['   PSDs, Redo should'],$
    ['   then work.'],$
    ['                    '],$
    ['2. If you want to'],$
    ['   change to other'],$
    ['   mode. Always turn'],$
    ['   the button off,'],$
    ['   then start again.'],$
    ['                  ']]



textmsg=widget_text(OpsBase, value=messages,/wrap,ysize=18,/Frame)
;    text2 = WIDGET_TEXT(base, $       ;This widget belongs to 'base'.
;        VALUE = 'This text widget cannot be edited.', $
;       YSIZE = 1, /FRAME)       ;Put a frame around it.
;   above is an example
;****************************************************

;-----------------------------------------------------
; Line 1: Text labels at bottom of image view
ImgInfoL1 = WIDGET_BASE(LeftButtonsBase, /row, /MAP, TITLE='ImgInfo', UVALUE='ImgInfoBase')

; Read in the pixel size
WIDGET_CONTROL, (*pStateInfo).PixSizeID, GET_VALUE=PixSize

FileName = (*pStateInfo).InFileName

WIDGET_CONTROL, MAINBase, /REALIZE

; Get drawable window index
WIDGET_CONTROL, MainView, GET_VALUE=MainViewID

;*********************************************************************************************

;(*pstateinfo).fsspdata.filename=C:\HHH_south_pole_work\MidCix_projects\April_19_filght\roi_5_flight_1914\04191914_SPP100log.txt
; *(*pstateinfo).fsspdata.time=[9494358 9494359 ..... ect.
; *(*pstateinfo).fsspdata.bins= 2.04550 4.35050      6.65600 8.96150   11.2665  ...ect
if (*pstateinfo).fsspdata.filename ne ' ' then begin
    fsspbins=*(*pstateinfo).fsspdata.bins
    fsspbwds=*(*pstateinfo).fsspdata.bwd
endif else begin
    fsspbins=[-99.0, -99.0]
    fsspbwds=[9.9, 9.9]
endelse
if (*pstateinfo).twodcdata.filename ne ' ' then begin
    twodcbins=*(*pstateinfo).twodcdata.bins
    twodcbwds=*(*pstateinfo).twodcdata.bwd
endif else begin
    twodcbins=[-99.0, -99.0]
    twodcbwds=[9.9, 9.9]
endelse

;make fssp bin edges
nnnfssp=n_elements(fsspbins)
fsspbinedges=fltarr(2*nnnfssp)
fsspbinedges(0)=fsspbins(0)-fsspbwds(0)/2.0
for i=0,nnnfssp-2 do fsspbinedges(2*i+1:2*i+2)=fsspbins(i)+fsspbwds(i)/2.0
fsspbinedges(2*nnnfssp-1)=fsspbins(nnnfssp-1)+fsspbwds(nnnfssp-1)/2.0
;*****************************************************************************************


LocalState = { pGroup:pGroup,$           ; ptr to first link in list
    year:(*pStateInfo).fileHead.year,$;    year of data
    pGroupPtr:ptr_new(groupPtr),$  ; pointer to array of all group pointer links
    brk1:1,$   ;for combined psd break point.
    brk2:30,$  
    brk3:300,$   
    brk4:3000,$  
    FFFx:1.0,$   ;      for FFF_x
    FFFxID:FFFxID,$;    for FFF_x
    AdjorNot:1,$
    binsize:1.0,$  
    mincntsperbin:2.0,$
    SumSecs:SumSecs,$          ; secs to average over
    MainView:MainView, $      ; draw window widget ID
    MViewID:MainViewID, $       ; draw window ID
    InFileName:FileName, $        ; main .roi data file name
    TypeScaling:typeScaling, $     ; keyword
    sizeType:sizeType,$          ; keyword for size type
    grpNum:1,$               ; group number
    grpCnt:(*pStateInfo).spectra.groupCnt,$; number of groups
    PixSize:PixSize, $          ; pixel size from GUI
    appname:(*pStateInfo).appname,$       ; name of application = 'CpiView'
    position:position,$          ; widgetID of position slider
    BinSizeIDaa:BinSizeIDaa, $        ; bin size slider widget ID
    BincntsIDbb:BincntsIDbb, $        ; mincntsPerbin  slider widget ID
    BinSizeID:BinSizeID, $        ; brk1
    BincntsID:BincntsID, $        ; brk2
    BinSizeID2:BinSizeID2, $        ;brk3
    BincntsID2:BincntsID2, $        ;brk4
    TopLabelID:TopLabelID, $     ; widget ID for bottom label1 to hold time info
    PrinterSetup:0, $
    SampleVolume:SampleVolume,$;} ; sample volume passed in via keyword
    filledn:1,$              ;flag for all particles(1), liquid=2. ice=3 particles
    fsspbins:fsspbins,$,
fsspbwds:fsspbwds,$,
fsspbinedges:fsspbinedges,$
    twodcbins:twodcbins,$
    twodcbwds:twodcbwds,$
    SAFID:SAFID,$
    SAF:1.0}



; Save ASCII file?
IF((OutPutFlags AND 4)/4)THEN BEGIN
    ; Create a filename
    ; Get Path
    NamePos = RSTRPOS(LocalState.InFileName, '.')
    IF(NamePos ne '') THEN BEGIN
        FileName = STRMID(LocalState.InFileName, 0, NamePos)
        FileName = FileName + '_' + strtrim((*pGroup).StartTime,2)
    ENDIF ELSE FileName = strtrim((*pGroup).StartTime,2)
    ;  stop
    FileName = FileName + '_all_cmb_PSD.txt'
    Ret = WriteHistogram_addfssp2dc(LocalState, FILENAME=FileName)
ENDIF

if((OutPutFlags and 2)/2)then begin
    ; output TIFFs
    pGroup = find_first_link(LocalState.pGroup)
    pFirst = pGroup
    LocalState.pGroup = pGroup
    FOR i=1, LocalState.grpCnt DO BEGIN
        PlotHistogram_addfssp2dc, LocalState, OutPutFlags=2
        LocalState.pGroup =  (*LocalState.pGroup).next_link
    ENDFOR
    LocalState.pGroup = pFirst

endif


if((OutPutFlags and 1)/1)then begin
    IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

    IF LocalState.PrinterSetup THEN BEGIN
        pGroup = find_first_link(LocalState.pGroup)
        pFirst = pGroup
        LocalState.pGroup = pGroup
        FOR i=1, LocalState.grpCnt DO BEGIN
            PlotHistogram_addfssp2dc, LocalState, OutPutFlags=1
            LocalState.pGroup =  (*LocalState.pGroup).next_link
        ENDFOR
        LocalState.pGroup = pFirst
    ENDIF
endif

; Show 1st plot

PlotHistogram_addfssp2dc, LocalState

; Save state
WIDGET_CONTROL, tlb, SET_UVALUE=LocalState,/no_copy

; Hand off control of the widget to the XMANAGER:
XMANAGER, 'ROIHistogram_addfssp2dc', tlb, /NO_BLOCK

END

;**************************************************************************

;*********************************************************************************
PRO du_combPSD,use_Acor,use_wid,use_len,use_perim,PMSbins,PMSbwds,FSPout,use_Dcor,sampV_IMG,use_adj,pathnm,x2dc,y2dc,A2dc,M2dc $
    ,FFF_i,FFF_x,strt_date,sHH,sMM,sSS,eHH,eMM,eSS,cut_l,left,right,cut_r,comb_PSD_x,comb_PSD_y,TDC_A_bar,TDC_M_bar $
    ,expname,leg,uni_hist_num,min_del_x,vals,mincntsperbin,use_Mcor,wysiwyg_r
;******************************************************************************************
; I need to insert this to replace the calculation of those things using use_wid, use+len, use_perim
;  (1)   mass=use_Mcor3
;  (2): COMBiwc_cpi=total(Mass)
;       scale_conc=0.0
;       for i=0,n_elements(x3)-1,2 do scale_conc=scale_conc+(x3(i+1)-x3(i))*cy3(i)    ;#/L
;       cCPI_conc  =scale_conc
;  (3)  M_=Total(mass(somarr4))
;wysiwyg_r eq 1 mean using cpi wywisyg_r scale; eq 0 means using normal scale. and sampV_img
; is different for two scales.
;*********************************************************************************************

somarr=where(FSPout lt 10.^(-37.))
if somarr[0] ne -1 then FSPout(somarr)=10.0^(-37.0)   ;10^-7 is the low end of Yrange for the plot

x2dc_orig=x2dc
y2dc_orig=y2dc
A2dc_orig=A2dc
M2dc_orig=M2dc

L2dc=y2dc

;print,PMSbins.FSSP+PMSbwds.FSSP/2.
;left=0.0
;right=10000.0
;good='n'
;while good ne 'y' do begin
;print,'please specify 4 break points'
;read,cut_l,left,right,cut_r,prompt='# #'
if cut_r lt right then cut_r=right
if cut_l gt left then cut_l=left
if cut_r gt 9999999.9 then cut_r=9999999.9
if right gt 9999999.9 then right=9999999.9

;for 2d later but do now for first plot command

a1=where(x2dc le right)   
if a1[0] eq -1 then a1=0
a2=where(x2dc ge cut_r)
if a2[0] eq -1 then a2=n_elements(x2dc)-1
if max(a1) le min(a2) then x2dc=x2dc[max(a1):min(a2)] else x2dc=[0]
if max(a1) le min(a2) then y2dc=y2dc[max(a1):min(a2)] else y2dc=[0]
if max(a1) le min(a2) then L2dc=L2dc[max(a1):min(a2)] else L2dc=[0]
if max(a1) le min(a2) then A2dc=A2dc[max(a1):min(a2)] else A2dc=[0]
if max(a1) le min(a2) then M2dc=M2dc[max(a1):min(a2)] else M2dc=[0]
x2dc[0]=max([right,x2dc[0]])
x2dc[n_elements(x2dc)-1]=min([cut_r,x2dc[n_elements(x2dc)-1]])
;--------------------------------------------------------------------

;;calc FSSP IWC contribution and FSSP conc contribution and plot the FSSP contribution to combPSD
;;  extinc=2.0*FFF_i*total(use_adj*use_Acor)/sampV_IMG/1000000.0     ;in /Km
;;  for i=0,n_elements(CPI_x)-1,2 do begin
;;   cc=(CPI_x(i)+CPI_x(i+1))/2.
;;   num=num+(CPI_x(i+1)-CPI_x(i))*cCPI_y(i)*(cc/2.)^3.0
;;   den=den+(CPI_x(i+1)-CPI_x(i))*cCPI_y(i)*(cc/2.)^2.0
;;  endfor

xFSSP=fltarr(2.0*n_elements(PMSbins.FSSP))
yFSSP=xFSSP
for i=0,n_elements(PMSbins.FSSP)-1 do begin
    xFSSP[2*i]=PMSbins.FSSP[i]-PMSbwds.FSSP[i]/2.0
    xFSSP[2*i+1]=PMSbins.FSSP[i]+PMSbwds.FSSP[i]/2.0
    yFSSP[2*i]=FSPout[i]
    yFSSP[2*i+1]=FSPout[i]
endfor

a1=where(xFSSP le cut_l)
if a1[0] eq -1 then a1=0
a2=where(xFSSP ge left)
if a2[0] eq -1 then a2=n_elements(xFSSP)-1
xFSSP=xFSSP[max(a1):min(a2)]
yFSSP=yFSSP[max(a1):min(a2)]
LFSSP=yFSSP
AFSSP=yFSSP
MFSSP=yFSSP
if xFSSP[0] lt cut_l then xFSSP[0] = cut_l
if xFSSP[n_elements(xFSSP)-1] gt left then xFSSP[n_elements(xFSSP)-1]=left

if n_elements(xFSSP) ge 2 then begin
    COMBiwc_fssp=0.0
    cFSSP_conc=0.0
    ext_fssp=0.0
    num_fssp=0.0
    den_fssp=0.0
    Z_fssp=0d0
    for i=0,n_elements(xFSSP)-1,2 do begin
        cc=(xFSSP(i)+xFSSP(i+1))/2.
        COMBiwc_fssp=COMBiwc_fssp+0.917*(xFSSP(i+1)-xFSSP(i))*(yFSSP(i)/1000.)*(4./3.)*!pi*((cc/20.)^3.)*0.001      ; g/m3
        cFSSP_conc=cFSSP_conc+(xFSSP(i+1)-xFSSP(i))*yFSSP(i)                       ;#/L
        num_fssp=num_fssp+(xFSSP(i+1)-xFSSP(i))*yFSSP(i)*(cc/2.)^3.0
        den_fssp=den_fssp+(xFSSP(i+1)-xFSSP(i))*yFSSP(i)*(cc/2.)^2.0
        ext_fssp=ext_fssp+2.0*((xFSSP(i+1)-xFSSP(i))*yFSSP(i)) * !pi*((cc/2.)^2.)/1000000.0  ;in /Km
        ;Z_fssp=Z_fssp+(xFSSP(i+1)-xFSSP(i))*(yFSSP(i)*1000.)*((min([(0.24/0.9)*(0.917^2.0),(0.24/0.9)*(0.07^2.0)*(cc/1000.)^(-2.2)]))^2.0)*(cc/1000.)^6.0   ;mm6/m3
        Z_fssp=Z_fssp+(xFSSP(i+1)-xFSSP(i))*(yFSSP(i)*1000.)*(min([(0.24/0.9)*(0.917^2.0),(0.24/0.9)*(0.07^2.0)*(cc/1000.)^(-2.2)]))*(cc/1000.)^6.0     ;mm6/m3
        LFSSP[i]=yFSSP(i) * cc    ;um/L/um
        LFSSP[i+1]=LFSSP[i]
        AFSSP[i]=yFSSP(i) * !pi*((cc/2.)^2.)/1000000.0  ;in mm2/L/um
        AFSSP[i+1]=AFSSP[i]
        MFSSP[i]=yFSSP(i) * 0.917 * (!pi*4.0/3.0) * ((cc)/2000.)^3.0    ;in mg/L/um
        MFSSP[i+1]=MFSSP[i]
    endfor
    ;if x2dc[n_elements(x2dc)-1] gt 10000 then $
    ;plot_oo,xFSSP,yFSSP,color=0,ytitle='#/L/um',title=strt_date+'   '+sHH+':'+sMM+':'+sSS+'-'+eHH+':'+eMM+':'+eSS, $
    ;xtitle='size (microns)',xrange=[1,x2dc[n_elements(x2dc)-1]+1000.],ystyle=1,xstyle=1,yrange=[0.00000001,1000000] else $
    ;plot_oo,xFSSP,yFSSP,color=0,ytitle='#/L/um',title=strt_date+'   '+sHH+':'+sMM+':'+sSS+'-'+eHH+':'+eMM+':'+eSS, $
    ;xtitle='size (microns)',xrange=[1,10000],ystyle=1,yrange=[0.0000001,1000000]
    comb_PSD_x=xFSSP
    comb_PSD_y=yFSSP
    comb_PSD_L=LFSSP
    comb_PSD_A=AFSSP
    comb_PSD_M=MFSSP
endif else begin
    COMBiwc_fssp=0.0
    cFSSP_conc=0.0
    comb_PSD_x=-1
    comb_PSD_y=-1
    comb_PSD_L=-1
    comb_PSD_A=-1
    comb_PSD_M=-1
    ext_fssp=0.0
    num_fssp=0.0
    den_fssp=0.0
    Z_fssp=0.0
endelse

;same for CPI now
somarr2=where(use_Dcor ge left and use_Dcor le right)

if somarr2(0) ne -1 then begin
    use_Acor3=use_Acor(somarr2)
    use_Dcor3=use_Dcor(somarr2)
    use_adj3=use_adj(somarr2)
    use_wid3=use_wid(somarr2)
    use_len3=use_len(somarr2)
    use_perim3=use_perim(somarr2)
    use_Mcor3=use_Mcor(somarr2)

    unihist_adj,use_Dcor3,uni_hist_num,min_del_x,x3,y3,use_adj3
    if wysiwyg_r eq 1 then FFF_i=1.0
    if n_elements(y3) ne 0  then begin
        y3=y3/sampV_IMG
        cy3=y3*FFF_i*FFF_x
    endif

    mass=use_Dcor3
    mass(*)=0.0
    ;mass = ( use_adj3 * (0.16) * ((use_Acor3/1000000.) * (use_wid3/1000.) * [2.0 * (use_len3 + use_wid3)/use_perim3])^(0.83) )    ;mg 128 particle anal
    mass = ( use_adj3 * (0.13515) * ((use_Acor3/1000000.) * (use_wid3/1000.) * [2.0 * (use_len3 + use_wid3)/use_perim3])^(0.79287) )    ;mg 864 particle anal
    mass_sph = use_adj3 * 0.917 * (!pi*4.0/3.0) * (use_Dcor3/2000.)^3.0                     ;mg
    test=where(mass gt mass_sph)
    if test[0] ne -1 then mass[test] = mass_sph[test]

    mass=use_adj3*use_Mcor3;   ;add this to replace the fake calculation;  moqixu

endif else begin
    if n_elements(x3) gt 0 then temp=TEMPORARY(x3)
    if n_elements(cy3) gt 0 then temp=TEMPORARY(cy3)
endelse

if n_elements(x3) ge 2 then begin
    CPI_N=fltarr(n_elements(x3))
    CPI_L=fltarr(n_elements(x3))
    CPI_A=fltarr(n_elements(x3))
    CPI_M=fltarr(n_elements(x3))

    for j=0,n_elements(x3)-1,2 do begin

        if J+1 eq n_elements(x3)-1 then somarr4=where(use_Dcor3 ge x3[j] and use_adj3 ge 1) else somarr4=where(use_Dcor3 lt x3[j+1] and use_Dcor3 ge x3[j] and use_adj3 ge 1)

        if n_elements(somarr4) ge 2 then begin

            ; if n_elements(somarr4) ne mincntsperbin then print,'!!counts per first bin = ',n_elements(somarr4),' !!while min counts per bin = ',mincntsperbin $
            ; ,' j = ',j,' n_elements(x3) = ',n_elements(x3)

            N_=total(use_adj3(somarr4))
            L_=total(use_Dcor3(somarr4)*use_adj3(somarr4))
            A_=Total(use_Acor3(somarr4)*use_adj3(somarr4))
            M_=Total(mass(somarr4))
            ;M_sph=Total(mass_sph(somarr4))

            CPI_N[j]=FFF_i*FFF_x*N_/sampV_IMG/(x3[j+1]-x3[j])                           ;#/liter/um
            CPI_N[j+1]=FFF_i*FFF_x*N_/sampV_IMG/(x3[j+1]-x3[j])
            CPI_L[j]=FFF_i*FFF_x*L_/sampV_IMG/(x3[j+1]-x3[j])                           ;microns/liter/um
            CPI_L[j+1]=FFF_i*FFF_x*L_/sampV_IMG/(x3[j+1]-x3[j])
            CPI_A[j]=FFF_i*FFF_x*A_/sampV_IMG/1000000./(x3[j+1]-x3[j])                    ;mm2/liter/um
            CPI_A[j+1]=FFF_i*FFF_x*A_/sampV_IMG/1000000./(x3[j+1]-x3[j])
            CPI_M[j]=FFF_i*FFF_x*M_/sampV_IMG/(x3[j+1]-x3[j])                           ;mg/liter/um
            CPI_M[j+1]=FFF_i*FFF_x*M_/sampV_IMG/(x3[j+1]-x3[j])
            ;vals[3,1,j]=FFF_i*FFF_x*M_sph/sampV_IMG/(x3[j+1]-x3[j])                         ;mg/liter/um
            ;vals[3,1,j+1]=FFF_i*FFF_x*M_sph/sampV_IMG/(x3[j+1]-x3[j])

        endif else begin
            ;assuming we are on last bin now and it had too few
            x3=x3[0:n_elements(x3)-3]
            cy3=cy3[0:n_elements(x3)-1]
            CPI_N=CPI_N[0:n_elements(x3)-1]
            CPI_L=CPI_L[0:n_elements(x3)-1]
            CPI_A=CPI_A[0:n_elements(x3)-1]
            CPI_M=CPI_M[0:n_elements(x3)-1]
        endelse
    endfor

    print,'SCALING working for other PSDs in combpsd.pro? max deviation = ',max(CPI_N-cy3)

endif


COMBiwc_cpi=0.0
cCPI_conc=0.0
ext_cpi=0.0
ext_cpi_a=0.0
num_cpi_a=0.0
den_cpi_a=0.0
num_cpi_b=0.0
den_cpi_b=0.0
Z_cpi=0d0
COMBiwc_cpi_M=0.0
if n_elements(x3) ge 2 then begin
    CPI_IWC,x3,cy3,use_adj3,use_Acor3,use_wid3,use_len3,use_perim3,COMBiwc_cpi,cCPI_conc,use_Dcor3
    ;stop;  I suspected that these two COMBiwc is different.
    ;**********************************************************************************
    scale_conc=0.0
    for i=0,n_elements(x3)-1,2 do scale_conc=scale_conc+(x3(i+1)-x3(i))*cy3(i)    ;#/L
    CPI_conc=total(use_adj3)
    FFF=scale_conc/CPI_conc
    COMBiwc_cpi=FFF*total(Mass);* should time a factor of FFF=total(adjs)/integration of (x3,cy3)
    cCPI_conc  =scale_conc
    ;************************************************************************************

    CPI_IWC_M_II, x3,cy3,COMBiwc_cpi_M,cCPI_conc_M
    ext_cpi=2.0*FFF_i*FFF_x*total(use_adj3*use_Acor3)/sampV_IMG/1000000.0 ;in /Km
    for i=0,n_elements(x3)-1,2 do begin
        cc=(x3(i)+x3(i+1))/2.
        num_cpi_a=num_cpi_a+(x3(i+1)-x3(i))*cy3(i)*(cc/2.)^3.0
        den_cpi_a=den_cpi_a+(x3(i+1)-x3(i))*cy3(i)*(cc/2.)^2.0
        ext_cpi_a=ext_cpi_a+2.0*((x3(i+1)-x3(i))*cy3(i)) * !pi*((cc/2.)^2.)/1000000.0   ;in /Km
        ;Z_cpi=Z_cpi+(x3(i+1)-x3(i))*(cy3(i)*1000.)*((min([(0.24/0.9)*(0.917^2.0),(0.24/0.9)*(0.07^2.0)*(cc/1000.)^(-2.2)]))^2.0)*(cc/1000.)^6.0     ;mm6/m3
        Z_cpi=Z_cpi+(x3(i+1)-x3(i))*(cy3(i)*1000.)*(min([(0.24/0.9)*(0.917^2.0),(0.24/0.9)*(0.07^2.0)*(cc/1000.)^(-2.2)]))*(cc/1000.)^6.0     ;mm6/m3
    endfor
    Vol=COMBiwc_cpi*10.^9./.917                         ;in um3 per Liter
    Proj_Area=FFF_i*FFF_x*total(use_adj3*use_Acor3)/sampV_IMG  ;in um2 per Liter
    ;Reff_b=0.75*Vol/Proj_Area
    num_cpi_b=0.75*Vol/!pi
    den_cpi_b=Proj_Area/!pi
endif

;if n_elements(x3) ge 2 and n_elements(xFSSP) ge 2 then oplot,x3,cy3,color=0 else if n_elements(x3) ge 2 then plot_oo,x3,cy3,color=0, $
;ytitle='#/L/um',title=strt_date+'   '+sHH+':'+sMM+':'+sSS+'-'+eHH+':'+eMM+':'+eSS,xtitle='size (microns)',xrange=[1,10000],ystyle=1,yrange=[0.0000001,1000000]
;if n_elements(xFSSP) ge 2 and n_elements(x3) ge 2 then oplot,[xFSSP[n_elements(xFSSP)-1],x3[0]],[yFSSP[n_elements(xFSSP)-1],cy3[0]],color=0

if n_elements(x3) ge 2 then begin
    if comb_PSD_x[0] ne -1 then begin
        comb_PSD_x=[comb_PSD_x,x3]
        comb_PSD_y=[comb_PSD_y,cy3]
        comb_PSD_L=[comb_PSD_L,CPI_L]
        comb_PSD_A=[comb_PSD_A,CPI_A]
        comb_PSD_M=[comb_PSD_M,CPI_M]
    endif else begin
        comb_PSD_x=x3
        comb_PSD_y=cy3
        comb_PSD_L=CPI_L
        comb_PSD_A=CPI_A
        comb_PSD_M=CPI_M
    endelse
endif

;and now do 2DC

if n_elements(x2dc) ge 2 then begin
    CPI_IWC_M_II, x2dc,y2dc,COMBiwc_2dc_M,c2DC_conc_M
    ;if n_elements(x3) ge 2 or n_elements(xFSSP) ge 2 then oplot,x2dc,y2dc,color=0 else plot_oo,x2dc,y2dc,color=0, $
    ;ytitle='#/L/um',title=strt_date+'   '+sHH+':'+sMM+':'+sSS+'-'+eHH+':'+eMM+':'+eSS,xtitle='size (microns)',xrange=[1,10000],ystyle=1,yrange=[0.0000001,1000000]
    ;if n_elements(x3) ge 2 then oplot,[x3[n_elements(x3)-1],x2dc[0]],[cy3[n_elements(cy3)-1],y2dc[0]],color=0 $
    ;else if n_elements(xFSSP) ge 2 then oplot,[xFSSP[n_elements(xFSSP)-1],x2dc[0]],[yFSSP[n_elements(xFSSP)-1],y2dc[0]],color=0
    ext_2dc=0.0
    ext_2dc_a=0.0
    COMBiwc_2dc=0.0
    num_2dc_b=0.0
    den_2dc_b=0.0
    num_2dc_a=0.0
    den_2dc_a=0.0
    c2DC_conc=0.0
    Z_2dc=0d0
    for i=0,n_elements(x2dc)-1,2 do begin
        cc=(x2dc(i)+x2dc(i+1))/2.
        num_2dc_a=num_2dc_a+(x2dc(i+1)-x2dc(i))*y2dc(i)*(cc/2.)^3.0
        den_2dc_b=den_2dc_b+(x2dc(i+1)-x2dc(i))*A2dc(i)
        den_2dc_a=den_2dc_a+(x2dc(i+1)-x2dc(i))*y2dc(i)*(cc/2.)^2.0
        c2DC_conc=c2DC_conc+(x2dc(i+1)-x2dc(i))*y2dc(i)
        COMBiwc_2dc=COMBiwc_2dc+(x2dc(i+1)-x2dc(i))*M2dc(i)   ;yikes bug here!!!???
        ext_2dc_a=ext_2dc_a+2.0*((x2dc(i+1)-x2dc(i))*y2dc(i)) * !pi*((cc/2.)^2.)/1000000.0   ;in /Km
        ;Z_2dc=Z_2dc+(x2dc(i+1)-x2dc(i))*(y2dc(i)*1000.)*((min([(0.24/0.9)*(0.917^2.0),(0.24/0.9)*(0.07^2.0)*(cc/1000.)^(-2.2)]))^2.0)*(cc/1000.)^6.0              ;mm6/m3
        Z_2dc=Z_2dc+(x2dc(i+1)-x2dc(i))*(y2dc(i)*1000.)*(min([(0.24/0.9)*(0.917^2.0),(0.24/0.9)*(0.07^2.0)*(cc/1000.)^(-2.2)]))*(cc/1000.)^6.0             ;mm6/m3
        L2dc[i]=y2dc(i) * cc      ;um/L/um
        L2dc[i+1]=L2dc[i]
    endfor
    ext_2dc=2*den_2dc_b                   ;/Km
    den_2dc_b=den_2dc_b*1000.*1000./!pi         ;convert from mm2 to um2 and divide by pi
    Vol_2=COMBiwc_2dc*10.^9./.917                           ;in um3 per Liter
    num_2dc_b=0.75*Vol_2/!pi

endif else begin
    COMBiwc_2dc_M=0.0
    c2DC_conc_M=0.0
    ext_2dc=0.0
    ext_2dc_a=0.0
    COMBiwc_2dc=0.0
    num_2dc_b=0.0
    den_2dc_b=0.0
    num_2dc_a=0.0
    den_2dc_a=0.0
    c2DC_conc=0.0
    Z_2dc=0.0
endelse

if (COMBiwc_fssp lt 0.0 or COMBiwc_cpi lt 0.0 or COMBiwc_cpi_M lt 0.0 or COMBiwc_2dc_M lt 0.0 or COMBiwc_2dc lt 0.0) then begin
    print,'!!!!YIKES a IWC is less than 0.0!!!!!!!!  tell Brad'
endif
COMBiwc=COMBiwc_fssp+COMBiwc_cpi+COMBiwc_2dc
COMBiwc_M=COMBiwc_fssp+COMBiwc_cpi_M+COMBiwc_2dc_M

print,'COMBiwc_fssp & COMBiwc_cpi & COMBiwc_2dc',COMBiwc_fssp,COMBiwc_cpi,COMBiwc_2dc
print,'COMBiwc_fssp & COMBiwc_cpi_M & COMBiwc_2dc_M',COMBiwc_fssp,COMBiwc_cpi_M,COMBiwc_2dc_M
COMBconc=cFSSP_conc+cCPI_conc+c2DC_conc
if c2DC_conc_M ne c2DC_conc then print,'c2DC_conc_M not = c2DC_conc',c2DC_conc_M,c2DC_conc,' Tell Brad!'
Z_i=Z_2dc+Z_cpi+Z_fssp
dBZ=10.0*ALOG10(Z_i)

;fact=total(TStms)/(n_elements(TStms)*COMBconc)
;TStms_scaled=TStms/(fact)

if COMBiwc lt 0.0001 then COMBiwc = 0.0
;xyouts,5,100000,'TWC = '+strmid(strtrim(float(COMBiwc),2),0,6)+' g/m3',color=0,charsize=1.5
;if COMBconc ge 100 then xyouts,70,20000,'conc='+strtrim(round(COMBconc),2)+' #/L',color=0,charsize=1.5 else $
;if COMBconc ge 0.0001 then xyouts,70,20000,'conc='+strmid(strtrim(float(COMBconc),2),0,6)+' #/L',color=0,charsize=1.5 else $
;xyouts,70,20000,'conc'+'<0.0001'+' #/L',color=0,charsize=1.5

ext=ext_fssp+ext_cpi+ext_2dc
ext_a=ext_fssp+ext_cpi_a+ext_2dc_a
print,'ext_fssp=',ext_fssp,' ext_cpi=',ext_cpi,' ext_2dc=',ext_2dc,' ext_cpi_a=',ext_cpi_a,' ext_2dc_a=',ext_2dc_a
Reff_a=(num_fssp+num_cpi_a+num_2dc_a)/(den_fssp+den_cpi_a+den_2dc_a)
Vol=COMBiwc*10.^9./.917               ;in um3 per Liter
Proj_Area=ext*1000000./2.     ;in um2 per Liter
Reff_b=0.75*Vol/Proj_Area     ; um
Reff_test=(num_fssp+num_cpi_b+num_2dc_b)/(den_fssp+den_cpi_b+den_2dc_b)
print,'Reff_b = ',Reff_b,' Reff_test = ',Reff_test,' Reff_a = ',Reff_a
;if ext lt 0.0001 then ext = 0.0
;xyouts,80,5000,'Extinction='+strmid(strtrim(float(ext),2),0,6)+'/Km',color=0,charsize=1.5
;if Reff_a lt 0.0001 then Reff_a = 0.0
;xyouts,90,1000,'Reff_a='+strmid(strtrim(float(Reff_a),2),0,6)+'microns',color=0,charsize=1.5
;if Reff_b lt 0.0001 then Reff_b = 0.0
;xyouts,90,300,'Reff_b='+strmid(strtrim(float(Reff_b),2),0,6)+'microns',color=0,charsize=1.5

;xyouts,100,100,'Z = '+strtrim(round(dBZ),2)+' dB',color=0,charsize=1.5

if n_elements(x2dc) ge 2 then begin
    if comb_PSD_x[0] ne -1 then begin
        comb_PSD_x=[comb_PSD_x,x2dc]
        comb_PSD_y=[comb_PSD_y,y2dc]
        comb_PSD_L=[comb_PSD_L,L2dc]
        comb_PSD_A=[comb_PSD_A,A2dc]
        comb_PSD_M=[comb_PSD_M,M2dc]
    endif else begin
        comb_PSD_x=x2dc
        comb_PSD_y=y2dc
        comb_PSD_L=L2dc
        comb_PSD_A=A2dc
        comb_PSD_M=M2dc
    endelse
endif

temparr=where(comb_PSD_y gt 10d^(-100d))
max_size=comb_PSD_x[max(temparr)]
min_y=min(comb_PSD_y[where(comb_PSD_y gt 0.0)])

;if max_size gt 10000 then $
;plot_oo,comb_PSD_x,comb_PSD_y,color=0,ytitle='#/L/um',title=strt_date+'   '+sHH+':'+sMM+':'+sSS+'-'+eHH+':'+eMM+':'+eSS, $
;xtitle='size (microns)',xrange=[1,max_size+1000.],ystyle=1,xstyle=1,yrange=[0.00000001,1000000] else $
;plot_oo,comb_PSD_x,comb_PSD_y,color=0,ytitle='#/L/um',title=strt_date+'   '+sHH+':'+sMM+':'+sSS+'-'+eHH+':'+eMM+':'+eSS, $
;xtitle='size (microns)',xrange=[1,10000],ystyle=1,xstyle=1,yrange=[0.0000001,1000000]

;xyouts,5,100000,'TWC = '+strmid(strtrim(float(COMBiwc),2),0,6)+' g/m3',color=0,charsize=1.5
;if COMBconc ge 100 then conc_str=strtrim(round(COMBconc),2)+'#/L' else $
;if COMBconc ge 0.0001 then conc_str=strmid(strtrim(float(COMBconc),2),0,6)+'#/L' else $
;conc_str='<0.0001#/L'

;if ext lt 0.0001 then ext = 0.0
;xyouts,80,5000,'Extinction='+strmid(strtrim(float(ext),2),0,6)+'/Km',color=0,charsize=1.5
;if Reff_a lt 0.0001 then Reff_a = 0.0
;xyouts,90,1000,'Reff_a='+strmid(strtrim(float(Reff_a),2),0,6)+'microns',color=0,charsize=1.5
;if Reff_b lt 0.0001 then Reff_b = 0.0
;xyouts,90,300,'Reff_b='+strmid(strtrim(float(Reff_b),2),0,6)+'microns',color=0,charsize=1.5

;xyouts,100,100,'Z = '+strtrim(round(dBZ),2)+' dB',color=0,charsize=1.5

;xyouts,0.20,0.20,/normal,'Conc='+conc_str+' Reff_a='+strmid(strtrim(float(Reff_a),2),0,6)+'um' $
;+' Reff_b='+strmid(strtrim(float(Reff_b),2),0,6)+'um'+' Ext='+strmid(strtrim(float(ext),2),0,6)+'/Km',charsize=1.0,color=0
;xyouts,0.20,0.16,/normal,'TWC='+strmid(strtrim(float(COMBiwc),2),0,6)+'g/m3'+' Z='+strtrim(round(dBZ),2)+' dB',charsize=1.0,color=0
;xyouts,0.60,0.01,/normal,'break points: '+strmid(strtrim(float(cut_l),2),0,6)+','+strmid(strtrim(float(left),2),0,6)+',' $
;+strmid(strtrim(float(right),2),0,6)+','+strmid(strtrim(float(cut_r),2),0,6),charsize=0.75,color=0

;oplot,comb_PSD_x,comb_PSD_y,color=53687,line=2

;print,'good? y/n'
;read,good,prompt='y/n'

x2dc=x2dc_orig
y2dc=y2dc_orig
L2dc=y2dc_orig
A2dc=A2dc_orig
M2dc=M2dc_orig

;endwhile

;printf,17,format='(A20,F6.3,A10,F6.3,A9,F11.3,A15,F7.3,A17,F7.3,A11,F7.2,A11,F7.2,A6,F6.1,A3,A12,F8.1)', $
;'Combined PSD: TWC = ',COMBiwc,'  TWC_M = ',COMBiwc_M,'  conc = ',COMBconc,'  Extinction = ',ext,'  Extinction_a = ', $
;ext_a,'  Reff_a = ',Reff_a,'  Reff_b = ',Reff_b, '  Z = ',dBZ,' dB',' Max size = ',max_size

vals=fltarr(4,2,n_elements(comb_PSD_x))
for i=0,n_elements(comb_PSD_x)-1,2 do begin
    cc=(comb_PSD_x(i)+comb_PSD_x(i+1))/2.
    vals[0,1,i:i+1]=comb_PSD_y[i]
    vals[1,1,i:i+1]=comb_PSD_y[i]*cc     ;um/L/um
    vals[2,1,i:i+1]=(!pi*comb_PSD_y[i]*cc^2.0)/4000000.0
    vals[3,1,i:i+1]=((4./3.)*!pi*comb_PSD_y[i]*cc^3.0)/8000000000.0
endfor
vals[0,0,*]=comb_PSD_y
vals[1,0,*]=comb_PSD_L   ;um/L/um
vals[2,0,*]=comb_PSD_A
vals[3,0,*]=comb_PSD_M
end  ; end of du_combpsd.pro
;*********************************************************************************************

;*************************************************************************************

PRO CPI_IWC_M_II, xpts,vals,CPIiwc_M,CPI_conc

    CPI_conc=0.0
    CPIiwc_M=0.0
    for i=0,n_elements(xpts)-1,2 do begin
        cc=(xpts(i)+xpts(i+1))/2.
        if cc lt 200 then CPIiwc_M=CPIiwc_M+(xpts(i+1)-xpts(i))*(vals(i)/1000.)*(4./3.)*!pi*((cc/20.)^3.)*0.000917 else $
            CPIiwc_M=CPIiwc_M+(xpts(i+1)-xpts(i))*vals(i)*0.022*((cc/1000.)^2.0)            ; g/m3
        CPI_conc=CPI_conc+(xpts(i+1)-xpts(i))*vals(i)                      ;#/L
    endfor

END
;***************************************************************************************************************

PRO CPI_IWC,xpts,vals,adj,A,W,L,P,CPIiwc,CPI_conc,D

    ;xpts and vals need to be input in #/L/um (already FFFed) inorder to properly scale the iwc here

    scale_conc=0.0
    for i=0,n_elements(xpts)-1,2 do scale_conc=scale_conc+(xpts(i+1)-xpts(i))*vals(i)   ;#/L

    CPI_conc=total(adj)
    FFF=scale_conc/CPI_conc
    CPI_conc=scale_conc

    ;CPIiwc_1= adj * (0.16) * ((A/1000000.) * (W/1000.) * [2.0 * (L + W)/P])^(0.83)    ;mg 128 particle anal
    ;CPIiwc_1= adj * (0.1387) * ((A/1000000.) * (W/1000.) * [2.0 * (L + W)/P])^(0.8026)    ;mg 537 particle anal
    CPIiwc_1= adj * (0.13515) * ((A/1000000.) * (W/1000.) * [2.0 * (L + W)/P])^(0.79287)    ;mg 864 particle anal
    ;if change here then also in du_other_psds.pro and du_spice_habits.pro and du_comb_psd.pro and du_all_other_psds_compared.pro
    ;and IWCcals_compared.pro and du_habits.pro and du_minihabits.pro and build_cor_matrices...? also search on coef #s

    ;CPIiwc_2=adj * 0.917 * (!pi*4.0/3.0) * ((L+W)/4000.)^3.0                   ;mg
    CPIiwc_2=adj * 0.917 * (!pi*4.0/3.0) * ((D)/2000.)^3.0                 ;mg
    test=where(CPIiwc_1 gt CPIiwc_2)

    CPIiwc_3=CPIiwc_1
    if test[0] ne -1 then CPIiwc_3[test] = CPIiwc_2[test]

    ;CPIiwc = FFF * total( adj * (0.16) * ((A/1000000.) * (W/1000.) * [2.0 * (L + W)/P])^(0.83) )    ;mg/L or g/m3
    ;print,'old= ',CPIiwc,' or ',FFF*total(CPIiwc_1),' new= ',FFF*total(CPIiwc_3),' spheres= ',FFF*total(CPIiwc_2)
    ;print,'min mean max of L are',min(L),mean(L),max(L)
    ;if test[0] ne -1 then print,'min mean max of L[test] > are',min(L(test)),mean(L(test)),max(L(test))

    CPIiwc=FFF*total(CPIiwc_3)

    ;CPIiwc_w=0.0
    ;CPI_conc_w=0.0
    ;for i=0,n_elements(xpts)-1,2 do begin
    ;  cc=(xpts(i)+xpts(i+1))/2.
    ;  CPIiwc_w=CPIiwc_w+(xpts(i+1)-xpts(i))*(vals(i)/1000.)*(4./3.)*!pi*((cc/20.)^3.)*0.000917        ; g/m3
    ;  CPI_conc_w=CPI_conc_w+(xpts(i+1)-xpts(i))*vals(i)
    ;endfor
    ;print,'CPI_conc_w = ',CPI_conc_w,'  CPIiwc_w = ',CPIiwc_w
    ;print,'CPI_conc = ',CPI_conc,'  CPIiwc = ',CPIiwc

END
