PRO ROIHistogram_condspectra_event, event

    FORWARD_FUNCTION  WriteHistogram_condspectra

    WIDGET_CONTROL, event.top, GET_UVALUE= LocalState,/no_copy
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of

        ; Handle a kill request.
        'WIDGET_KILL_REQUEST':begin
        pGroup = find_first_link(LocalState.pGroup)
        while( ptr_valid((*pGroup).next_link) ) do begin
            pNext_link = (*pGroup).next_link
            deleteGroup,pGroup
            pGroup = pNext_link
        endwhile

        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin

    ; Handle a sizing request
    'WIDGET_BASE':begin
    WIDGET_CONTROL, event.top, XSIZE =1000, YSIZE =800  ; added by mo sept 9,2004
    WIDGET_CONTROL, LocalState.MainView, XSIZE = 780, YSIZE =560
    PlotHistogram_condspectra, LocalState
    WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
    return
end

else: begin

    ; a normal event

    WIDGET_CONTROL, event.id, GET_UVALUE = eventval
    CASE eventval OF    ; Note that pos  is not equal Pos, it is case_senitive
        'pos':begin
        widget_control,LocalState.position, get_value = pos
        localState.grpNum = pos
        Localstate.pGroup = (*LocalState.pGroupPtr)[pos-1]
        PlotHistogram_condspectra, LocalState
    end ;end of eventval= pos
    'Brk2': begin
        LocalState.Brk2 = event.value
        PlotHistogram_condspectra, LocalState
    end ; end of eventval= mincntsperbin

    'Brk1': begin
        LocalState.Brk1 = event.value
        PlotHistogram_condspectra, LocalState
    end ; end of binszie


    'WFJorONE': begin
        LocalState.WfjorOne = event.value
        PlotHistogram_condspectra, LocalState
    end

    'PRINT': BEGIN

        IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

        IF LocalState.PrinterSetup THEN PlotHistogram_condspectra, LocalState, OutPutFlags=1
    END

    'SAVETIFF': PlotHistogram_condspectra, LocalState, OutPutFlags=2

    'PRINTALL': BEGIN
        IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

        IF LocalState.PrinterSetup THEN BEGIN
            pGroup = find_first_link(LocalState.pGroup)
            LocalState.pGroup = pGroup
            FOR i=1, LocalState.grpCnt DO BEGIN
                PlotHistogram_condspectra, LocalState, OutPutFlags=1
                LocalState.pGroup =  (*LocalState.pGroup).next_link
            ENDFOR
            ; redisplay first
            LocalState.pGroup =  pGroup
            PlotHistogram_condspectra, LocalState
        ENDIF
    END  ; end of printall

    'SAVE': Ret = WriteHistogram_condspectra(LocalState)

    ; 'OPEN': Ret = ReadHistogram_condspectra(LocalState)

    'QUIT': BEGIN
        pGroup = find_first_link(LocalState.pGroup)
        while( ptr_valid((*pGroup).next_link) ) do begin
            pNext_link = (*pGroup).next_link
            deleteGroup,pGroup
            pGroup = pNext_link
        endwhile
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;endof quit
    ELSE:
ENDCASE ; end of event.id case
end
endcase ; end of sname case

WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
END

;============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output

PRO PlotHistogram_condspectra, LocalState, OutPutFlags=OutPutFlags
    called_save_png=0
    called_print_png=0
    ; pGroup is a pointer to a structured linked list for this plot
    pGroup = localState.pGroup
    Dvect=*(*pgroup).pDvect
    Wvect=*(*pgroup).pWvect
    Nvect=*(*pgroup).pNvect
    ZFrmcont=*(*pgroup).pZFrmcont
    Nmax=max(Nvect)
    ;find out the frameI counts {x,y}=xframe,frameconts
    if Nmax lt 4 then Npoints=5 else Npoints=Nmax+2
    frameconts=lonarr(Npoints)
    partwconts=lonarr(Npoints)
    part1conts=lonarr(Npoints)
    for i=1,Nmax do begin
        index=where(Nvect eq i,counts)
        frameconts(i)=float(counts)/float(i);      ;for N_imgs=2 the Nvect is twice.
        part1conts(i)=counts
        if counts gt 0 then partwconts(i)=total(Wvect(index)) else partwconts(i)=0
    endfor
    frameconts(0)=Zfrmcont
    xframe=indgen(Npoints)

    ;calculate  poison distribution
    ave=n_elements(Dvect)/float(total(Frameconts))
    poisson=dblarr(n_elements(Frameconts))
    k=dindgen(n_elements(Frameconts))
    for i=0,n_elements(k)-1 do poisson[i]=ave^k[i] * exp(-1.*ave) / factorial(k[i])
    poisson=poisson*total(Frameconts)

    brk1=localstate.brk1
    brk2=localstate.brk2
    if brk1 gt Nmax then brk1=Nmax
    if brk2 gt Nmax then brk2=Nmax

    ;find 0 to Frame brk1 particles
    index=where(Nvect le brk1,contN)
    if contN gt 0 then  begin
        Dcor1=Dvect(index)
        WFJ1 =Wvect(index)
    endif else begin
        Dcor1=[0,0]
        WFJ1=[0,0]
    endelse

    ;find brk2 to Frame Nmax particles
    index=where(Nvect ge brk2,contN)
    if contN gt 0 then  begin
        Dcor2=Dvect(index)
        WFJ2 =Wvect(index)
    endif else begin
        Dcor2=[0,0]
        WFJ2=[0,0]
    endelse

    N_tot=round(total(Wvect))
    if localstate.wfjorone eq 1 then begin
        WFJ1=WFJ1*0.0+1.0
        WFJ2=WFJ2*0.0+1.0
        N_tot=round(n_elements(Dvect))
        partwconts=part1conts
    end
    N1=round(total(WFJ1))
    N2=round(total(WFJ2))

    cpiview_unihist_adj, Dcor1,2,1,x1,cy1,WFJ1
    cpiview_unihist_adj, Dcor2,2,1,x2,cy2,WFJ2
    local1=0.0
    for i=0,n_elements(x1)-1,2 do local1=local1+(x1(i+1)-x1(i))*cy1(i)
    local2=0.0
    for i=0,n_elements(x2)-1,2 do local2=local2+(x2(i+1)-x2(i))*cy2(i)

    if local1 ne 0.0 then y1=100.0*cy1/local1 else y1=cy1*0.0
    if local2 ne 0.0 then y2=100.0*cy2/local2 else y2=cy2*0.0

    ; Default is to send ouput to plot only
    IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

    t = ConvertFromSeconds((*pGroup).StartTime, LocalState.year)
    Time = strtrim(t.month,2)+'/'+strtrim(t.day,2)+' '+strtrim(t.hour,2)+':'+strtrim(t.minute,2)+':'+strtrim(t.sec,2)
    Time = STRING(FORM='("Period: ",A, " StartTime: ",A,"  Time =", I5, " sec")',strtrim(LocalState.GrpNum,2),time,LocalState.SumSecs)
    if t.month lt 10 then mm='0'+strtrim(round(t.month),2)  else mm=strtrim(round(t.month),2)
    if t.day lt 10 then dd='0'+strtrim(round(t.day),2) else dd= strtrim(round(t.day),2)
    ScreenFilename=mm+dd+'_'+strtrim(t.hour,2)+'-'+strtrim(t.minute,2)+'-'+strtrim(t.sec,2)+'_cond_PSD.png'
    ; Display Time info
    WIDGET_CONTROL, LocalState.TopLabelID, SET_VALUE=Time

    ;if( max(*(*pGroup).pData) eq 0) then begin
    if( not ptr_valid((*pgroup).pDvect) ) then begin
        return
    endif

    ; New Plot
    ;*****************************************************************************************
    startplot: donothing=0
    TopLabel = 'Particle Per Frame Distribution'

    WSET, LocalState.MViewID
    erase

    !P.multi=[0,1,3]

    PLOT,xframe,Frameconts, COLOR=Color, YRANGE=[0,max(Frameconts)*1.1],$
        YTITLE='Number of occurences', Xstyle = 1,$
        TITLE=TopLabel,THICK=1, Ystyle=1,charsize=2.0,$
        position=[0.07,0.61,0.45,0.96]
    oplot,xframe,Frameconts,color=color,psym=6
    oplot,[brk1,brk1],[0,max(Frameconts)*1.1],color=color,line=1
    oplot,[brk2,brk2],[0,max(Frameconts)*1.1],color=color,line=1
    xyouts,Npoints*0.4,0.8*max(Frameconts),'Ntot='+strtrim(N_tot,2),color=color,charsize=1.0
    oplot,xframe,poisson,color=color,line=1

    ymax=max(Partwconts)*1.1
    if ymax lt 2.0 then  ymax=10.0
    PLOT,xframe,partwconts, COLOR=Color, YRANGE=[0,ymax],$
        YTITLE='Number of Particles', XTITLE='Number/frame', Xstyle = 1,$
        THICK=1, Ystyle=1,charsize=2.0, subtitle=time,$
        position=[0.07,0.12,0.45,0.57]
    xyouts,Npoints*0.6,0.90*ymax,'  N1='+strtrim(N1,2),color=color,charsize=1.0,alignment=0.5
    xyouts,Npoints*0.6,0.85*ymax,'<-----------|',color=color,charsize=1.0,alignment=0.5
    xyouts,Npoints*0.6,0.80*ymax,'#/Frm <='+strtrim(round(brk1),2),color=color,charsize=1.0,alignment=0.5
    xyouts,Npoints*0.6,0.55*ymax,'  N2='+strtrim(N2,2),color=color,charsize=1.0,alignment=0.5
    xyouts,Npoints*0.6,0.50*ymax,'|----------->',color=color,charsize=1.0,alignment=0.5
    xyouts,Npoints*0.6,0.45*ymax,'#/Frm >='+strtrim(round(brk2),2),color=color,charsize=1.0,alignment=0.5
    oplot,[brk1,brk1],[0,ymax],color=color,line=1
    oplot,[brk2,brk2],[0,ymax],color=color,line=1


    rightTitle='CPI Conditional PSD'
    Ylabel='Relative #/Liter/um'
    temp=[y1,y2]
    index=where(temp ne 0.0,contF)
    if contF ne 0 then ymin=min(temp(index),max=ymax) else ymin=min([1.0,10.0],max=ymax)
    xtitle_str='solid: <='+strtrim(round(brk1),2)+'    size,um     '+'dot:  >='+strtrim(round(brk2),2)

    PLOT,x1,y1, COLOR=Color, XRANGE=[10.0,1000.0],/xlog,/ylog,$
        YTITLE=Ylabel, XTITLE=xtitle_str, Xstyle = 1,charsize=2.0,ystyle=1,$
        TITLE=rightTitle,THICK=1, YRANGE=[10.0^floor(Alog10(ymin)),10.0^ceil(Alog10(ymax))],$
        position=[0.55,0.12,0.97,0.96], subtitle=ScreenFilename
    oplot,x2,y2,color=color,line=1,thick=3

    if called_save_png eq 1  then goto, BacktoSavePng
    if called_print_png eq 1 then goto,BacktoPrintPng


    ; Save image file?
    IF (OutPutFlags AND 2)/2  THEN BEGIN
        ; Create a filename  in case for saving the pngs file.
        ; Get Path
        NamePos = RSTRPOS(LocalState.InFileName, '.')
        IF NamePos GE 0 THEN BEGIN
            FileName = STRMID(LocalState.InFileName, 0, NamePos)
            FileName = FileName + '_' + strtrim((*pGroup).StartTime,2)
        ENDIF ELSE FileName = strtrim((*pGroup).StartTime,2)

        FileName = FileName + '_Cond_PSD.png'
        ;*************************************************************************************************
        ; stop
        called_save_png=1
        goto, startplot
        BacktoSavePng: donothing=0
        ;***************************************************************************************************
        ; Read in screen
        Buf = TVRD()
        ;Invert colors
        Indx = WHERE(Buf GT 0, Count)
        Buf[*] = 255
        IF Count GT 0 THEN Buf[Indx] = 0
        ;WRITE_TIFF, FileName, Buf;, 1, RED=r, GREEN=g, BLUE=b
        buf = rotate(temporary(buf),7)
        WRITE_png, FileName, Buf, bindgen(256),bindgen(256),bindgen(256)
    ENDIF 
    ;******************end of save imge file

    ; Print it?
    IF OutPutFlags AND 1 THEN BEGIN
        IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()
        ; Switch to PRINTER output
        SET_PLOT, 'PRINTER'
        DEVICE, /LANDSCAPE
        tvlct,r,g,b,/get
        loadct,0
        ;****************************************************************************
        called_print_png=1;   not need for this part.
        goto, startplot
        BacktoPrintPng: donothing=0
        ;*****************************************************************************
        DEVICE, /CLOSE_DOCUMENT
        ; Switch back to display output
        SET_PLOT, 'WIN'
        tvlct,r,g,b
    ENDIF
    ;reset the window for 1
    !P.multi=[0,1,1]
END


;=================================================================================
;================================================================================
;===============================================================================
FUNCTION WriteHistogram_condspectra, LocalState, FILENAME=FileName

    ; Get file name from user?
    IF (not keyword_set(FileName))THEN FileName = DIALOG_PICKFILE(FILTER='*.txt', TITLE="Select cond_spectra Histogram Data File")

    dotloc = rstrpos(filename,'.')
    if(dotloc eq -1)then filename = filename + '.txt'

    IF( FileName eq '') THEN RETURN, -10

    Openw, DFileUnit, FileName, /Get_lun, ERROR = err
    IF (err NE 0) THEN BEGIN
        PRINT, !ERR_STRING
        return, -2
    ENDIF

    if localstate.WFJorOne eq 1 then WFJorONE_str='  1  ' else WFJorONE_str=' wfj '
    PRINTF, DFileUnit,format='(A7,1x,A6,1x,A6,1x,A13,1x,A13)', '#OfGrps','T_Step', 'ScaleType','Break_Point_1','Break_Point_2'
    PRINTF, DFileUnit,format='(A7,1x,A6,1x,A6,1x,A13,1x,A13)', strtrim(LocalState.grpCnt,2),strtrim(LocalState.sumsecs,2),$
        wfjorone_str,strtrim(LocalState.brk1,2),strtrim(LocalState.BRK2,2)
    ; Write the data  next line's pgroup is the first group. becasreful.
    pGroup = find_first_link(LocalState.pGroup)   ; pgroup is a pointer, *pgroup contains a structure.
    ;*************************************************   September 4, 2004
    ;calculated the PSD value for output
    get_cond_spectra_values,Pgroup,localstate,Frameconts,x1,y1,x2,y2,N1,N2,N_tot,strtTime
    ;**********************************************************************************

    FOR j=1, LocalState.grpCnt DO BEGIN
        printF,DFileUnit,format='(A60)','==========================================================================='
        printF,DFileUnit,format='(A8,2x,A22,4x,A16,4x,A16)','StrtTime','Particle counts: N_tot','N1(#/Frm <=brk1)','N2(#/FRm >=brk2)'
        printF,DFileUnit,format='(A14,9x,I8,1x,I8,13x,I8)', strtrim(StrtTime,2),   N_tot,    N1,    N2
        ;print out the #/Frame index and the counts.
        printF,DFileUnit,format='(A10,2x,A10)','#/frame','Counts'
        index=where(Frameconts ne 0, conts)
        if conts gt 0 then begin
            numPF= index
            numcnts=Frameconts(index)
            for i=0,conts-1 do begin
                printF,DFileUnit,format='(F10.0,2x,F10.0)',numpF(i),numcnts(i)
            endfor
            ;print out the x,y1,x2,y2 and pad the short array with same number
            printF,DFileUnit,format='(A12,2x,A12,2x,A12,2x,A12)','Binedge1','binheight1','Binedge2','binheight2'
            length1=n_elements(x1)
            length2=n_elements(x2)
            if length1 gt length2 then begin
                nx1=x1
                ny1=y1
                nx2=x1*0
                ny2=nx2
                nx2=[x2,indgen(length1-length2-1)*0+x2(length2-1)]
                ny2=[y2,indgen(length1-length2-1)*0+y2(length2-1)]
            endif
            if length1 lt length2 then begin
                nx2=x2
                ny2=y2
                nx1=x2*0
                ny1=nx1
                nx1=[x1,indgen(length2-length1-1)*0.0+x1(length1-1)]
                ny1=[y1,indgen(length2-length1-1)*0.0+y1(length1-1)]
            endif
            for i=0,n_elements(nx1)-1 do begin
                printF,DFileUnit,format='(F12.2,2x,F12.5,2x,F12.2,2x,F12.5)',nx1(i),ny1(i),nx2(i),ny2(i)
            endfor
        endif else  printF,DFileUnit,0  ; end printing one group data.

        if j eq localstate.grpCnt then begin
            j=j+1  ; do nothing
        endif else begin
            ;start next group data
            pGroup = (*pGroup).next_link    ; *(*pgroup).pdata is a vector have particles sizes.
            ;get_the_plotData,pGroup,localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM
            if j lt localstate.grpCnt and ptr_valid(pGrouppData)then begin    ; no need to do more than grpCnt times.only that many
                ;******************************************************************
                get_cond_spectra_values,Pgroup,localstate,Frameconts,x1,y1,x2,y2,N1,N2,N_tot,strtTime
            endif

        endelse; endelse of "if j eq localstate.grpCnt then j=j+1 else begin if j lt localstate.grpCnt"
        ;*****************************************************************************************
        ;  stop
    ENDFOR
    FREE_LUN, DFileUnit
    RETURN, 0
END

;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output; Bit 2 set = ASCII file output

PRO ShowHistograms_condspectra, pStateInfo, sumSecs, GROUP=GROUP, OutPutFlags=OutPutFlags, SAMPLEVOLUME=SampleVolume, typeSCALING=typeScaling ,sizeType = sizeType

; if typeScaling is true, then use missed, otherwise use deadtime

IF N_ELEMENTS(SampleVolume) EQ 0 THEN SampleVolume = -1
IF N_ELEMENTS(MissScaling) EQ 0 THEN MissScaling = 1

; Default is to send ouput to plot, only once
IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

pGroup = (*pStateInfo).spectra.pGroup

; mo qixu comment this following lines out on oct 25 2005.
if(not ptr_valid(pGroup))then begin
    ; r=dialog_message("Error: no data to display")
    return
endif

; take ownership of this pointer info
(*pStateInfo).spectra.pGroup = ptr_new()
groupPtr = ptrarr((*pStateInfo).spectra.groupCnt)
groupPtr[0]    = pGroup
pGrp = pGroup
for i=1,(*pStateInfo).spectra.groupCnt-1 do begin
    if(ptr_valid(pGrp))then begin
        groupPtr[i]  = (*pGrp).next_link
        pGrp = (*pGrp).next_link
    endif
endfor

; build GUI
tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, /TLB_SIZE_EVENTS, /col, TITLE='conditional PSD Histograms',mbar=menuBase)

; button bar   add options label
button_bar = widget_base(tlb,/row)
bb1 = widget_base(button_bar,/row)
;  readBut = widget_button(bb1,value='open.bmp',/bitmap,uvalue='OPEN') ;ascii
saveBut = widget_button(bb1,value='Save.bmp',/bitmap,uvalue='SAVE') ;sacii
;saveBut = widget_button(bb1,value='Save txt',/bitmap,uvalue='SAVE')

bb2 = widget_base(button_bar,/row)
printBut = widget_button(bb2,value='print.bmp',/bitmap,uvalue='PRINT') ;print one file
printallBut = widget_button(bb2,value='print1.bmp',/bitmap,uvalue='PRINTALL') ; print all

bb3 = widget_base(button_bar,/row)
tiffBut = widget_button(bb3,value='freeform.bmp',/bitmap,uvalue='SAVETIFF')  ; save png
;tiffBut = widget_button(bb3,value='save png',/bitmap,uvalue='SAVETIFF')

bb4 = widget_base(button_bar,/row)
; quitBut = widget_button(bb4,value='quit.bmp',/bitmap,uvalue='QUIT')  ; quite
quitBut = widget_button(bb4,value='quit',/bitmap,uvalue='QUIT')

topbase = widget_base(tlb,/row)
if((*pStateInfo).spectra.groupCnt gt 1)then begin
    position = widget_slider(topbase,value=1,uvalue='pos',min = 1, max = (*pStateInfo).spectra.groupCnt,/suppress_value)
endif else position = -1

TopLabelID = WIDGET_LABEL(topbase, UVALUE='BottomLab', VALUE='',XSIZE=550,/align_left,font='TIMES*20*BOLD')

MAINBase = widget_base(tlb,/row)
;-----------------------------------------------------
; Image View and image-related labels
ViewBase = WIDGET_BASE(MAINBase, /COL, TITLE='ImgView', UVALUE=' ')

;MainView = WIDGET_DRAW(ViewBase, /BUTTON_EVENTS, /FRAME, /RETAIN, UVALUE='MAIN_VIEW',XSIZE=450, YSIZE=350)
MainView = WIDGET_DRAW(ViewBase, /BUTTON_EVENTS, /FRAME, /RETAIN, UVALUE='MAIN_VIEW',$
    XSIZE=820, YSIZE=560);, X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004

;-----------------------------------------------------
; Base for all buttons and radio buttons on the left side
LeftButtonsBase = WIDGET_BASE(MAINBase, /COLUMN, UVALUE='AllButtons')
;-----------------------------------------------------
; Base for options
OpsBase = WIDGET_BASE(LeftButtonsBase, /COL, /FRAME, /BASE_ALIGN_CENTER, UVALUE='ProcButtons', TITLE='Histogram Options')

BinSizeID = WIDGET_SLIDER(OpsBase,MIN=1, MAX=10, TITLE='Brk1', VALUE =1, UVALUE='Brk1')
BincntsID = WIDGET_SLIDER(OpsBase,MIN=1, MAX=10,TITLE='Brk2', VALUE =1, UVALUE='Brk2')
buttns=['wfj','1']
wfjoneID=CW_Bgroup(opsbase,buttns,/exclusive,/col,button_uvalue=[0,1],Uvalue='WFJorONE',/no_release)
widget_control,wfjoneID, set_value=0;     above 3 added oct 27, 2004.
;-----------------------------------------------------
messages=[['Note:'],$
    ['1. Wfj means small particles are counted as more than one to account for their small depth of field.'],$              '],$
    ['    '],$
    ['2. 1  means each  image is counted as 1 particle.'],$
    ['    '],$
    ['3. You can save the plot as *.txt or *.png file  or print them on paper.'],$
    ['   '],$
    ['4. High concentration region may get many images per frame,'],$
    ['   Low concentration region may get 0 to 1 image per frame.'],$
    ['  '],$
    ['5. By select brk1 & brk2, you may compare PSD of High Conc region to that of Low Conc Region.']]


textmsg=widget_text(OpsBase, value=messages,/wrap,ysize=30,/Frame)
;    text2 = WIDGET_TEXT(base, $       ;This widget belongs to 'base'.
;        VALUE = 'This text widget cannot be edited.', $
;       YSIZE = 1, /FRAME)       ;Put a frame around it.
;   above is an example
;****************************************************

;-----------------------------------------------------
; Line 1: Text labels at bottom of image view
ImgInfoL1 = WIDGET_BASE(LeftButtonsBase, /row, /MAP, TITLE='ImgInfo', UVALUE='ImgInfoBase')

; Read in the pixel size
WIDGET_CONTROL, (*pStateInfo).PixSizeID, GET_VALUE=PixSize

FileName = (*pStateInfo).InFileName

WIDGET_CONTROL, MAINBase, /REALIZE

; Get drawable window index
WIDGET_CONTROL, MainView, GET_VALUE=MainViewID

LocalState = { pGroup:pGroup,$           ; ptr to first link in list
    year:(*pStateInfo).fileHead.year,$;    year of data
    pGroupPtr:ptr_new(groupPtr),$  ; pointer to array of all group pointer links
    brk1:1,$   ;for conditional spectra break point.
    brk2:1,$  
    SumSecs:SumSecs,$          ; secs to average over
    MainView:MainView, $      ; draw window widget ID
    MViewID:MainViewID, $       ; draw window ID
    InFileName:FileName, $        ; main .roi data file name
    TypeScaling:typeScaling, $     ; keyword
    sizeType:sizeType,$          ; keyword for size type
    grpNum:1,$               ; group number
    grpCnt:(*pStateInfo).spectra.groupCnt,$; number of groups
    PixSize:PixSize, $          ; pixel size from GUI
    appname:(*pStateInfo).appname,$       ; name of application = 'CpiView'
    position:position,$          ; widgetID of position slider
    BinSizeID:BinSizeID, $        ; bin size slider widget ID
    BincntsID:BincntsID, $        ; mincntsPerbin  slider widget ID
    TopLabelID:TopLabelID, $     ; widget ID for bottom label1 to hold time info
    PrinterSetup:0, $
    SampleVolume:SampleVolume,$;} ; sample volume passed in via keyword
    wfjorone:0}
; Save ASCII file?
IF((OutPutFlags AND 4)/4)THEN BEGIN
    ; Create a filename
    ; Get Path
    NamePos = RSTRPOS(LocalState.InFileName, '.')
    IF(NamePos ne '') THEN BEGIN
        FileName = STRMID(LocalState.InFileName, 0, NamePos)
        FileName = FileName + '_' + strtrim((*pGroup).StartTime,2)
    ENDIF ELSE FileName = strtrim((*pGroup).StartTime,2)

    FileName = FileName + '_Cond_PSD.txt'
    Ret = WriteHistogram_condspectra(LocalState, FILENAME=FileName)
ENDIF

if((OutPutFlags and 2)/2)then begin
    ; output TIFFs
    pGroup = find_first_link(LocalState.pGroup)
    pFirst = pGroup
    LocalState.pGroup = pGroup
    FOR i=1, LocalState.grpCnt DO BEGIN
        PlotHistogram_condspectra, LocalState, OutPutFlags=2
        LocalState.pGroup =  (*LocalState.pGroup).next_link
    ENDFOR
    LocalState.pGroup = pFirst

endif


if((OutPutFlags and 1)/1)then begin
    IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

    IF LocalState.PrinterSetup THEN BEGIN
        pGroup = find_first_link(LocalState.pGroup)
        pFirst = pGroup
        LocalState.pGroup = pGroup
        FOR i=1, LocalState.grpCnt DO BEGIN
            PlotHistogram_condspectra, LocalState, OutPutFlags=1
            LocalState.pGroup =  (*LocalState.pGroup).next_link
        ENDFOR
        LocalState.pGroup = pFirst
    ENDIF
endif

; Show 1st plot
PlotHistogram_condspectra, LocalState

; Save state
WIDGET_CONTROL, tlb, SET_UVALUE=LocalState,/no_copy

; Hand off control of the widget to the XMANAGER:
XMANAGER, 'ROIHistogram_condspectra', tlb, /NO_BLOCK

END

;**************************************************************************
pro  get_cond_spectra_values,Pgroup,localstate,Frameconts,x1,y1,x2,y2,N1,N2,N_tot,StrtTime
    ; pGroup is a pointer to a structured linked list for this plot
    Dvect=*(*pgroup).pDvect
    Wvect=*(*pgroup).pWvect
    Nvect=*(*pgroup).pNvect
    ZFrmcont=*(*pgroup).pZFrmcont
    Nmax=max(Nvect)
    ;find out the frameI counts {x,y}=xframe,frameconts
    if Nmax lt 4 then Npoints=5 else Npoints=Nmax+2
    frameconts=lonarr(Npoints)
    partwconts=lonarr(Npoints)
    part1conts=lonarr(Npoints)
    for i=1,Nmax do begin
        index=where(Nvect eq i,counts)
        frameconts(i)=counts
        part1conts(i)=counts
        if counts gt 0 then partwconts(i)=total(Wvect(index)) else partwconts(i)=0
    endfor
    frameconts(0)=Zfrmcont
    xframe=indgen(Npoints)

    brk1=localstate.brk1
    brk2=localstate.brk2
    if brk1 gt Nmax then brk1=Nmax
    if brk2 gt Nmax then brk2=Nmax

    ;find 0 to Frame brk1 particles
    index=where(Nvect le brk1,contN)
    if contN gt 0 then  begin
        Dcor1=Dvect(index)
        WFJ1 =Wvect(index)
    endif else begin
        Dcor1=[0,0]
        WFJ1=[0,0]
    endelse

    ;find brk2 to Frame Nmax particles
    index=where(Nvect ge brk2,contN)
    if contN gt 0 then  begin
        Dcor2=Dvect(index)
        WFJ2 =Wvect(index)
    endif else begin
        Dcor2=[0,0]
        WFJ2=[0,0]
    endelse

    N_tot=round(total(Wvect))
    if localstate.wfjorone eq 1 then begin
        WFJ1=WFJ1*0.0+1.0
        WFJ2=WFJ2*0.0+1.0
        N_tot=round(n_elements(Dvect))
        partwconts=part1conts
    end
    N1=round(total(WFJ1))
    N2=round(total(WFJ2))

    cpiview_unihist_adj, Dcor1,2,1,x1,cy1,WFJ1
    cpiview_unihist_adj, Dcor2,2,1,x2,cy2,WFJ2
    local1=0.0
    for i=0,n_elements(x1)-1,2 do local1=local1+(x1(i+1)-x1(i))*cy1(i)
    local2=0.0
    for i=0,n_elements(x2)-1,2 do local2=local2+(x2(i+1)-x2(i))*cy2(i)

    if local1 ne 0.0 then y1=100.0*cy1/local1 else y1=cy1*0.0
    if local2 ne 0.0 then y2=100.0*cy2/local2 else y2=cy2*0.0

    t = ConvertFromSeconds((*pGroup).StartTime, LocalState.year)
    StrtTime = strtrim(t.month,2)+'/'+strtrim(t.day,2)+' '+strtrim(t.hour,2)+':'+strtrim(t.minute,2)+':'+strtrim(t.sec,2)

end; end of  get_cond_spectra_values,Pgroup,localstate,Frameconts,x1,y1,x2,y2
;*******************************************************************************
