;*********************************************************
pro auto_bead_size_calibration,ptr
    ; on oct 27, 2006.  *************
    ; do the table 35 first

    tablenumber='Alexeis_table35.txt'
    Tablehead='Xbin35';      need to change X to I or O

    calculate_L7_of_all_H_andV_particlesTable,tablenumber
    calculate_L8_of_all_H_andV_particlesTable,tablenumber
    ; get the 8 traces
    get_psd_trace1to8v2,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    draw_averaged_8psds,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    save_psd_pngTable,tableHead,ptr
    write_compare_psd_asciiTable,tablehead,ptr
    ;stop

    tablenumber='Alexeis_table40.txt'
    Tablehead='Xbin40'

    calculate_L7_of_all_H_andV_particlesTable,tablenumber
    calculate_L8_of_all_H_andV_particlesTable,tablenumber
    ; get the 8 traces
    get_psd_trace1to8v2,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    draw_averaged_8psds,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    save_psd_pngTable,tableHead,ptr
    write_compare_psd_asciiTable,tablehead,ptr
    ;stop

    tablenumber='Alexeis_table45.txt'
    Tablehead='Xbin45'

    calculate_L7_of_all_H_andV_particlesTable,tablenumber
    calculate_L8_of_all_H_andV_particlesTable,tablenumber
    ; get the 8 traces
    get_psd_trace1to8v2,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    draw_averaged_8psds,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    save_psd_pngTable,tableHead,ptr
    write_compare_psd_asciiTable,tablehead,ptr
    ;stop

    tablenumber='Alexeis_table50.txt'
    Tablehead='Xbin50'

    calculate_L7_of_all_H_andV_particlesTable,tablenumber
    calculate_L8_of_all_H_andV_particlesTable,tablenumber
    ; get the 8 traces
    get_psd_trace1to8v2,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    draw_averaged_8psds,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    save_psd_pngTable,tableHead,ptr
    write_compare_psd_asciiTable,tablehead,ptr
    ;stop

    tablenumber='Alexeis_table60.txt'
    Tablehead='Xbin60'

    calculate_L7_of_all_H_andV_particlesTable,tablenumber
    calculate_L8_of_all_H_andV_particlesTable,tablenumber
    ; get the 8 traces
    get_psd_trace1to8v2,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    draw_averaged_8psds,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    save_psd_pngTable,tableHead,ptr
    write_compare_psd_asciiTable,tablehead,ptr
    ;stop

    tablenumber='Alexeis_table40_special1.txt'
    Tablehead='Xbin40_special1'

    calculate_L7_of_all_H_andV_particlesTable,tablenumber
    calculate_L8_of_all_H_andV_particlesTable,tablenumber
    ; get the 8 traces
    get_psd_trace1to8v2,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    draw_averaged_8psds,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    save_psd_pngTable,tableHead,ptr
    write_compare_psd_asciiTable,tablehead,ptr

    ; done the in or Out of focus cases.

end; ******* do this just for bead size works.


;********************************************************
pro save_psd_pngTable,tableHead,ptr
    Widget_Control, (*ptr).psddrawid, Get_Value=wid  ; get the window ID for drawing.
    ave_info=(*ptr).ave_info
    ;get the output file name.
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'png\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "png\"
    outputfilename=!currentHPname+'png\'+tablehead+'_PSD_CMP_'+plot_string+'.png'
    wset,wid
    write_png,outputfilename,tvrd(true=1)
end; end of save_psd_pngTable,Tablehead, ptr
;************************************************************
pro write_compare_psd_asciiTable,tablehead,ptr

    ;get the output file name.
    ave_info=(*ptr).ave_info
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'asscii\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "ascii\"
    outputfilename=!currentHPname+'ascii\'+tablehead+'_PSD_CMP_'+plot_string+'.txt'
    ;open file to write
    openw, 88,outputfilename
    printf,88,'PSD_compare psd plot file generated at   ',systime()
    printf,88,ave_info.binfilename;  ;input_filename
    printf,88,'Time period is:  ',ave_info.plot_string
    printf,88,'The criteria applied to get the subset of data is:'
    printf,88,ave_info.criteria.label
    printf,88,'Bins are fixed into 200 bins, 400 binheights'
    printf,88,'The 8 traces are in the following  order:'
    ;***********************************************
    aaa=strsplit( (*ptr).psdlabels.y1, ':',/extract)
    s1=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y2, ':',/extract)
    s2=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y3, ':',/extract)
    s3=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y4, ':',/extract)
    s4=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y5, ':',/extract)
    s5=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y6, ':',/extract)
    s6=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y7, ':',/extract)
    s7=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y8, ':',/extract)
    s8=strjoin(aaa(0:2),'-')
    ;************************************************
    printf,88,format='(9A11)','xbin_edges',s1,s2,s3,s4,s5,s6,s7,s8
    y1=(*ptr).psdvalues.y1
    y2=(*ptr).psdvalues.y2
    y3=(*ptr).psdvalues.y3
    y4=(*ptr).psdvalues.y4
    y5=(*ptr).psdvalues.y5
    y6=(*ptr).psdvalues.y6
    y7=(*ptr).psdvalues.y7
    y8=(*ptr).psdvalues.y8
    xpts=(*ptr).psdvalues.xpts
    for i=0,399 do begin
        printf,88,format='(F8.1,1x,7(E11.4,1x),E11.4)',xpts(i),y1(i),y2(i),y3(i),y4(i),y5(i),y6(i),y7(i),y8(i)
    endfor
    close,88
end; ;end of write_compare_tms_asciiTable,TableHead,ptr
;***********************************************************************

pro calculate_L7_of_all_H_andV_particlesTable,tablenumber
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

    ;first do H-particles
    L4=(*alldataH).L4
    L1n=(*alldataH).L1n
    L5=(*alldataH).L5

    roundness=L1n gt 0.49*L5 and L5 gt 0.49*L1n
    (*alldataH).roundness=roundness*1.0

    Area=(*alldataH).Area
    Alexei1=(*alldataH).alexei1

    ;calculate teh focus value.
    A1C=Alexei1
    indexC1=where(Alexei1 le 0, contC1)
    if contC1 gt 0 then begin
        A1C(indexC1)=100
        focus=float(Area)/A1C
        focus(indexC1)=0.0
    endif  else begin
        focus=float(Area)/A1C
    endelse
    (*alldataH).focus=focus

    index7=where(L4 le 0.0 or alexei1 le 0.0,cont7)
    if cont7 gt 0 then begin
        alexei7=alexei1
        area7=area
        alexei7(index7)=10
        area7(index7)=10
        Get_alexei_correct_sizetable,tablenumber,Alexei7,area7,L4*10,L7;  L7 in unit 10um.
        L7(index7)=0.0;  throw these index7 particles away.
        ;L7=round(L7/10.0+0.5);   L7 changed back to pixels.
    endif else begin
        Get_alexei_correct_sizeTable,Tablenumber,Alexei1,tablenumber,area,L4*10,L7
        ;L7=round(L7/10.0+0.5);   L7 changed back to pixels.
    endelse
    (*alldataH).L7=L7/10.0
    ;********************************************************************
    ;now do V-particles
    L4=(*alldataV).L4
    L1n=(*alldataV).L1n
    L5=(*alldataV).L5

    roundness=L1n gt 0.49*L5 and L5 gt 0.49*L1n
    (*alldataV).roundness=roundness*1.0


    Area=(*alldataV).Area
    Alexei1=(*alldataV).alexei1

    ;calculate teh focus value.
    A1C=Alexei1
    indexC1=where(Alexei1 le 0, contC1)
    if contC1 gt 0 then begin
        A1C(indexC1)=100
        focus=float(Area)/A1C
        focus(indexC1)=0.0
    endif else begin
        focus=float(Area)/A1C
    endelse
    (*alldataV).focus=focus

    index7=where(L4 le 0.0 or alexei1 le 0.0,cont7)
    if cont7 gt 0 then begin
        alexei7=alexei1
        area7=area
        alexei7(index7)=10
        area7(index7)=10
        Get_alexei_correct_sizeTable,tablenumber,Alexei7,area7,L4*10,L7;  L7 in unit 10um.
        L7(index7)=0.0;  throw these index7 particles away.
        ;L7=round(L7/10.0+0.5);   L7 changed back to pixels.
    endif else begin
        Get_alexei_correct_sizeTable,tablenumber,Alexei1,area,L4*10,L7

        ;L7=round(L7/10.0+0.5);   L7 changed back to pixels.
    endelse
    (*alldataV).L7=L7/10.0

end; end of calculate_L&_of_all_H_and_V_particles
;***********************************************************
pro calculate_L8_of_all_H_andV_particlesTable,tablenumber
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    ;first do H-particles
    L4=(*alldataH).L4
    L1n=(*alldataH).L1n
    Area=(*alldataH).Area
    Alexei1=(*alldataH).alexei1

    ;replace L4 with L4n to do L8 calculation.
    indexnn=where(L1n eq 0, contGN4)
    if contGN4 gt 0 then begin
        L1n(indexnn)=10
        L4n= 2.0*sqrt(Area*L4/L1n/!pi)
    endif else L4n=2.0*sqrt(Area*L4/L1n/!pi)

    index8=where(L4n le 0.0 or alexei1 le 0.0,cont8)
    if cont8 gt 0 then begin
        alexei8=alexei1
        area8=area
        alexei8(index8)=10
        area8(index8)=10
        Get_alexei_correct_sizeTable,tablenumber,Alexei8,area8,L4n*10,L8;  L8 in unit 10um.

        L8(index8)=0;  throw these index7 particles away.
        ;L8=round(L8/10.0+0.5);   L7 changed back to pixels.
    endif else begin
        Get_alexei_correct_sizetable,tablenumber,Alexei1,area,L4n*10,L8
        ;L8=round(L8/10.0+0.5);   L7 changed back to pixels.
    endelse
    (*alldataH).L8=L8/10.0
    ;********************************************************************
    ;first do V-particles
    L4=(*alldataV).L4
    L1n=(*alldataV).L1n
    Area=(*alldataV).Area
    Alexei1=(*alldataV).alexei1

    ;replace L4 with L4n to do L8 calculation.
    indexnn=where(L1n eq 0, contGN4)
    if contGN4 gt 0 then begin
        L1n(indexnn)=10
        L4n= 2.0*sqrt(Area*L4/L1n/!pi)
    endif else L4n=2.0*sqrt(Area*L4/L1n/!pi)

    index8=where(L4n le 0.0 or alexei1 le 0.0,cont8)
    if cont8 gt 0 then begin
        alexei8=alexei1
        area8=area
        alexei8(index8)=10
        area8(index8)=10
        Get_alexei_correct_sizeTable,tablenumber,Alexei8,area8,L4n*10,L8;  L8 in unit 10um.

        L8(index8)=0;  throw these index7 particles away.
        ; L8=round(L8/10.0+0.5);   L7 changed back to pixels.
    endif else begin
        Get_alexei_correct_sizeTable,tablenumber,Alexei1,area,L4n*10,L8

        ; L8=round(L8/10.0+0.5);   L7 changed back to pixels.
    endelse
    (*alldataV).L8=L8/10.0; in units of pixels.
    ;********************************************************************
end; end of calculate_L&_of_all_H_and_V_particles
;***********************************************************
pro Get_alexei_correct_sizeTable,Tablenumber,Dmax,Dimg,sizes_L4,SizeDo
    ;input Dmax-----maximium area of the alexei's  90 or 0 degree counter area; chris_code curr_data.alexei1
    ;input Dimg-----total area of the image, curr_data.Area from chris code.
    ;input sizes_L4-------sizes using L4   and using L8 size also.
    ;output sizeDo ----the corrected size of the particle.----Sept 14, 2005.

    get_alexeis_tableTable,tablenumber,Ratio_DmDo,Ratio_DpDm; teh ration tells
    ; the relation of Dimg, Dpson spot, and the apparent size and true size
    indexGT=where(Dimg-Dmax gt 0.0,contGT)
    if contGT gt 0 then begin
        rrr=dialog_message('Dimg greater than Dmax !!! '+string(contGT)+'Times',/information)
        Dimg(indexGT)=Dmax(indexGT)
    endif

    ratio=sqrt(1.0-float(Dimg)/float(Dmax));   ; it is a vector of the imput variables.
    nnn=n_elements(ratio);   in Rico flight 4, there is one case dimg=3, Dmax=2.
    rdmdo=fltarr(nnn)
    for i=0LL,nnn-1LL do begin
        values=abs(ratio(i)-Ratio_DpDm)
        minv=min(values)
        index=where( values eq minv)
        rdmdo(i)=Ratio_DmDo(index(0))
    endfor;    ;sizes_L4 can be L8 also as of DEc 7, 2005.
    sizeDo=sizes_L4/(rdmdo ); >1.0) ; sizeDo is not multiple of 10. in unit of um.
end; end of pro Get_alexei_correct_size,Dmax,Dimg,SizeDo
;get alexeis table
;***********************************************************
pro get_alexeis_tableTable,tablenumber,Ratio_DmDo,Ratio_DpDm
    ; filename=dialog_pickfile(filter='Alexeis_table.txt')
    a3vcpiviewloc = strpos(!path,'2DSVIEW')
    end_semicolonloc = strpos(!path,';',a3vcpiviewloc)
    start_semicolonloc = strpos(!path,';',a3vcpiviewloc,/reverse_search)
    length=end_semicolonloc-start_semicolonloc-1
    a3vcpiviewPath = strmid(!path,start_semicolonloc+1,length)

    filename=a3vcpiviewPath+'\'+tablenumber; Alexeis_table.txt'
    data=read_ascii(filename,data_start=4)

    Ratio_DmDo=transpose(data.field1(1,*))
    ;Ratio_DiDm=transpose(data.field1(2,*))
    Ratio_DpDm=transpose(data.field1(4,*))
end;**************end of get_alxeis_table
;**************************************************
