pro load_navigation_time_tas_two_column_data
    common TASBlock, extTime,extTas
    ;filename=dialog_pickfile(filter='Alexeis_table.txt')
    ;filename=a2dsviewPath+'\Alexeis_table.txt'

    ;first find the file,  if the file is not found, prompt user to input it
    ; the navigtaion data files should be always in the same directory as teh sorted_****.2DS file.
    ; the sorted***.2DS  is in directory !currentHPname
    strs=strsplit(!currentHPname,'\',/extract)
    last_part_length=strlen(strs( n_elements(strs)-1 ))
    up_pathname=strmid(!currentHPname,0,strlen(!currentHPname)-last_part_length-1)

    filter_str=up_pathname+'*TAS.txt'
    ;filter_str='*TAS.txt'

    filenames=dialog_pickfile(filter='*TAS.txt')
    ;xxx=findfile(filter_str,COUNT=file_count2)

    file_count=n_elements(filenames)

    if strlen(filenames(0)) le 6 then begin
        !use_external_TAS =0
        rrr=dialog_message(' You have choose no to use externla TAS files !!',/info)
        return
    end

    if file_count eq 1 and strlen(filenames(0)) ge 7 then  begin
        ;filename='yyyymmddhhmmssTAS.txt'
        filename=filenames(0)
        ; see if the filename is correct or not.
        ;sub_strs=strsplit(filename,'\',/extract)
        ;name_length=strlen(sub_strs(n_elements(sub_strs)-1))
        ;if name_length ne 21 then begin
        ;   rrr=dialog_message('Navigtaion data file name is not correct !, rename it ands try again',/information)
        ;   rrr=dialog_message('I will quit !!!',/information)
        ;stop
        ; endif else begin
        data=read_ascii(filename,data_start=0)
        extTime=transpose(data.field1(0,*));  ; 0 is the first field ==first column.
        exttas    =transpose(data.field1(1,*))

        if extTime(0) ge 86400LL then extTime=extTime-86400LL

        ;      endelse
    endif
    if file_count ge 2 then begin
        rrr=dialog_message('There are more than two navigation TAS data files, please choose the correct data file !!!',/information)
        filename=dialog_pickfile(title='pick a yyyymmddhhmmssTAS.txt file',filter='*TAS.txt',Get_path=pathnm)
        sub_strs=strsplit(filename,'\',/extract)
        name_length=strlen(sub_strs(n_elements(sub_strs)-1))
        if name_length ne 21 then begin
            rrr=dialog_message('Navigtaion data file name is not correct !, rename it ands try again',/information)
            rrr=dialog_message('I will quit !!!',/information)
            ;stop
        endif else begin
            data=read_ascii(filename,data_start=0)
            extTime=transpose(data.field1(0,*))
            exttas    =transpose(data.field1(1,*))
        endelse
    endif

end;**************end of load_navigtaion_time_tas_two_column_data
;**************************************************
