; added this  prgram on 2012-01-12   to do stormVex processing

pro read_3VCPI_sortedfile_N_make_png_pages_batch_fast
    Common  DataBlock,alldataH,alldataV

    forward_function SPEC_Nano2HMS

    ; TAF NOTE 2013-09-30 not implemented with pointers yet

    stop

    define_sysv;  ; define all system variables.

    currentFname = ""
    currentPname = ""
    currentFnameV = ""
    currentPnameV = ""
    datestamp = ""
    statusID=0

    dataColorName = "Red"
    axisColorName = "Navy"
    backcolorName = "White"
    colortable = 4
    colortable = 0 > colortable < 40
    imagecolors = !D.Table_Size-4

    TotalParticles = 0UL

    tlb = Widget_Base(Column=1, TLB_Size_Events=1, Title="SPEC 2DSView - Version 0.92", MBar=menubarID, /KBRD_Focus_Events,  /CONTEXT_EVENTS )

    starting_window_x = 250
    starting_window_y = 100

    drawID = Widget_Draw(tlb,XSize=starting_window_x, YSize=starting_window_y)
    Widget_Control, tlb, /Realize
    device, CURSOR_STANDARD= !ARROW_CURSOR

    ; Bring main window to current focus

    Widget_Control, drawID, Get_Value=wid
    WSet, wid

    erase,color='ffffff'x  ; get background to white

    ; Create the info structure with the information
    ; required to run the program.

    info = { axisColorName:axisColorName, $   ; The name of the axis color.
        backColorName:backcolorName, $   ; The name of the background color.
        dataColorName:datacolorName, $   ; The name of the data color.
        drawID:drawID, $                 ; The identifier of the draw widget.
        currentFname:currentFname, $     ; If not "", then the currently opened file
        currentPname:currentPname, $     ; If not "", then the currently opened file
        currentFnameV:currentFnameV, $     ; If not "", then the currently opened file
        currentPnameV:currentPnameV, $     ; If not "", then the currently opened file
        datestamp:datestamp, $           ; the yymmddhhmmss part of the file we're currently working on
        statusID:statusID, $             ; for access to status bar from events
        TotalParticles:TotalParticles, $
        wid:wid}; The window index number of the graphics window.

    info.currentFname = ""
    info.wid = tlb

    ; set xscale and yscale to the size of the window (and change this when we resize)
    ; Add the Status bar to the bottom of the window
    BASE_Status = WIDGET_BASE(tlb, $
        COLUMN=3, $
        FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Status', $
        ;BASE_ALIGN_CENTER=1, $
        ;ALIGN_BOTTOM=1, $
        YSIZE=20      )

    info.statusID = WIDGET_LABEL(BASE_Status,VALUE="Status bar                         ")


    ;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    cd,'D:\storm_vex_data_process',current=Wkdir


    filename=dialog_pickfile(filter='*sorted*.2DSCPI',get_path=pathnm)
    !currentHPname=pathnm
    pathnm=file_dirname(filename)+'\'
    filter_str='Sorted*.2DSCPI'

    get_all_data_filenames,filter_str,pathnm,filenames,file_count

    cd, wkdir

    for kkkk=0L, file_count-1L do begin
        inputfile=filenames(kkkk)
        !currentHFname=file_basename(inputfile)

        start_a_new_page,my_png_pageV
        start_a_new_page,my_png_pageH

        OpenR, lun, inputfile, /Get_Lun

        ;info={totalParticles:0UL};  info is already define before this line.
        info.TotalParticles=0UL
        errcount = 0L

        struct = {_DerivedDataRev2, $
            PartID: 0 , $
            Nanosecsold:0ULL , $
            NanoSeconds:0ULL , $
            ImageOffset: 0UL , $
            ImageWords: 0 , $
            Area: 0.0 , $
            Nslice: 0 , $
            L2: 0 , $
            F1: 0 , $
            Adj1: 0.0, $
            Pc1: 0.0, $
            TAS: 0.0, $
            ProbeCounter:0ULL, $
            L3: 0.0, $
            L4: 0, $
            L5: 0, $
            PC3x: 0.0, $
            PC3y: 0.0, $
            PC4x: 0.0, $
            PC4y: 0.0, $
            A3: 0.0, $
            Alexei1: 0.0, $
            Alexei2: 0L, $
            reject: byte(0), $
            w8_t: 0LL, $
            L7: 0.0, $
            L8: 0.0, $
            roundness: 0.0, $
            focus: 0.0, $
            warn: 0.0, $  ; some day we will change this to byte value to svae memory.
            adj0: 1.0, $  ;added on May 8-2007 for w8_t cleaning.
            noisebyte:byte(0),$;; added in June 2007.
            AccDTtick:0ULL,$   ; added on oct5 2007
            w8_t_clean:0LL, $; added on oct5,2007.
            L1n: 0.0, $;    ; added on nov 9, 2007.
            largest_satellite_area: 0.0, $    ;added dec19,2007
            alexei1old: 0.0, $ ;added dec19,2007
            TASold: 0.0, $    ; added dec19,2007
            Spare_16: 0.0, $
            Spare_17: 0.0, $
            Spare_18: 0.0, $
            Spare_19: 0.0, $
            Spare_20: 0.0,$
            CPI_trigger: 0}
        ;add this tempary to fix the bug for generating the zoomed ascii
        ;**************************************************************************
        struct_ascii = {_AsciiData, $
            Nanosecsold:0ULL , $
            NanoSeconds:0ULL , $
            Area: 0.0 , $
            Nslice: 0 , $
            L2: 0 , $
            F1: 0 , $
            Adj1: 0.0, $
            Pc1: 0.0, $
            TAS: 0.0,$    ;added more in the following on oct 14 , 2005 by mo for outputing ascii data file.
            ProbeCounter:0ULL, $
            L3: 0.0, $
            L4: 0, $
            L5: 0, $
            PC3x: 0.0, $
            PC3y: 0.0, $
            PC4x: 0.0, $
            PC4y: 0.0, $
            A3: 0.0, $
            Alexei1: 0.0, $
            Alexei2: 0L,$
            L1n:0.0, $;  added nov 9, 2007.
            largest_satellite_area: 0.0, $    ;added dec19,2007
            alexei1old: 0.0, $ ;added dec19,2007
            TASold: 0.0 $    ; added dec19,2007
            }


        ;***************************************************************************



        struct2 = {_Timestamp, $
            Year: 0, $
            Month: 0, $
            Day: 0, $
            Hours: 0, $
            Minutes: 0, $
            Seconds: 0, $
            Milliseconds: 0, $
            Microseconds: 0, $
            Nanoseconds: 0 }

        horiz_count=0LL
        NanosecondsPerSecond = 1000000000ULL
        NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
        NanosecondsPerHour   = NanosecondsPerMinute * 60ULL
        NanosecondsPerDay    = NanosecondsPerHour * 24ULL
        out_array = BytArr(20000)

        ; allot memory to hold the data.
        num_data_points=1000000LL
        HGoodcount=0LL
        VGoodcount=0LL

        (*alldataH) = REPLICATE({_DerivedDataRev2},num_data_points)
        (*alldataV) = REPLICATE({_DerivedDataRev2},num_data_points)

        ;Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

        ;get the sorted file's starttime and endtime
        substrs=strsplit(inputfile,'\',/extract)
        sortedFileName=substrs(n_elements(substrs)-1)
        datetimestring=strmid(sortedFilename,6,strlen(sortedfilename)-9); =yymmddhhmmss_hhmmss_hhmmss_000x
        if strlen(datetimestring) eq 32 then begin
            subtrs=strsplit(datetimestring,'_',/extract)
            Stime=subtrs(1)
            Etime=subtrs(2)
            FSTime=(strmid(Stime,0,2)*3600LL+strmid(Stime,2,2)*60LL+strmid(Stime,4,2)*1LL)*1000000000;nanoseconds
            FETime=(strmid(Etime,0,2)*3600LL+strmid(Etime,2,2)*60LL+strmid(Etime,4,2)*1LL)*1000000000
        endif;     FStime is full-seconds say: 50045000000000LL nanoseconds. FEtime ends with 12345.999999999
        WriteH_OK=0; once the the first double-fake particle's time is readed, it is Ok to write to the bin file.
        WriteV_Ok=0


        ; Put the info structure back in its storage location.

        OpenR, lun, inputfile, /Get_Lun

        fileheader = bytarr(256)
        ReadU, lun, fileheader
        v_string = strmid(string(fileheader),4,4)
        reads, v_string, FORMAT='(%"%f")',cur_version
        if (cur_version ne 3.0) then begin
            r = dialog_message(['Warning, file you have selected is not a REV 3 SORTED file!','Use an older version of 2DSView to process this file..'],TITLE = 'File incompatible')
            close, lun
            return
        endif

        ;===========================================================
        ; Create Headers for the Ver 3.0 files
        ;===========================================================
        vheader = bytarr(256)
        vheader(*)=32 ; all spaces
        sheader = string(vheader)
        strput,sheader,'Ver 3.00 BIN PARTICLE DATA',0  ; put info on the front

        DataType = 0  ; header of all record types is an integer with repeated letters
        TimingWord = UIntArr(2)
        StartTimingWord = UIntArr(2)
        EndTimingWord = UIntArr(2)
        Masks = UIntArr(16)
        HK_ints = UIntArr(48)   ; changed from 40->52 with version 5.0
        HK_timingwords = UIntArr(2)
        HK_TAS  = 0.0
        TAS = 0.0
        Tas_H=0.0
        Tas_V=0.0
        PartID = 0
        Slices = 0U
        WordCount =  0U
        Timestamp = { _Timestamp }
        HTimestamp = { _Timestamp }
        VTimestamp = { _Timestamp }
        StartTimestamp = { _Timestamp }
        EndTimestamp = { _Timestamp }
        pos = 0UL
        Area = 0UL
        Midpoint = 0
        Edges = 0
        pxs = 0.01
        pxs_in_microns = 10.0
        dww = 63.0 ;  6300  ; 6.3cm
        sa_default = 128.0 * pxs *  dww
        strbsz = 0.01
        Rollover = 0 ; 16 bit integer
        Rollover2= 0;  16 bit integer
        ProbeCount = 0uL ; 32 bit unsigned
        ProbeCount2 = 0uL ; 32 bit unsigned
        CPI_trigger = 0 ; 16 bit integer
        temp_64 = 0ULL ; 32 bit result
        OneRollover = 4294967296ULL  ; 2^32
        onebyte = 33B

        L3 = 0.0
        L4 = 0
        L5 = 0
        PC3x = 0.0
        PC3y = 0.0
        PC4x = 0.0
        PC4y = 0.0
        A3 = 0.0
        lastH=10; keep a record of the last H particle written to the bin file.  possible values
        ; are 0, -104, -103, -101, -106, -108. 0 means it is a good particle. for wipe off decision.
        lastV=10

        ;********************************************************
        OD = {_DerivedDataRev2}
        OD_block_size= N_TAGS( OD , /DATA_LENGTH )
        ;added above so that bad-data can be deleted. Oct 4, 2006.--by mo
        ;******************************************************
        backward=0

        counter = 0L

        ;******************************************

        ;generate H png page  model and V png page model.
        ;when ever a new image is read, determin if it is a noise or good image and them output it to the png page
        ;until the sorted is read to then end.
        ;make HPC1_array  VPC1_array with 100 particle to use for stuck bit noise.


        ;******************************************

        WHILE ~ EOF(lun) DO BEGIN

            counter++
            ;if counter GT 67254L then begin
            ;print, format='(Z4)',DataType
            ; print, counter
            ;end

            ReadU, lun, DataType
            SWITCH DataType OF
                ;----------------------------
                ;added this block to handle new type of dummy particles that Chris added in september
                ;19th 2006, for those bad images ----tick or time is not monotonic.

                ; The 4 new deadtime indicaters are defined as:

                ;  V_DUMMY_DEADTIME_HEADER = &H1414 ' 5140 decimal   ; treat them as normal deadtime
                ;  H_DUMMY_DEADTIME_HEADER = &H1424 ' 5156 decimal   ; treat them as normal deadtime
                ;  V_BACKUP_DEADTIME_HEADER = &H2414 ' 9236 decimal  ; when I see this, throw out earlier
                ;  H_BACKUP_DEADTIME_HEADER = &H2424 ' 9252 decimal  ; raeded H or V particles.

                5156: ;$    ;this way all dummy_dead_times are assigned as mask_flags.
                    ;print , "H Dummmy_deadtime_header"
                    6425: $;   H_streaker_deadTime_header; no mre backup type anymore.
                    begin
                ; if datatype eq 6425 then  print, 'H_streaker_DEADTIME_HEADER'
                ; do delete last readed in H-particles from the array.
                ; point_lun,-horiz_lun, current_posH
                ; point_lun, horiz_lun,current_posH-OD_block_size
                ;    stop
                ; truncate_lun,Horiz_lun;   after we truncate it, we replaced it with the deadtime mark from the sorted
                ;    stop
                ;write out new type of fake particles -105 -106 for area
                ReadU, lun, StartTimestamp,EndTimestamp
                ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

                OD = {_DerivedDataRev2}

                lastH=-106;  -106 and -108 is of the same type.

                break
            end  ; end of H-backup-deadtime particles.
            ;***********************************************************************************
            9252: $;   H_backup_deadTime_header
                begin
            ;print, 'H_Backup_DEADTIME_HEADER'


            ; begin reading the two time stamps and counts to write two bad particles.

            ReadU, lun,  StartTimestamp,EndTimestamp
            ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
            OD = {_DerivedDataRev2}

            lastH=-110

            break
        end; end of wipping off H-bad non_monotonic data and puting a deadtime pair inside.

        27756 :;$   ; H_DEADTIME (0x6C6C)
            ;print , "H DEADTIME"
            7196 : $   ; H_MASK (0x1C1C)
            begin
        ReadU, lun, StartTimestamp,EndTimestamp
        ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

        if probecount2 eq probecount and rollover eq rollover2  then begin
            break;  added this for verion 992 on Dec 15, 2006.
        endif

        lastH=-103;   -101 and -103 is the of the same type.

        break
    end ; end of H-dead_time and H-mask

    5140: ;$   ; V_DUMMY_DEADTIME_HEADER = &H1414 ' 5140 decimal
        ;print, 'V_DUMMY_DEADTIME_HEADER'
        6168: $;   H_streaker_deadTime_header; no mre backup type anymore.
        begin
    ;if datatype eq 6168 then  print, 'V_streaker_DEADTIME_HEADER'
    ; begin reading the two time stamps and counts to write two bad particles.
    ReadU, lun,  StartTimestamp,EndTimestamp
    ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

    lastV=-106
    break
end; end of type1 and type1 V Bad Particles.
;----------------------------
9236: $;   V_backup_deadTime_header
    begin
;print, 'V_Backup_DEADTIME_HEADER'

; do delete last readed in V-particles from the array.

;****************************

; begin reading the two time stamps and counts to write two bad particles.

ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
lastV=-110
break
end; end of wipping off bad non_monotonic data and puting a deadtime pair inside.


31868 :; $   ; V_DEADTIME (0x7C7C)
    ;if datatype eq 31868 then print, "V DEADTIME"  ; won't compile without some statement here
    11308 : $   ; V_MASK (0x2C2C)
    begin
ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
lastV=-103
break
end

;----------------------------
19789 : $
    begin
ReadU, lun, TimingWord, Masks
;print , "MASK"
break
end

;----------------------------
16705 :; $  ; TAS_HEADER_V
    ;print , "V TAS",TAS
    ;----------------------------
    21588 : $  ; TAS_HEADER_H;  chris, is this the TAS change fake particle ? -104 ?
    BEGIN
ReadU, lun , TAS
if DataType eq 16705 then TAS_V=tas else TAS_H=tas; added thsi on Nov.28, 2006.

ReadU, lun, StartTimestamp, Rollover,ProbeCount
break
END


;----------------------------
19275 : $  ; HK_HEADER
    BEGIN

;print, "HK_HEADER read"

ReadU, lun , HK_ints, HK_TAS, HK_timingwords
ReadU, lun, Rollover,ProbeCount
; print , "HK", HK_TAS
break
END

;----------------------------
18504 : $  ; H_PARTICLE_HEADER
    BEGIN

;print, "H_PARTICLE_HEADER read"

ReadU, lun , PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount, CPI_trigger

HTimestamp = Timestamp
if (WordCount GE 500) then begin
    ;print, "H WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
    ;stop
end

Nanoseconds=0LL
NanoSeconds = Timestamp.Nanoseconds + $
    Timestamp.Microseconds * 1000ULL + $
    Timestamp.Milliseconds * 1000000ULL + $
    Timestamp.Seconds * NanosecondsPerSecond + $
    Timestamp.Minutes * NanosecondsPerMinute + $
    Timestamp.Hours * NanosecondsPerHour
;--------------------------------------------------------------------------------------
; We'd like (in 2DS executable) to trap all goofy particles before they are placed into the SORTED
;  file but as new DSP error or data transmission errors occur, we may miss some. So
;  we are forced to double check here. If the particle slice count or integer data word
;  couint is zero, we clearly cannot proceed to create zero length arrays. However,
;  we still need to read the image, if there is one. So we force Slices =1000 to avoid
;  doing processing that would crash this program, and we ignore this particle.
;--------------------------------------------------------------------------------------
;if (Wordcount gt 0 and Slices gt 0) then begin

;if(wordcount eq 2 and slices eq 2) then begin
;   stop
;endif

if (Wordcount gt 0 and Slices gt 0) then begin
    ;HImage = BytArr(WordCount * 2)
    ;HSums = IntArr(Slices)
    ;out_byte_array = BytArr(128L, Slices)
    ;out_array = bytarr(16L * Slices)
    ;HMax  = 0

    ;****************************************************
    Catch, onError
    IF onError NE 0 THEN BEGIN
        Catch, /Cancel
        result = Error_Message(Traceback=1)
        out_array=0
    ENDIF
    out_array=0

    out_array = bytarr(16L * Slices)           ; 128 bits = 16 bytes * 8 bits
    out_byte_array = BytArr(128L, Slices)

    HImage = BytArr(WordCount * 2)
    HSums = IntArr(Slices)

    HMax  = 0

endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, HImage

; debugging check for some weird crashes
if(wordcount eq 2 and slices eq 2) then begin
    if(himage[0] eq 0 and himage[1] eq 0 and himage[2] eq 0 and himage[3] eq 0) then begin
        stop
    endif
endif


if (Slices LT 1000) then begin
    Err=0

    nstop = 2

    ;ProcessParticle, HImage, HSums, out_array, out_byte_array, Wordcount, Slices,  HMax, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3

    ProcessParticle,  HImage, out_array, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3
    d = 0
    find_Image_Parameters, out_byte_array, d  ; this is to find alexi1 max area.


    if (Err EQ 0) then begin

        Info.TotalParticles++
        ;a = string( format = '("Particles Read:" , I3)',info.TotalParticles)
        if info.TotalParticles mod 1000 EQ 0 then print,string( format = '("Particles Read:" , I8)',info.TotalParticles)

        dof = 0.0D
        particle_in_microns = WordCount * 10
        dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm

        sa_actual = (127.0 +  particle_in_microns/pxs_in_microns) * pxs * min([dww,dof])
        ; sa_default = 128.0 * pxs *  dww

        ; time interval is the 32 bit tick interval times the # slices
        clock_interval = 0.000010 / TAS

        adj1 = sa_default/sa_actual     ; change the above to this line im May 17th, 2006.

        OD = {_DerivedDataRev2}

        OD.PartID = PartID
        OD.NanoSeconds = Timestamp.Nanoseconds + $
            (Timestamp.Microseconds * 1000ULL) + $
            (Timestamp.Milliseconds * 1000000ULL) + $
            (Timestamp.Seconds * NanosecondsPerSecond) + $
            (Timestamp.Minutes * NanosecondsPerMinute) + $
            (Timestamp.Hours * NanosecondsPerHour)
        OD.Nanosecsold=OD.nanoseconds ;= Timestamp.Year * 12 + Timestamp.Month
        OD.ImageOffset = pos
        OD.ImageWords = WordCount
        OD.Area = Area
        OD.Nslice = Slices
        OD.L2 = HMax
        OD.F1 = Edges
        OD.Adj1 = adj1
        OD.Pc1 = Midpoint
        OD.TAS = TAS_H
        OD.ProbeCounter = Rollover * OneRollover + ProbeCount
        OD.L3 = L3
        OD.L4 = L4
        OD.L5 = L5
        OD.PC3x = PC3x
        OD.PC3y = PC3y
        OD.PC4x = PC4x
        OD.PC4y = PC4y
        OD.A3 = A3
        OD.Alexei1= d
        OD.CPI_trigger = CPI_trigger
        ;update L1n, adj1, area and alexei1 by HK_tas coorections.
        ;**********************************************************
        this_time=float(OD.nanoseconds)/1000000000.0
        ;indx8=where(HKseconds ge this_time and HKseconds le this_time+1.0,contN)
        factor=1.0

        ;if contN gt 0 then factor=((HKtas(indx8(0))/170.0) > 1.0)  else factor=1.0

        This_L1n=(OD.Nslice+randomu(seed)-0.5)*factor

        OD.L1n    =This_L1n
        OD.area   =area*factor
        OD.alexei1=   d*factor

        ;now re-calculated adj1 values.
        dof = (5.13 * This_L1n*this_L1n) / 10.0D ;; convert to mm
        sa_actual = (127.0 + This_L1n) * pxs * min([dww,dof])
        OD.adj1= sa_default/sa_actual

        ;***********************************************************
        ;if OD.tas gt 0.0 then $
        ;WRITEU, horiz_lun, OD
        lastH=0
        horiz_count++
        ;stop
        ; if timestamp.hours eq 15 and timestamp.minutes eq 33 and timestamp.seconds eq 45 then begin
        ; print,slices
        ; print,Himage
        ; print,timestamp.milliseconds
        ; print,OD.probecounter
        ;  stop
        ; endif


        !HPC1_array=[!HPC1_array(1:99),OD.PC1];  : this is a circle holder for the last 100 particles for Statistical noise
        ;now determine if the Particle is noise  or dot_Line or big splashas.
        Find_out_if_this_particle_bad,!HPC1_array,OD.PC1,OD.Nslice,OD.L2,OD.L4,OD.L5,area, OD.alexei1,Good

        if Good eq 1 then begin
            ;write data to (*alldataH)
            (*alldataH)(Hgoodcount)=OD

            ;get_this_image_and_text,'V',Slices,wordcount,Vimage, dimg,dispsize,my_text_string,nanoseconds
            HGoodcount++;               ; imput is Vimg, 'V'; return is dimg ect.


            dimg=rotate(out_byte_array,1)
            my_text_string=SPEC_Nano2HMS(OD.nanoseconds)
            dispsize=size(dimg,/dimension)
            output_png_images_to_my_png_page, my_png_pageH,'H',dimg,dispsize,my_text_string,nanoseconds,timestamp
        endif



    Endif ; end of if Err eq 0

endif else begin  ; endif of if slices Lt 1000.
    ;print, "Error H Slices =", Slices ,"  at ",counter
end

break


END

;----------------------------
22102 : $  ; V_PARTICLE_HEADER
    BEGIN

;print, "V_PARTICLE_HEADER read"

ReadU, lun , PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount, CPI_trigger

VTimestamp = Timestamp
if (WordCount GE 500) then begin
    ;    print, "V WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
end
Nanoseconds=0LL
NanoSeconds = Timestamp.Nanoseconds + $
    Timestamp.Microseconds * 1000ULL + $
    Timestamp.Milliseconds * 1000000ULL + $
    Timestamp.Seconds * NanosecondsPerSecond + $
    Timestamp.Minutes * NanosecondsPerMinute + $
    Timestamp.Hours * NanosecondsPerHour

;--------------------------------------------------------------------------------------
; We'd like (in 2DS executable) to trap all goofy particles before they are placed into the SORTED
;  file but as new DSP error or data transmission errors occur, we may miss some. So
;  we are forced to double check here. If the particle slice count or integer data word
;  couint is zero, we clearly cannot proceed to create zero length arrays. However,
;  we still need to read the image, if there is one. So we force Slices =1000 to avoid
;  doing processing that would crash this program, and we ignore this particle.
;--------------------------------------------------------------------------------------
if (Wordcount gt 0 and Slices gt 0) then begin

    ;VImage = BytArr(WordCount*2)
    ;VSums = IntArr(Slices)
    ;out_array = bytarr(16L * Slices)
    ;out_byte_array = BytArr(128L, Slices)

    Catch, onError
    IF onError NE 0 THEN BEGIN
        Catch, /Cancel
        result = Error_Message(Traceback=1)
        out_array=0
    ENDIF
    out_array=0

    out_array = bytarr(16L * Slices)           ; 128 bits = 16 bytes * 8 bits
    out_byte_array = BytArr(128, Slices)

    VImage = BytArr(WordCount * 2)
    VSums = IntArr(Slices)
    VMax  = 0

endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, VImage

if (Slices LT 1000) then begin

    Err=0
    nstop = 3


    ProcessParticle, VImage, out_array, out_byte_array, WordCount, Slices, VSums, VMax, Area, Midpoint, Edges,Err , L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3

    ;ProcessParticle, VImage, VSums, out_array, out_byte_array, WordCount, Slices, VMax, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3

    d = 0
    find_Image_Parameters, out_byte_array, d


    Info.TotalParticles++
    if info.TotalParticles mod 1000 EQ 0 then print, string( format = '("Particles Read:" , I8)',info.TotalParticles)

    ; dof = 0.0D
    particle_in_microns = WordCount * 10
    dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm

    sa_actual = (127.0 +  particle_in_microns/pxs_in_microns) * pxs * min([dww,dof])
    ;  sa_default = 128.0 * pxs *  dww

    ; time interval is the 32 bit tick interval times the # slices
    clock_interval = 0.000010 / TAS

    adj1 = sa_default/sa_actual ; changed above to this line in May 17th, 2006.

    OD = {_DerivedDataRev2}
    OD.PartID = PartID
    OD.NanoSeconds = Timestamp.Nanoseconds + $
        Timestamp.Microseconds * 1000ULL + $
        Timestamp.Milliseconds * 1000000ULL + $
        Timestamp.Seconds * NanosecondsPerSecond + $
        Timestamp.Minutes * NanosecondsPerMinute + $
        Timestamp.Hours * NanosecondsPerHour
    OD.Nanosecsold=OD.nanoseconds ;= Timestamp.Year * 12 + Timestamp.Month

    OD.ImageOffset = pos
    OD.ImageWords = WordCount
    OD.Area = Area
    OD.Nslice = Slices
    OD.L2 = VMax
    OD.F1 = Edges
    OD.Adj1 = adj1
    OD.Pc1 = Midpoint
    OD.TAS = TAS_V
    OD.ProbeCounter = Rollover * OneRollover + ProbeCount
    OD.L3 = L3
    OD.L4 = L4
    OD.L5 = L5
    OD.PC3x = PC3x
    OD.PC3y = PC3y
    OD.PC4x = PC4x
    OD.PC4y = PC4y
    OD.A3 = A3
    OD.Alexei1= d
    OD.CPI_trigger = CPI_trigger
    ;**********************************************************
    this_time=float(OD.nanoseconds)/1000000000.0
    ;indx8=where(HKseconds ge this_time and HKseconds le this_time+1.0,contN)
    factor=1.0

    ;if contN gt 0 then factor=((HKtas(indx8(0))/170.0) > 1.0)  else factor=1.0

    This_L1n=(OD.Nslice+randomu(seed)-0.5)*factor

    OD.L1n    =This_L1n
    OD.area   =area*factor
    OD.alexei1=   d*factor

    ;now re-calculated adj1 values.
    dof = (5.13 * This_L1n*this_L1n) / 10.0D ;; convert to mm
    sa_actual = (127.0 + This_L1n) * pxs * min([dww,dof])
    OD.adj1= sa_default/sa_actual

    ;***********************************************************
    ;if OD.tas gt 0.0 then $
    ;WRITEU, vert_lun, OD
    lastV=0
    ;if oD.nanoseconds gt 46391203000000LL and OD.probecounter gt 0LL then begin
    ;print, OD.probecounter,' ', oD.area,' ',OD.L1n
    ;stop
    ;endif

    ; stop;  it is good in here.---Feb 16, 2006---by mo   why not cont vertical particles numbers ?

    !VPC1_array=[!VPC1_array(1:99),OD.PC1];  : this is a circle holder for the last 100 particles for Statistical noise
    ;now determine if the Particle is noise  or dot_Line or big splashas.
    Find_out_if_this_particle_bad,!VPC1_array,OD.PC1,OD.Nslice,OD.L2,OD.L4,OD.L5,area, OD.alexei1,Good

    if Good eq 1 then begin
        ;write data to (*alldataV)
        (*alldataV)(Vgoodcount)=OD

        ;get_this_image_and_text,'V',Slices,wordcount,Vimage, dimg,dispsize,my_text_string,nanoseconds
        VGoodcount++;               ; imput is Vimg, 'V'; return is dimg ect.

        dimg=rotate(out_byte_array,1)
        my_text_string=SPEC_Nano2HMS(OD.nanoseconds)
        dispsize=size(dimg,/dimension)

        output_png_images_to_my_png_page, my_png_pageV,'V',dimg,dispsize,my_text_string,nanoseconds,timestamp
    endif



Endif

break

END

;----------------------------
ELSE: begin
    POINT_LUN, -lun, badpos
    print , "Error, bad header in data file. Offset = ",badpos, '    value=',DataType
    goto, force_out_while
    ;printf, 22, "Chris said impossible Error: bad header in data file. Offset = ",badpos," value = ", DataType
end
ENDSWITCH

ENDWHILE

force_out_while:    ; this is forced out point where chris wieland said imposible place.

Close ,lun

Free_Lun, lun

;Widget_Control, event.top, Set_UValue=info, /No_Copy
print, 'Done making image png pages of file  ' + !currentHFname + '  !!!!'

;Start cleaning the data and do 1Hz archiving.
index=where((*alldataH).L1n >0.0)
(*alldataH)=(*alldataH)(index)
index=where((*alldataV).L1n >0.0)
(*alldataV)=(*alldataV)(index)

; store the old values to keep them in the commond data block.
(*alldataH).Tasold     =(*alldataH).tas
(*alldataH).alexei1old =(*alldataH).alexei1
(*alldataH).largest_satellite_area    =(*alldataH).area

(*alldataV).Tasold     =(*alldataV).tas
(*alldataV).alexei1old =(*alldataV).alexei1
(*alldataV).largest_satellite_area    =(*alldataV).area


;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="correct_HV_first_last_particle_ticks" ; tell user what we're up to

; TAF plotting unsorted times

correct_HV_first_last_particles_ticks
Plot_unsorted_particles_nanotimes_and_ticks_and_tas,'H'
Plot_unsorted_particles_nanotimes_and_ticks_and_tas,'V'
;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="correct_tas_of_HV_particles" ; tell user what we're up to
;correct_tas_of_HV_particles; including fake particles.
;TAF skipping this until the TAS is correct
;print, "Skipping correct_tas_of_HV_particles until TAS section is correct"

;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Label_all_saw_tooth_events" ; tell user what we're up to
Label_all_saw_tooth_events,'H';  added on March 31, 2008.
Label_all_saw_tooth_events,'V'

;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="calculate_wait_time_of_all_HVparticles" ; tell user what we're up to
calculate_wait_time_of_all_HVparticles,'H'; assigne warn=warn+10 and reject particles if w8_tless than 0.
calculate_wait_time_of_all_HVparticles,'V'; f w8_t less than 0, it mean time is non-monotonic.

;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100" ; tell user what we're up to
Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100,'H';  just assign warn=warn+100.
Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100,'V'

;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="correct_HV_particles_nanotimes" ; tell user what we're up to
;correct_HV_particles_nanotimes,'H';  assigned warn=warn+1000; to time can not recovered particles.
;correct_HV_particles_nanotimes,'V'; ; comment time correction  for bead testing

;************************************************************
;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="calculate_L7_of_all_H_andV_particles" ; tell user what we're up to
calculate_L7_of_all_H_andV_particles
;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="calculate_L8_of_all_H_andV_particles" ; tell user what we're up to
calculate_L8_of_all_H_andV_particles

; Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="calculate_AccDeadtime_of_all_H_andV_particles" ; tell user what we're up to
calculate_AccDeadtime_of_all_H_andV_particles; added on oct 4, 2007.

;Now call cleaning routine to clean particles.
AllOrKps='NoClean'
liqorice='ice'
; note that info only use info.statusID to show the staus %35 finished .

Auto_clean_oneParticle_by_oneParticleH,info,AllOrKps,liqorice;  This is for cleaning all both ice or liq
Auto_clean_oneParticle_by_oneParticleV,info,AllorKps,liqorice

!autoarchive_method='M4'
Do_Nsecond_Ultimate_archive_61bins,info=info,AllorKps,liqorice;;  This has extinction, mass psds with it.
!autoarchive_method='M1'
Do_Nsecond_Ultimate_archive_61bins,info=info,AllorKps,liqorice;;  This has extinction, mass psds with it.

endfor; end of for kkkk=1, file count-1


end ;===== end of spec_toolbar_save make the horizon. vert_***bin files ===========================


;*****************

;*****************************************************
pro start_a_new_page,my_png_page
    ; Prepare fonts
    Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=12)
    Font2 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=14)
    Font3 = OBJ_NEW('IDLgrFont', 'Helvetica Bold',SIZE=8)

    ; Get current color table
    TVLCT, r, g, b, /GET
    r[0] = 255
    g[0] = 255
    b[0] = 0
    Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)

    OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res
    dims=[612,792];  use 3000 will draw teh two lines added by mo at 10th amy 2004.
    res=[0.025,0.025];   added by mo on May 10th 2004.
    PageDX = Dims[0]
    PageDY = Dims[1]

    ; create a view
    View = OBJ_NEW('IDLgrView', VIEW=[0,0,PageDX,PageDY])
    Model = OBJ_NEW('IDLgrModel')
    TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=Font3,recompute_dimensions=0)

    Model->Add,TimeText
    View->Add, Model
    currenty=pageDy-10; the position to put the texline 2006/01/25 ctreitera *****
    my_png_page={view:view,model:model,timeText:timeText,pageDX:pageDX,pageDy:pageDY,$
        CurrentX:0,currentY:currentY,font:font3,count:0L,startTime:0LL,EndTime:0LL,Time0:'',TimeText_1:''}
end;  end of start_a_new_page
;*****************************************************
pro get_this_image_and_text,HorV,Slices,wordcount,Image, dimg,dispsize,my_text_string,nanoseconds

    ;Slices = L1size_array
    ;WordCount = ImgWord_array

    ; Image = BytArr(WordCount * 2)

    out_array = bytarr(16L * Slices)
    out_byte_array = bytarr(128, Slices)

    ;POINT_LUN, lun, fOffsets_array
    ;ReadU, lun, Image

    Hsums = intarr(Slices)
    HMax  = 0
    Area = 0UL
    Midpoint = 0
    Edges = 0
    L3 = 0.0
    L4 = 0.0
    L5 = 0.0
    PC3x = 0.0
    PC3y = 0.0
    PC4x = 0.0
    PC4y = 0.0
    A3 = 0.0

    Err=0
    ProcessParticle, Image, out_array, out_byte_array, Wordcount,Slices, HSums,$
        HMax, Area, Midpoint, Edges,Err , L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3

    ;  tv,ROTATE(out_byte_array,1),yoffset,0
    dimg=rotate(out_byte_array,1)
    my_text_string=SPEC_Nano2HMS(nanoseconds_array)
    dispsize=size(dimg,/dimension)

    ;****************************************************
    Catch, onError
    IF onError NE 0 THEN BEGIN
        Catch, /Cancel
        result = Error_Message(Traceback=1)
        Hsums=0
    ENDIF

    Hsums=0
end
; **************************************************************
;===============================================================================
PRO SaveWndToFile, OutPutWnd,time0,timetext_2,HorV,timestamp

    starttime=strsplit(time0,':',/extract)
    if strlen(time0) lt 5 then return
    starttime=strjoin(starttime(0:2))
    starttime=strsplit(starttime,'.',/extract)
    starttime=starttime(0)+'_'+starttime(1)+starttime(2)

    if n_elements(Timetext_2) eq 0 then begin
        timetext_2=strmid(Time0,0,(strlen(time0)-3))+'999'; added this on 2010-02-29
    endif

    endtime  =strsplit(timetext_2,':',/extract)
    endtime  =strjoin(endtime(0:2))
    endtime=strsplit(endtime,'.',/extract)
    endtime=endtime(0)+'_'+endtime(1)+endtime(2)


    year=strtrim(string(timestamp.year),2);      ;'20'+strmid(plot_string2,5,2)
    if timestamp.month lt 10 then begin
        month='0'+strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
    endif else begin
        month=strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
    endelse
    ;day=strtrim(string(timestamp.day),2);;       strmid(plot_string2,9,2)
    if timestamp.day lt 10 then begin
        day='0'+strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
    endif else begin
        day=strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
    endelse
    date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

    time_str='_'+endtime;+'_'+endtime

    ;get the yyyy mm dd of the data file.
    ;   subfile_str=strsplit(!currentHFname,'\',/extract)
    ;   plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)
    ;   year='20'+strmid(plot_string2,5,2)
    ;   month=strmid(plot_string2,7,2)
    ;  day=strmid(plot_string2,9,2)
    date_yyyymmdd_string=year+month+day; '20060201 '

    ; Create a filename
    sortfile_str=strmid(!currentHFname,0,strlen(!currentHFname)-7)
    junk=findfile(!currentHPname+sortfile_str+'_png\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname +sortfile_str+"_png\"
    outputfilename=!currentHPname+sortfile_str+'_png\'+HorV+date_yyyymmdd_string+time_str+'.png'
    ;outputfilename=!currentHPname+'png\TDS_xxx_'+date_yyyymmdd_string+strmid(time_str,0,6)+'_R0_'+HorV+'.png'

    ;Get window image
    Img = OutPutWnd->Read()
    ; Get the actual buffer
    Img->GetProperty, Data=Buf; , /NO_COPY
    y = (size(Buf))[2]
    dy = round(y)
    ;write_png,outputfilename, Buf[*,y-dy:*];r,g,b; this has size(buf)=[612,753]---a black strip on the png.
    write_png,outputfilename, Buf[*,40:*]   ;this don't have the balck strip anymore, save inks.

    OBJ_DESTROY, Img
    heap_gc
end;SaveWndToFile, OutPutWnd,time_text
;****************************************************
pro output_png_images_to_my_png_page,my_png_page,HorV,dimg,dispsize,my_text_string,nanoseconds,timestamp

    if my_png_page.currentY ge 782 then begin;  do it at the Top of the page one Time.
        ;!strip_height=128; pixels
        subfile_str=strsplit(!currentHFname,'\',/extract)

        plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)

        year=strtrim(string(timestamp.year),2);      ;'20'+strmid(plot_string2,5,2)
        if timestamp.month lt 10 then begin
            month='0'+strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endif else begin
            month=strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endelse
        ;day=strtrim(string(timestamp.day),2);;       strmid(plot_string2,9,2)
        if timestamp.day lt 10 then begin
            day='0'+strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endif else begin
            day=strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endelse
        date_time_string=year+'/'+month+'/'+day; '2006/02/01 '


        criteria='all images'

        title=date_time_string +' '+HorV+' '+criteria
        TimeText = OBJ_NEW('IDLgrText',title,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)
        my_png_page.Model->Add,timeText

        ; draw top line
        my_png_page.currentY=my_png_page.currentY-3

        myline=bytarr(612,2); x-ength is 2400, height is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image


        ;ready for drawing images.
        my_png_page.currentY=my_png_page.currentY-!strip_height-3

    endif

    ;here equivalent of the while loop to added more and more images.


    my_png_page.count=my_png_page.count+1;  ; count of particles shown in this line.

    image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[$
        my_png_page.currentX,my_png_page.currentY,0], ORDER=0);,interpolate=1) don't do the interp
    my_png_page.Model->Add, image

    This_nano_second=nanoseconds

    if my_png_page.currentX lt 1 then begin; add text if a new strip.
        TimeText_1 = my_text_string
        TimeText_1_time =This_nano_second

        my_png_page.StartTime=This_nano_second
        my_png_page.TimeText_1=TimeText_1

        if my_png_page.currentY gt my_png_page.pageDY-150 then begin
            time0=timetext_1
            my_png_page.Time0=Time0; This keep a record of the first particle time of the new or new page ? line.
        endif

    endif
    my_png_page.currentX=my_png_page.currentX+dispsize(0)+1



    if my_png_page.currentX gt 600 and my_png_page.currentY gt 40 then begin; add time stamp at end and begin a new line
        TimeText_2 =my_text_string
        TimeText_2_time =This_nano_second;         ;get 478 only give one page.
        ;delt_milisec=(TimeText_2_time -TimeText_1_time)/1000000LL
        delt_milisec=(TimeText_2_time -my_png_Page.StartTime)/1000000LL
        DmiliS='--DtmiliSec='+strtrim(string(Delt_milisec),2)
        TimeText_2 =TimeText_2 +DmiliS+'---Total: '+strtrim(string(my_png_page.count),2)
        ; reset the counts  since the line is finished.
        my_png_page.count=0L
        my_png_page.currentX=0
        my_png_page.currentY=my_png_page.currentY-3; ready fo rdrawing bottom line.



        ;draw bottom line
        myline=bytarr(612,2); heiht is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image

        ;draw the text1 and text 2 string below the bottom line.

        timetext_1=my_png_page.TimeText_1

        my_png_page.currentY=my_png_page.currentY-10
        timeText= OBJ_NEW('IDLgrText','From'+timetext_1+$
            '--- to ---'+timetext_2,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)

        my_png_page.Model->Add, timetext

        ;if there are still space to draw another strip of images then do drawing the to line.
        ;if my_png_page.currentY gt 10+!strip_height+14+60 then begin
        ;draw top line now for next strip
        my_png_page.currentY=my_png_page.currentY-3
        myline=bytarr(612,2);  must be 2 pixels.  2 or three dimsensions of images allowed.
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image
        my_png_page.currentY=my_png_page.currentY-!strip_height-3; ready for image drawing now.
        ;endif
        my_png_page.StartTime=nanoseconds;  This is teh new line's StartTime.
    endif

    if my_png_page.currentY lt 50 then begin; get a new page and save the current page.

        ;show and save the current page
        OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        output3 ->draw,my_png_page.view;   show teh vie wto teh screen.
        wait,0.1
        ;save the view to a file
        output2 ->draw,my_png_page.view;   Put the view wto the Buffer.

        Time0=my_png_page.Time0
        SaveWndToFile,OutPut2,time0,timetext_2,HorV,timestamp

        ;destroy the view foe geneating the new view
        OBJ_DESTROY,my_png_page.View
        OBJ_DESTROY,output3
        OBJ_DESTROY,output2


        ;start a new page
        start_a_new_page,my_png_page
        subfile_str=strsplit(!currentHFname,'\',/extract)
        plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)

        year=strtrim(string(timestamp.year),2);      ;'20'+strmid(plot_string2,5,2)
        if timestamp.month lt 10 then begin
            month='0'+strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endif else begin
            month=strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endelse
        ;day=strtrim(string(timestamp.day),2);;       strmid(plot_string2,9,2)
        if timestamp.day lt 10 then begin
            day='0'+strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endif else begin
            day=strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endelse
        date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

        criteria='all images'


        title=date_time_string +' '+HorV+' '+criteria
        TimeText = OBJ_NEW('IDLgrText',title,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)
        my_png_page.Model->Add,timeText

        ; draw top line
        my_png_page.currentY=my_png_page.currentY-3

        myline=bytarr(612,2); x-ength is 2400, heiht is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY], ORDER=0,interpolate=1)
        my_png_page.Model->Add, image
        ;ready for drawing images.
        my_png_page.currentY=my_png_page.currentY-!strip_height-3
        ;add the readed images adn take a note the starttime strin
        ;*******************************************************
        ;TimeText_1 = my_text_string
        ;time0=timetext_1
        ; my_png_page.currentX=my_png_page.currentX+dispsize(0)+1
        ;********************************************************
    endif


end; end of output_pngs_images_pages
;*****************************************************


pro  Find_out_if_this_particle_bad,PC1_array,This_PC1,Nslice,L2,L4,L5,area, alexei1,Good

    Find_allBad_pixels_in_thisPC1group_brad,PC1_array,BadPixel_array

    junkindex=where(BadPixel_array eq This_PC1, YesCont)

    If Yescont eq 1 then  begin
        ; unless it meets on one of the three following criteria.
        Crit_a=Nslice  ge 4 and L5  ge 4 and L2  ge 3 and area  ge 0.5*alexei1  and Nslice  lt 10*L2
        if Crit_a eq 0 then begin;  That mean it is a noise.
            Good=0 & return
        endif; else : this particle is still a good particle.
    endif


    ; if lineNdot eq 1 then  goto, label_it_as_bad
    if ( Nslice  eq Area  and L2  eq 1 and Nslice  gt 4 ) then begin
        good=0 & return
    endif

    if ( Area  le 1.35*Nslice  and L4  eq L5  and Nslice  gt 4 and L2  eq 2) then begin
        good=0 & return
    endif

    if ( Nslice  gt 10 and Nslice  gt 0.75*area  and Nslice  le 1.5*area ) then begin
        good=0 & return
    endif

    if ( L4  eq L5  and Alexei1  gt 0.9*Nslice *L5  and L2  eq 2 and L2  ne L4 ) then begin
        good=0 & return
    endif

    if ( L4  eq L5  and Alexei1  gt 3.0*Area  and L2  eq 2)  then begin
        good=0 & return
    endif

    if ( L4  eq L5  and Alexei1  gt 4.0*Area ) then begin
        good=0 & return
    endif

    ; added this to take away black spot rectangular images.
    if area  gt 0.8*Nslice *126.0 then begin
        good=0 & return
    endif

    if area  gt 0.8*Nslice *126.0 then begin
        good=0 & return
    endif
    ; setp 3 to see if it is round.
    roundness=(Nslice ge 0.15*L5) and ( (L5 ge 0.15*Nslice) or L5 gt 50 )
    if roundness  eq 0 then begin;  roundness of a particle
        good=0 & return
    endif

    ;step 4 to see if it is big splash.
    if (L5  gt 10 or Nslice  gt 10) and Alexei1  gt 3.0*area  then begin
        good=0 & return
    endif

    if (L5  gt 15 or Nslice  gt 15) and Alexei1  gt 2.5*area  then begin
        good=0 & return
    endif

    if (L5  gt 20 or Nslice  gt 20) and Alexei1  gt 2.0*area  then begin
        good=0 & return
    endif


    ; find out of it is a long striker
    if (Nslice gt 50 and Area lt Nslice*0.2*L5) then begin
        good=0 & return
    endif


    good=1;;at here the image is good.  put it on the png page file.


end
; end of find if this particle good or bad.



;***********************************************************************
pro Find_allBad_pixels_in_thisPC1group,PC1_array,BadPixel_array
    done=0
    ;stop
    BadPixel_array=[-9]
    N_diodes=128.0
    while done eq 0 do begin
        meanH=float(n_elements(PC1_array))/n_diodes
        Threshold= (5.0*sqrt(meanH)+meanH) > 1.5;  from brad
        H1=histogram(Pc1_array,binsize=1,min=0,max=128)
        index=where(H1 gt Threshold,ContG)
        n_diodes=n_diodes-ContG; n_diodes is the number of remaining pixels that could be not noisy.

        if ContG gt 0 then begin;   There are bad pixels in the PC1_array.
            BadPixel_array=[BadPixel_array,index]
            ;there are ContG groups of bad pixels. eliminate then all.
            for i=0, contG-1 do begin
                indextemp=where(PC1_array ne index(i),contDD)
                if contDD gt 0 then begin
                    PC1_new=PC1_array(indextemp)
                    PC1_array=PC1_new
                endif else done=1;if contDD=0 means all PC1_array are bad. we can stop now.
            endfor

        endif else begin
            done=1
        endelse

        if n_diodes eq 0 then done=1
    endwhile

end;Find_allBad_pixels_in_thisPC1group,PC1_array,BadPixel_array
;*********************************************************************************

;***********************************************************************
pro Find_allBad_pixels_in_thisPC1group_brad,PC1_array,BadPixel_array
    ; This rountine finds all Bad particles in the vectors of PC1_array.
    ; output is the BadPixel_array, if any particle's PC1(i) values in this
    ; group matches one of the BadPixel_array elements, then that  particle i
    ; will be considered as noise. badPixel_array=[-9, 26, 105] will means
    ; that pixle 26, 105 is bad.

    done=0
    BadPixel_array=[-9]
    N_diodes=128.0
    while done eq 0 do begin
        mean1=float(n_elements(PC1_array))/n_diodes
        His=histogram(Pc1_array,binsize=1,min=0,max=128)
        indexBQ=where(His gt mean1-3.*sqrt(mean1),cont_Gt33)
        if cont_GT33 lt 32 then meanHis=mean1 else meanHis=mean(His(indexBQ))

        Threshold= (5.0*sqrt(meanhis)+meanhis) > 1.5;  from brad

        index=where(His gt Threshold,ContG)
        n_diodes=n_diodes-ContG; n_diodes is the number of remaining pixels that could be not noisy.

        if ContG gt 0 then begin;   There are bad pixels in the PC1_array.
            BadPixel_array=[BadPixel_array,index]
            ;there are ContG groups of bad pixels. eliminate then all.
            for i=0, contG-1 do begin
                indextemp=where(PC1_array ne index(i),contDD)
                if contDD gt 0 then begin
                    PC1_new=PC1_array(indextemp)
                    PC1_array=PC1_new
                endif else done=1;if contDD=0 means all PC1_array are bad. we can stop now.
            endfor

        endif else begin
            done=1
        endelse
        if n_diodes eq 0 then done=1
    endwhile

end;Find_allBad_pixels_in_thisPC1group_brad,PC1_array,BadPixel_array
;*********************************************************************************
PRO ProcessParticle, Image, out_array, out_byte_array, WordCount, Slices, Sums, Nslice, Area, Midpoint, Edges, Err, $
    L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3


; TAF found an odd size for an image array, which should always be even, putting in a stop
; the odd size was caused by a bad copy into my test program, and should not be encountered
; in normal operation.  Still, this stop should be left in to help debug if an odd Image is
; ever encountered.
if((size(Image))[1] mod 2 eq 1) then begin
    print, "Image size is odd, should be 2*Slices long"
    help, Image, Slices
    stop
endif


; assemble all variables in a big fltarr for testing communication with .dll

n_args = 20 ; the number of arguments sent by IDL, used by the .dll as a quick sanity check

;expected_rettest = [n_args, Image, Sums, out_byte_array, Wordcount, Slices, Nslice, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3]
;rettest = expected_rettest
;rettest[*] = 0. ; initiallize and zero rettest
;rettest = fltarr(5)
;rt_size = (size(rettest))[1]



retval = CALL_EXTERNAL('C:\SPEC_2DS_process_particles.dll', 'process_particles', $
    n_args,            $
    Image,             $
    Sums,              $
    out_array,         $
    out_byte_array,    $
    Wordcount,         $
    Slices,            $
    Nslice,            $
    Area,              $
    Midpoint,          $
    Edges,             $
    Err,               $
    L3,                $
    L4,                $
    L5,                $
    PC3x,              $
    PC3y,              $
    Pc4x,              $
    Pc4y,              $
    A3,                $
    ;rt_size,           $ ; size of the rettest float array
    ;rettest,           $ ; testing .dll will copy variables to here to verify transmission
    /I_VALUE,          $
    ;/UNLOAD,           $ ; comment out /UNLOAD when not debugging
    /CDECL)

if(retval eq -1) then begin
    print, ''
    print, "CALL_EXTERNAL on DecompressParticle returned -1, bad number of arguments"
    print, ''
    stop
endif

Catch, onError
IF onError NE 0 THEN BEGIN
    Catch, /Cancel
    result = Error_Message(Traceback=1)
    print, "caught error in a2dsview call_external", onError

    stop

    onError = 0

ENDIF



; resize to appropriate dims -- TAF might be fixed when Wordcount and Slices are fixed...

size_oba = (size(out_byte_array))[2]

if(Slices le size_oba) then begin
    out_byte_array = out_byte_array(0:(Slices * 128L)-1)
    out_byte_array = reform(out_byte_array,128L,Slices)
endif else begin
    print, "Slices ", Slices, " does not agree with size of out_byte_array ", size_oba
endelse

; since ProcessParticle now returns out_byte_array in the Alexei processing format, we need to fix it here
; TAF this should likely be done within the .dll
aa = where(out_byte_array eq 1, complement=bb, count)

if(count gt 0) then begin
    out_byte_array(aa) = 255; that means out_byte_array is either 255 or 0 values to make it balck or white.
endif

if(count lt size_oba) then begin
    out_byte_array(bb) = 0;   what are the values in out_array ??
endif



;   ENDIF ELSE MESSAGE,'External call to Decompress failed'
END ; ProcessParticle   ;---------------------------------------------------------------------------

;****************************************************************************************

;+
; NAME:
;    ERROR_MESSAGE

; PURPOSE:

;    The purpose of this function  is to have a device-independent
;    error messaging function. The error message is reported
;    to the user by using DIALOG_MESSAGE if widgets are
;    supported and MESSAGE otherwise.

;    In general, the ERROR_MESSAGE function is not called directly.
;    Rather, it is used in a CATCH error handler. Errors are thrown
;    to ERROR_MESSAGE with the MESSAGE command. A typical CATCH error
;    handler is shown below.

;       Catch, theError
;       IF theError NE 0 THEN BEGIN
;          Catch, /Cancel
;          ok = Error_Message(/Traceback, /Error)
;          RETURN
;       ENDIF

;    Error messages would get into the ERROR_MESSAGE function by
;    throwing an error with the MESSAGE command, like this:

;       IF test NE 1 THEN Message, 'The test failed.'

; AUTHOR:

;   FANNING SOFTWARE CONSULTING
;   David Fanning, Ph.D.
;   1645 Sheely Drive
;   Fort Collins, CO 80526 USA
;   Phone: 970-221-0438
;   E-mail: davidf@dfanning.com
;   Coyote's Guide to IDL Programming: http://www.dfanning.com/

; CATEGORY:

;    Utility.

; CALLING SEQUENCE:

;    ok = Error_Message(the_Error_Message)

; INPUTS:

;    the_Error_Message: This is a string argument containing the error
;       message you want reported. If undefined, this variable is set
;       to the string in the !Error_State.Msg system variable.

; KEYWORDS:

;    ERROR: Set this keyword to cause Dialog_Message to use the ERROR
;       reporting dialog. Note that a bug in IDL causes the ERROR dialog
;       to be used whether this keyword is set to 0 or 1!

;    INFORMATIONAL: Set this keyword to cause Dialog_Message to use the
;       INFORMATION dialog instead of the WARNING dialog. Note that a bug
;       in IDL causes the ERROR dialog to be used if this keyword is set to 0!

;    TITLE: Set this keyword to the title of the DIALOG_MESSAGE window. By
;       default the keyword is set to 'System Error' unless !ERROR_STATE.NAME
;       equals "IDL_M_USER_ERR", in which case it is set to "Trapped Error'.

;    TRACEBACK: Setting this keyword results in an error traceback
;       being printed to standard output with the PRINT command. Set to
;       1 (ON) by default. Use TRACEBACK=0 to turn this functionality off.

; OUTPUTS:

;    Currently the only output from the function is the string "OK".

; RESTRICTIONS:

;    The WARNING Dialog_Message dialog is used by default.

; EXAMPLE:

;    To handle an undefined variable error:

;    IF N_Elements(variable) EQ 0 THEN $
;       ok = Error_Message('Variable is undefined', /Traceback)

; MODIFICATION HISTORY:

;    Written by: David W. Fanning, 27 April 1999.
;    Added the calling routine's name in the message and NoName keyword. 31 Jan 2000. DWF.
;    Added _Extra keyword. 10 February 2000. DWF.
;    Forgot to add _Extra everywhere. Fixed for MAIN errors. 8 AUG 2000. DWF.
;    Adding call routine's name to Traceback Report. 8 AUG 2000. DWF.
;    Added ERROR, INFORMATIONAL, and TITLE keywords. 19 SEP 2002. DWF.
;    Removed the requirement that you use the NONAME keyword with the MESSAGE
;      command when generating user-trapped errors. 19 SEP 2002. DWF.
;    Added distinctions between trapped errors (errors generated with the
;      MESSAGE command) and IDL system errors. Note that if you call ERROR_MESSAGE
;      directly, then the state of the !ERROR_STATE.NAME variable is set
;      to the *last* error generated. It is better to access ERROR_MESSAGE
;      indirectly in a Catch error handler from the MESSAGE command. 19 SEP 2002. DWF.
;    Change on 19 SEP 2002 to eliminate NONAME requirement did not apply to object methods.
;      Fixed program to also handle messages from object methods. 30 JULY 2003. DWF.
;-
;###########################################################################

; LICENSE

; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.

; Copyright  1999-2003 Fanning Software Consulting

; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.

; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:

; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.

; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.

; 3. This notice may not be removed or altered from any source distribution.

; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.

;###########################################################################


FUNCTION ERROR_MESSAGE, theMessage, Error=error, Informational=information, $
    Traceback=traceback, NoName=noname, Title=title, _Extra=extra

On_Error, 2

; Check for presence and type of message.

IF N_Elements(theMessage) EQ 0 THEN theMessage = !Error_State.Msg
s = Size(theMessage)
messageType = s[s[0]+1]
IF messageType NE 7 THEN BEGIN
    Message, "The message parameter must be a string.", _Extra=extra
ENDIF

; Get the call stack and the calling routine's name.

Help, Calls=callStack
IF Float(!Version.Release) GE 5.2 THEN $
    callingRoutine = (StrSplit(StrCompress(callStack[1])," ", /Extract))[0] ELSE $
    callingRoutine = (Str_Sep(StrCompress(callStack[1])," "))[0]

; Are widgets supported?

widgetsSupported = ((!D.Flags AND 65536L) NE 0)
IF widgetsSupported THEN BEGIN

    ; If this is an error produced with the MESSAGE command, it is a trapped
    ; error and will have the name "IDL_M_USER_ERR".

    IF !ERROR_STATE.NAME EQ "IDL_M_USER_ERR" THEN BEGIN

        IF N_Elements(title) EQ 0 THEN title = 'Trapped Error'

        ; If the message has the name of the calling routine in it,
        ; it should be stripped out. Can you find a colon in the string?

        ; Is the calling routine an object method? If so, special processing
        ; is required. Object methods will have two colons together.

        doublecolon = StrPos(theMessage, "::")
        IF doublecolon NE -1 THEN BEGIN

            prefix = StrMid(theMessage, 0, doublecolon+2)
            submessage = StrMid(theMessage, doublecolon+2)
            colon = StrPos(submessage, ":")
            IF colon NE -1 THEN BEGIN

                ; Extract the text up to the colon. Is this the same as
                ; the callingRoutine? If so, strip it.

                IF StrMid(theMessage, 0, colon+StrLen(prefix)) EQ callingRoutine THEN $
                    theMessage = StrMid(theMessage, colon+1+StrLen(prefix))
            ENDIF
        ENDIF ELSE BEGIN

            colon = StrPos(theMessage, ":")
            IF colon NE -1 THEN BEGIN

                ; Extract the text up to the colon. Is this the same as
                ; the callingRoutine? If so, strip it.

                IF StrMid(theMessage, 0, colon) EQ callingRoutine THEN $
                    theMessage = StrMid(theMessage, colon+1)
            ENDIF

        ENDELSE


        ; Add the calling routine's name, unless NONAME is set.

        IF Keyword_Set(noname) THEN BEGIN
            answer = Dialog_Message(theMessage, Title=title, _Extra=extra, $
                Error=error, Information=information)
        ENDIF ELSE BEGIN
            answer = Dialog_Message(StrUpCase(callingRoutine) + ": " + $
                theMessage, Title=title, _Extra=extra, $
                Error=error, Information=information)
        ENDELSE

    ENDIF ELSE BEGIN

        ; Otherwise, this is an IDL system error.

        IF N_Elements(title) EQ 0 THEN title = 'System Error'

        IF StrUpCase(callingRoutine) EQ "$MAIN$" THEN $
            answer = Dialog_Message(theMessage, _Extra=extra, Title=title, $
            Error=error, Information=information) ELSE $
            IF Keyword_Set(noname) THEN BEGIN
            answer = Dialog_Message(theMessage, _Extra=extra, Title=title, $
                Error=error, Information=information)
        ENDIF ELSE BEGIN
            answer = Dialog_Message(StrUpCase(callingRoutine) + "--> " + $
                theMessage, _Extra=extra, Title=title, $
                Error=error, Information=information)
        ENDELSE
    ENDELSE
ENDIF ELSE BEGIN
    Message, theMessage, /Continue, /NoPrint, /NoName, /NoPrefix, _Extra=extra
    Print, '%' + callingRoutine + ': ' + theMessage
    answer = 'OK'
ENDELSE

; Provide traceback information if requested.

IF Keyword_Set(traceback) THEN BEGIN
    Help, /Last_Message, Output=traceback
    Print,''
    Print, 'Traceback Report from ' + StrUpCase(callingRoutine) + ':'
    Print, ''
    FOR j=0,N_Elements(traceback)-1 DO Print, "     " + traceback[j]
ENDIF

RETURN, answer
END ; ----------------------------------------------------------------------------



;*****************************************************
function SPEC_Nano2HMS, ns
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    orig_ns = ns

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)
    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)

    ns = orig_ns

    return,a


end
;*****************************************************
;*****************************************************
function  SPEC_Nano2HMS_struct, ns, time_struct
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    ts  = { _time_struct, $
        Hours: 0, $
        Minutes: 0, $
        Seconds: 0, $
        Milliseconds: 0, $
        Microseconds: 0, $
        Nanoseconds: 0 }

    time_struct = ({_time_struct})

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)

    time_struct.Hours = hours
    time_struct.Minutes = minutes
    time_struct.Seconds = seconds
    time_struct.Milliseconds = milli
    time_struct.Microseconds = micro
    time_struct.Nanoseconds = ns

    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)

    return,a


end


;*****************************************************
;*****************************************************


pro  get_all_data_filenames,filter_str,pathnm,filenames,file_count
    ;input is filter_str, pathnm
    ;output is filenames,file_count
    substrs=strsplit(filter_str,'.',/extract)
    extension=substrs(1)

    do_loop=1
    WHILE (do_loop eq 1) do begin    ;repeatedly selecting files until
        ;user comfirms
        whole_filter_str=pathnm+filter_str
        filenames=findfile(whole_filter_str,COUNT=file_count)
        ;find all files with filter_str and counts the number of these files

        ; display the files in the screen for user to review
        print,'***********************************************************'
        print,'********  Here are data files with ',filter_str, '   ******'
        print,'*** found in current directory for input by this program ***'
        print,'************************************************************'

        for j=0, (file_count-1)  do begin
            print, filenames(j)
        endfor

        print,'*********************************************'

        ; print the message to ask user to confirm
        ; define answer to be a string
        answer=' '

        print,'Are you sure to read above files ? yes/no'

        print,'----if no, then enter a string with wildcat (* or ?)'
        print,'           to limit the files being selected for input.'
        print,'           for example:   *lear_1749*.',extension
        print,'----Or--stop now, delete those unwanted files from  '
        print,'           the current directory, then restart '
        print,'           this program'
        print, 'Enter y or n:'
        ;read,answer
        answer='y'

        if strcmp(answer,'y') then  do_loop=0
        if (strcmp(answer,'y') eq 0) then begin
            print,'  Enter the string(ie: *6*b?*.',extension,'):'
            read,answer    ; use this string for selecting input data files.
            filter_str=pathnm+answer
        endif

    ENDWHILE           ; end of initial start up.
    print,'                            '
    print,' done,get the files,.....Processing,  please wait ! '
    print,'
end; endof get_all_data_filenames,filter_str,filenames,pathnm
;****************************************************************************

pro define_sysv
    DEFSYSV, '!NO_CHART', 0
    DEFSYSV, '!H_CHART', 1
    DEFSYSV, '!V_CHART', 2
    DEFSYSV, '!HOURGLASS_CURSOR' , 32514
    DEFSYSV, '!ARROW_CURSOR' , 32512
    DEFSYSV, '!STRIP_WINDOW' , 3
    DEFSYSV, '!STRIP_WIDTH' , 1000 ; 600
    DEFSYSV, '!CHAR_SIZE' , 0.4
    DEFSYSV, '!CurrentHPname' , ''
    DEFSYSV, '!CurrentHFname' , ''
    DEFSYSV, '!CurrentVPname' , ''
    DEFSYSV, '!CurrentVFname' , ''
    DEFSYSV, '!FOFFSET', 0UL  ; default to start of file
    DEFSYSV, '!StereoFOFFset',[0UL,0UL]
    DEFSYSV, '!CRLF', string(13B) + string(10B)
    DEFSYSV, '!CURRENT_CHANNEL' , 1   ; 0=none, 1=horiz, 2=vert
    DEFSYSV, '!ZOOM_STATE' , 0b
    DEFSYSV, '!ZOOM_START_INDEX_H',0L
    DEFSYSV, '!ZOOM_END_INDEX_H', 0L
    DEFSYSV, '!ZOOM_START_INDEX_V',0L
    DEFSYSV, '!ZOOM_END_INDEX_V', 0L
    DEFSYSV, '!ZOOM_START_STRING' , ""
    DEFSYSV, '!ZOOM_END_STRING' , ""
    DEFSYSV, '!ZOOM_START_BIN_1HZ',0L
    DEFSYSV, '!ZOOM_END_BIN_1HZ', 0L
    DEFSYSV, '!DEADTIME_START_FLAG' , -100
    DEFSYSV, '!DEADTIME_END_FLAG' ,   -101
    DEFSYSV, '!MASK_START_FLAG' ,     -102
    DEFSYSV, '!MASK_END_FLAG' ,       -103
    DEFSYSV, '!TAS_FLAG' ,            -104
    DEFSYSV, '!CURRENT_VERSION',       1.0

    DEFSYSV, '!PLAYBACK_ACTIVE' , 1
    DEFSYSV, '!REWIND_ACTIVE' , 1
    DEFSYSV, '!PLAYBACK_SPEED', 0.10
    DEFSYSV, '!HI_LO_STATE' , 0   ; 0=low, 1=high

    DEFSYSV, '!ZOOM_START_NS',0ULL
    DEFSYSV, '!ZOOM_END_NS', 0ULL
    DEFSYSV, '!HPC1_array', fltarr(100)
    DEFSYSV, '!VPC1_array', fltarr(100)
    DEFSYSV, '!strip_height', 128

    DEFSYSV, '!Infocus_on',0;    for doing infocus only analysis.
    DEFSYSV, '!focuspercent',0.9; chosing infocus threshold.
    DEFSYSV, '!AutoArchive',0;   Program mode to supress the dialog_message.Dec 5, 2006.
    DEFSYSV, '!AutoArchive_png_only',0;   Program mode to supress the dialog_message.August 22, 2007.
    DEFSYSV, '!roundness_threshold1',0.5;for if (L1 gt 0.5*L5 and L5 gt 0.5*L1) then roundness=1
    DEFSYSV, '!roundness_threshold2',50.0;  for if (L1 gt 0.5*L5 and L1 gt 50_pixel) then roundness=1
    DEFSYSV, '!filter',0; if filter=0, all adj0=1; if filter=1, adj0=clean1's adj0 values. 1.0 to 1.1
    DEFSYSV, '!AutoArchive_method','M6';   added this in July 11, 2007 for TC4.
    DEFSYSV, '!archive_ice_pop_up_clicked',0;   make sure it is click at list once.
    DEFSYSV, '!Dt',0.0001; To prevent outping too many images just out first image of DT time interval.
    DEFSYSV, '!set_has_big_always_eq_1',0;  When keyword precip is set, ignore_has_big_eq_1 is set  to 1.
    DEFSYSV, '!use_nav_tas_correct_L1n',0;  when keyword NavTAS is set, load Nav TAS to correct L1n alexei1 and area.
end
;********************************************************************************
pro Do_Nsecond_ultimate_archive_61bins,info=info,AllorKps,liqorice

    Common  DataBlock,AllDataH,AllDataV
    Nseconds=1LL;   change this value to 1 to 10 or to 30 for N seconds psd archiving
    bad_data=-9.99;    change to -9.99 on Aprile 2008.     9.999*1E+30
    H_has_bad=0; if H_bad eq 0 then do it. if H_bad eq 1 then do not it and assign bad value for output.
    V_has_bad=0;   use this conditions to skip doing one-channel if there is one channel that is bad.

    alpha = 0.115D ; this hsould be changed to 0.115 according to brad' paper
    beta = 1.218D   ;this should be changed to 1.218  june 8, 2005.
    ; stop
    subfile_str=strsplit(!currentHFname,'\',/extract)
    binfilename=strtrim(subfile_str(n_elements(subfile_str)-1),2)
    ;datetimestring=strmid(binfilename,5,strlen(binfilename)-9); =yymmddhhmmss_hhmmss_hhmmss_000x
    datetimestring=strmid(binfilename,6,strlen(binfilename)-13); =yymmddhhmmss_hhmmss_hhmmss_000x  % this is special for fast processing

    junk=findfile(!currentHPname+'ascii\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "ascii\"
    ;************************************************************************************
    if AllorKps eq 'All' then begin
        Houtputfilename=!currentHPname+'ascii\H_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'.txt'
        Voutputfilename=!currentHPname+'ascii\V_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'.txt'
    endif

    if AllorKps eq 'KeepSplashes' then begin
        Houtputfilename=!currentHPname+'ascii\H_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'WS.txt'
        Voutputfilename=!currentHPname+'ascii\V_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'WS.txt'
    endif

    if AllorKps eq 'NoClean' then begin
        Houtputfilename=!currentHPname+'ascii\H_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'NC.txt'
        Voutputfilename=!currentHPname+'ascii\V_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'NC.txt'
    endif


    ;openw,2,outputfilename
    openw,21,Houtputfilename
    openw,22,Voutputfilename
    MN=!autoarchive_method;   MN can be M1, M2, M4, M6 ect.
    if liqorice eq 'ice' then begin
        ;**********************************
        header_strM11=' %accept is the percentage of images accepted by M1.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM12='Time %Accept #_irreg SVolume(L) conc(#/L)  extn(1/km) IWC(g/m3) #M1_0-50um  #M1_50-250um #M1_>250um '+$
            'N1:5-15  N1:15-25   N1:25-35   N1:35-45   N1:45-55   N1:55-65   N1:65-75   N1:75-85   N1:85-95   N1:95:105  N1:105-115 N1:115-125 '+ $
            'N1:125-135 N1:135-145 N1:145-155 N1:155-165 N1:165-175 N1:175-185 N1:185-195 N1:195-205 N1:205-225 N1:225-245 N1:245-265 N1:265-285 '+ $
            'N1:285-305 N1:305-325 N1:325-345 N1:345-365 N1:365-385 N1:385-405 N1:405-425 N1:425-445 N1:445-465 N1:465-485 N1:485-505 N1:505-555 '+ $
            'N1:555-605 N1:605-655 N1:655-705 N1:705-755 N1:755-805 N1:805-855 N1:855-905 N1:905-955 N1:955-1005 N1:1005-1105 N1:1105-1205 N1:1205-1305 '+ $
            'N1:1305-1405 N1:1405-1505 N1:1505-1605 N1:1605-1705 N1:1705-1805 N1:1805-1905 N1:1905-2005 N1:2005-2205 N1:2205-2405 N1:2405-2605 N1:2605-2805 N1:2805-3005 '+ $
            'N1:3005-inf ' +$
            'A1:5-15  A1:15-25   A1:25-35   A1:35-45   A1:45-55   A1:55-65   A1:65-75   A1:75-85   A1:85-95   A1:95:105  A1:105-115 A1:115-125 '+ $
            'A1:125-135 A1:135-145 A1:145-155 A1:155-165 A1:165-175 A1:175-185 A1:185-195 A1:195-205 A1:205-225 A1:225-245 A1:245-265 A1:265-285 '+ $
            'A1:285-305 A1:305-325 A1:325-345 A1:345-365 A1:365-385 A1:385-405 A1:405-425 A1:425-445 A1:445-465 A1:465-485 A1:485-505 A1:505-555 '+ $
            'A1:555-605 A1:605-655 A1:655-705 A1:705-755 A1:755-805 A1:805-855 A1:855-905 A1:905-955 A1:955-1005 A1:1005-1105 A1:1105-1205 A1:1205-1305 '+ $
            'A1:1305-1405 A1:1405-1505 A1:1505-1605 A1:1605-1705 A1:1705-1805 A1:1805-1905 A1:1905-2005 A1:2005-2205 A1:2205-2405 A1:2405-2605 A1:2605-2805 A1:2805-3005 '+ $
            'A1:3005-inf ' +$
            'M1:5-15  M1:15-25   M1:25-35   M1:35-45   M1:45-55   M1:55-65   M1:65-75   M1:75-85   M1:85-95   M1:95:105  M1:105-115 M1:115-125 '+ $
            'M1:125-135 M1:135-145 M1:145-155 M1:155-165 M1:165-175 M1:175-185 M1:185-195 M1:195-205 M1:205-225 M1:225-245 M1:245-265 M1:265-285 '+ $
            'M1:285-305 M1:305-325 M1:325-345 M1:345-365 M1:365-385 M1:385-405 M1:405-425 M1:425-445 M1:445-465 M1:465-485 M1:485-505 M1:505-555 '+ $
            'M1:555-605 M1:605-655 M1:655-705 M1:705-755 M1:755-805 M1:805-855 M1:855-905 M1:905-955 M1:955-1005 M1:1005-1105 M1:1105-1205 M1:1205-1305 '+ $
            'M1:1305-1405 M1:1405-1505 M1:1505-1605 M1:1605-1705 M1:1705-1805 M1:1805-1905 M1:1905-2005 M1:2005-2205 M1:2205-2405 M1:2405-2605 M1:2605-2805 M1:2805-3005 '+ $
            'M1:3005-inf '+$
            ' M1:spare1 M1:spare2 M1:spare3  #M1_spare  #M1_spare '

        header_strM21=' %accept is the percentage of images accepted by M2.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM22='Time %Accept #_irreg SVolume(L) conc(#/L)  extn(1/km) IWC(g/m3) #M2_0-50um  #M2_50-250um #M2_>250um '+$
            'N2:5-15  N2:15-25   N2:25-35   N2:35-45   N2:45-55   N2:55-65   N2:65-75   N2:75-85   N2:85-95   N2:95:105  N2:105-115 N2:115-125 '+ $
            'N2:125-135 N2:135-145 N2:145-155 N2:155-165 N2:165-175 N2:175-185 N2:185-195 N2:195-205 N2:205-225 N2:225-245 N2:245-265 N2:265-285 '+ $
            'N2:285-305 N2:305-325 N2:325-345 N2:345-365 N2:365-385 N2:385-405 N2:405-425 N2:425-445 N2:445-465 N2:465-485 N2:485-505 N2:505-555 '+ $
            'N2:555-605 N2:605-655 N2:655-705 N2:705-755 N2:755-805 N2:805-855 N2:855-905 N2:905-955 N2:955-1005 N2:1005-1105 N2:1105-1205 N2:1205-1305 '+ $
            'N2:1305-1405 N2:1405-1505 N2:1505-1605 N2:1605-1705 N2:1705-1805 N2:1805-1905 N2:1905-2005 N2:2005-2205 N2:2205-2405 N2:2405-2605 N2:2605-2805 N2:2805-3005 '+ $
            'N2:3005-inf ' +$
            'A2:5-15  A2:15-25   A2:25-35   A2:35-45   A2:45-55   A2:55-65   A2:65-75   A2:75-85   A2:85-95   A2:95:105  A2:105-115 A2:115-125 '+ $
            'A2:125-135 A2:135-145 A2:145-155 A2:155-165 A2:165-175 A2:175-185 A2:185-195 A2:195-205 A2:205-225 A2:225-245 A2:245-265 A2:265-285 '+ $
            'A2:285-305 A2:305-325 A2:325-345 A2:345-365 A2:365-385 A2:385-405 A2:405-425 A2:425-445 A2:445-465 A2:465-485 A2:485-505 A2:505-555 '+ $
            'A2:555-605 A2:605-655 A2:655-705 A2:705-755 A2:755-805 A2:805-855 A2:855-905 A2:905-955 A2:955-1005 A2:1005-1105 A2:1105-1205 A2:1205-1305 '+ $
            'A2:1305-1405 A2:1405-1505 A2:1505-1605 A2:1605-1705 A2:1705-1805 A2:1805-1905 A2:1905-2005 A2:2005-2205 A2:2205-2405 A2:2405-2605 A2:2605-2805 A2:2805-3005 '+ $
            'A2:3005-inf ' +$
            'M2:5-15  M2:15-25   M2:25-35   M2:35-45   M2:45-55   M2:55-65   M2:65-75   M2:75-85   M2:85-95   M2:95:105  M2:105-115 M2:115-125 '+ $
            'M2:125-135 M2:135-145 M2:145-155 M2:155-165 M2:165-175 M2:175-185 M2:185-195 M2:195-205 M2:205-225 M2:225-245 M2:245-265 M2:265-285 '+ $
            'M2:285-305 M2:305-325 M2:325-345 M2:345-365 M2:365-385 M2:385-405 M2:405-425 M2:425-445 M2:445-465 M2:465-485 M2:485-505 M2:505-555 '+ $
            'M2:555-605 M2:605-655 M2:655-705 M2:705-755 M2:755-805 M2:805-855 M2:855-905 M2:905-955 M2:955-1005 M2:1005-1105 M2:1105-1205 M2:1205-1305 '+ $
            'M2:1305-1405 M2:1405-1505 M2:1505-1605 M2:1605-1705 M2:1705-1805 M2:1805-1905 M2:1905-2005 M2:2005-2205 M2:2205-2405 M2:2405-2605 M2:2605-2805 M2:2805-3005 '+ $
            'M2:3005-inf '+$
            ' M2:spare1 M2:spare2 M2:spare3  #M2_spare  #M2_spare '

        header_strM41=' %accept is the percentage of images accepted by M4.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM42='Time %Accept #_irreg SVolume(L) conc(#/L)  extn(1/km) IWC(g/m3) #M4_0-50um  #M4_50-250um #M4_>250um '+$
            'N4:5-15  N4:15-25   N4:25-35   N4:35-45   N4:45-55   N4:55-65   N4:65-75   N4:75-85   N4:85-95   N4:95:105  N4:105-115 N4:115-125 '+ $
            'N4:125-135 N4:135-145 N4:145-155 N4:155-165 N4:165-175 N4:175-185 N4:185-195 N4:195-205 N4:205-225 N4:225-245 N4:245-265 N4:265-285 '+ $
            'N4:285-305 N4:305-325 N4:325-345 N4:345-365 N4:365-385 N4:385-405 N4:405-425 N4:425-445 N4:445-465 N4:465-485 N4:485-505 N4:505-555 '+ $
            'N4:555-605 N4:605-655 N4:655-705 N4:705-755 N4:755-805 N4:805-855 N4:855-905 N4:905-955 N4:955-1005 N4:1005-1105 N4:1105-1205 N4:1205-1305 '+ $
            'N4:1305-1405 N4:1405-1505 N4:1505-1605 N4:1605-1705 N4:1705-1805 N4:1805-1905 N4:1905-2005 N4:2005-2205 N4:2205-2405 N4:2405-2605 N4:2605-2805 N4:2805-3005 '+ $
            'N4:3005-inf ' +$
            'A4:5-15  A4:15-25   A4:25-35   A4:35-45   A4:45-55   A4:55-65   A4:65-75   A4:75-85   A4:85-95   A4:95:105  A4:105-115 A4:115-125 '+ $
            'A4:125-135 A4:135-145 A4:145-155 A4:155-165 A4:165-175 A4:175-185 A4:185-195 A4:195-205 A4:205-225 A4:225-245 A4:245-265 A4:265-285 '+ $
            'A4:285-305 A4:305-325 A4:325-345 A4:345-365 A4:365-385 A4:385-405 A4:405-425 A4:425-445 A4:445-465 A4:465-485 A4:485-505 A4:505-555 '+ $
            'A4:555-605 A4:605-655 A4:655-705 A4:705-755 A4:755-805 A4:805-855 A4:855-905 A4:905-955 A4:955-1005 A4:1005-1105 A4:1105-1205 A4:1205-1305 '+ $
            'A4:1305-1405 A4:1405-1505 A4:1505-1605 A4:1605-1705 A4:1705-1805 A4:1805-1905 A4:1905-2005 A4:2005-2205 A4:2205-2405 A4:2405-2605 A4:2605-2805 A4:2805-3005 '+ $
            'A4:3005-inf ' +$
            'M4:5-15  M4:15-25   M4:25-35   M4:35-45   M4:45-55   M4:55-65   M4:65-75   M4:75-85   M4:85-95   M4:95:105  M4:105-115 M4:115-125 '+ $
            'M4:125-135 M4:135-145 M4:145-155 M4:155-165 M4:165-175 M4:175-185 M4:185-195 M4:195-205 M4:205-225 M4:225-245 M4:245-265 M4:265-285 '+ $
            'M4:285-305 M4:305-325 M4:325-345 M4:345-365 M4:365-385 M4:385-405 M4:405-425 M4:425-445 M4:445-465 M4:465-485 M4:485-505 M4:505-555 '+ $
            'M4:555-605 M4:605-655 M4:655-705 M4:705-755 M4:755-805 M4:805-855 M4:855-905 M4:905-955 M4:955-1005 M4:1005-1105 M4:1105-1205 M4:1205-1305 '+ $
            'M4:1305-1405 M4:1405-1505 M4:1505-1605 M4:1605-1705 M4:1705-1805 M4:1805-1905 M4:1905-2005 M4:2005-2205 M4:2205-2405 M4:2405-2605 M4:2605-2805 M4:2805-3005 '+ $
            'M4:3005-inf '+$
            ' M4:spare1 M4:spare2 M4:spare3  #M4_spare  #M4_spare '

        header_strM61=' %accept is the percentage of images accepted by M1.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM62='Time %Accept #_irreg SVolume(L) conc(#/L) extn(1/km) IWC(g/m3) #M6_0-50um  #M6_50-250um #M6_>250um '+$
            'N6:5-15  N6:15-25   N6:25-35   N6:35-45   N6:45-55   N6:55-65   N6:65-75   N6:75-85   N6:85-95   N6:95:105  N6:105-115 N6:115-125 '+ $
            'N6:125-135 N6:135-145 N6:145-155 N6:155-165 N6:165-175 N6:175-185 N6:185-195 N6:195-205 N6:205-225 N6:225-245 N6:245-265 N6:265-285 '+ $
            'N6:285-305 N6:305-325 N6:325-345 N6:345-365 N6:365-385 N6:385-405 N6:405-425 N6:425-445 N6:445-465 N6:465-485 N6:485-505 N6:505-555 '+ $
            'N6:555-605 N6:605-655 N6:655-705 N6:705-755 N6:755-805 N6:805-855 N6:855-905 N6:905-955 N6:955-1005 N6:1005-1105 N6:1105-1205 N6:1205-1305 '+ $
            'N6:1305-1405 N6:1405-1505 N6:1505-1605 N6:1605-1705 N6:1705-1805 N6:1805-1905 N6:1905-2005 N6:2005-2205 N6:2205-2405 N6:2405-2605 N6:2605-2805 N6:2805-3005 '+ $
            'N6:3005-inf ' +$
            'A6:5-15  A6:15-25   A6:25-35   A6:35-45   A6:45-55   A6:55-65   A6:65-75   A6:75-85   A6:85-95   A6:95:105  A6:105-115 A6:115-125 '+ $
            'A6:125-135 A6:135-145 A6:145-155 A6:155-165 A6:165-175 A6:175-185 A6:185-195 A6:195-205 A6:205-225 A6:225-245 A6:245-265 A6:265-285 '+ $
            'A6:285-305 A6:305-325 A6:325-345 A6:345-365 A6:365-385 A6:385-405 A6:405-425 A6:425-445 A6:445-465 A6:465-485 A6:485-505 A6:505-555 '+ $
            'A6:555-605 A6:605-655 A6:655-705 A6:705-755 A6:755-805 A6:805-855 A6:855-905 A6:905-955 A6:955-1005 A6:1005-1105 A6:1105-1205 A6:1205-1305 '+ $
            'A6:1305-1405 A6:1405-1505 A6:1505-1605 A6:1605-1705 A6:1705-1805 A6:1805-1905 A6:1905-2005 A6:2005-2205 A6:2205-2405 A6:2405-2605 A6:2605-2805 A6:2805-3005 '+ $
            'A6:3005-inf' +$
            'M6:5-15  M6:15-25   M6:25-35   M6:35-45   M6:45-55   M6:55-65   M6:65-75   M6:75-85   M6:85-95   M6:95:105  M6:105-115 M6:115-125 '+ $
            'M6:125-135 M6:135-145 M6:145-155 M6:155-165 M6:165-175 M6:175-185 M6:185-195 M6:195-205 M6:205-225 M6:225-245 M6:245-265 M6:265-285 '+ $
            'M6:285-305 M6:305-325 M6:325-345 M6:345-365 M6:365-385 M6:385-405 M6:405-425 M6:425-445 M6:445-465 M6:465-485 M6:485-505 M6:505-555 '+ $
            'M6:555-605 M6:605-655 M6:655-705 M6:705-755 M6:755-805 M6:805-855 M6:855-905 M6:905-955 M6:955-1005 M6:1005-1105 M6:1105-1205 M6:1205-1305 '+ $
            'M6:1305-1405 M6:1405-1505 M6:1505-1605 M6:1605-1705 M6:1705-1805 M6:1805-1905 M6:1905-2005 M6:2005-2205 M6:2205-2405 M6:2405-2605 M6:2605-2805 M6:2805-3005 '+ $
            'M6:3005-inf ' +$
            'M1:265-285 M1:285-305 M1:305-325 #M6_lt265 #M6_gt325 '
    endif;  endif of if liqorice eq 'ice'

    if liqorice eq 'liq' then begin
        ;**********************************
        header_strM11=' %accept is the percentage of images accepted by M1.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM12='Time %Accept #_irreg SVolume(L) conc(#/L)  extn(1/km) IWC(g/m3) #M1_0-50um  #M1_50-250um #M1_>250um '+$
            'N1:5-15  N1:15-25   N1:25-35   N1:35-45   N1:45-55   N1:55-65   N1:65-75   N1:75-85   N1:85-95   N1:95:105  N1:105-115 N1:115-125 '+ $
            'N1:125-135 N1:135-145 N1:145-155 N1:155-165 N1:165-175 N1:175-185 N1:185-195 N1:195-205 N1:205-225 N1:225-245 N1:245-265 N1:265-285 '+ $
            'N1:285-305 N1:305-325 N1:325-345 N1:345-365 N1:365-385 N1:385-405 N1:405-425 N1:425-445 N1:445-465 N1:465-485 N1:485-505 N1:505-555 '+ $
            'N1:555-605 N1:605-655 N1:655-705 N1:705-755 N1:755-805 N1:805-855 N1:855-905 N1:905-955 N1:955-1005 N1:1005-1105 N1:1105-1205 N1:1205-1305 '+ $
            'N1:1305-1405 N1:1405-1505 N1:1505-1605 N1:1605-1705 N1:1705-1805 N1:1805-1905 N1:1905-2005 N1:2005-2205 N1:2205-2405 N1:2405-2605 N1:2605-2805 N1:2805-3005 '+ $
            'N1:3005-inf ' +$
            ' M1:spare1 M1:spare2 M1:spare3  #M1_spare  #M1_spare '

        header_strM21=' %accept is the percentage of images accepted by M2.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM22='Time %Accept #_irreg SVolume(L) conc(#/L)  extn(1/km) IWC(g/m3) #M2_0-50um  #M2_50-250um #M2_>250um '+$
            'N2:5-15  N2:15-25   N2:25-35   N2:35-45   N2:45-55   N2:55-65   N2:65-75   N2:75-85   N2:85-95   N2:95:105  N2:105-115 N2:115-125 '+ $
            'N2:125-135 N2:135-145 N2:145-155 N2:155-165 N2:165-175 N2:175-185 N2:185-195 N2:195-205 N2:205-225 N2:225-245 N2:245-265 N2:265-285 '+ $
            'N2:285-305 N2:305-325 N2:325-345 N2:345-365 N2:365-385 N2:385-405 N2:405-425 N2:425-445 N2:445-465 N2:465-485 N2:485-505 N2:505-555 '+ $
            'N2:555-605 N2:605-655 N2:655-705 N2:705-755 N2:755-805 N2:805-855 N2:855-905 N2:905-955 N2:955-1005 N2:1005-1105 N2:1105-1205 N2:1205-1305 '+ $
            'N2:1305-1405 N2:1405-1505 N2:1505-1605 N2:1605-1705 N2:1705-1805 N2:1805-1905 N2:1905-2005 N2:2005-2205 N2:2205-2405 N2:2405-2605 N2:2605-2805 N2:2805-3005 '+ $
            'N2:3005-inf ' +$
            ' M2:spare1 M2:spare2 M2:spare3  #M2_spare  #M2_spare '

        header_strM41=' %accept is the percentage of images accepted by M4.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM42='Time %Accept #_irreg SVolume(L) conc(#/L)  extn(1/km) IWC(g/m3) #M4_0-50um  #M4_50-250um #M4_>250um '+$
            'N4:5-15  N4:15-25   N4:25-35   N4:35-45   N4:45-55   N4:55-65   N4:65-75   N4:75-85   N4:85-95   N4:95:105  N4:105-115 N4:115-125 '+ $
            'N4:125-135 N4:135-145 N4:145-155 N4:155-165 N4:165-175 N4:175-185 N4:185-195 N4:195-205 N4:205-225 N4:225-245 N4:245-265 N4:265-285 '+ $
            'N4:285-305 N4:305-325 N4:325-345 N4:345-365 N4:365-385 N4:385-405 N4:405-425 N4:425-445 N4:445-465 N4:465-485 N4:485-505 N4:505-555 '+ $
            'N4:555-605 N4:605-655 N4:655-705 N4:705-755 N4:755-805 N4:805-855 N4:855-905 N4:905-955 N4:955-1005 N4:1005-1105 N4:1105-1205 N4:1205-1305 '+ $
            'N4:1305-1405 N4:1405-1505 N4:1505-1605 N4:1605-1705 N4:1705-1805 N4:1805-1905 N4:1905-2005 N4:2005-2205 N4:2205-2405 N4:2405-2605 N4:2605-2805 N4:2805-3005 '+ $
            'N4:3005-inf ' +$
            ' M4:spare1 M4:spare2 M4:spare3  #M4_spare  #M4_spare '

        header_strM61=' %accept is the percentage of images accepted by M1.  #_irreg is the number of timing irregularities that occured during that second.'
        header_strM62='Time %Accept #_irreg SVolume(L) conc(#/L) extn(1/km) IWC(g/m3) #M6_0-50um  #M6_50-250um #M6_>250um '+$
            'N6:5-15  N6:15-25   N6:25-35   N6:35-45   N6:45-55   N6:55-65   N6:65-75   N6:75-85   N6:85-95   N6:95:105  N6:105-115 N6:115-125 '+ $

            'N6:125-135 N6:135-145 N6:145-155 N6:155-165 N6:165-175 N6:175-185 N6:185-195 N6:195-205 N6:205-225 N6:225-245 N6:245-265 N6:265-285 '+ $
            'N6:285-305 N6:305-325 N6:325-345 N6:345-365 N6:365-385 N6:385-405 N6:405-425 N6:425-445 N6:445-465 N6:465-485 N6:485-505 N6:505-555 '+ $
            'N6:555-605 N6:605-655 N6:655-705 N6:705-755 N6:755-805 N6:805-855 N6:855-905 N6:905-955 N6:955-1005 N6:1005-1105 N6:1105-1205 N6:1205-1305 '+ $
            'N6:1305-1405 N6:1405-1505 N6:1505-1605 N6:1605-1705 N6:1705-1805 N6:1805-1905 N6:1905-2005 N6:2005-2205 N6:2205-2405 N6:2405-2605 N6:2605-2805 N6:2805-3005 '+ $
            'N6:3005-inf ' +$
            'M1:265-285 M1:285-305 M1:305-325 #M6_lt265 #M6_gt325 '
    endif

    case !autoarchive_method of
        'M1': begin
            printf,21,header_strM11
            printf,21,header_strM12
            printf,22,header_strM11
            printf,22,header_strM12
        end
        'M2': begin
            printf,21,header_strM21
            printf,21,header_strM22
            printf,22,header_strM21
            printf,22,header_strM22
        end
        'M4': begin
            printf,21,header_strM41
            printf,21,header_strM42
            printf,22,header_strM41
            printf,22,header_strM42
        end
        'M6': begin
            printf,21,header_strM61
            printf,21,header_strM62
            printf,22,header_strM61
            printf,22,header_strM62
        end
    endcase


    ;********************************
    nnnH=n_elements((*alldataH).area)
    nnnV=n_elements((*alldataV).area)
    data_starttime=min([(*alldataH)(0).nanoseconds,(*alldataV)(0).nanoseconds]);  common H and V starttime
    data_startseconds=round(data_starttime/1000000000.0); start earlier; no trouble hope.

    HlastTime=(*alldataH)(nnnH-1LL).nanoseconds
    VlastTime=(*alldataV)(nnnV-1LL).nanoseconds
    data_endtime  =max([HlastTime,VlastTime]);take the max of  H avd V endtime.


    ; added this on June 5, 2007 to avoid archiving from 0 second to 20-hours  that takes days to do.
    ;************************************************************************
    ;calculate the file_name-start_time from the datetimestring
    if strlen(datetimestring) lt 20 then begin
        filename_startTime1=strmid(datetimestring,6,6)
        filename_startsec=(strmid(filename_starttime1,0,2)*3600LL+strmid(filename_starttime1,2,2)*60LL+$
            strmid(filename_starttime1,4,2)*1LL)
        fileName_endsec  =(data_endtime/1000000000LL-1LL)
        if fileName_endsec lt filename_startsec then begin
            fileName_endSec=86400000000000LL;  to teh time 24:00:00 seconds.
            rrr=dialog_message('End_time less than start time, archive to midnight!!',/information)
            stop
        endif
    endif

    if strlen(datetimestring) ge 20 then begin ; for this kind:070808202239_202306_0000
        filename_startTime2=strmid(datetimestring,13,6);   ;that is 20:23:06
        filename_startsec=(strmid(filename_starttime2,0,2)*3600LL+strmid(filename_starttime2,2,2)*60LL+$
            strmid(filename_starttime2,4,2)*1LL)
        fileName_endsec  =(data_endtime/1000000000LL) ;  >  fileName_startSec
        if fileName_endsec lt filename_startsec then begin
            fileName_endSec=86400000000000LL;  to teh time 24:00:00 seconds.
            rrr=dialog_message(['End_time less than start time, archive to midnight!!'],/information)
            print,!currentHFname
            stop
        endif
    endif
    ;*************************************************************************************
    if strlen(datetimestring) ge 30 then begin
        filename_endTime1=strmid(datetimestring,20,6)
        filename_Endsec=(strmid(filename_endtime1,0,2)*3600LL+strmid(filename_endtime1,2,2)*60LL+$
            strmid(filename_endtime1,4,2)*1LL)
        if fileName_endsec lt filename_startsec then begin
            fileName_endSec=86400LL;  to teh time 24:00:00 seconds.
            rrr=dialog_message('End_time less than start time, archive to midnight!!',/information)
            print,!currentHFname
            stop
        endif
    endif else begin
        filename_Endsec= (round(data_endtime/1000000000.0)) ;> fileName_startSec
        if fileName_endsec lt filename_startsec then begin
            fileName_endSec=86400LL;  to the time 24:00:00 seconds.
            rrr=dialog_message('End_time less than start time, archive to midnight!!',/information)
            print,!currentHFname
            stop
        endif
    endelse

    ;*************************************************************************************
    ; changed to following line for namma data , because it is very odd in the namma data
    ; if data_startseconds eq 0LL then begin
    ; data_startseconds=(firstdata.nanoseconds/1000000000LL +0LL); start earlier; no trouble hope.
    ; endif

    data_endseconds  =floor(data_endtime/1000000000LL +0LL);  changed from +1LL to +0LL on Oct23,2007.
    nnn=(data_endseconds-data_startseconds) > 2; make at least 2 points for 1 second.

    ferry1=0
    ;make aaccount of ferry flight the wrong time.
    if ferry1 eq 1 then begin ; 3V2DS time is 7 hours ahhead of CPIview time.
        seconds_offset=17LL*3600LL;  00:25:00  to 17:25:00
    endif else seconds_offset=0LL

    starttime_insec=filename_startSec >data_startseconds;   data_startseconds
    if strlen(datetimestring) eq 12 then  starttime_insec=filename_startSec > data_startseconds

    ;added this part in June 5 2007 to avoid archiving from 0 seconds to 20-hourse
    ;*********************************************************************************
    ; if abs(long64(starttime_insec)-long64(filename_startsec)) gt 1 then begin
    if data_startseconds eq 0 then begin
        print,'data_start_time=',starttime_insec
        print,'filename_start_time =',filename_startsec
        print,'data_startseconds eq 0, use filename_start_time_to start_archiving___, Warning ****** !!!!'
        ; rrr=dialog_message('Looks like data start_time is too much off setted, use file_name-start_time ?',/question)
        ; if rrr eq 'Yes' then starttime_insec=filename_startsec else stop
        starttime_insec=filename_startsec

    endif
    ;*********************************************************************************

    ;Get 1Hz bin file end second time. fixed that after sorted there is some time spikes in the sorted file
    ; max_seconds=1LL+(lastData.nanoseconds > lastdataV.nanoseconds)/1000000000LL
    ; data_endseconds= (data_endseconds < max_seconds);56040LL
    ; comment above to line and added below one line on oct 23, 2007.
    data_endseconds= (data_endseconds < filename_endsec )

    total_seconds=(data_endseconds-data_startseconds) > 2;  for calculation the percentage done.
    Five_percent=(total_seconds/20LL) > 1
    Done_count=0

    ; ******************************************************
    make_61_bins_ultimate,nbins,nedges,xpts,dbl_binwidths; xptsjunk(0)=5; xptsjunk(1)=15 IN HERE.
    single_binwidths=dbl_binwidths(0:n_elements(dbl_binwidths)-1:2)
    bin_centers=fltarr(61)
    for i=0,60 do bin_centers(i)=(xpts(2*i)+xpts(2*i+1))/2.0
    bin_centers(60)=3105.0
    ;*******************************************************

    ;starttime_insec= data_startseconds;                          56020LL
    ;  filename_endsec=56136; what is data_enseconds ?
    ; while starttime_insec Le data_endseconds do begin
    if !use_nav_tas_correct_L1n eq 1  then begin
        ; TAF commenting out unresolved for making .sav
        stop
        ;load_navigation_time_tas_two_column_data,TAStime,TasVal
    endif

    while starttime_insec Le (filename_endSEc-1LL) do begin

        endtime_insec=starttime_insec+Nseconds
        starttime=starttime_insec*1000000000LL; nanoseconds

        endtime  =  endtime_insec*1000000000LL;  nanoseconds


        Are_there_non_monotonic_data,startTime,endTime,H_has_bad,V_has_bad

        ;if startTime ge 75747000000000LL then stop

        ;*************************************************************************************************
        if H_has_bad eq 0 then begin
            if !autoarchive_method eq 'M6' then begin
                get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'H','M6=1','M1',liqorice,starttime,endtime,$ ;inputs
                    has_dataM1,xpts,dbl_binwidths,yptsM1,AptsM1,Iptsm1,ystrM1,sizesM1,areasM1,adjsM1,HliveV,Hdeadtime,HPartcontM1,adjustmentfactorM1; outputs
                get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'H','M6=1','M2',liqorice,starttime,endtime,$ ;inputs
                    has_dataM2,xpts,dbl_binwidths,yptsM2,AptsM2,IptsM2,ystrM2,sizesM2,areasM2,adjsM2,HliveV,Hdeadtime,HPartcontM2,adjustmentfactorM2; outputs
                ;make the combined 64 bins data and the time series of the M1 M2 methods.
                Make_M1M2_64bins_data,xpts,yptsM1,yptsM2,$ ; input
                    HyptsM1M2,Hbin1,Hbin2,Hbin3; output; also PartcontM1, partcontM2
                Make_M1M2_64bins_data,xpts,AptsM1,AptsM2,$ ; input
                    HAptsM1M2,Hbin1b,Hbin2b,Hbin3b; output; also PartcontM1, partcontM2
                Make_M1M2_64bins_data,xpts,IptsM1,IptsM2,$ ; input;  I means ice
                    HIptsM1M2,Hbin1c,Hbin2c,Hbin3c; output; also PartcontM1, partcontM2
                adjustmentfactor=adjustmentfactorM1;  ???????????????????????
                has_data=has_dataM1 or has_dataM2
                ;replace PartcontM1 and PartcontM2 with size range values.
                junk=where(sizesM2 le 26.50 and sizesM2 gt 0.0,HPartcontM2)
                junk=where(sizesM1 ge 32.50,HPartcontM1)
                Get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,'H','M4',liqorice,starttime,endtime,$;  need to work on. later
                    HNGoodpercent,Hirregular_cont,Hcont0to50,Hcont50to250,Hcontgt250

                ;**********************************************************************
                Hconc =total(HyptsM1M2*single_binwidths) ; #/L
                Hextn = 2.0*total(HAptsM1M2*single_binwidths);  mm^2/L
                HIWC =total(HIptsM1M2*single_binwidths);    mg/L
                if Hconc gt.0 then begin
                    HMnSz=total(HyptsM1M2*bin_centers*single_binwidths)/Hconc;  in unit um.
                endif else HmnSz=0.0

                HApts=HAPtsM1M2
                HIPts=HIPtsM1M2
                HYpts=HyptsM1M2
                Hlt=1.0-Hdeadtime
                if adjustmentfactor eq 0.0 then begin
                    Hsv=HliveV >0.00000001
                endif else begin
                    Hsv=(HliveV >0.00000001)/adjustmentfactor
                    if HliveV gt 40.0 then begin
                        mymessage='Sample volume too big HliveV='+string(HliveV)+'At time:' + string(startTime)+'--'+string(endtime)
                        print,mymessage;  ;open a file to write the problematic time periods.
                        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
                        openw,8,outputfilename,/append
                        printf,8,mymessage
                        close,8
                        goto,has_bad_data_h
                    endif
                endelse
                ;*********************************************************************
                ;               if startTime ge 75747LL then stop
            endif else begin;  here is M1, M2, M4
                ;get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'M4',starttime,endtime,$ ;inputs
                ;has_data,xpts,Hypts,ystr,sizes,areas,adjs,HliveV,Hdeadtime,Partcont,adjustmentfactor; outputs
                get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'H','M6=0',!autoarchive_method,liqorice,starttime,endtime,$ ;inputs
                    has_data,xpts,dbl_binwidths,Hypts,HApts,HIpts,ystr,sizes,areas,adjs,HliveV,Hdeadtime,Partcont,adjustmentfactor; outputs



                ;Get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,'H',!autoarchive_method,liqorice,starttime,endtime,$
                ;         HNGoodpercent,Hirregular_cont,Hcont0to50,Hcont50to250,Hcontgt250

                ; TAF need to update this with HorV and liqorice
                Get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,!autoarchive_method,starttime,endtime,$
                    HNGoodpercent,Hirregular_cont,Hcont0to50,Hcont50to250,Hcontgt250


                ;print,HliveV,'  ',Hdeadtime,'toatl_adjs=',total(adjs),' ',partcont,' time=',starttime, 'factor=',adjustmentfactor
                ;print,'Hypts=',Hypts(0:3)
                ;if starttime eq 56770000000000LL then stop

                Hlt=1.0-Hdeadtime
                if adjustmentfactor eq 0.0 then begin
                    Hsv=HliveV >0.00000001
                endif else begin
                    Hsv=(HliveV >0.00000001)/adjustmentfactor
                    if HliveV gt 40.0 then begin
                        mymessage='Sample volume too big HliveV='+string(HliveV)+'At time:' + string(startTime)+'--'+string(endtime)
                        print,mymessage;  ;open a file to write the problematic time periods.
                        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
                        openw,8,outputfilename,/append
                        printf,8,mymessage
                        close,8
                        goto,has_bad_data_h
                    endif
                endelse

                if total(adjs) gt .0 then begin
                    HMnSz=10.0*total(adjs*sizes)/total(adjs);  in unit um.
                endif else HmnSz=0.0
                Hconc=total(Hypts*single_binwidths); #/L
                Hextn=2.0*total(HApts*single_binwidths); 1/km.
                HIWC =total(HIpts*single_binwidths); g/M3.
            endelse


            ; get the  TAS mean values during this seconds and the Correct TAS values to correct the HliveV.
            ;Added flowing to correct for maCpex because TAS is not correct.

            if !use_nav_tas_correct_L1n eq 1  then begin
                indexCor=where(TasTime ge StartTime_insec and TasTime le EndTime_insec,contGcor)
                if contGcor gt 0 then begin
                    TAS_correct =mean( TASval(indexCor))
                endif else begin
                    indexCor=where(abs(TasTime-StartTime_insec) eq min(abs(TasTime-Starttime_insec)))
                    TAS_correct=TASval(indexCor(0))
                endelse

                indexTAS=where((*alldataH).nanoseconds ge StartTime and (*alldataH).nanoseconds le EndTime, contTas)
                if contTAS gt 0 then begin
                    This_mean_TAS=mean((*alldataH)(indexTAS).tas)
                endif else begin
                    indexB=where((*alldataH).nanoseconds ge startTime, contB)
                    indexA=where((*alldataH).nanoseconds le EndTime, contA)
                    if contB gt 0 then TASB=(*alldataH)(indexB(0)).tas else TASB=(*alldataH)(n_elements((*alldataH).tas)-1).tas
                    if contA gt 0 then TASA=(*alldataH)(max(indexA)).tas else TASA=(*alldataH)(0).tas
                    This_mean_TAS=(TASA+TASB)/2.0
                endelse

                factor_tas= TAS_correct/This_mean_TAS
                Hsv=Hsv*Factor_tas
                HApts=HApts/Factor_tas
                Hypts=Hypts/Factor_tas
                HIpts=HIpts/Factor_tas
                Hconc=Hconc/Factor_tas
                Hextn=Hextn/Factor_tas
                HIWC =Hiwc/Factor_tas
            endif

            ;**************************************************************************
        endif else begin;  H_has_bad =1 there is bad time in the time interval.
            has_bad_data_h:
            HNgoodpercent=0
            Hirregular_cont=bad_data
            Hconc=bad_data
            Hextn=bad_data
            HLWC=bad_data
            Hcont0to50=bad_data
            Hcont50to250=bad_data
            Hcontgt250=bad_data;8 numbers
            Hypts=replicate(Bad_data,61)
            HApts=Hypts
            HIpts=Hypts
            HYptsM1M2=Hypts;$; 2x61 bins values.
                HAptsM1M2=Hypts
            HIptsM1M2=Hypts
            Hbin1=bad_data
            Hbin2=bad_data
            Hbin3=bad_data
            HPartcontM2=bad_data
            HPartcontM1=bad_data
            HIWC       =bad_data
            Hsv  =bad_data; sample vloume.
        endelse


        ;if startTime ge 75747000000000LL then stop
        ;***************************************************************
        if V_has_bad eq 0 then begin
            ;***********************************************************
            if !autoarchive_method eq 'M6' then begin
                get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'V','M6=1','M1',liqorice,starttime,endtime,$ ;inputs
                    has_dataM1,xpts,dbl_binwidths,yptsM1,AptsM1,IptsM1,ystrM1,sizesM1,areasM1,adjsM1,VliveV,Vdeadtime,VPartcontM1,adjustmentfactorM1; outputs
                get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'V','M6=1','M2',liqorice,starttime,endtime,$ ;inputs
                    has_dataM2,xpts,dbl_binwidths,yptsM2,AptsM2,IptsM2,ystrM2,sizesM2,areasM2,adjsM1,VliveV,Vdeadtime,VPartcontM2,adjustmentfactorM2; outputs
                ;make the combined 64 bins data and the time series of the M1 M2 methods.
                Make_M1M2_64bins_data,xpts,yptsM1,yptsM2,$ ; input
                    VyptsM1M2,Vbin1,Vbin2,Vbin3; output; also PartcontM1, partcontM2
                Make_M1M2_64bins_data,xpts,AptsM1,AptsM2,$ ; input
                    VAptsM1M2,Vbin1b,Vbin2b,Vbin3b; output; also PartcontM1, partcontM2
                Make_M1M2_64bins_data,xpts,IptsM1,IptsM2,$ ; input
                    VIptsM1M2,Vbin1c,Vbin2c,Vbin3c; output; also PartcontM1, partcontM2

                adjustmentfactor=adjustmentfactorM1;  ???????????????????????
                has_data=has_dataM1 or has_dataM2

                ;replace PartcontM1 and PartcontM2 with size range values.
                junk=where(sizesM2 le 26.5 and sizesM2 gt 0.0,VPartcontM2);  sizes M2 is unit pixels.
                junk=where(sizesM1 ge 32.5,VPartcontM1)

                ; TAF need to update this with HorV and liqorice
                ;get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,'V','M4',liqorice,starttime,endtime,$
                ;              VNGoodpercent,Virregular_cont,Vcont0to50,Vcont50to250,Vcontgt250

                get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,'M4',starttime,endtime,$
                    VNGoodpercent,Virregular_cont,Vcont0to50,Vcont50to250,Vcontgt250


                ;**********************************************************************
                Vconc =total(vyptsM1M2*single_binwidths) ; #/L
                Vextn =2.0*total(VAptsM1M2*single_binwidths);  mm^2/L
                VIWC =total(VIptsM1M2*single_binwidths)
                if Vconc gt.0 then begin
                    VMnSz=total(VyptsM1M2*bin_centers*single_binwidths)/Vconc;  in unit um.
                endif else VmnSz=0.0

                VApts=VAPtsM1M2
                VIPts=VIPtsM1M2
                VYpts=VyptsM1M2

                Vlt=1.0-Vdeadtime
                if adjustmentfactor eq 0.0 then begin
                    Vsv=VliveV >0.00000001
                endif else begin
                    Vsv=(VliveV >0.00000001)/adjustmentfactor
                    if VliveV gt 40.0 then begin
                        mymessage='Sample volume too big VliveV='+string(VliveV)+'At time:' + string(startTime)+'--'+string(endtime)
                        print,mymessage;  ;open a file to write the problematic time periods.
                        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
                        openw,8,outputfilename,/append
                        printf,8,mymessage
                        close,8
                        goto,has_bad_data_v
                    endif
                endelse
                ;*********************************************************************
            endif else begin


                get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'V','M6=0',!autoarchive_method,liqorice,starttime,endtime,$ ;inputs
                    has_data,xpts,dbl_binwidths,Vypts,VApts,VIpts,ystr,sizes,areas,adjs,VliveV,Vdeadtime,Partcont,adjustmentfactor; outputs

                ; TAF need to update this with HorV and liqorice
                ;           get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,'V',!autoarchive_method,liqorice,starttime,endtime,$
                ;                    VNGoodpercent,Virregular_cont,Vcont0to50,Vcont50to250,Vcontgt250

                get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,!autoarchive_method,starttime,endtime,$
                    VNGoodpercent,Virregular_cont,Vcont0to50,Vcont50to250,Vcontgt250


                Vlt=1.0-Vdeadtime
                if adjustmentfactor eq 0.0 then begin
                    Vsv=VliveV >0.00000001
                endif else begin
                    Vsv=(VliveV >0.00000001)/adjustmentfactor
                    if VliveV gt 40.0 then begin
                        mymessage='Sample volume too big VliveV='+string(VliveV)+'At time:' + string(startTime)+'--'+string(endtime)
                        print,mymessage;  ;open a file to write the problematic time periods.
                        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
                        openw,8,outputfilename,/append
                        printf,8,mymessage
                        close,8
                        goto,has_bad_data_v
                    endif
                endelse
                if total(adjs) gt.0 then begin
                    VMnSz=10.0*total(adjs*sizes)/total(adjs);  in unit um.
                endif else VmnSz=0.0
                Vconc=total(Vypts*single_binwidths); #/L
                Vextn=2.0*total(VApts*single_binwidths); 1/km.
                VIWC =total(VIpts*single_binwidths); g/M3.
            endelse
            ;********************************************************

            ; get the  TAS mean values during this seconds and the Correct TAS values to correct the HliveV.
            ;Added flowing to correct for maCpex because TAS is not correct.
            if !use_nav_tas_correct_L1n eq 1  then begin
                indexCor=where(TasTime ge StartTime_insec and TasTime le EndTime_insec,contGcor)
                if contGcor gt 0 then begin
                    TAS_correct =mean( TASval(indexCor))
                endif else begin
                    indexCor=where(abs(TasTime-StartTime_insec) eq min(abs(TasTime-Starttime_insec)))
                    TAS_correct=TASval(indexCor(0))
                endelse

                indexTAS=where((*alldataV).nanoseconds ge StartTime and (*alldataV).nanoseconds le EndTime, contTas)
                if contTAS gt 0 then begin
                    This_mean_TAS=mean((*alldataV)(indexTAS).tas)
                endif else begin
                    indexB=where((*alldataV).nanoseconds ge startTime, contB)
                    indexA=where((*alldataV).nanoseconds le EndTime, contA)
                    if contB gt 0 then TASB=(*alldataV)(indexB(0)).tas else TASB=(*alldataV)(n_elements((*alldataV).tas)-1).tas
                    if contA gt 0 then TASA=(*alldataV)(max(indexA)).tas else TASA=(*alldataV)(0).tas
                    This_mean_TAS=(TASA+TASB)/2.0
                endelse
                factor_tas= TAS_correct/This_mean_TAS
            endif  else factor_tas=1.0

            Vsv=Vsv*Factor_tas
            VApts=VApts/Factor_tas
            Vypts=Vypts/Factor_tas
            VIpts=VIpts/Factor_tas
            Vconc=Vconc/Factor_tas
            Vextn=Vextn/Factor_tas
            VIWC =Viwc/Factor_tas

        endif else begin;  if V_hasBad=1 there is  bad time in this time interval.
            has_bad_data_v:
            VNgoodpercent=0
            Virregular_cont=bad_data
            Vconc=bad_data
            Vextn=bad_data
            VLWC=bad_data
            Vcont0to50=bad_data
            Vcont50to250=bad_data
            Vcontgt250=bad_data;8 numbers
            Vypts=replicate(Bad_data,61)
            VApts=Vypts
            VIpts=Vypts
            VYptsM1M2=Vypts;$; 2x61 bins values.
                VAptsM1M2=Vypts
            VIptsM1M2=Vypts
            Vbin1=bad_data
            Vbin2=bad_data
            Vbin3=bad_data
            VPartcontM2=bad_data
            VPartcontM1=bad_data
            VIWC =bad_data
            Vsv  =bad_data
        endelse
        ;***********************************************************************
        ;********************************************************************
        ;********************************************************************
        if !autoarchive_method eq 'M6' then begin
            if liqorice eq 'ice' then begin
                printf,21,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    HNgoodpercent,Hirregular_cont,Hsv,Hconc,Hextn,HIWC,Hcont0to50,Hcont50to250,Hcontgt250,$  ;9 numbers
                    HYptsM1M2,HAptsM1M2,HIptsM1M2, $; 2x61 bins values.
                    Hbin1,Hbin2,Hbin3,HPartcontM2,HPartcontM1; 5 values.  need to add Hsv
                ;**************************************************************************

                ;********************************************************************
                printf,22,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    VNgoodpercent,Virregular_cont,Vsv,Vconc,Vextn,VIWC,Vcont0to50,Vcont50to250,Vcontgt250,$  ;9 numbers
                    VYptsM1M2,VAptsM1M2,VIptsM1M2, $; 3x61 bins values.
                    Vbin1,Vbin2,Vbin3,VPartcontM2,VPartcontM1; 5 values.  need to add Vsv
                ;**************************************************************************
            endif
            if liqorice eq 'liq' then begin
                printf,21,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    HNgoodpercent,Hirregular_cont,Hsv,Hconc,Hextn,HIWC,Hcont0to50,Hcont50to250,Hcontgt250,$  ;9 numbers
                    HYptsM1M2, $; 1x61 bins values.
                    Hbin1,Hbin2,Hbin3,HPartcontM2,HPartcontM1; 5 values.  need to add Hsv
                ;**************************************************************************

                ;********************************************************************
                printf,22,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    VNgoodpercent,Virregular_cont,Vsv,Vconc,Vextn,VIWC,Vcont0to50,Vcont50to250,Vcontgt250,$  ;9 numbers
                    VYptsM1M2,$; 1x61 bins values.
                    Vbin1,Vbin2,Vbin3,VPartcontM2,VPartcontM1; 5 values.  need to add Vsv
                ;**************************************************************************
            endif

        endif else begin
            if liqorice eq 'ice' then begin; ; TAF need to correct for case sensitive
                printf,21,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    HNgoodpercent,Hirregular_cont,Hsv,Hconc,Hextn,HIWC,Hcont0to50,Hcont50to250,Hcontgt250,$  ;9 numbers
                    Hypts,HApts,HIpts, $; 3x61 bins values.
                    0.0, 0.0, 0.0, 0.0,0.0;   ; 5 values.  need to add Hsv

                printf,22,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    VNgoodpercent,Virregular_cont,Vsv,Vconc,Vextn,VIWC,Vcont0to50,Vcont50to250,Vcontgt250,$  ;9 numbers
                    Vypts,VApts,VIpts, $; 3x61 bins values.
                    0.0, 0.0, 0.0, 0.0,0.0;   ; 5 values.  need to add Vsv
            endif;   end of liqorice eq 'ice'

            if liqorice eq 'liq' then begin
                printf,21,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    HNgoodpercent,Hirregular_cont,Hsv,Hconc,Hextn,HIWC,Hcont0to50,Hcont50to250,Hcontgt250,$  ;9 numbers
                    Hypts, $; 3x61 bins values.
                    0.0, 0.0, 0.0, 0.0,0.0;   ; 5 values.  need to add Hsv

                printf,22,format='(I5,1x,I3,1x,8(E11.3,1x),46(E11.3,1x),15(E11.3,1x),5(E11.3,1x))',$
                    starttime_insec+seconds_offset,$;    ;1 number
                    VNgoodpercent,Virregular_cont,Vsv,Vconc,Vextn,VIWC,Vcont0to50,Vcont50to250,Vcontgt250,$  ;9 numbers
                    Vypts, $; 1x61 bins values.
                    0.0, 0.0, 0.0, 0.0,0.0;   ; 5 values.  need to add Vsv
            endif;   end of liqorice eq 'ice'
        endelse

        if !autoarchive_method ne 'M6' then if min(Hypts)     lt 0.0 and min(Hypts) ne bad_data then stop
        if !autoarchive_method eq 'M6' then if min(HyptsM1M2) and min(HyptsM1M2) ne bad_data  lt 0.0 then stop

        done_count=done_count+1LL

        if done_count mod five_percent eq 0 and n_elements(info) gt 0  then begin
            percentage=100.0*float(done_count)/float(total_seconds)
            Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value=$
                string( format = '("Archiving Done:" , F5.0,"%")',percentage)
        endif

        starttime_insec=endtime_insec

    endwhile
    ;close,2
    close,21,22
    print,'Finished 1 seconds ultimate psd archive processing !!!!!!!*********' + !currentHFname
    free_all
end; do_Nsecond_ultimate_archive_61bins
;********************************************************************************

;*****************************************************************************************
pro  get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,HorV,M6TorF,L_choice,liqorice,starttime,endtime,$ ;inputs
    has_data,xpts,dbl_binwidths,ypts,Apts,Ipts,ystr,sizes,areas,adjs,HliveV,Hdeadtime,Partcont,adjustmentfactor; outputs
Common  DataBlock,alldataH,alldataV
;the output sizes are in pixels.

;Get_Hsv_deadtime_between_time1_time2,starttime,endtime,HliveV,Hdeadtime
Get_total_DTs_btw_T1T2,HorV,starttime,endtime,Hdeadtime,Fullticks,HliveV
; TAF 2013-09-27 need to update alldata to pointers!
if HorV eq 'H' then alldata = alldataH
if HorV eq 'V' then alldata = alldataV

case L_choice of
    'M1': begin  ; M1 should be in focus but not cleaned.
        if M6TorF eq 'M6=0' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0,total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L1n; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                adjustmentfactor=factor1
                ;adjs  = (*alldata)(subindex).adj1; for M6 method.
                F1=(*alldata)(subindex).F1
                get_method1adjvalues_of_normal,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse
        endif ; if M6TorF eq M6False

        if M6TorF eq 'M6=1' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0 and $
                (*alldata).area gt 0.9*(*alldata).alexei1,total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L1n; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                adjustmentfactor=factor1
                ;adjs  = (*alldata)(subindex).adj1; for M6 method.
                F1=(*alldata)(subindex).F1
                get_method1adjvalues_of_M6,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse

        endif ; if M6TorF eq M6=1
    end; end of M1 method; wihci is not clean.

    'M2': begin ; M2 should be cleaned and in focus.
        if M6TorF eq 'M6=0' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0, total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L4; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                adjustmentfactor=factor1
                get_method2adjvalues_of_normal,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
                sizes=sizes
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse
        endif; end of M6TorF eq 'M6=0'
        if M6TorF eq 'M6=1' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0 and $
                (*alldata).area gt 0.9*(*alldata).alexei1, total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L4; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                adjustmentfactor=factor1
                get_method2adjvalues_of_M6,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
                sizes=sizes
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse
        endif; end of M6TorF eq 'M6=1'
    end
    'M4':begin ; should be both in-focus and out of focus and cleaned.
    subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        (*alldata).area gt 0 and (*alldata).reject eq 0,total_accepted_N)
    factor1=1.0

    if subindex(0) ne -1 then begin
        has_data=1
        Partcont=strtrim(n_elements(subindex))
        L7=(*alldata)(subindex).L7
        areas=(*alldata)(subindex).area
        sizes_L4=(*alldata)(subindex).L4
        sizes_L1=(*alldata)(subindex).L1n
        adj0s   =(*alldata)(subindex).adj0
        F1      =(*alldata)(subindex).F1
        Dmax    =(*alldata)(subindex).alexei1;  ;maximium total countor_area from alexei's
        index=where(Dmax gt 0.0,total_events)
        ;need to select only those true particle, get rid of fake particles
        ;index=where(Dmax gt 0.0 and (Sizes_L4 gt 0.49*sizes_L1 and sizes_L4 gt 0.49*sizes_L1), contDmax)
        roundness=(*alldata)(subindex).roundness
        index =where(Dmax gt 0.0 and roundness eq 1,contDmax)
        Partcont=strtrim(contDmax,2)

        if contDmax ge 1 then begin
            adjustmentfactor=factor1*float(total_events)/float(contDmax)
        endif else adjustmentfactor=0.0

        if contDmax ge 1 then begin
            sizes=L7(index)
            F1    =F1(index)
            areas=areas(index);area=!pi*sizes^2/4.0;in unit pixel^2  Chnaged on May 27, 2011 for ice method M4, still use shaded area.
            get_method4adjvalues,HorV,sizes,F1,adjs; ;input sizes has to be in unit pixels
            if !filter eq 1 then  adjs=adjs*adj0s(index)
        endif else begin
            sizes=[0.0,0.0]
            areas=[0.0,0.0]
            adjs=areas
            ;xxxxx=dialog_message('There are no M4 particles',/information)
        endelse
    endif else begin
        has_data=0
        Partcont='0';strtrim(n_elements(subinxex))
        sizes=[0.0]
        areas=[0.0]
        adjs=0.0
        adjustmentfactor=0.0
    endelse
end; end; of M4 method
endcase

area_liq=!pi*(sizes^2)/4.0
area_ice=area_liq < areas

if liqorice eq 'liq' then  areas=area_liq;    in unit pixel^2
if liqorice eq 'ice' then  areas=area_ice;    in unit pixel^2

;step 2:    sizes from abobe is in unit pixels.
;calculate the mean psd of the H-channel parricles. since sizes, area and adjs are obtained.
SVdefault=HliveV
original_factor=1.0;  because no criteria is selected for archiving, orig_factor has to be 1.0

xpts(0)=0.001;  ;make_61_bins,nbins,nedges,xpts,dbl_binwidths
nedges=n_elements(xpts)
ypts = fltarr(nedges)
Apts =fltarr(nedges)
Ipts =fltarr(nedges)

if has_data eq 1 then begin
    alpha = 0.115D
    beta = 1.218D
    sizes=sizes*10.0

    for j=0,nedges-2,2 do begin  ;sizes should be in um in here ?????
        binwidth=dbl_binwidths(j);  (xpts[j+1]-xpts[j]); this in uni unit of um.
        LiterTum=binwidth*SVdefault
        somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins
        if contG gt 0 then begin;  if there is no particles, area and mass should be zero
            this_adj1=adjs(somarr)
            ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]

            this_area=areas(somarr);       in unit pixels.
            Apts[j:j+1] =total(this_adj1*this_area*0.0001)/LiterTum; area mm^2/Liter/um. plot_area

            This_sizes=sizes(somarr)
            This_area_mm2=This_area*0.0001; change it to be mm2.

            if liqorice eq 'ice' then begin
                get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2
                Ipts[j:j+1]=total_IWC/LiterTum;  mg/L/um
            endif

            if liqorice eq 'liq' then begin
                total_LWC=total(0.917*(0.1^9)*this_adj1*This_sizes^3)*!pi/6.0
                Ipts[j:j+1]=total_LWC/LiterTum;  mg/L/um
            endif

        endif ; else begin
        ; no need to assign all ypts[j:j+1]
        ; endelse
    endfor

    ;**********************************************************
    xpts(0)=5.0
    ;handle last bin;  save a lot of if statement in the for loop
    j=nedges-2
    somarr=where(sizes ge max(xpts),contG);   max(xpts)=2010.0
    binwidth=200.0; (xpts[j+1]-xpts[j]);       xpts(j+1)=2010.0 also.
    LiterTum=binwidth*SVdefault
    ; somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins

    if contG eq 0 then begin;  there is no particles, area and mass should be zero
        ; do nothing becasue ypts(j:j+1) are already =0.
    endif else begin
        this_adj1=adjs(somarr)
        ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]

        this_area=areas(sommarr)
        Apts[j:j+1] =total(this_adj1*this_area*0.0001)/LiterTum; area mm^2/Liter/um. plot_area

        This_sizes=sizes(somarr)
        This_area_mm2=This_area*0.0001; change it to be mm2.

        if liqorice eq 'ice' then begin
            get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2
            Ipts[j:j+1]=total_IWC/LiterTum
        endif

        if liqorice eq 'liq' then begin
            total_LWC=total(0.917*(0.1^9)*this_adj1*This_sizes^3)*!pi/6.0
            Ipts[j:j+1]=total_LWC/LiterTum;  mg/L/um
        endif

    endelse
    ; stop
endif ; if has_data =1

; if starttime eq 82504000000000LL then stop

;make adjustment for M4 which is L7 ; Number/bin don't need to be adjusted.
if L_choice eq 'M4' or L_choice eq 'M3' then begin
    ;plot_Size =adjustmentfactor*plot_Size; adjf=(L1GT0_and_criteria)/(L1NL4_criteria).
    ypts=ypts*adjustmentfactor
    Apts=Apts*adjustmentfactor
    Ipts=Ipts*adjustmentfactor
endif

ystr='#/L/um'
;change ypts to single value arrays
;if total(ypts) gt 0.0 then stop
k=indgen(n_elements(ypts)/2)*2
ypts=ypts(k)
Apts=Apts(k)
Ipts=Ipts(k)
sizes=sizes/10.0;  recovered sizes to be pixels.
;end of step 2

;******************************************************************************
end;  end of get64binUltimate_Hpsd_size_area_adjs_HliveV_Hdeadtime_bewteen_t1_t2,L_choices,starttime,endtime,sizes,adjs
;*****************************************************************
;*****************************************************************
;***********************************************************************
pro make_61_bins_ultimate,nbins,nedges,xpts,dbl_binwidths
    nbins=61
    nedges=2*nbins
    xpts=dblarr(2*nbins)
    xpts(0)=5.0
    for i =0, 19  DO BEGIN ; from 15, 15,25,25, ******205,205.
        xpts[2*i+1:2*i+2] =5.0+(i+1)*10.0
    endfor
    for i =20,34  DO BEGIN ; from 205 225, 245,265,285, *****485,485,505,505
        xpts[2*i+1:2*i+2] =205.0+(i-19)*20.0
    endfor

    for i =35,44  DO BEGIN ; from 555,555,605,606,*******1005,1005
        xpts[2*i+1:2*i+2] =505.0+(i-34)*50.0
    endfor

    for i =45,54  DO BEGIN ; from 1105,1105,*******2005,2005
        xpts[2*i+1:2*i+2] =1005.0+(i-44)*100.0
    endfor

    for i =55,59  DO BEGIN ; from 2205,2205,*******3005,3005
        xpts[2*i+1:2*i+2] =2005.0+(i-54)*200.0
    endfor
    xpts(121)=xpts(120)+200.0; to make last bin-width=200.0um
    dbl_binwidths=xpts(1:*)-xpts(0:120)
    dbl_binwidths=[dbl_binwidths,0.0]
    xpts(121)=100000.0;    but hin here group anything greater that 3005 to be the last bin.
end; end of make_61_bins_ultimate
;***********************************************************************

;********************************************************************************

;*****************************************************************************************
pro  get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,HorV,M6TorF,L_choice,liqorice,starttime,endtime,$ ;inputs
    has_data,xpts,dbl_binwidths,ypts,Apts,Ipts,ystr,sizes,areas,adjs,HliveV,Hdeadtime,Partcont,adjustmentfactor; outputs
Common  DataBlock,alldataH,alldataV
;the output sizes are in pixels.

;Get_Hsv_deadtime_between_time1_time2,starttime,endtime,HliveV,Hdeadtime
Get_total_DTs_btw_T1T2,HorV,starttime,endtime,Hdeadtime,Fullticks,HliveV
; TAF 2013-09-27 need to update alldata to pointers!
if HorV eq 'H' then alldata = alldataH
if HorV eq 'V' then alldata = alldataV

case L_choice of
    'M1': begin  ; M1 should be in focus but not cleaned.
        if M6TorF eq 'M6=0' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0,total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L1n; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                adjustmentfactor=factor1
                ;adjs  = (*alldata)(subindex).adj1; for M6 method.
                F1=(*alldata)(subindex).F1
                get_method1adjvalues_of_normal,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse
        endif ; if M6TorF eq M6False

        if M6TorF eq 'M6=1' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0 and $
                (*alldata).area gt 0.9*(*alldata).alexei1,total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L1n; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                adjustmentfactor=factor1
                ;adjs  = (*alldata)(subindex).adj1; for M6 method.
                F1=(*alldata)(subindex).F1
                get_method1adjvalues_of_M6,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse

        endif ; if M6TorF eq M6=1
    end; end of M1 method; wihci is not clean.

    'M2': begin ; M2 should be cleaned and in focus.
        if M6TorF eq 'M6=0' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0, total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L4; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                adjustmentfactor=factor1
                get_method2adjvalues_of_normal,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
                sizes=sizes
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse
        endif; end of M6TorF eq 'M6=0'
        if M6TorF eq 'M6=1' then begin
            subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
                (*alldata).area gt 0 and (*alldata).reject eq 0 and $
                (*alldata).area gt 0.9*(*alldata).alexei1, total_accepted_N)
            factor1=1.0

            if subindex(0) ne -1 then begin
                has_data=1
                Partcont=strtrim(n_elements(subindex))
                sizes = (*alldata)(subindex).L4; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                adjustmentfactor=factor1
                get_method2adjvalues_of_M6,HorV,sizes,F1,adjs
                if !filter eq 1 then  adjs=adjs*adj0s
                sizes=sizes
            endif else begin
                has_data=0
                Partcont='0';strtrim(n_elements(subinxex))
                sizes=[0.0]
                areas=[0.0]
                adjs=0.0
                adjustmentfactor=0.0
            endelse
        endif; end of M6TorF eq 'M6=1'
    end
    'M4':begin ; should be both in-focus and out of focus and cleaned.
    subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        (*alldata).area gt 0 and (*alldata).reject eq 0,total_accepted_N)
    factor1=1.0

    if subindex(0) ne -1 then begin
        has_data=1
        Partcont=strtrim(n_elements(subindex))
        L7=(*alldata)(subindex).L7
        areas=(*alldata)(subindex).area
        sizes_L4=(*alldata)(subindex).L4
        sizes_L1=(*alldata)(subindex).L1n
        adj0s   =(*alldata)(subindex).adj0
        F1      =(*alldata)(subindex).F1
        Dmax    =(*alldata)(subindex).alexei1;  ;maximium total countor_area from alexei's
        index=where(Dmax gt 0.0,total_events)
        ;need to select only those true particle, get rid of fake particles
        ;index=where(Dmax gt 0.0 and (Sizes_L4 gt 0.49*sizes_L1 and sizes_L4 gt 0.49*sizes_L1), contDmax)
        roundness=(*alldata)(subindex).roundness
        index =where(Dmax gt 0.0 and roundness eq 1,contDmax)
        Partcont=strtrim(contDmax,2)

        if contDmax ge 1 then begin
            adjustmentfactor=factor1*float(total_events)/float(contDmax)
        endif else adjustmentfactor=0.0

        if contDmax ge 1 then begin
            sizes=L7(index)
            F1    =F1(index)
            areas=areas(index);area=!pi*sizes^2/4.0;in unit pixel^2  Chnaged on May 27, 2011 for ice method M4, still use shaded area.
            get_method4adjvalues,HorV,sizes,F1,adjs; ;input sizes has to be in unit pixels
            if !filter eq 1 then  adjs=adjs*adj0s(index)
        endif else begin
            sizes=[0.0,0.0]
            areas=[0.0,0.0]
            adjs=areas
            ;xxxxx=dialog_message('There are no M4 particles',/information)
        endelse
    endif else begin
        has_data=0
        Partcont='0';strtrim(n_elements(subinxex))
        sizes=[0.0]
        areas=[0.0]
        adjs=0.0
        adjustmentfactor=0.0
    endelse
end; end; of M4 method
endcase

area_liq=!pi*(sizes^2)/4.0
area_ice=area_liq < areas

if liqorice eq 'liq' then  areas=area_liq;    in unit pixel^2
if liqorice eq 'ice' then  areas=area_ice;    in unit pixel^2

;step 2:    sizes from abobe is in unit pixels.
;calculate the mean psd of the H-channel parricles. since sizes, area and adjs are obtained.
SVdefault=HliveV
original_factor=1.0;  because no criteria is selected for archiving, orig_factor has to be 1.0

xpts(0)=0.001;  ;make_61_bins,nbins,nedges,xpts,dbl_binwidths
nedges=n_elements(xpts)
ypts = fltarr(nedges)
Apts =fltarr(nedges)
Ipts =fltarr(nedges)

if has_data eq 1 then begin
    alpha = 0.115D
    beta = 1.218D
    sizes=sizes*10.0

    for j=0,nedges-2,2 do begin  ;sizes should be in um in here ?????
        binwidth=dbl_binwidths(j);  (xpts[j+1]-xpts[j]); this in uni unit of um.
        LiterTum=binwidth*SVdefault
        somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins
        if contG gt 0 then begin;  if there is no particles, area and mass should be zero
            this_adj1=adjs(somarr)
            ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]

            this_area=areas(somarr);       in unit pixels.
            Apts[j:j+1] =total(this_adj1*this_area*0.0001)/LiterTum; area mm^2/Liter/um. plot_area

            This_sizes=sizes(somarr)
            This_area_mm2=This_area*0.0001; change it to be mm2.

            if liqorice eq 'ice' then begin
                get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2
                Ipts[j:j+1]=total_IWC/LiterTum;  mg/L/um
            endif

            if liqorice eq 'liq' then begin
                total_LWC=total(0.917*(0.1^9)*this_adj1*This_sizes^3)*!pi/6.0
                Ipts[j:j+1]=total_LWC/LiterTum;  mg/L/um
            endif

        endif ; else begin
        ; no need to assign all ypts[j:j+1]
        ; endelse
    endfor

    ;**********************************************************
    xpts(0)=5.0
    ;handle last bin;  save a lot of if statement in the for loop
    j=nedges-2
    somarr=where(sizes ge max(xpts),contG);   max(xpts)=2010.0
    binwidth=200.0; (xpts[j+1]-xpts[j]);       xpts(j+1)=2010.0 also.
    LiterTum=binwidth*SVdefault
    ; somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins

    if contG eq 0 then begin;  there is no particles, area and mass should be zero
        ; do nothing becasue ypts(j:j+1) are already =0.
    endif else begin
        this_adj1=adjs(somarr)
        ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]

        this_area=areas(sommarr)
        Apts[j:j+1] =total(this_adj1*this_area*0.0001)/LiterTum; area mm^2/Liter/um. plot_area

        This_sizes=sizes(somarr)
        This_area_mm2=This_area*0.0001; change it to be mm2.

        if liqorice eq 'ice' then begin
            get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2
            Ipts[j:j+1]=total_IWC/LiterTum
        endif

        if liqorice eq 'liq' then begin
            total_LWC=total(0.917*(0.1^9)*this_adj1*This_sizes^3)*!pi/6.0
            Ipts[j:j+1]=total_LWC/LiterTum;  mg/L/um
        endif

    endelse
    ; stop
endif ; if has_data =1

; if starttime eq 82504000000000LL then stop

;make adjustment for M4 which is L7 ; Number/bin don't need to be adjusted.
if L_choice eq 'M4' or L_choice eq 'M3' then begin
    ;plot_Size =adjustmentfactor*plot_Size; adjf=(L1GT0_and_criteria)/(L1NL4_criteria).
    ypts=ypts*adjustmentfactor
    Apts=Apts*adjustmentfactor
    Ipts=Ipts*adjustmentfactor
endif

ystr='#/L/um'
;change ypts to single value arrays
;if total(ypts) gt 0.0 then stop
k=indgen(n_elements(ypts)/2)*2
ypts=ypts(k)
Apts=Apts(k)
Ipts=Ipts(k)
sizes=sizes/10.0;  recovered sizes to be pixels.
;end of step 2

;******************************************************************************
end;  end of get64binUltimate_Hpsd_size_area_adjs_HliveV_Hdeadtime_bewteen_t1_t2,L_choices,starttime,endtime,sizes,adjs
;*****************************************************************
;*****************************************************************
