; added thi sprgram on 2012-01-12   to do stormVex processing

pro read_3VCPI_sortedfile_N_make_png_pages_single_fast

    forward_function SPEC_Nano2HMS

    DEFSYSV, '!NO_CHART', 0
    DEFSYSV, '!H_CHART', 1
    DEFSYSV, '!V_CHART', 2
    DEFSYSV, '!HOURGLASS_CURSOR' , 32514
    DEFSYSV, '!ARROW_CURSOR' , 32512
    DEFSYSV, '!STRIP_WINDOW' , 3
    DEFSYSV, '!STRIP_WIDTH' , 1000 ; 600
    DEFSYSV, '!CHAR_SIZE' , 0.4
    DEFSYSV, '!CurrentHPname' , ''
    DEFSYSV, '!CurrentHFname' , ''
    DEFSYSV, '!CurrentVPname' , ''
    DEFSYSV, '!CurrentVFname' , ''
    DEFSYSV, '!FOFFSET', 0UL  ; default to start of file
    DEFSYSV, '!StereoFOFFset',[0UL,0UL]
    DEFSYSV, '!CRLF', string(13B) + string(10B)
    DEFSYSV, '!CURRENT_CHANNEL' , 1   ; 0=none, 1=horiz, 2=vert
    DEFSYSV, '!ZOOM_STATE' , 0b
    DEFSYSV, '!ZOOM_START_INDEX_H',0L
    DEFSYSV, '!ZOOM_END_INDEX_H', 0L
    DEFSYSV, '!ZOOM_START_INDEX_V',0L
    DEFSYSV, '!ZOOM_END_INDEX_V', 0L
    DEFSYSV, '!ZOOM_START_STRING' , ""
    DEFSYSV, '!ZOOM_END_STRING' , ""
    DEFSYSV, '!ZOOM_START_BIN_1HZ',0L
    DEFSYSV, '!ZOOM_END_BIN_1HZ', 0L
    DEFSYSV, '!DEADTIME_START_FLAG' , -100
    DEFSYSV, '!DEADTIME_END_FLAG' ,   -101
    DEFSYSV, '!MASK_START_FLAG' ,     -102
    DEFSYSV, '!MASK_END_FLAG' ,       -103
    DEFSYSV, '!TAS_FLAG' ,            -104
    DEFSYSV, '!CURRENT_VERSION',       1.0

    DEFSYSV, '!PLAYBACK_ACTIVE' , 1
    DEFSYSV, '!REWIND_ACTIVE' , 1
    DEFSYSV, '!PLAYBACK_SPEED', 0.10
    DEFSYSV, '!HI_LO_STATE' , 0   ; 0=low, 1=high

    DEFSYSV, '!ZOOM_START_NS',0ULL
    DEFSYSV, '!ZOOM_END_NS', 0ULL
    DEFSYSV, '!HPC1_array', fltarr(100)
    DEFSYSV, '!VPC1_array', fltarr(100)
    DEFSYSV, '!strip_height', 128

    cd,'G:\stormVex_data_2DS_processed\TDS_FEB\20110220',current=Wkdir


    stop

    filename=dialog_pickfile(filter='*sorted*.2DSCPI',get_path=pathnm)
    !currentHPname=pathnm
    ;pathnm=file_dirname(filename)+'\'
    ;filter_str='Sorted*.2DSCPI'
    ;get_all_data_filenames,filter_str,pathnm,filenames,file_count
    cd,Wkdir


    file_count=1
    for kkkk=0L, file_count-1L do begin
        inputfile=filename; filenames(kkkk)
        !currentHFname=file_basename(inputfile)

        start_a_new_page,my_png_pageV
        start_a_new_page,my_png_pageH

        OpenR, lun, inputfile, /Get_Lun

        info={totalParticles:0UL}
        info.TotalParticles=0UL
        errcount = 0L

        struct = {_DerivedDataRev2, $
            PartID: 0 , $
            Nanosecsold:0ULL , $
            NanoSeconds:0ULL , $
            ImageOffset: 0UL , $
            ImageWords: 0 , $
            Area: 0.0 , $
            Nslice: 0 , $
            L2: 0 , $
            F1: 0 , $
            Adj1: 0.0, $
            Pc1: 0.0, $
            TAS: 0.0, $
            ProbeCounter:0ULL, $
            L3: 0.0, $
            L4: 0, $
            L5: 0, $
            PC3x: 0.0, $
            PC3y: 0.0, $
            PC4x: 0.0, $
            PC4y: 0.0, $
            A3: 0.0, $
            Alexei1: 0.0, $
            Alexei2: 0L, $
            reject: byte(0), $
            w8_t: 0LL, $
            L7: 0.0, $
            L8: 0.0, $
            roundness: 0.0, $
            focus: 0.0, $
            warn: 0.0, $  ; some day we will change this to byte value to svae memory.
            adj0: 1.0, $  ;added on May 8-2007 for w8_t cleaning.
            noisebyte:byte(0),$;; added in June 2007.
            AccDTtick:0ULL,$   ; added on oct5 2007
            w8_t_clean:0LL, $; added on oct5,2007.
            L1n: 0.0, $;    ; added on nov 9, 2007.
            largest_satellite_area: 0.0, $    ;added dec19,2007
            alexei1old: 0.0, $ ;added dec19,2007
            TASold: 0.0, $    ; added dec19,2007
            Spare_16: 0.0, $
            Spare_17: 0.0, $
            Spare_18: 0.0, $
            Spare_19: 0.0, $
            Spare_20: 0.0,$
            CPI_trigger: 0}
        ;add this tempary to fix the bug for generating the zoomed ascii
        ;**************************************************************************
        struct_ascii = {_AsciiData, $
            Nanosecsold:0ULL , $
            NanoSeconds:0ULL , $
            Area: 0.0 , $
            Nslice: 0 , $
            L2: 0 , $
            F1: 0 , $
            Adj1: 0.0, $
            Pc1: 0.0, $
            TAS: 0.0,$    ;added more in the following on oct 14 , 2005 by mo for outputing ascii data file.
            ProbeCounter:0ULL, $
            L3: 0.0, $
            L4: 0, $
            L5: 0, $
            PC3x: 0.0, $
            PC3y: 0.0, $
            PC4x: 0.0, $
            PC4y: 0.0, $
            A3: 0.0, $
            Alexei1: 0.0, $
            Alexei2: 0L,$
            L1n:0.0, $;  added nov 9, 2007.
            largest_satellite_area: 0.0, $    ;added dec19,2007
            alexei1old: 0.0, $ ;added dec19,2007
            TASold: 0.0 $    ; added dec19,2007
            }


        ;***************************************************************************



        struct2 = {_Timestamp, $
            Year: 0, $
            Month: 0, $
            Day: 0, $
            Hours: 0, $
            Minutes: 0, $
            Seconds: 0, $
            Milliseconds: 0, $
            Microseconds: 0, $
            Nanoseconds: 0 }

        horiz_count=0
        NanosecondsPerSecond = 1000000000ULL
        NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
        NanosecondsPerHour   = NanosecondsPerMinute * 60ULL
        NanosecondsPerDay    = NanosecondsPerHour * 24ULL
        out_array = BytArr(20000)


        ;Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

        ;get the sorted file's starttime and endtime
        substrs=strsplit(inputfile,'\',/extract)
        sortedFileName=substrs(n_elements(substrs)-1)
        datetimestring=strmid(sortedFilename,6,strlen(sortedfilename)-9); =yymmddhhmmss_hhmmss_hhmmss_000x
        if strlen(datetimestring) eq 32 then begin
            subtrs=strsplit(datetimestring,'_',/extract)
            Stime=subtrs(1)
            Etime=subtrs(2)
            FSTime=(strmid(Stime,0,2)*3600LL+strmid(Stime,2,2)*60LL+strmid(Stime,4,2)*1LL)*1000000000;nanoseconds
            FETime=(strmid(Etime,0,2)*3600LL+strmid(Etime,2,2)*60LL+strmid(Etime,4,2)*1LL)*1000000000
        endif;     FStime is full-seconds say: 50045000000000LL nanoseconds. FEtime ends with 12345.999999999
        WriteH_OK=0; once the the first double-fake particle's time is readed, it is Ok to write to the bin file.
        WriteV_Ok=0


        ; Put the info structure back in its storage location.

        OpenR, lun, inputfile, /Get_Lun

        fileheader = bytarr(256)
        ReadU, lun, fileheader
        v_string = strmid(string(fileheader),4,4)
        reads, v_string, FORMAT='(%"%f")',cur_version
        if (cur_version ne 3.0) then begin
            r = dialog_message(['Warning, file you have selected is not a REV 3 SORTED file!','Use an older version of 2DSView to process this file..'],TITLE = 'File incompatible')
            close, lun
            return
        endif

        ;===========================================================
        ; Create Headers for the Ver 3.0 files
        ;===========================================================
        vheader = bytarr(256)
        vheader(*)=32 ; all spaces
        sheader = string(vheader)
        strput,sheader,'Ver 3.00 BIN PARTICLE DATA',0  ; put info on the front

        DataType = 0  ; header of all record types is an integer with repeated letters
        TimingWord = UIntArr(2)
        StartTimingWord = UIntArr(2)
        EndTimingWord = UIntArr(2)
        Masks = UIntArr(16)
        HK_ints = UIntArr(48)   ; changed from 40->52 with version 5.0
        HK_timingwords = UIntArr(2)
        HK_TAS  = 0.0
        TAS = 0.0
        Tas_H=0.0
        Tas_V=0.0
        PartID = 0
        Slices = 0U
        WordCount =  0U
        Timestamp = { _Timestamp }
        HTimestamp = { _Timestamp }
        VTimestamp = { _Timestamp }
        StartTimestamp = { _Timestamp }
        EndTimestamp = { _Timestamp }
        pos = 0UL
        Area = 0UL
        Midpoint = 0
        Edges = 0
        pxs = 0.01
        pxs_in_microns = 10.0
        dww = 63.0 ;  6300  ; 6.3cm
        sa_default = 128.0 * pxs *  dww
        strbsz = 0.01
        Rollover = 0 ; 16 bit integer
        Rollover2= 0;  16 bit integer
        ProbeCount = 0uL ; 32 bit unsigned
        ProbeCount2 = 0uL ; 32 bit unsigned
        CPI_trigger = 0 ; 16 bit integer
        temp_64 = 0ULL ; 32 bit result
        OneRollover = 4294967296ULL  ; 2^32
        onebyte = 33B

        L3 = 0.0
        L4 = 0
        L5 = 0
        PC3x = 0.0
        PC3y = 0.0
        PC4x = 0.0
        PC4y = 0.0
        A3 = 0.0
        lastH=10; keep a record of the last H particle written to the bin file.  possible values
        ; are 0, -104, -103, -101, -106, -108. 0 means it is a good particle. for wipe off decision.
        lastV=10

        ;********************************************************
        OD = {_DerivedDataRev2}
        OD_block_size= N_TAGS( OD , /DATA_LENGTH )
        ;added above so that bad-data can be deleted. Oct 4, 2006.--by mo
        ;******************************************************
        backward=0

        counter = 0L

        ;******************************************

        ;generate H png page  model and V png page model.
        ;when ever a new image is read, determin if it is a noise or good image and them output it to the png page
        ;until the sorted is read to then end.
        ;make HPC1_array  VPC1_array with 100 particle to use for stuck bit noise.



        ;******************************************

        WHILE ~ EOF(lun) DO BEGIN

            counter++
            ;if counter GT 67254L then begin
            ;print, format='(Z4)',DataType
            ; print, counter
            ;end

            ReadU, lun, DataType

            SWITCH DataType OF
                ;----------------------------
                ;added this block to handle new type of dummy particles that Chris added in september
                ;19th 2006, for those bad images ----tick or time is not monotonic.

                ; The 4 new deadtime indicaters are defined as:

                ;  V_DUMMY_DEADTIME_HEADER = &H1414 ' 5140 decimal   ; treat them as normal deadtime
                ;  H_DUMMY_DEADTIME_HEADER = &H1424 ' 5156 decimal   ; treat them as normal deadtime
                ;  V_BACKUP_DEADTIME_HEADER = &H2414 ' 9236 decimal  ; when I see this, throw out earlier
                ;  H_BACKUP_DEADTIME_HEADER = &H2424 ' 9252 decimal  ; raeded H or V particles.

                5156: $    ;this way all dummy_dead_times are assigned as mask_flags.
                    ;print , "H Dummmy_deadtime_header"
                    6425: $;   H_streaker_deadTime_header; no mre backup type anymore.
                    begin
                if datatype eq 6425 then  print, 'H_streaker_DEADTIME_HEADER'
                ; do delete last readed in H-particles from the array.
                ; point_lun,-horiz_lun, current_posH
                ; point_lun, horiz_lun,current_posH-OD_block_size
                ;    stop
                ; truncate_lun,Horiz_lun;   after we truncate it, we replaced it with the deadtime mark from the sorted
                ;    stop
                ;write out new type of fake particles -105 -106 for area
                ReadU, lun, StartTimestamp,EndTimestamp
                ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

                lastH=-106;  -106 and -108 is of the same type.

                ; print,rollover, probecount
                ;print,rollover2, probecount2
                ;stop
                break
            end  ; end of H-backup-deadtime particles.
            ;***********************************************************************************
            9252: $;   H_backup_deadTime_header
                begin
            print, 'H_Backup_DEADTIME_HEADER'


            ; begin reading the two time stamps and counts to write two bad particles.

            ReadU, lun,  StartTimestamp,EndTimestamp
            ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
            lastH=-110

            break
        end; end of wipping off H-bad non_monotonic data and puting a deadtime pair inside.

        27756 :$   ; H_DEADTIME (0x6C6C)
            ;print , "H DEADTIME"
            7196 : $   ; H_MASK (0x1C1C)
            begin
        ReadU, lun, StartTimestamp,EndTimestamp
        ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

        lastH=-103;   -101 and -103 is the of the same type.

        break
    end ; end of H-dead_time and H-mask

    5140: $   ; V_DUMMY_DEADTIME_HEADER = &H1414 ' 5140 decimal
        print, 'V_DUMMY_DEADTIME_HEADER'
    6168: $;   H_streaker_deadTime_header; no mre backup type anymore.
        begin
    if datatype eq 6168 then  print, 'V_streaker_DEADTIME_HEADER'
    ; begin reading the two time stamps and counts to write two bad particles.
    ReadU, lun,  StartTimestamp,EndTimestamp
    ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
    lastV=-106
    break
end; end of type1 and type1 V Bad Particles.
;----------------------------
9236: $;   V_backup_deadTime_header
    begin
;print, 'V_Backup_DEADTIME_HEADER'

; do delete last readed in V-particles from the array.

;****************************

; begin reading the two time stamps and counts to write two bad particles.

ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
lastV=-110
break
end; end of wipping off bad non_monotonic data and puting a deadtime pair inside.


31868 : $   ; V_DEADTIME (0x7C7C)
    if datatype eq 31868 then print, "V DEADTIME"  ; won't compile without some statement here
11308 : $   ; V_MASK (0x2C2C)
    begin
ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2


lastV=-103
break
end

;----------------------------
19789 : $
    begin
ReadU, lun, TimingWord, Masks
;print , "MASK"
break
end

;----------------------------
16705 : $  ; TAS_HEADER_V
    ;print , "V TAS",TAS
    ;----------------------------
    21588 : $  ; TAS_HEADER_H;  chris, is this the TAS change fake particle ? -104 ?
    BEGIN
ReadU, lun , TAS
if DataType eq 16705 then TAS_V=tas else TAS_H=tas; added thsi on Nov.28, 2006.

ReadU, lun, StartTimestamp, Rollover,ProbeCount
break
END


;----------------------------
19275 : $  ; HK_HEADER
    BEGIN

;print, "HK_HEADER read"

ReadU, lun , HK_ints, HK_TAS, HK_timingwords
ReadU, lun, Rollover,ProbeCount
;print , "HK", HK_TAS
break
END

;----------------------------
18504 : $  ; H_PARTICLE_HEADER
    BEGIN

;print, "H_PARTICLE_HEADER read"

ReadU, lun , PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount, CPI_trigger

HTimestamp = Timestamp
if (WordCount GE 500) then begin
    ;print, "H WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
    ;stop
end

Nanoseconds=0LL
NanoSeconds = Timestamp.Nanoseconds + $
    Timestamp.Microseconds * 1000ULL + $
    Timestamp.Milliseconds * 1000000ULL + $
    Timestamp.Seconds * NanosecondsPerSecond + $
    Timestamp.Minutes * NanosecondsPerMinute + $
    Timestamp.Hours * NanosecondsPerHour
;--------------------------------------------------------------------------------------
; We'd like (in 2DS executable) to trap all goofy particles before they are placed into the SORTED
;  file but as new DSP error or data transmission errors occur, we may miss some. So
;  we are forced to double check here. If the particle slice count or integer data word
;  couint is zero, we clearly cannot proceed to create zero length arrays. However,
;  we still need to read the image, if there is one. So we force Slices =1000 to avoid
;  doing processing that would crash this program, and we ignore this particle.
;--------------------------------------------------------------------------------------
;if (Wordcount gt 0 and Slices gt 0) then begin

;if(wordcount eq 2 and slices eq 2) then begin
;   stop
;endif

if (Wordcount gt 0 and Slices gt 0) then begin
    ;HImage = BytArr(WordCount * 2)
    ;HSums = IntArr(Slices)
    ;out_byte_array = BytArr(128L, Slices)
    ;out_array = bytarr(16L * Slices)
    ;****************************************************

    out_array = bytarr(16L * Slices)           ; 128 bits = 16 bytes * 8 bits
    out_byte_array = BytArr(128L, Slices)

    HImage = BytArr(WordCount * 2)
    HSums = IntArr(Slices)

    HMax  = 0

endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, HImage

; debugging check for some weird crashes
if(wordcount eq 2 and slices eq 2) then begin
    if(himage[0] eq 0 and himage[1] eq 0 and himage[2] eq 0 and himage[3] eq 0) then begin
        stop
    endif
endif


if (Slices LT 1000) then begin
    Err=0

    nstop = 2

    ;ProcessParticle, HImage, HSums, out_array, out_byte_array, Wordcount, Slices,  HMax, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3

    ProcessParticle,  HImage, out_array, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3
    d = 0
    find_Image_Parameters, out_byte_array, d  ; this is to find alexi1 max area.


    if (Err NE 0) then begin
        print, ""
    endif

    if (Err EQ 0) then begin

        Info.TotalParticles++
        ;a = string( format = '("Particles Read:" , I3)',info.TotalParticles)
        if info.TotalParticles mod 1000 EQ 0 then print,string( format = '("Particles Read:" , I8)',info.TotalParticles)

        dof = 0.0D
        particle_in_microns = WordCount * 10
        dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm

        sa_actual = (127.0 +  particle_in_microns/pxs_in_microns) * pxs * min([dww,dof])
        ; sa_default = 128.0 * pxs *  dww

        ; time interval is the 32 bit tick interval times the # slices
        clock_interval = 0.000010 / TAS

        adj1 = sa_default/sa_actual     ; change the above to this line im May 17th, 2006.

        OD = {_DerivedDataRev2}

        OD.PartID = PartID
        OD.NanoSeconds = Timestamp.Nanoseconds + $
            (Timestamp.Microseconds * 1000ULL) + $
            (Timestamp.Milliseconds * 1000000ULL) + $
            (Timestamp.Seconds * NanosecondsPerSecond) + $
            (Timestamp.Minutes * NanosecondsPerMinute) + $
            (Timestamp.Hours * NanosecondsPerHour)
        OD.Nanosecsold=OD.nanoseconds ;= Timestamp.Year * 12 + Timestamp.Month
        OD.ImageOffset = pos
        OD.ImageWords = WordCount
        OD.Area = Area
        OD.Nslice = Slices
        OD.L2 = HMax
        OD.F1 = Edges
        OD.Adj1 = adj1
        OD.Pc1 = Midpoint
        OD.TAS = TAS_H
        OD.ProbeCounter = Rollover * OneRollover + ProbeCount
        OD.L3 = L3
        OD.L4 = L4
        OD.L5 = L5
        OD.PC3x = PC3x
        OD.PC3y = PC3y
        OD.PC4x = PC4x
        OD.PC4y = PC4y
        OD.A3 = A3
        OD.Alexei1= d
        OD.CPI_trigger = CPI_trigger
        ;update L1n, adj1, area and alexei1 by HK_tas coorections.
        ;**********************************************************
        this_time=float(OD.nanoseconds)/1000000000.0
        ;indx8=where(HKseconds ge this_time and HKseconds le this_time+1.0,contN)
        factor=1.0

        ;if contN gt 0 then factor=((HKtas(indx8(0))/170.0) > 1.0)  else factor=1.0

        This_L1n=(OD.Nslice+randomu(seed)-0.5)*factor

        OD.L1n    =This_L1n
        OD.area   =area*factor
        OD.alexei1=   d*factor

        ;now re-calculated adj1 values.
        dof = (5.13 * This_L1n*this_L1n) / 10.0D ;; convert to mm
        sa_actual = (127.0 + This_L1n) * pxs * min([dww,dof])
        OD.adj1= sa_default/sa_actual

        ;***********************************************************
        ;if OD.tas gt 0.0 then $
        ;WRITEU, horiz_lun, OD
        lastH=0
        horiz_count++
        ;stop
        ; if timestamp.hours eq 15 and timestamp.minutes eq 33 and timestamp.seconds eq 45 then begin
        ; print,slices
        ; print,Himage
        ; print,timestamp.milliseconds
        ; print,OD.probecounter
        ;  stop
        ; endif


        !HPC1_array=[!HPC1_array(1:99),OD.PC1];  : this is a circle holder for the last 100 particles for Statistical noise
        ;now determine if the Particle is noise  or dot_Line or big splashas.
        Find_out_if_this_particle_bad,!HPC1_array,OD.PC1,OD.Nslice,OD.L2,OD.L4,OD.L5,area, OD.alexei1,Good

        if Good eq 1 then begin
            ;get_this_image_and_text,'V',Slices,wordcount,Vimage, dimg,dispsize,my_text_string,nanoseconds
            ; imput is Vimg, 'V'; return is dimg ect.
            dimg=rotate(out_byte_array,1)
            my_text_string=SPEC_Nano2HMS(OD.nanoseconds)
            dispsize=size(dimg,/dimension)
            output_png_images_to_my_png_page, my_png_pageH,'H',dimg,dispsize,my_text_string,nanoseconds,timestamp
        endif



    Endif ; end of if Err eq 0

endif else begin  ; endif of if slices Lt 1000.
    print, "Error H Slices =", Slices ,"  at ",counter
end

break


END

;----------------------------
22102 : $  ; V_PARTICLE_HEADER
    BEGIN

;print, "V_PARTICLE_HEADER read"

ReadU, lun , PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount, CPI_trigger

VTimestamp = Timestamp
if (WordCount GE 500) then begin
    ;    print, "V WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
end
Nanoseconds=0LL
NanoSeconds = Timestamp.Nanoseconds + $
    Timestamp.Microseconds * 1000ULL + $
    Timestamp.Milliseconds * 1000000ULL + $
    Timestamp.Seconds * NanosecondsPerSecond + $
    Timestamp.Minutes * NanosecondsPerMinute + $
    Timestamp.Hours * NanosecondsPerHour

;--------------------------------------------------------------------------------------
; We'd like (in 2DS executable) to trap all goofy particles before they are placed into the SORTED
;  file but as new DSP error or data transmission errors occur, we may miss some. So
;  we are forced to double check here. If the particle slice count or integer data word
;  couint is zero, we clearly cannot proceed to create zero length arrays. However,
;  we still need to read the image, if there is one. So we force Slices =1000 to avoid
;  doing processing that would crash this program, and we ignore this particle.
;--------------------------------------------------------------------------------------
if (Wordcount gt 0 and Slices gt 0) then begin

    ;VImage = BytArr(WordCount*2)
    ;VSums = IntArr(Slices)
    ;out_array = bytarr(16L * Slices)
    ;out_byte_array = BytArr(128L, Slices)
    ;****************************************************

    out_array = bytarr(16L * Slices)           ; 128 bits = 16 bytes * 8 bits
    out_byte_array = BytArr(128, Slices)


    VImage = BytArr(WordCount * 2)
    VSums = IntArr(Slices)
    VMax  = 0

endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, VImage

if (Slices LT 1000) then begin

    Err=0
    nstop = 3


    ProcessParticle, VImage, out_array, out_byte_array, WordCount, Slices, VSums, VMax, Area, Midpoint, Edges,Err , L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3

    ;ProcessParticle, VImage, VSums, out_array, out_byte_array, WordCount, Slices, VMax, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3

    d = 0
    find_Image_Parameters, out_byte_array, d


    Info.TotalParticles++
    if info.TotalParticles mod 1000 EQ 0 then print, string( format = '("Particles Read:" , I8)',info.TotalParticles)

    ; dof = 0.0D
    particle_in_microns = WordCount * 10
    dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm

    sa_actual = (127.0 +  particle_in_microns/pxs_in_microns) * pxs * min([dww,dof])
    ;  sa_default = 128.0 * pxs *  dww

    ; time interval is the 32 bit tick interval times the # slices
    clock_interval = 0.000010 / TAS

    adj1 = sa_default/sa_actual ; changed above to this line in May 17th, 2006.

    OD = {_DerivedDataRev2}
    OD.PartID = PartID
    OD.NanoSeconds = Timestamp.Nanoseconds + $
        Timestamp.Microseconds * 1000ULL + $
        Timestamp.Milliseconds * 1000000ULL + $
        Timestamp.Seconds * NanosecondsPerSecond + $
        Timestamp.Minutes * NanosecondsPerMinute + $
        Timestamp.Hours * NanosecondsPerHour
    OD.Nanosecsold=OD.nanoseconds ;= Timestamp.Year * 12 + Timestamp.Month

    OD.ImageOffset = pos
    OD.ImageWords = WordCount
    OD.Area = Area
    OD.Nslice = Slices
    OD.L2 = VMax
    OD.F1 = Edges
    OD.Adj1 = adj1
    OD.Pc1 = Midpoint
    OD.TAS = TAS_V
    OD.ProbeCounter = Rollover * OneRollover + ProbeCount
    OD.L3 = L3
    OD.L4 = L4
    OD.L5 = L5
    OD.PC3x = PC3x
    OD.PC3y = PC3y
    OD.PC4x = PC4x
    OD.PC4y = PC4y
    OD.A3 = A3
    OD.Alexei1= d
    OD.CPI_trigger = CPI_trigger
    ;**********************************************************
    this_time=float(OD.nanoseconds)/1000000000.0
    ;indx8=where(HKseconds ge this_time and HKseconds le this_time+1.0,contN)
    factor=1.0

    ;if contN gt 0 then factor=((HKtas(indx8(0))/170.0) > 1.0)  else factor=1.0

    This_L1n=(OD.Nslice+randomu(seed)-0.5)*factor

    OD.L1n    =This_L1n
    OD.area   =area*factor
    OD.alexei1=   d*factor

    ;now re-calculated adj1 values.
    dof = (5.13 * This_L1n*this_L1n) / 10.0D ;; convert to mm
    sa_actual = (127.0 + This_L1n) * pxs * min([dww,dof])
    OD.adj1= sa_default/sa_actual

    ;***********************************************************
    ;if OD.tas gt 0.0 then $
    ;WRITEU, vert_lun, OD
    lastV=0
    ;if oD.nanoseconds gt 46391203000000LL and OD.probecounter gt 0LL then begin
    ;print, OD.probecounter,' ', oD.area,' ',OD.L1n
    ;stop
    ;endif

    ; stop;  it is good in here.---Feb 16, 2006---by mo   why not cont vertical particles numbers ?

    !VPC1_array=[!VPC1_array(1:99),OD.PC1];  : this is a circle holder for the last 100 particles for Statistical noise
    ;now determine if the Particle is noise  or dot_Line or big splashas.
    Find_out_if_this_particle_bad,!VPC1_array,OD.PC1,OD.Nslice,OD.L2,OD.L4,OD.L5,area, OD.alexei1,Good

    if Good eq 1 then begin
        ; write out all pricle to dataH and dataV.

        dimg=rotate(out_byte_array,1)
        my_text_string=SPEC_Nano2HMS(OD.nanoseconds)
        dispsize=size(dimg,/dimension)

        output_png_images_to_my_png_page, my_png_pageV,'V',dimg,dispsize,my_text_string,nanoseconds,timestamp
    endif



Endif

break

END

;----------------------------
ELSE: begin
    POINT_LUN, -lun, badpos

    ;stop

    print , "Error, bad header in data file. Offset = ",badpos
    print, "value = ", DataType ; FLAG=0
    ; printf, 22, "Chris said impossible Error: bad header in data file. Offset = ",badpos," value = ", DataType
end
ENDSWITCH

ENDWHILE


Close ,lun

Free_Lun, lun

;Widget_Control, event.top, Set_UValue=info, /No_Copy

; read_verticle_file
device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data

print, 'Done making image png pages of file  ' + !currentHFname + '  !!!!'

endfor; end of for kkkk=1, file count-1


end ;===== end of spec_toolbar_save make the horizon. vert_***bin files ===========================


;*****************

;*****************************************************
pro start_a_new_page,my_png_page
    ; Prepare fonts
    Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=12)
    Font2 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=14)
    Font3 = OBJ_NEW('IDLgrFont', 'Helvetica Bold',SIZE=8)

    ; Get current color table
    TVLCT, r, g, b, /GET
    r[0] = 255
    g[0] = 255
    b[0] = 0
    Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)

    OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res
    dims=[612,792];  use 3000 will draw teh two lines added by mo at 10th amy 2004.
    res=[0.025,0.025];   added by mo on May 10th 2004.
    PageDX = Dims[0]
    PageDY = Dims[1]

    ; create a view
    View = OBJ_NEW('IDLgrView', VIEW=[0,0,PageDX,PageDY])
    Model = OBJ_NEW('IDLgrModel')
    TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=Font3,recompute_dimensions=0)

    Model->Add,TimeText
    View->Add, Model
    currenty=pageDy-10; the position to put the texline 2006/01/25 ctreitera *****
    my_png_page={view:view,model:model,timeText:timeText,pageDX:pageDX,pageDy:pageDY,$
        CurrentX:0,currentY:currentY,font:font3,count:0L,startTime:0LL,EndTime:0LL,Time0:'',TimeText_1:''}
end;  end of start_a_new_page
;*****************************************************
pro get_this_image_and_text,HorV,Slices,wordcount,Image, dimg,dispsize,my_text_string,nanoseconds

    ;Slices = L1size_array
    ;WordCount = ImgWord_array

    ; Image = BytArr(WordCount * 2)

    out_array = bytarr(16L * Slices)
    out_byte_array = bytarr(128, Slices)

    ;POINT_LUN, lun, fOffsets_array
    ;ReadU, lun, Image

    Hsums = intarr(Slices)
    HMax  = 0
    Area = 0UL
    Midpoint = 0
    Edges = 0
    L3 = 0.0
    L4 = 0.0
    L5 = 0.0
    PC3x = 0.0
    PC3y = 0.0
    PC4x = 0.0
    PC4y = 0.0
    A3 = 0.0

    Err=0
    ProcessParticle, Image, out_array, out_byte_array, Wordcount,Slices, HSums,$
        HMax, Area, Midpoint, Edges,Err , L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3

    ;  tv,ROTATE(out_byte_array,1),yoffset,0
    dimg=rotate(out_byte_array,1)
    my_text_string=SPEC_Nano2HMS(nanoseconds_array)
    dispsize=size(dimg,/dimension)

    ;****************************************************
    Catch, onError
    IF onError NE 0 THEN BEGIN
        Catch, /Cancel
        result = Error_Message(Traceback=1)
        Hsums=0
    ENDIF

    Hsums=0
end
; **************************************************************
;===============================================================================
PRO SaveWndToFile, OutPutWnd,time0,timetext_2,HorV,timestamp

    starttime=strsplit(time0,':',/extract)
    if strlen(time0) lt 5 then return
    starttime=strjoin(starttime(0:2))
    starttime=strsplit(starttime,'.',/extract)
    starttime=starttime(0)+'_'+starttime(1)+starttime(2)

    endtime  =strsplit(timetext_2,':',/extract)
    endtime  =strjoin(endtime(0:2))
    endtime=strsplit(endtime,'.',/extract)
    endtime=endtime(0)+'_'+endtime(1)+endtime(2)


    year=strtrim(string(timestamp.year),2);      ;'20'+strmid(plot_string2,5,2)
    if timestamp.month lt 10 then begin
        month='0'+strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
    endif else begin
        month=strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
    endelse
    ;day=strtrim(string(timestamp.day),2);;       strmid(plot_string2,9,2)
    if timestamp.day lt 10 then begin
        day='0'+strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
    endif else begin
        day=strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
    endelse
    date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

    time_str='_'+endtime;+'_'+endtime

    ;get the yyyy mm dd of the data file.
    ;   subfile_str=strsplit(!currentHFname,'\',/extract)
    ;   plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)
    ;   year='20'+strmid(plot_string2,5,2)
    ;   month=strmid(plot_string2,7,2)
    ;  day=strmid(plot_string2,9,2)
    date_yyyymmdd_string=year+month+day; '20060201 '

    ; Create a filename
    sortfile_str=strmid(!currentHFname,0,strlen(!currentHFname)-7)
    junk=findfile(!currentHPname+sortfile_str+'_png\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname +sortfile_str+"_png\"
    outputfilename=!currentHPname+sortfile_str+'_png\'+HorV+date_yyyymmdd_string+time_str+'.png'
    ;outputfilename=!currentHPname+'png\TDS_xxx_'+date_yyyymmdd_string+strmid(time_str,0,6)+'_R0_'+HorV+'.png'

    ;Get window image
    Img = OutPutWnd->Read()
    ; Get the actual buffer
    Img->GetProperty, Data=Buf; , /NO_COPY
    y = (size(Buf))[2]
    dy = round(y)
    ;write_png,outputfilename, Buf[*,y-dy:*];r,g,b; this has size(buf)=[612,753]---a black strip on the png.
    write_png,outputfilename, Buf[*,40:*]   ;this don't have the balck strip anymore, save inks.

    OBJ_DESTROY, Img
    heap_gc
end;SaveWndToFile, OutPutWnd,time_text
;****************************************************
pro output_png_images_to_my_png_page,my_png_page,HorV,dimg,dispsize,my_text_string,nanoseconds,timestamp

    if my_png_page.currentY ge 782 then begin;  do it at the Top of the page one Time.
        ;!strip_height=128; pixels
        subfile_str=strsplit(!currentHFname,'\',/extract)

        plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)

        year=strtrim(string(timestamp.year),2);      ;'20'+strmid(plot_string2,5,2)
        if timestamp.month lt 10 then begin
            month='0'+strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endif else begin
            month=strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endelse
        ;day=strtrim(string(timestamp.day),2);;       strmid(plot_string2,9,2)
        if timestamp.day lt 10 then begin
            day='0'+strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endif else begin
            day=strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endelse
        date_time_string=year+'/'+month+'/'+day; '2006/02/01 '


        criteria='all images'

        title=date_time_string +' '+HorV+' '+criteria
        TimeText = OBJ_NEW('IDLgrText',title,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)
        my_png_page.Model->Add,timeText

        ; draw top line
        my_png_page.currentY=my_png_page.currentY-3

        myline=bytarr(612,2); x-ength is 2400, height is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image


        ;ready for drawing images.
        my_png_page.currentY=my_png_page.currentY-!strip_height-3

    endif

    ;here equivalent of the while loop to added more and more images.


    my_png_page.count=my_png_page.count+1;  ; count of particles shown in this line.

    image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[$
        my_png_page.currentX,my_png_page.currentY,0], ORDER=0);,interpolate=1) don't do the interp
    my_png_page.Model->Add, image

    This_nano_second=nanoseconds

    if my_png_page.currentX lt 1 then begin; add text if a new strip.
        TimeText_1 = my_text_string
        TimeText_1_time =This_nano_second

        my_png_page.StartTime=This_nano_second
        my_png_page.TimeText_1=TimeText_1

        if my_png_page.currentY gt my_png_page.pageDY-150 then begin
            time0=timetext_1
            my_png_page.Time0=Time0; This keep a record of the first particle time of the new or new page ? line.
        endif

    endif
    my_png_page.currentX=my_png_page.currentX+dispsize(0)+1



    if my_png_page.currentX gt 600 and my_png_page.currentY gt 40 then begin; add time stamp at end and begin a new line
        TimeText_2 =my_text_string
        TimeText_2_time =This_nano_second;         ;get 478 only give one page.
        ;delt_milisec=(TimeText_2_time -TimeText_1_time)/1000000LL
        delt_milisec=(TimeText_2_time -my_png_Page.StartTime)/1000000LL
        DmiliS='--DtmiliSec='+strtrim(string(Delt_milisec),2)
        TimeText_2 =TimeText_2 +DmiliS+'---Total: '+strtrim(string(my_png_page.count),2)
        ; reset the counts  since the line is finished.
        my_png_page.count=0L
        my_png_page.currentX=0
        my_png_page.currentY=my_png_page.currentY-3; ready fo rdrawing bottom line.



        ;draw bottom line
        myline=bytarr(612,2); heiht is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image

        ;draw the text1 and text 2 string below the bottom line.

        timetext_1=my_png_page.TimeText_1

        my_png_page.currentY=my_png_page.currentY-10
        timeText= OBJ_NEW('IDLgrText','From'+timetext_1+$
            '--- to ---'+timetext_2,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)

        my_png_page.Model->Add, timetext

        ;if there are still space to draw another strip of images then do drawing the to line.
        ;if my_png_page.currentY gt 10+!strip_height+14+60 then begin
        ;draw top line now for next strip
        my_png_page.currentY=my_png_page.currentY-3
        myline=bytarr(612,2);  must be 2 pixels.  2 or three dimsensions of images allowed.
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image
        my_png_page.currentY=my_png_page.currentY-!strip_height-3; ready for image drawing now.
        ;endif
        my_png_page.StartTime=nanoseconds;  This is teh new line's StartTime.
    endif

    if my_png_page.currentY lt 50 then begin; get a new page and save the current page.

        ;show and save the current page
        OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        output3 ->draw,my_png_page.view;   show teh vie wto teh screen.
        wait,0.01
        ;save the view to a file
        output2 ->draw,my_png_page.view;   Put the view wto the Buffer.

        Time0=my_png_page.Time0
        SaveWndToFile,OutPut2,time0,timetext_2,HorV,timestamp

        ;destroy the view foe geneating the new view
        OBJ_DESTROY,my_png_page.View
        OBJ_DESTROY,output3
        OBJ_DESTROY,output2


        ;start a new page
        start_a_new_page,my_png_page
        subfile_str=strsplit(!currentHFname,'\',/extract)
        plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)

        year=strtrim(string(timestamp.year),2);      ;'20'+strmid(plot_string2,5,2)
        if timestamp.month lt 10 then begin
            month='0'+strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endif else begin
            month=strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
        endelse
        ;day=strtrim(string(timestamp.day),2);;       strmid(plot_string2,9,2)
        if timestamp.day lt 10 then begin
            day='0'+strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endif else begin
            day=strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
        endelse
        date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

        criteria='all images'


        title=date_time_string +' '+HorV+' '+criteria
        TimeText = OBJ_NEW('IDLgrText',title,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)
        my_png_page.Model->Add,timeText

        ; draw top line
        my_png_page.currentY=my_png_page.currentY-3

        myline=bytarr(612,2); x-ength is 2400, heiht is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY], ORDER=0,interpolate=1)
        my_png_page.Model->Add, image
        ;ready for drawing images.
        my_png_page.currentY=my_png_page.currentY-!strip_height-3
        ;add the readed images adn take a note the starttime strin
        ;*******************************************************
        ;TimeText_1 = my_text_string
        ;time0=timetext_1
        ; my_png_page.currentX=my_png_page.currentX+dispsize(0)+1
        ;********************************************************
    endif


end; end of output_pngs_images_pages
;*****************************************************


pro  Find_out_if_this_particle_bad,PC1_array,This_PC1,Nslice,L2,L4,L5,area, alexei1,Good

    Find_allBad_pixels_in_thisPC1group_brad,PC1_array,BadPixel_array

    junkindex=where(BadPixel_array eq This_PC1, YesCont)

    If Yescont eq 1 then  begin
        ; unless it meets on one of the three following criteria.
        Crit_a=Nslice  ge 4 and L5  ge 4 and L2  ge 3 and area  ge 0.5*alexei1  and Nslice  lt 10*L2
        if Crit_a eq 0 then begin;  That mean it is a noise.
            Good=0 & return
        endif; else : this particle is still a good particle.
    endif


    ; if lineNdot eq 1 then  goto, label_it_as_bad
    if ( Nslice  eq Area  and L2  eq 1 and Nslice  gt 4 ) then begin
        good=0 & return
    endif

    if ( Area  le 1.35*Nslice  and L4  eq L5  and Nslice  gt 4 and L2  eq 2) then begin
        good=0 & return
    endif

    if ( Nslice  gt 10 and Nslice  gt 0.75*area  and Nslice  le 1.5*area ) then begin
        good=0 & return
    endif

    if ( L4  eq L5  and Alexei1  gt 0.9*Nslice *L5  and L2  eq 2 and L2  ne L4 ) then begin
        good=0 & return
    endif

    if ( L4  eq L5  and Alexei1  gt 3.0*Area  and L2  eq 2)  then begin
        good=0 & return
    endif

    if ( L4  eq L5  and Alexei1  gt 4.0*Area ) then begin
        good=0 & return
    endif

    ; added this to take away black spot rectangular images.
    if area  gt 0.8*Nslice *126.0 then begin
        good=0 & return
    endif

    if area  gt 0.8*Nslice *126.0 then begin
        good=0 & return
    endif
    ; setp 3 to see if it is round.
    roundness=(Nslice ge 0.15*L5) and ( (L5 ge 0.15*Nslice) or L5 gt 50 )
    if roundness  eq 0 then begin;  roundness of a particle
        good=0 & return
    endif

    ;step 4 to see if it is big splash.
    if (L5  gt 10 or Nslice  gt 10) and Alexei1  gt 3.0*area  then begin
        good=0 & return
    endif

    if (L5  gt 15 or Nslice  gt 15) and Alexei1  gt 2.5*area  then begin
        good=0 & return
    endif

    if (L5  gt 20 or Nslice  gt 20) and Alexei1  gt 2.0*area  then begin
        good=0 & return
    endif


    ; find out of it is a long striker
    if (Nslice gt 50 and Area lt Nslice*0.2*L5) then begin
        good=0 & return
    endif


    good=1;;at here the image is good.  put it on the png page file.


end
; end of find if this particle good or bad.



;***********************************************************************
pro Find_allBad_pixels_in_thisPC1group,PC1_array,BadPixel_array
    done=0
    ;stop
    BadPixel_array=[-9]
    N_diodes=128.0
    while done eq 0 do begin
        meanH=float(n_elements(PC1_array))/n_diodes
        Threshold= (5.0*sqrt(meanH)+meanH) > 1.5;  from brad
        H1=histogram(Pc1_array,binsize=1,min=0,max=128)
        index=where(H1 gt Threshold,ContG)
        n_diodes=n_diodes-ContG; n_diodes is the number of remaining pixels that could be not noisy.

        if ContG gt 0 then begin;   There are bad pixels in the PC1_array.
            BadPixel_array=[BadPixel_array,index]
            ;there are ContG groups of bad pixels. eliminate then all.
            for i=0, contG-1 do begin
                indextemp=where(PC1_array ne index(i),contDD)
                if contDD gt 0 then begin
                    PC1_new=PC1_array(indextemp)
                    PC1_array=PC1_new
                endif else done=1;if contDD=0 means all PC1_array are bad. we can stop now.
            endfor

        endif else begin
            done=1
        endelse

        if n_diodes eq 0 then done=1
    endwhile

end;Find_allBad_pixels_in_thisPC1group,PC1_array,BadPixel_array
;*********************************************************************************

;***********************************************************************
pro Find_allBad_pixels_in_thisPC1group_brad,PC1_array,BadPixel_array
    ; This rountine finds all Bad particles in the vectors of PC1_array.
    ; output is the BadPixel_array, if any particle's PC1(i) values in this
    ; group matches one of the BadPixel_array elements, then that  particle i
    ; will be considered as noise. badPixel_array=[-9, 26, 105] will means
    ; that pixle 26, 105 is bad.

    done=0
    BadPixel_array=[-9]
    N_diodes=128.0
    while done eq 0 do begin
        mean1=float(n_elements(PC1_array))/n_diodes
        His=histogram(Pc1_array,binsize=1,min=0,max=128)
        indexBQ=where(His gt mean1-3.*sqrt(mean1),cont_Gt33)
        if cont_GT33 lt 32 then meanHis=mean1 else meanHis=mean(His(indexBQ))

        Threshold= (5.0*sqrt(meanhis)+meanhis) > 1.5;  from brad

        index=where(His gt Threshold,ContG)
        n_diodes=n_diodes-ContG; n_diodes is the number of remaining pixels that could be not noisy.

        if ContG gt 0 then begin;   There are bad pixels in the PC1_array.
            BadPixel_array=[BadPixel_array,index]
            ;there are ContG groups of bad pixels. eliminate then all.
            for i=0, contG-1 do begin
                indextemp=where(PC1_array ne index(i),contDD)
                if contDD gt 0 then begin
                    PC1_new=PC1_array(indextemp)
                    PC1_array=PC1_new
                endif else done=1;if contDD=0 means all PC1_array are bad. we can stop now.
            endfor

        endif else begin
            done=1
        endelse
        if n_diodes eq 0 then done=1
    endwhile

end;Find_allBad_pixels_in_thisPC1group_brad,PC1_array,BadPixel_array
;*********************************************************************************
PRO ProcessParticle, Image, out_array, out_byte_array, WordCount, Slices, Sums, Nslice, Area, Midpoint, Edges, Err, $
    L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3


; TAF found an odd size for an image array, which should always be even, putting in a stop
; the odd size was caused by a bad copy into my test program, and should not be encountered
; in normal operation.  Still, this stop should be left in to help debug if an odd Image is
; ever encountered.
if((size(Image))[1] mod 2 eq 1) then begin
    print, "Image size is odd, should be 2*Slices long"
    help, Image, Slices
    stop
endif


; assemble all variables in a big fltarr for testing communication with .dll

n_args = 20 ; the number of arguments sent by IDL, used by the .dll as a quick sanity check

;expected_rettest = [n_args, Image, Sums, out_byte_array, Wordcount, Slices, Nslice, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3]
;rettest = expected_rettest
;rettest[*] = 0. ; initiallize and zero rettest
;rettest = fltarr(5)
;rt_size = (size(rettest))[1]



retval = CALL_EXTERNAL('C:\SPEC_2DS_process_particles.dll', 'process_particles', $
    n_args,            $
    Image,             $
    Sums,              $
    out_array,         $
    out_byte_array,    $
    Wordcount,         $
    Slices,            $
    Nslice,            $
    Area,              $
    Midpoint,          $
    Edges,             $
    Err,               $
    L3,                $
    L4,                $
    L5,                $
    PC3x,              $
    PC3y,              $
    Pc4x,              $
    Pc4y,              $
    A3,                $
    ;rt_size,           $ ; size of the rettest float array
    ;rettest,           $ ; testing .dll will copy variables to here to verify transmission
    /I_VALUE,          $
    ;/UNLOAD,           $ ; comment out /UNLOAD when not debugging
    /CDECL)

if(retval eq -1) then begin
    print, ''
    print, "CALL_EXTERNAL on DecompressParticle returned -1, bad number of arguments"
    print, ''
    stop
endif

Catch, onError
IF onError NE 0 THEN BEGIN
    Catch, /Cancel
    result = Error_Message(Traceback=1)
    print, "caught error in a2dsview call_external", onError

    stop

    onError = 0

ENDIF



; resize to appropriate dims -- TAF might be fixed when Wordcount and Slices are fixed...

size_oba = (size(out_byte_array))[2]

if(Slices le size_oba) then begin
    out_byte_array = out_byte_array(0:(Slices * 128L)-1)
    out_byte_array = reform(out_byte_array,128L,Slices)
endif else begin
    print, "Slices ", Slices, " does not agree with size of out_byte_array ", size_oba
endelse

; since ProcessParticle now returns out_byte_array in the Alexei processing format, we need to fix it here
; TAF this should likely be done within the .dll
aa = where(out_byte_array eq 1, complement=bb, count)

if(count gt 0) then begin
    out_byte_array(aa) = 255; that means out_byte_array is either 255 or 0 values to make it balck or white.
endif

if(count lt size_oba) then begin
    out_byte_array(bb) = 0;   what are the values in out_array ??
endif



;   ENDIF ELSE MESSAGE,'External call to Decompress failed'
END ; ProcessParticle   ;---------------------------------------------------------------------------

;****************************************************************************************

;+
; NAME:
;    ERROR_MESSAGE

; PURPOSE:

;    The purpose of this function  is to have a device-independent
;    error messaging function. The error message is reported
;    to the user by using DIALOG_MESSAGE if widgets are
;    supported and MESSAGE otherwise.

;    In general, the ERROR_MESSAGE function is not called directly.
;    Rather, it is used in a CATCH error handler. Errors are thrown
;    to ERROR_MESSAGE with the MESSAGE command. A typical CATCH error
;    handler is shown below.

;       Catch, theError
;       IF theError NE 0 THEN BEGIN
;          Catch, /Cancel
;          ok = Error_Message(/Traceback, /Error)
;          RETURN
;       ENDIF

;    Error messages would get into the ERROR_MESSAGE function by
;    throwing an error with the MESSAGE command, like this:

;       IF test NE 1 THEN Message, 'The test failed.'

; AUTHOR:

;   FANNING SOFTWARE CONSULTING
;   David Fanning, Ph.D.
;   1645 Sheely Drive
;   Fort Collins, CO 80526 USA
;   Phone: 970-221-0438
;   E-mail: davidf@dfanning.com
;   Coyote's Guide to IDL Programming: http://www.dfanning.com/

; CATEGORY:

;    Utility.

; CALLING SEQUENCE:

;    ok = Error_Message(the_Error_Message)

; INPUTS:

;    the_Error_Message: This is a string argument containing the error
;       message you want reported. If undefined, this variable is set
;       to the string in the !Error_State.Msg system variable.

; KEYWORDS:

;    ERROR: Set this keyword to cause Dialog_Message to use the ERROR
;       reporting dialog. Note that a bug in IDL causes the ERROR dialog
;       to be used whether this keyword is set to 0 or 1!

;    INFORMATIONAL: Set this keyword to cause Dialog_Message to use the
;       INFORMATION dialog instead of the WARNING dialog. Note that a bug
;       in IDL causes the ERROR dialog to be used if this keyword is set to 0!

;    TITLE: Set this keyword to the title of the DIALOG_MESSAGE window. By
;       default the keyword is set to 'System Error' unless !ERROR_STATE.NAME
;       equals "IDL_M_USER_ERR", in which case it is set to "Trapped Error'.

;    TRACEBACK: Setting this keyword results in an error traceback
;       being printed to standard output with the PRINT command. Set to
;       1 (ON) by default. Use TRACEBACK=0 to turn this functionality off.

; OUTPUTS:

;    Currently the only output from the function is the string "OK".

; RESTRICTIONS:

;    The WARNING Dialog_Message dialog is used by default.

; EXAMPLE:

;    To handle an undefined variable error:

;    IF N_Elements(variable) EQ 0 THEN $
;       ok = Error_Message('Variable is undefined', /Traceback)

; MODIFICATION HISTORY:

;    Written by: David W. Fanning, 27 April 1999.
;    Added the calling routine's name in the message and NoName keyword. 31 Jan 2000. DWF.
;    Added _Extra keyword. 10 February 2000. DWF.
;    Forgot to add _Extra everywhere. Fixed for MAIN errors. 8 AUG 2000. DWF.
;    Adding call routine's name to Traceback Report. 8 AUG 2000. DWF.
;    Added ERROR, INFORMATIONAL, and TITLE keywords. 19 SEP 2002. DWF.
;    Removed the requirement that you use the NONAME keyword with the MESSAGE
;      command when generating user-trapped errors. 19 SEP 2002. DWF.
;    Added distinctions between trapped errors (errors generated with the
;      MESSAGE command) and IDL system errors. Note that if you call ERROR_MESSAGE
;      directly, then the state of the !ERROR_STATE.NAME variable is set
;      to the *last* error generated. It is better to access ERROR_MESSAGE
;      indirectly in a Catch error handler from the MESSAGE command. 19 SEP 2002. DWF.
;    Change on 19 SEP 2002 to eliminate NONAME requirement did not apply to object methods.
;      Fixed program to also handle messages from object methods. 30 JULY 2003. DWF.
;-
;###########################################################################

; LICENSE

; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.

; Copyright  1999-2003 Fanning Software Consulting

; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.

; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:

; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.

; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.

; 3. This notice may not be removed or altered from any source distribution.

; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.

;###########################################################################


FUNCTION ERROR_MESSAGE, theMessage, Error=error, Informational=information, $
    Traceback=traceback, NoName=noname, Title=title, _Extra=extra

On_Error, 2

; Check for presence and type of message.

IF N_Elements(theMessage) EQ 0 THEN theMessage = !Error_State.Msg
s = Size(theMessage)
messageType = s[s[0]+1]
IF messageType NE 7 THEN BEGIN
    Message, "The message parameter must be a string.", _Extra=extra
ENDIF

; Get the call stack and the calling routine's name.

Help, Calls=callStack
IF Float(!Version.Release) GE 5.2 THEN $
    callingRoutine = (StrSplit(StrCompress(callStack[1])," ", /Extract))[0] ELSE $
    callingRoutine = (Str_Sep(StrCompress(callStack[1])," "))[0]

; Are widgets supported?

widgetsSupported = ((!D.Flags AND 65536L) NE 0)
IF widgetsSupported THEN BEGIN

    ; If this is an error produced with the MESSAGE command, it is a trapped
    ; error and will have the name "IDL_M_USER_ERR".

    IF !ERROR_STATE.NAME EQ "IDL_M_USER_ERR" THEN BEGIN

        IF N_Elements(title) EQ 0 THEN title = 'Trapped Error'

        ; If the message has the name of the calling routine in it,
        ; it should be stripped out. Can you find a colon in the string?

        ; Is the calling routine an object method? If so, special processing
        ; is required. Object methods will have two colons together.

        doublecolon = StrPos(theMessage, "::")
        IF doublecolon NE -1 THEN BEGIN

            prefix = StrMid(theMessage, 0, doublecolon+2)
            submessage = StrMid(theMessage, doublecolon+2)
            colon = StrPos(submessage, ":")
            IF colon NE -1 THEN BEGIN

                ; Extract the text up to the colon. Is this the same as
                ; the callingRoutine? If so, strip it.

                IF StrMid(theMessage, 0, colon+StrLen(prefix)) EQ callingRoutine THEN $
                    theMessage = StrMid(theMessage, colon+1+StrLen(prefix))
            ENDIF
        ENDIF ELSE BEGIN

            colon = StrPos(theMessage, ":")
            IF colon NE -1 THEN BEGIN

                ; Extract the text up to the colon. Is this the same as
                ; the callingRoutine? If so, strip it.

                IF StrMid(theMessage, 0, colon) EQ callingRoutine THEN $
                    theMessage = StrMid(theMessage, colon+1)
            ENDIF

        ENDELSE


        ; Add the calling routine's name, unless NONAME is set.

        IF Keyword_Set(noname) THEN BEGIN
            answer = Dialog_Message(theMessage, Title=title, _Extra=extra, $
                Error=error, Information=information)
        ENDIF ELSE BEGIN
            answer = Dialog_Message(StrUpCase(callingRoutine) + ": " + $
                theMessage, Title=title, _Extra=extra, $
                Error=error, Information=information)
        ENDELSE

    ENDIF ELSE BEGIN

        ; Otherwise, this is an IDL system error.

        IF N_Elements(title) EQ 0 THEN title = 'System Error'

        IF StrUpCase(callingRoutine) EQ "$MAIN$" THEN $
            answer = Dialog_Message(theMessage, _Extra=extra, Title=title, $
            Error=error, Information=information) ELSE $
            IF Keyword_Set(noname) THEN BEGIN
            answer = Dialog_Message(theMessage, _Extra=extra, Title=title, $
                Error=error, Information=information)
        ENDIF ELSE BEGIN
            answer = Dialog_Message(StrUpCase(callingRoutine) + "--> " + $
                theMessage, _Extra=extra, Title=title, $
                Error=error, Information=information)
        ENDELSE
    ENDELSE
ENDIF ELSE BEGIN
    Message, theMessage, /Continue, /NoPrint, /NoName, /NoPrefix, _Extra=extra
    Print, '%' + callingRoutine + ': ' + theMessage
    answer = 'OK'
ENDELSE

; Provide traceback information if requested.

IF Keyword_Set(traceback) THEN BEGIN
    Help, /Last_Message, Output=traceback
    Print,''
    Print, 'Traceback Report from ' + StrUpCase(callingRoutine) + ':'
    Print, ''
    FOR j=0,N_Elements(traceback)-1 DO Print, "     " + traceback[j]
ENDIF

RETURN, answer
END ; ----------------------------------------------------------------------------



;*****************************************************
function SPEC_Nano2HMS, ns
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    orig_ns = ns

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)
    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)

    ns = orig_ns

    return,a


end
;*****************************************************
;*****************************************************
function  SPEC_Nano2HMS_struct, ns, time_struct
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    ts  = { _time_struct, $
        Hours: 0, $
        Minutes: 0, $
        Seconds: 0, $
        Milliseconds: 0, $
        Microseconds: 0, $
        Nanoseconds: 0 }

    time_struct = ({_time_struct})

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)

    time_struct.Hours = hours
    time_struct.Minutes = minutes
    time_struct.Seconds = seconds
    time_struct.Milliseconds = milli
    time_struct.Microseconds = micro
    time_struct.Nanoseconds = ns

    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)

    return,a


end


;*****************************************************
;*****************************************************


pro  get_all_data_filenames,filter_str,pathnm,filenames,file_count
    ;input is filter_str, pathnm
    ;output is filenames,file_count
    substrs=strsplit(filter_str,'.',/extract)
    extension=substrs(1)

    do_loop=1
    WHILE (do_loop eq 1) do begin    ;repeatedly selecting files until
        ;user comfirms
        whole_filter_str=pathnm+filter_str
        filenames=findfile(whole_filter_str,COUNT=file_count)
        ;find all files with filter_str and counts the number of these files

        ; display the files in the screen for user to review
        print,'***********************************************************'
        print,'********  Here are data files with ',filter_str, '   ******'
        print,'*** found in current directory for input by this program ***'
        print,'************************************************************'

        for j=0, (file_count-1)  do begin
            print, filenames(j)
        endfor

        print,'*********************************************'

        ; print the message to ask user to confirm
        ; define answer to be a string
        answer=' '

        print,'Are you sure to read above files ? yes/no'

        print,'----if no, then enter a string with wildcat (* or ?)'
        print,'           to limit the files being selected for input.'
        print,'           for example:   *lear_1749*.',extension
        print,'----Or--stop now, delete those unwanted files from  '
        print,'           the current directory, then restart '
        print,'           this program'
        print, 'Enter y or n:'
        read,answer

        if strcmp(answer,'y') then  do_loop=0
        if (strcmp(answer,'y') eq 0) then begin
            print,'  Enter the string(ie: *6*b?*.',extension,'):'
            read,answer    ; use this string for selecting input data files.
            filter_str=pathnm+answer
        endif

    ENDWHILE           ; end of initial start up.
    print,'                            '
    print,' done,get the files,.....Processing,  please wait ! '
    print,'
end; endof get_all_data_filenames,filter_str,filenames,pathnm
;****************************************************************************

