pro reconstruct_sizes_L9
    ;input is x1,x2,y1,and F.   output is L9,adj1.
    pxs = 0.01
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    sa_default = 128.0 * pxs *  dww

    if F eq 1 and L5 lt 128 then begin
        L9=x1*x1/y1/4.0+y1
        Wp=w+2*(L9/2.0-y1)*1.0E-4
    endif

    if F eq 2 and L5 lt 128 then begin; condition is x2>=x1
        L9=sqrt((y1+(x2*x2-x1*x1)/(4.0*y1) )^2 + x1*x1 )
        Wp=w+2*(L9/2.0-y1)*1.0E-4
    endif

    if F gt 0 and L5 eq 128 then begin; particle touches bothe edges.
        L9=sqrt((y1+(x2*x2-x1*x1)/(4.0*y1) )^2 + x1*x1 )
        Wp=w+2*(L9/2.0-y1)*1.0E-4
    endif
    ;dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm
    dof = (5.13*L9*L9) / 10.0D ;; convert to mm
    sa_actual = (127.0 + L9) * pxs * min([dww,dof]);  ; sa_default = 128.0 * pxs *  dww
    adj1 = sa_default/sa_actual







end;reconstruct_sizes_L9

