;***************************************************************
pro ZoomPanel, info, ave_info

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV

    base = WIDGET_BASE(/row, Title = 'Zoomed Data')
    info.ZoomWindowID = base


    ZoomDisplay = Widget_Draw(base,XSize=650, YSize=500)
    info.ZoomWindowDrawID = ZoomDisplay



    RightControlPanel = WIDGET_BASE(base, $
        ROW=10, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        XSIZE=95)


    tlabel = WIDGET_LABEL(RightControlPanel, $
        VALUE="Settings", $
        XSIZE=90, $
        YSIZE=14)


    ;===========================================

    tlb_cb = Widget_Base(RightControlPanel, Column=1, Scr_XSize=200, /NonExclusive)
    ave_info.IDAveXLog = Widget_Button(tlb_cb, Value='X Log')
    ave_info.IDAveYLog = Widget_Button(tlb_cb, Value='Y Log')
    Widget_Control, ave_info.IDAveXLog, Set_Button=1
    Widget_Control, ave_info.IDAveYLog, Set_Button=1

    tlb_tx = Widget_Base(RightControlPanel, Column=1, xsize = 150)

    templabel = WIDGET_LABEL(tlb_tx, VALUE="Min X",XSIZE=50, ALIGN_LEFT = 1 ,YSIZE=14)
    IDAveXMin = Widget_TEXT(tlb_tx, EDITABLE=1, frame=40,  Scr_XSize = 50, Value='10')
    templabel = WIDGET_LABEL(tlb_tx, VALUE="Max X",XSIZE=50, ALIGN_LEFT = 1, YSIZE=14)
    IDAveXMax = Widget_TEXT(tlb_tx, EDITABLE=1, frame=40,  Scr_XSize = 50, Value='1000')

    templabel = WIDGET_LABEL(RightControlPanel, $
        VALUE="", $
        XSIZE=90, $
        YSIZE=40)

    templabel = WIDGET_LABEL(tlb_tx, VALUE="Min.Bin.Size",XSIZE=90, ALIGN_LEFT = 1, YSIZE=14)
    IDAveMinBinSize = Widget_TEXT(tlb_tx, EDITABLE=1, frame=40,  Scr_XSize = 50, Value='10')

    templabel = WIDGET_LABEL(tlb_tx, VALUE="Min.Counts/Bin",XSIZE=90, ALIGN_LEFT = 1, YSIZE=14)
    IDAveMinCountPerBin = Widget_TEXT(tlb_tx, EDITABLE=1, frame=40,  Scr_XSize = 50, Value='100')

    ave_info.IDAveXMin = IDAveXMin
    ave_info.IDAveXMax = IDAveXMax
    ave_info.IDAveMinBinSize = IDAveMinBinSize
    ave_info.IDAveMinCountPerBin = IDAveMinCountPerBin

    BUTTON_Update = WIDGET_BUTTON( RightControlPanel, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=80, $
        TOOLTIP="Update", $
        VALUE="UPDATE", $
        Event_Pro='ZoomChartUpdate_event')
    BUTTON_PNG     = WIDGET_BUTTON( RightControlPanel, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=80, $
        TOOLTIP="Save as PNG", $
        VALUE="Save PNG", $
        Event_Pro='ZoomChartPNG_event')
    BUTTON_ASCII   = WIDGET_BUTTON( RightControlPanel, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=80, $
        TOOLTIP="Save as ASCII", $
        VALUE="Save Ascii", $
        Event_Pro='ZoomChartAscii_event')


    ave_info.ZoomWindowID = info.ZoomWindowID
    ave_info.ZoomWindowDrawID = info.ZoomWindowDrawID




    WIDGET_CONTROL, base, /REALIZE

    XMANAGER, 'CreateZoom', base, /JUST_REG
end
