pro Get_alexei_correct_size,Dmax,Dimg,sizes_L4,SizeDo
    ;input Dmax-----maximium area of the alexei's  90 or 0 degree counter area
    ;input Dimg-----total area of the image, A1 from Chris code.
    ;input sizes_L4-------sizes using L4
    ;output sizeDo ----the corrected size of the particle.----Sept 14, 2005.

    get_alexeis_table,Ratio_DmDo,Ratio_DiDm; teh ration tells
    ; the relation of Dimg, Dpson spot, and the apparent size and true size

    ratio=sqrt(Dimg/Dmax);   ; it is a vector of the imput variables.
    nnn=n_elements(ratio)
    rdmdo=fltarr(nnn)
    for i=0LL,nnn-1LL do begin
        values=abs(ratio-Ratio_DiDm)
        minv=min(values)
        index=where( values eq minv)
        rdmdo(i)=Ratio_DmDo(index(0))
    endfor
    sizeDo=sizes_L4/rdmdo

end; end of pro Get_alexei_correct_size,Dmax,Dimg,SizeDo
;get alexeis table
;***********************************************************
pro get_alexeis_table,Ratio_DmDo,Ratio_DiDm

    filename=dialog_pickfile(filter='Alexeis_table.txt')
    data=read_ascii(filename,data_start=4)
    Ratio_DmDo=transpose(data.field1(1,*))
    Ratio_DiDm=transpose(data.field1(2,*))
end;**************end of get_alxeis_table
;**************************************************
