pro make_cond_SpectValues_pre_bansemer,$
    ;Inputs
    pROIArray, pStateInfo, pLink, ROINum, ver, $
    ;In/Out
    cond_wmeanLenArr,cond_wmeanadjarr; this line for wysisyg_r all particles. Octoner7, 2004

;***********************************************************************************************************
;the above has to be changed using teh corrected length Dcor.  August 23, 2004
; note that if there are several particles, roinum will equal 0, 1, 2, 3, 4 ect.
; if there are only one particle. then roinum will be just 0.
; we can calculate one particle into Acor_area.
; we need to calculate adj value.
; from du_adj.pro of do_alone use_adj=Co_1 - Co_2*PDS(somarr3[0]) + Co_3*use_Acor(sompt)
; where co_1=-0.2; CO_2=0.0; Co_3=0.00012; Min_P=0.005; and Acor=area/Dratio

cutoff=(*pROIArray)[ROINum].imageHeader.cutoff
fcs=(*pROIArray)[ROINum].imageHeader.focus
pos=1.57547- 0.0614464*fcs + 0.000838895*fcs^2.0d -3.8254e-06*fcs^3.0d;  ;pos varies from 0 to 0.65
Dratio=1.1031377+(1.2314287-0.34444972*pos)*pos;   ;Dratio varies from 1.1 to 1.65.
;do a few more thing incase teh particle is a sphere.
if ((*pROIArray)[ROINum].imageHeader.crystal eq 1) $
    then Dapp=((*pROIArray)[ROINum].imageHeader.len + (*pROIArray)[ROINum].imageHeader.wid)/2.0 $
    else Dapp=(*pROIArray)[ROINum].imageHeader.len
Dcor=Dapp*(*pStateInfo).Settings.pixsize/Dratio
Pcor=(*pROIArray)[ROINum].imageHeader.perim*(*pStateInfo).Settings.pixsize/Dratio
Lcor=(*pROIArray)[ROINum].imageHeader.len*(*pStateInfo).Settings.pixsize/Dratio
Wcor=(*pROIArray)[ROINum].imageHeader.wid*(*pStateInfo).Settings.pixsize/Dratio
AsphCor=!pi*Dcor*Dcor/4.0;   no need to multiply the 2.3*2.3; because Dcor has 2.3 in it.
Acor=(*pROIArray)[ROINum].imageHeader.area*(((*pStateInfo).Settings.pixsize)^2.0)/Dratio; Dratio is always >0.
Acor_area=min([AsphCor,Acor]);  That is if Acor gt AsphCor then Acor=AsphCor
Acor_old=Acor*Dratio*(1.0+1.0/(Dratio^2.0)-1.0/Dratio); just for calculating adj
;***************************************************

;****************************************************
crit= (fcs gt 20) and (cutoff lt 6)

;get wfj values    wfj is for wysiwyg2 calculations ---true wysiwyg calculations
wfj=2.3379617/(Dcor*Dcor/10000d);  attention  I added Dratio in here to make it the same as do_alone
if wfj lt 1.0 then wfj=1.0

if crit eq 1 and wfj ne 0.0 then begin ;output the wysiwyg2 data---all data for calculations.
    cond_wmeanLenarr     =[cond_wmeanLenarr,DCor]
    cond_wmeanadjarr     =[cond_wmeanadjarr,wfj]
endif; else wmeanLenarr=wmeanLenarr ; no need for this else line.

;*************************************************************************************************************
;print,wmeanlenarr
;print,wmeanadjarr
end;  ; this is pre-bansemer code.
pro make_cond_SpectValues,$  ; this post_bansemer code implemented on Feb.19, 2009.
    ;Inputs
    pROIArray, pStateInfo, pLink, ROINum, ver, $
    ;In/Out
    cond_wmeanLenArr,cond_wmeanadjarr; this line for wysisyg_r all particles. Octoner7, 2004

forward_function Kcorrection_factor
;***********************************************************************************************************
;the above has to be changed using teh corrected length Dcor.  August 23, 2004
; note that if there are several particles, roinum will equal 0, 1, 2, 3, 4 ect.
; if there are only one particle. then roinum will be just 0.
; we can calculate one particle into Acor_area.
; we need to calculate adj wfj value.

;pixsize=2.3 ; TAF 2014-08-20 this came in from 1.1.18 Mo -- why is this hard coded in here?  It should be defined on a probe by probe basis, and should be moved to the main a3VCPIView.pro define_Pixel_resolutions

pixsize = !CPI_MICRONS_PER_PIXEL

cutoff=(*pROIArray)[ROINum].imageHeader.cutoff
fcs=(*pROIArray)[ROINum].imageHeader.focus
fcs100    =(100.0-fcs) >0.0;  caps fcs to be 100 at maximum
fcs100caps=fcs100/4.0
Lob=(*pROIArray)[ROINum].imageHeader.len*pixsize;    in microns
Wob=(*pROIArray)[ROINum].imageHeader.wid*pixsize;    in microns
Pob=(*pROIArray)[ROINum].imageHeader.perim*pixsize;  in microns
Aob=(*pROIArray)[ROINum].imageHeader.area*pixsize*pixsize;   in micron_square
Lab=Lob-fcs100caps
Wab=Wob-fcs100caps

Kcor_l=Kcorrection_factor(Lab)
Kcor_w=Kcorrection_factor(Wab)

Lcor=Lob-Kcor_l*fcs100
Wcor=Wob-Kcor_w*fcs100

if ((*pROIArray)[ROINum].imageHeader.crystal eq 1) then Dcor=(Lcor+Wcor)/2.0 else Dcor=Lcor

Pcor=Pob-2.0*!pi*(Kcor_L+Kcor_w)*fcs100caps
AsphCor=!pi*Dcor*Dcor/4.0;   no need to multiply the 2.3*2.3; because Dcor has 2.3 in it.
Acor=Aob-!pi*(Wob*Kcor_l+Lcor*Kcor_w)*fcs100caps
Acor_area=min([AsphCor,Acor]);  That is if Acor gt AsphCor then Acor=AsphCor
;***************************************************

;****************************************************
crit= (fcs gt 50 or fcs eq 50) and (cutoff lt 1 or cutoff eq 1.0)

;get wfj values    wfj is for wysiwyg2 calculations ---true wysiwyg calculations
wfj=(1024.0/(1024.0-ceil(Lob/2.0)))*(1024.0/(1024.0-ceil(Wob/2.0)))*( (1.167/(0.018*Dcor+0.2223)) > 1.0 )

if crit eq 1 and wfj ne 0.0 then begin ;output the wysiwyg2 data---all data for calculations.
    cond_wmeanLenarr     =[cond_wmeanLenarr,DCor]
    cond_wmeanadjarr     =[cond_wmeanadjarr,wfj]
endif; else wmeanLenarr=wmeanLenarr ; no need for this else line.

;*************************************************************************************************************
;print,wmeanlenarr
;print,wmeanadjarr
end

function Kcorrection_factor, Lsize
    Kcor=(-0.0000232*Lsize*Lsize+0.00153*Lsize +0.241) >0.0
end

pro sum_conditional_Spectra_values,n_imgs,cond_wMeanLenarr,cond_wmeanAdjarr,Pgroup,Zfrmcont,Dvect,Wvect,Nvect
    ;input: n_imgs,meanLenarr,meanAjarrr
    ;in/out:FrameI_cont,Dvect,Wvect,Nvect; added by mo oxt 29 2004.
    index=where(cond_wmeanlenarr gt 0, contD)

    if n_imgs eq 0 or contD eq 0 then begin
        ZFrmcont=Zfrmcont+1L
        if(ptr_valid((*pGroup).pZFrmcont)) then *(*pGroup).pZfrmcont =Zfrmcont else (*pGroup).pZfrmcont = ptr_new(fltarr(1))
    endif else begin
        index=where(cond_wmeanlenarr gt 0, contD);  this is redundant, but i keep it i here.

        if contD gt 0 then begin  ; n_img has to be replace because if original N_imgs is 5
            ; but if there is only 1 roint has fcs gt 20 then N_imgs should be change to 1.
            N_imgs=contD
            if Dvect(0) eq 0.0 then begin
                Dvect=cond_wmeanlenarr(index)
                Wvect=cond_wmeanAdjarr(index)
                Nvect=indgen(contD)*0+N_imgs
            endif else begin
                Dvect=[Dvect,cond_wmeanlenarr(index)]
                Wvect=[Wvect,cond_wmeanAdjarr(index)]
                Nvect=[Nvect,indgen(contD)*0+N_imgs]
                nnn=n_elements(Nvect)
                if(ptr_valid((*pGroup).pDvect))then begin
                    (*pGroup).pDvect  = ptr_new(fltarr(nnn))
                    (*pGroup).pWvect  = ptr_new(fltarr(nnn))
                    (*pGroup).pNvect  = ptr_new(fltarr(nnn))
                    *(*pGroup).pDvect  =Dvect
                    *(*pGroup).pWvect  =Wvect
                    *(*pGroup).pNvect  =Nvect
                endif else begin
                    (*pGroup).pDvect  = ptr_new(fltarr(1))
                    (*pGroup).pWvect  = ptr_new(fltarr(1))
                    (*pGroup).pNvect  = ptr_new(fltarr(1))
                endelse
            endelse
        endif ; end of if contD gt
    endelse

    ; resett the frame values to zero.
    cond_wMeanLenarr=0.0
    cond_wmeanAdjarr=0.0

end
;*************************************************************************************
pro finish_cond_Spectra,pGroup, groupCnt
    ;In/out:  pGroup, groupCnt

    ; note upon return, pGroup points to the next intervals link
    prev_link = pGroup          ; store old link for next

    ; create a new link and assign to this links next field
    (*pGroup).next_link = ptr_new({groupLink})

    ; next group
    groupCnt = groupCnt + 1

    ; set pGroup to the new link pointer
    pGroup = (*pGroup).next_link

    ; connect chain backwards
    (*pGroup).prev_link = prev_link
end

pro Init_cond_SpectraGroup, frameTime, n_imgs, pLink, $
    pGroup, SlastFrameSec, $ ;;Out
    ;In/Out
    IntEnd, cond_wmeanLenarr,cond_wmeanAdjarr,Zfrmcont,Dvect,Wvect,Nvect
;Note: this routine assumes pGroup is pointing at the link we are about to initialize

; start of new time group set initial values
(*pGroup).startTime = (*(*pGroup).prev_link).startTime + (*pLink).SumInt

; load first value
if n_imgs eq 0 then Zfrmcont=1 else Zfrmcont=0;  added oct 23 for condictional spectra.
;*************************************************************
if n_imgs gt 0 then begin
    index=where(cond_wmeanLenarr gt 0,contD)
    if contD gt 0 then begin
        Dvect = cond_wmeanLenarr(index)
        Wvect = cond_wmeanAdjarr(index)
        Nvect = indgen(contD)+n_imgs
    endif else begin
        Dvect=0
        Wvect=0
        Nvect=0
    endelse
endif; end of if n_imgs gt 0
;********************************************************************
nnn=n_elements(Dvect)
if(ptr_valid((*pGroup).pDvect))then begin
    (*pGroup).pDvect  =ptr_new(fltarr(nnn))
    (*pGroup).pWvect  =ptr_new(fltarr(nnn))
    (*pGroup).pNvect  =ptr_new(fltarr(nnn))
    *(*pGroup).pDvect  =Dvect
    *(*pGroup).pWvect  =Wvect
    *(*pGroup).pNvect  =Nvect
endif  else begin
    (*pGroup).pDvect =ptr_new(fltarr(1))
    (*pGroup).pWvect =ptr_new(fltarr(1))
    (*pGroup).pNvect =ptr_new(fltarr(1))
endelse
if(ptr_valid((*pGroup).pZfrmcont))then begin
    (*pGroup).pZfrmcont  =ptr_new(fltarr(1))
    *(*pGroup).pZfrmcont  =Zfrmcont
endif else (*pGroup).pZfrmcont =ptr_new(fltarr(1))
;*******************************************************************************
; resett the frame values to zero.

;************************************************************************************************
SlastFrameSec = ulong(frameTime)
IntEnd = IntEnd + (*pLink).SumInt ; ; set end of next interval

cond_wMeanLenarr=0.0
cond_wmeanAdjarr=0.0

end

pro Pad_cond_SpectralGroups,PadCnt,pGroup,groupCnt,SumInt

    for i = 0,padCnt-1 do begin

        prev_link = pGroup          ; store old link for next

        ; set start of current time group
        (*pGroup).startTime = (*(*pGroup).prev_link).startTime + SumInt

        ;create a new link and store in the current links next field
        (*pGroup).next_link = ptr_new({groupLink})

        ; next group
        groupCnt = groupCnt + 1

        ; get pointer to the new link
        pGroup = (*pGroup).next_link   ; new link

        ; update the backward link
        (*pGroup).prev_link = prev_link

    endfor

end
