PRO ROIHistogram_event, event

    FORWARD_FUNCTION  WriteHistogram, ReadHistogram

    WIDGET_CONTROL, event.top, GET_UVALUE= LocalState,/no_copy
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of

        ; Handle a kill request.
        'WIDGET_KILL_REQUEST':begin
        pGroup = find_first_link(LocalState.pGroup)
        while( ptr_valid((*pGroup).next_link) ) do begin
            pNext_link = (*pGroup).next_link
            deleteGroup,pGroup
            pGroup = pNext_link
        endwhile

        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin

    ; Handle a sizing request
    'WIDGET_BASE':begin
    ; Resize window
    ;WIDGET_CONTROL, event.top, XSIZE =event.X>600, YSIZE =event.Y>425
    ;WIDGET_CONTROL, LocalState.MainView, XSIZE = (event.X - 150)>450, YSIZE = (event.Y - 140)>290
    WIDGET_CONTROL, event.top, XSIZE =1000, YSIZE =800  ; added by mo sept 9,2004
    WIDGET_CONTROL, LocalState.MainView, XSIZE = 780, YSIZE =560
    PlotHistogram, LocalState
    WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
    return
end

else: begin

    ; a normal event

    WIDGET_CONTROL, event.id, GET_UVALUE = eventval
    CASE eventval OF    ; Note that pos  is not equal Pos, it is case_senitive
        'pos':begin
        widget_control,LocalState.position, get_value = pos
        localState.grpNum = pos
        Localstate.pGroup = (*LocalState.pGroupPtr)[pos-1]
        stop
        PlotHistogram, LocalState
    end ;end of eventval= pos
    'MinCntsPerbin': begin
        IF event.value NE LocalState.sizes.gMincntsperbin THEN BEGIN
            ; Save new val
            LocalState.sizes.Gmincntsperbin = event.value
            PlotHistogram, LocalState
        ENDIF
    end ; end of eventval= mincntsperbin
    'MINMAX':begin
    ; IF LocalState.sizes.auto THEN BEGIN ;autoscale always is set to 1 now.
    ; Autoscale on, ignore settings
    WIDGET_CONTROL, LocalState.MinBinID, SET_VALUE = LocalState.sizes.gMinSize
    WIDGET_CONTROL, LocalState.MaxBinID, SET_VALUE =LocalState.sizes.gMaxSize
    WIDGET_CONTROL, LocalState.MinYID, SET_VALUE = LocalState.sizes.gMinY
    WIDGET_CONTROL, LocalState.MaxYID, SET_VALUE = LocalState.sizes.gMaxY
    ; ENDIF
end  ;end of minmax
'BINSIZE': begin
    IF event.value NE LocalState.sizes.gBinSize THEN BEGIN
        ; Save new val
        LocalState.sizes.gBinSize = event.value
        PlotHistogram, LocalState
    ENDIF
end ; end of binszie
'logscale': begin  ; that is for ylog
    LocalState.sizes.log = (LocalState.sizes.log) ? !false : !true
    PlotHistogram, LocalState
END
'xlogscale': begin
    LocalState.sizes.xlog = (LocalState.sizes.xlog) ? !false : !true
    PlotHistogram, LocalState
END
'show':begin
localState.show = (LocalState.show) ? !false : !true
PlotHistogram, LocalState
end
'filled':begin
localState.filled = event.value
PlotHistogram, LocalState
end
'filledn':begin
localState.filled =0;   not event.value changed to event.value on oct15, 2004
localState.filledn =event.value;  =1 for #PSD, =2 for sphPSD, =3 for IcePSD
PlotHistogram, LocalState
end

'SAF': begin
    widget_control,localstate.SAFID,get_value=uval
    ; Save new val
    if uval eq 0.0 or uval gt 1.0 then begin
        r=dialog_message('SAF should be >0 and <=1.0, try again.',/information)
        uval=0.999
        widget_control,localstate.SAFID,set_value=0.999
    endif

    LocalState.SAF = uval
    PlotHistogram, LocalState
end ; end of FFFx


'PRINT': BEGIN

    IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

    IF LocalState.PrinterSetup THEN PlotHistogram, LocalState, OutPutFlags=1
END

'SAVETIFF': PlotHistogram, LocalState, OutPutFlags=2

'PRINTALL': BEGIN
    IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

    IF LocalState.PrinterSetup THEN BEGIN
        pGroup = find_first_link(LocalState.pGroup)
        LocalState.pGroup = pGroup
        FOR i=1, LocalState.grpCnt DO BEGIN
            PlotHistogram, LocalState, OutPutFlags=1
            LocalState.pGroup =  (*LocalState.pGroup).next_link
        ENDFOR
        ; redisplay first
        LocalState.pGroup =  pGroup
        PlotHistogram, LocalState
    ENDIF
END  ; end of printall

'SAVE': Ret = WriteHistogram(LocalState)

'OPEN': Ret = ReadHistogram(LocalState)

'QUIT': BEGIN
    pGroup = find_first_link(LocalState.pGroup)
    while( ptr_valid((*pGroup).next_link) ) do begin
        pNext_link = (*pGroup).next_link
        deleteGroup,pGroup
        pGroup = pNext_link
    endwhile
    WIDGET_CONTROL, event.top, /DESTROY
    RETURN
END ;endof quit
ELSE:
ENDCASE ; end of event.id case
end
endcase ; end of sname case

WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
END

;============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output

PRO PlotHistogram, LocalState, OutPutFlags=OutPutFlags

    ; pGroup is a pointer to a structured linked list for this plot
    pGroup = localState.pGroup
    get_the_plotData,pGroup,Localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM,$
        pGrouppDataI,pGrouppadjI,pGrouppdataAI,pGrouppDataMI,$
        pGrouppDataL,pGrouppadjL,pGrouppdataAL,pGrouppDataML
    ;assign this for later use.
    done_save_all_psd_plots=0

    ; Default is to send ouput to plot only
    IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

    WIDGET_CONTROL, LocalState.BinSizeID, GET_VALUE=BinSize
    WIDGET_CONTROL, LocalState.BincntsID, GET_VALUE=mincntsperbin

    ;index = where(*(*pGroup).pData ne 0,numParticles)

    loadct,1,/silent
    Color = 255
    WSET, LocalState.MViewID
    erase

    t = ConvertFromSeconds((*pGroup).StartTime, LocalState.year)
    Time = strtrim(t.month,2)+'/'+strtrim(t.day,2)+' '+strtrim(t.hour,2)+':'+strtrim(t.minute,2)+':'+strtrim(t.sec,2)
    Time_mo='StTime: '+time+'  dT='+strtrim(string(LocalState.SumSecs),2)+' sec'; for all_PSD used  added by mo spet 10, 2004
    Time = STRING(FORM='("Period Number:",A, " DateTime: ",A,"  Period:", I5, " sec")',strtrim(LocalState.GrpNum,2),time,LocalState.SumSecs)

    ; Display Time info
    WIDGET_CONTROL, LocalState.TopLabelID, SET_VALUE=Time

    ;if( max(*(*pGroup).pData) eq 0) then begin

    if( not ptr_valid(pGrouppData) ) then begin
        file = strmid(localState.InFileName,rstrpos(localState.InFileName,'\')+1,strlen(localState.InFileName))
        acceptedPart = 0
        InfoSubTitle = STRING(FORM='(A0, ": TF:", I0, " IF:", I0, " IP:", I0," NRP:",I0," AP:",I0)', $
            File,(*pGroup).TotFrmCnt, (*pGroup).ROIFrmCnt, (*pGroup).totImgPart ,(*pGroup).nonRejPArt,acceptedPart)
        xyouts,.5,.05,infosubtitle,/normal,align = .5
        xyouts,.5,.5,'No accepted data in interval',/normal,align = .5,charsize = 2.0
        return
    endif

    validData = where(*pGrouppData ne 0,dataCnt)

    if( dataCnt eq 0 ) then begin
        file = strmid(localState.InFileName,rstrpos(localState.InFileName,'\')+1,strlen(localState.InFileName))
        acceptedPart = 0
        InfoSubTitle = STRING(FORM='(A0, ": TF:", I0, " IF:", I0, " IP:", I0," NRP:",I0," AP:",I0)', $
            File,(*pGroup).TotFrmCnt, (*pGroup).ROIFrmCnt, (*pGroup).totImgPart ,(*pGroup).nonRejPart,acceptedPart)
        xyouts,.5,.05,infosubtitle,/normal,align = .5
        xyouts,.5,.5,'No accepted data in interval',/normal,align = .5,charsize = 2.0
        return
    endif

    ; Autoscale?  IF LocalState.sizes.auto THEN BEGIN  ; autosacle is always set to 1
    MinBin = min(*pGrouppData,max=MaxBin)
    WIDGET_CONTROL, LocalState.MinBinID, SET_VALUE='Xmin:'+string(MinBin)
    WIDGET_CONTROL, LocalState.MaxBinID, SET_VALUE='Xmax:'+string(MaxBin); ENDIF

    ; New Plot
    ;*****************************************************************************************
    ;redo the above using brad program unihist_adj.pro
    sizes=(*pGrouppData)[validData]
    adjs =(*pGrouppAdj)[validData]
    Acors=(*pGrouppDataA)[validData]
    Mcors=(*pGrouppDataM)[validData]
    mo_minbinsize=(localstate.sizes).gbinsize

    cpiview_unihist_adj, sizes,mincntsperbin,mo_minbinsize,xpts,vals,adjs
    ; the xpts are like  1, 2, 2, 6, 6, 9.5  9.5  12.7
    ; and vals are like  3, 3, 5, 5, 20, 20. 11.   11.0
    ; they need to be put back into  bins spectra format.
    spectra=vals;       ;vals should be multiplied with factor 1/IMG_SV or to be correct in here.
    bins=xpts
    ; stop
    ;here we may need to assign bin_edges to a structure to be stored in the local_state.
    ;*****************************************************************************************

    indx = where(spectra gt 0,cnt)
    if(cnt eq 0)then begin
        print,'No points to plot, Check sampling period'
        return
    endif
    if(n_elements(spectra) eq 1)then begin
        ; need at least 2 elements to do a plot, force this to be true if needed
        temp = spectra[0]
        temNbin = bins[0]
        spectra = fltarr(2)
        bins    = fltarr(2)
        spectra[0] = temp
        bins[0]    =temNbin
    endif
    ;stop
    case LocalState.TypeScaling of
        1: begin; ; this is similar using deadtime. but is not deadtiem scale. use conc=
            ; using dead time
            ; scaler = (localState.sumSecs - (*pGroup).deadtime)*LocalState.SampleVolume/localState.sumSecs + (*pGroup).TotFrmCnt*.0002
            conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
            ave_conc=float(localstate.sumsecs)*conc_norm*total(adjs );  because localstate.sampleV is SV of sumsecs.
            factor  =float(localstate.sumsecs)*conc_norm;   ;following Sizes=vector of Dcor


            du_cpiview_other_psds,factor,mincntsperbin,adjs,Acors,sizes,Mcors,xpts,Lvals,Avals,Mvals
            nnn=n_elements(xpts)
            (*pGroup).Nbinedges = ptr_new(fltarr(nnn))
            (*(*pGroup).Nbinedges)[0:nnn-1] = xpts
            (*pGroup).Nbinheights = ptr_new(fltarr(nnn))
            (*(*pGroup).Nbinheights)[0:nnn-1] = vals*factor
            spectra =(*(*pGroup).Nbinheights)[0:nnn-1]
            (*pGroup).Lbinheights = ptr_new(fltarr(nnn))
            (*pGroup).Abinheights = ptr_new(fltarr(nnn))
            (*pGroup).Mbinheights = ptr_new(fltarr(nnn))
            (*(*pGroup).Lbinheights)[0:nnn-1] = Lvals*factor
            (*(*pGroup).Abinheights)[0:nnn-1] = Avals*factor
            (*(*pGroup).Mbinheights)[0:nnn-1] = Mvals*factor
            Conc = ave_conc; total(spectra)  ; this is no use, but keep it in case the program somewhere it is needed.
            acceptedPart = dataCnt ; this is no use to me. but keep it.
            scalingType = '#/(LT*SV)/um'

        end

        3:begin   ;this is for wysisyg_r  scaling type is always 3.
        ;conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
        numfrms=max([(*pGroup).totFrmCnt, 1.0])
        DOFmax=1.411*2.54
        IMG_SV=DOFmax*1024d*0.00023*1024d*0.00023*(numfrms)/1000d   ;liters
        factor=1.0/IMG_SV;  if localstate.typescaling eq 3 then  factor = 1.0/IMG_SV
        ave_conc=factor*total(adjs );  because localstate.sampleV is SV of sumsecs.
        ; stop
        du_cpiview_other_psds,factor,mincntsperbin,adjs,Acors,sizes,Mcors,xpts,Lvals,Avals,Mvals
        nnn=n_elements(xpts)
        (*pGroup).Nbinedges = ptr_new(fltarr(nnn))
        (*(*pGroup).Nbinedges)[0:nnn-1] = xpts
        (*pGroup).Nbinheights = ptr_new(fltarr(nnn))
        (*(*pGroup).Nbinheights)[0:nnn-1] = vals*factor
        spectra =(*(*pGroup).Nbinheights)[0:nnn-1]
        (*pGroup).Lbinheights = ptr_new(fltarr(nnn))
        (*pGroup).Abinheights = ptr_new(fltarr(nnn))
        (*pGroup).Mbinheights = ptr_new(fltarr(nnn))
        (*(*pGroup).Lbinheights)[0:nnn-1] = Lvals*factor
        (*(*pGroup).Abinheights)[0:nnn-1] = Avals*factor
        (*(*pGroup).Mbinheights)[0:nnn-1] = Mvals*factor
        Conc = ave_conc; total(spectra)  ; this is no use, but keep it in case the program somewhere it is needed.
        acceptedPart = dataCnt ; this is no use to me. but keep it.
        scalingType = 'wysiwyg_r'

    end
endcase

; Take care of Y-axis scaling
; IF LocalState.sizes.auto THEN BEGIN
MinY = MIN(spectra, MAX=MaxY)
YStyle = 0

; For Y log scale make sure the min is not 0
IF LocalState.sizes.log THEN BEGIN
    IF MinY EQ 0 THEN BEGIN
        Indx = WHERE(all_spectra GT 0, Count)
        IF Count Ge 1 THEN MinY = MIN(all_spectra[Indx]) ELSE MinY = 1
        MinY = MinY < 1
        if(minY eq MaxY)then maxY = minY*2
    ENDIF
ENDIF

if(maxY eq 0)then maxY = 1.0

if(LocalState.sizes.log )then minY = 10.0^(floor(alog10(minY)))

; set values into gui
WIDGET_CONTROL, LocalState.setmin, SET_VALUE = minY
LocalState.sizes.gMinY = minY
WIDGET_CONTROL, LocalState.setmax, SET_VALUE = MaxY
LocalState.sizes.gMaxY = MaxY


; Labels
YLabel = 'Particle Counts #/liter/um'
; value = string(conc,format='(f8.2)')
value = string(ave_conc,format='(f12.2)')
TopLabel = 'Total #/L=' + strtrim(value,2) ;strmid(round(conc),2)

; Generate a sub-title
file = strmid(localState.InFileName,rstrpos(localState.InFileName,'\')+1,strlen(localState.InFileName))
;InfoSubTitle = STRING(FORM='(A0, ": Tot Frms ", I0, " Imgd Frms ", I0, " Imgd Prtcls ", I0,x,a0)', $
InfoSubTitle = STRING(FORM='(A0, ": TF:", I0, " IF:", I0, " IP:", I0," NRP:",I0," AP:",I0,x,a0)', $
    File,(*pGroup).TotFrmCnt, (*pGroup).ROIFrmCnt, (*pGroup).totImgPart ,(*pGroup).nonRejPart,acceptedPart,scalingType)

SubTitle = InfoSubTitle


if LocalState.sizes.xlog  eq 1 then begin

    minbin=1.0
    if max(sizes) lt 1000.0 then begin
        Maxbin=1000.0
    endif else begin
        maxbin=10.0^(ceil(Alog10(max(sizes))))
    endelse
endif else begin
    minbin=0.95*minbin
    maxbin=1.05*MaxBin
endelse


; Plot to screen
;PLOT, Bins, spectra, COLOR=Color, XRANGE=[10.0^(floor(Alog10(minbin))),10.0^(ceil(Alog10(MaxBin)))],$
PLOT, Bins, spectra, COLOR=Color, XRANGE=[minbin,MaxBin],$
    YTITLE=YLabel, XTITLE='Particle Size(um)', Xstyle = 1, YLOG=LocalState.sizes.log, SUBTITLE=SubTitle, $
    TITLE=TopLabel, PSYM=10, THICK=1, YRANGE=[MinY, MaxY],/nodata, YSTYLE=YStyle,Xlog=LocalState.sizes.xlog

cnt = (n_elements(spectra) lt n_elements(bins))? n_elements(spectra)-1:n_elements(bins)-1

plots,[bins[0],bins[0]],[MinY,spectra[0]],THICK=2,COLOR=Color,/data   ;plot first bin edges
plots,[bins[cnt],bins[cnt]],[MinY,spectra[cnt]],THICK=2,COLOR=Color,/data   ;plot last bin edges

for i=0L,cnt-1 do begin
    if(spectra[i] ge minY)then begin
        plots,[bins[i],bins[i+1],bins[i+1]],[(spectra[i]>minY)<MaxY,(spectra[i]>minY)<MaxY,(spectra[i+1]>minY)<MaxY],THICK=2,COLOR=Color
        if(localState.show)then begin
            if bins[i] ne bins[i+1] then begin
                value = round(10.*spectra[i]/(10.0^floor(alog10(spectra[i]))))/10.0
                if(value eq 10)then value = 1.0
                StrVal = string(value, format='(f3.1)')
                xyouts,(bins[i+1]+ bins[i])/2.0,(spectra[i]>minY)*1.1,StrVal,color=color,align = .5
            endif; only show between the two different bin edges.
        endif
    endif else begin
        plots,[bins[i+1],bins[i+1]],[minY,(spectra[i+1]>minY)<MaxY],THICK=2,COLOR=Color
    endelse
endfor


;test to see the binsizes.
if(localState.filled)then begin
    ;*****  RE do the plots with all 4 psd shows in one window.
    all_psd_plot:  do_nothing=1  ; just put a label in here
    WSET, LocalState.MViewID
    erase
    !P.multi=[0,2,2]
    ;get two subtitles
    strmo=strsplit(subtitle,' ',/extract)
    subtitle1=strmo(0)+' scale: '+strmo(n_elements(strmo)-1)
    subtitle2=strjoin(strmo(1:n_elements(strmo)-2),' ')
    nnnb=n_elements(bins)

    XRANGE_AB=[minbin,maxbin];  [10.0^(floor(Alog10(minbin))),10.0^(ceil(Alog10(MaxBin)))]

    yrange_low=10.0^(floor(Alog10(MinY)))
    yrange_hih=10.0^( ceil(Alog10(MAXY)))


    PLOT, Bins, spectra, COLOR=Color, XRANGE=XRANGE_AB, Xlog=LocalState.sizes.xlog,$
        YTITLE=YLabel, Xstyle = 1, YLOG=LocalState.sizes.log, $
        TITLE=TopLabel, PSYM=10, THICK=1, YRANGE=[yrange_low,yrange_hih],  $
        pos=[0.11,0.55,0.51,0.95],xmargin=[3,1],xtitle=subtitle1,YSTYLE=YStyle

    plots,[bins[0],bins[0]],[yrange_low,spectra[0]],THICK=2,COLOR=Color,/data
    plots,[bins[nnnb-1],bins[nnnb-1]],[yrange_low,spectra[nnnb-1]],THICK=2,COLOR=Color,/data
    ;end of plot 1 of 4 ***********************************************************************************

    ;get yticks numbers and xy for axis plots and the Yticklables;.

    ytikn=ceil(Alog10(Max(Lvals)))-floor(Alog10(Min(Lvals)))
    yymo1=10.0^(floor(Alog10(Min(Lvals))))
    yymo2=10.0^(ceil(Alog10(Max(Lvals))))

    if ytikn eq 0 then ytikn=2
    if yymo1 eq yymo2 then begin
        yymo1=yymo1*0.1
        yymo2=yymo2*10.0
    endif
    convert_thisValue_to_string,yymo1, myticknames
    myticknames=' '
    for i=1,ytikn do begin
        this_value=10.^( floor(Alog10(min(Lvals))) +i)
        convert_thisValue_to_string,this_value,this_string
        myticknames=[myticknames,' ']
    endfor

    PLOT, Bins, Lvals, COLOR=Color, XRANGE=XRANGE_AB, Xlog=LocalState.sizes.xlog,$
        XTITLE='Particle Size(um)', Xstyle = 1, YLOG=LocalState.sizes.log,$
        TITLE=Time_mo,PSYM=10, THICK=1,YRANGE=[yymo1,yymo2],YSTYLE=YStyle,$
        pos=[0.52,0.55,0.92,0.95],xmargin=[1,3],Yticks=ytikn,Ytickn=myticknames
    axis,yaxis=1,YTITLE='Len: um/L/um',ystyle=ystyle,yrange=[yymo1,yymo2]
    plots,[bins[0],bins[0]],[yymo1,Lvals[0]],COLOR=Color,/data
    plots,[bins[nnnb-1],bins[nnnb-1]],[yymo1,Lvals[nnnb-1]],COLOR=Color,/data
    ;end of plot 2 of 4 ***********************************************************************************

    yrange_low=10.0^(floor(Alog10(Min(Avals))))
    yrange_hih=10.0^( ceil(Alog10(MAX(Avals))))
    if yrange_low eq yrange_hih then begin
        yrange_low=yrange_low*0.1
        yrange_hih=yrange_hih*10.0
    endif

    PLOT, Bins, Avals, COLOR=Color, XRANGE=XRANGE_AB, Xlog=LocalState.sizes.xlog,$
        YTITLE='Area: mm2/L/um', XTITLE='Particle Size(um)', Xstyle = 1, YLOG=LocalState.sizes.log, $
        PSYM=10, THICK=1,YRANGE=[yrange_Low,yrange_hih],$
        pos=[0.11,0.08,0.51,0.48],xmargin=[3,1],YSTYLE=YStyle ;  ;don't need to assign ticknumbers
    plots,[bins[0],bins[0]],[yrange_low,Avals[0]],THICK=2,COLOR=Color,/data
    plots,[bins[nnnb-1],bins[nnnb-1]],[yrange_low,Avals[nnnb-1]],THICK=2,COLOR=Color,/data

    ;end of plot 3 of 4 ***********************************************************************************

    ;get yticks numbers and xy for axis plots and the Yticklables;.
    ytiknm=ceil(Alog10(Max(Mvals)))-floor(Alog10(Min(Mvals)))
    yymom1=10.0^(floor(Alog10(Min(Mvals))))
    yymom2=10.0^(ceil(Alog10(Max(Mvals))))
    if ytiknm eq 0 then ytiknm=2
    if yymom1 eq yymom2 then begin
        yymom1=yymom1*0.1
        yymom2=yymom2*10.0
    endif

    yyymom=[yymom1,yymom2]
    convert_thisValue_to_string,yymom1, myticknames
    myticknames=' '
    for i=1,ytiknm do begin
        this_value=10.^( floor(Alog10(min(Mvals))) +i)
        convert_thisValue_to_string,this_value,this_string
        myticknames=[myticknames,' ']
    endfor

    PLOT, Bins, Mvals, COLOR=Color, XRANGE=XRANGE_AB, Xlog=LocalState.sizes.xlog,$
        XTITLE='Particle Size(um)', Xstyle = 1, YLOG=LocalState.sizes.log,$
        PSYM=10, THICK=1,YRANGE=[yymom1,yymom2],YSTYLE=YStyle,$
        pos=[0.52,0.08,0.92,0.48],xmargin=[1,3],Yticks=ytiknm,Ytickn=myticknames
    axis,yaxis=1,YTITLE='Mass: mg/L/um',ystyle=ystyle,yrange=yyymom
    plots,[bins[0],bins[0]],[yymom1,Mvals[0]],COLOR=Color,/data
    plots,[bins[nnnb-1],bins[nnnb-1]],[yymom1,Mvals[nnnb-1]],COLOR=Color,/data
    ;end of plot 4 of 4 ***********************************************************************************

    !P.multi=[0,1,1]
    if (done_save_all_psd_plots eq 1) and (outputFlags and 2)/2 eq 1 then begin
        goto, save_all_psd_png; : do_nothing=1;   ;just for to going back to where it comes from.
    endif
endif

; stop; ;test binsizes binsize is default to be 10.0

; Save image file?
IF (OutPutFlags AND 2)/2 THEN BEGIN
    ; Create a filename
    ; Get Path
    NamePos = RSTRPOS(LocalState.InFileName, '.')
    IF NamePos GE 0 THEN BEGIN
        FileName = STRMID(LocalState.InFileName, 0, NamePos)
        FileName = FileName + '_' + strtrim((*pGroup).StartTime,2)
    ENDIF ELSE FileName = strtrim((*pGroup).StartTime,2)
    ;FileName = FileName + '_PS.tif'
    FileName = FileName + '_PS.png'

    ; Plot with sub-title
    SubTitle = InfoSubTitle
    PLOT, Bins, spectra, COLOR=Color, XSTYLE=1, XRANGE=[10.0^(floor(Alog10(minbin))),10.0^(ceil(Alog10(MaxBin)))],/xlog,$
        YTITLE=YLabel, XTITLE='Particle Size(um)', YLOG=LocalState.sizes.log, SUBTITLE=SubTitle, $
        TITLE=TopLabel, PSYM=10, THICK=1, POS=[0.15, 0.21, 0.9, 0.9], $
        YSTYLE=YStyle, YRANGE=[MinY, MaxY],/nodata
    xyouts,.5,.03,time,/normal,align = .5

    cnt = (n_elements(spectra) lt n_elements(bins))? n_elements(spectra)-1:n_elements(bins)-1

    ;     if(LocalState.sizes.log)then MinY = 10.0^floor(alog10(MinY))
    plots,[bins[0],bins[0]],[MinY,spectra[0]],THICK=2,COLOR=Color,/data
    for i=0L,cnt-1 do begin
        if(spectra[i] ge minY)then begin
            plots,[bins[i],bins[i+1],bins[i+1]],[(spectra[i]>minY)<MaxY,(spectra[i]>minY)<MaxY,(spectra[i+1]>minY)<MaxY],THICK=2,COLOR=Color
            if(localState.show)then begin
                if bins[i] ne bins[i+1] then begin
                    value = round(10.*spectra[i]/(10.0^floor(alog10(spectra[i]))))/10.0
                    StrVal = string(value, format='(f3.1)')
                    xyouts,(bins[i+1]+ bins[i])/2.0,(spectra[i]>minY)*1.1,StrVal,color=color,align = .5
                endif; only show between the two different bin edges.
            endif
        endif else begin
            plots,[bins[i+1],bins[i+1]],[minY,(spectra[i+1]>MinY)<MaxY],THICK=2,COLOR=Color
        endelse
    endfor
    ;if(spectra[cnt] ge minY)then begin
    ; plots,[bins[cnt],(bins[cnt]+binsize)<maxBin,(bins[cnt]+binsize)<maxBin],[(spectra[cnt]>MinY)<MaxY,(spectra[cnt]>minY)<MaxY,minY],THICK=2,COLOR=Color,/data
    ;if(localState.show)then begin
    ;value = round(10.*spectra[cnt]/(10.0^floor(alog10(spectra[i]))))/10.0
    ;StrVal = string(value, format='(f3.1)')
    ;xyouts,(binsize+ 2.*bins[cnt])/2.0,(spectra[cnt]>minY)*1.1,strval,color=color,align = .5
    ;endif
    ;endif
    ;***************************************************************************************************
    if(localState.filled)then begin
        done_save_all_psd_plots=1
        goto, all_psd_plot
        save_all_psd_png: do_nothing=1;   ;just for to coming back in here.
    endif ;end of if localstate.filled

    ; Read in screen
    ;Buf = TVRD(/order)
    Buf = TVRD()
    ;Invert colors
    Indx = WHERE(Buf GT 0, Count)
    Buf[*] = 255
    IF Count GT 0 THEN Buf[Indx] = 0
    ;WRITE_TIFF, FileName, Buf;, 1, RED=r, GREEN=g, BLUE=b
    buf = rotate(temporary(buf),7)
    WRITE_png, FileName, Buf, bindgen(256),bindgen(256),bindgen(256)
ENDIF

; Print it?
IF OutPutFlags AND 1 THEN BEGIN
    IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()
    ; Switch to PRINTER output
    SET_PLOT, 'PRINTER'
    DEVICE, /LANDSCAPE

    SubTitle = InfoSubTitle
    tvlct,r,g,b,/get
    loadct,0

    PLOT, Bins, spectra, XSTYLE=1,XRANGE=[10.^(floor(Alog10(minbin))),10.^(ceil(Alog10(MaxBin)))],charthick=3,xthick=3,ythick=3,/xlog,$ ;COOR=Color,
        YTITLE=YLabel, XTITLE='Particle Size(um)', YLOG=LocalState.sizes.log, SUBTITLE=SubTitle, $
        TITLE=TopLabel, PSYM=10, THICK=3, POS=[0.1, 0.15, 0.95, 0.9], YSTYLE=YStyle, YRANGE=[MinY, MaxY],/nodata

    cnt = n_elements(spectra)-1
    if(LocalState.sizes.log)then MinY = 10.0^floor(alog10(MinY))
    plots,[bins[0],bins[0]],[MinY,spectra[0]],THICK=3,/data ;COLOR=Color,
    for i=0L,cnt-1 do begin
        if(spectra[i] ge minY)then begin
            plots,[bins[i],bins[i+1],bins[i+1]],[(spectra[i]>minY)<MaxY,(spectra[i]>minY)<MaxY,(spectra[i+1]>minY)<MaxY],THICK=4;,COLOR=Color
            if(localState.show)then begin
                if bins[i] ne bins[i+1] then begin
                    value = round(10.*spectra[i]/(10.0^floor(alog10(spectra[i]))))/10.0
                    StrVal = string(value, format='(f3.1)')
                    xyouts,(bins[i+1]+ bins[i])/2.0,(spectra[i]>minY)*1.1,StrVal,color=color,align = .5
                endif; only show between the two different bin edges.
            endif
        endif else begin
            plots,[bins[i+1],bins[i+1]],[minY,(spectra[i+1]>MinY)<MaxY],THICK=4
        endelse
    endfor  ; end of add mantissa
    ;*****************************************************************************

    xyouts,.5,0,time,align=.5,charthick=3,/normal
    if(localState.filled)then begin
        for i=0L,cnt-1 do begin
            if(spectra[i] gt minY)then begin
                polyfill,[bins[i],bins[i],bins[i+1],bins[i+1],bins[i]],[MinY,(spectra[i]>minY)<MaxY,(spectra[i]>minY)<MaxY,minY,minY],THICK=2;,COLOR=Color
            endif
        endfor
        if(spectra[cnt] gt minY)then begin
            polyfill,[bins[cnt],bins[cnt],(bins[cnt]+binsize)<maxBin,(bins[cnt]+binsize)<maxBin,bins[cnt]],[MinY,(spectra[cnt]>MinY)<MaxY,(spectra[cnt]>minY)<MaxY,minY,minY],THICK=2;,COLOr=color,/data
        endif
    endif

    DEVICE, /CLOSE_DOCUMENT
    ; Switch back to display output
    SET_PLOT, 'WIN'
    tvlct,r,g,b
ENDIF
END
;=================================================================================
;================================================================================
pro get_the_plotData,pGroup,localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM,$
    pGrouppDataI,pGrouppadjI,pGrouppdataAI,pGrouppDataMI,$
    pGrouppDataL,pGrouppadjL,pGrouppdataAL,pGrouppDataML
;pro get_the_plotData,Localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM
;input: pGroup,localstate   output are others

; if n_elements(pgroupdata) eq 0 then return
junk=where(*(*pgroup).pdata ne 0,contgggg)
if contgggg eq 0 then return

if LocalState.TypeScaling eq 3 then begin
    ;this if  for wysiwyg_r
    ;***********************************************
    nnnn=n_elements(*((*pgroup).pdataW))
    pGrouppData=ptr_new(fltarr(nnnn))   ; pointers
    pGrouppadj=ptr_new(fltarr(nnnn))
    pGrouppDataA=ptr_new(fltarr(nnnn))
    pGrouppDataM=ptr_new(fltarr(nnnn))
    *pGrouppData=*((*pgroup).pdataW)   ; pointers
    *pGrouppadj=*((*pgroup).pwfj)/localstate.SAF
    *pGrouppDataA=*((*pgroup).pdataWA)
    *pGrouppDataM=*((*pgroup).pdataWM)

    ;get the ice and liquid data.
    crystalH=*(*pgroup).pdataWH
    indexL=where(crystalH eq 1, cntF)
    if cntF gt 0 then begin
        pGrouppDataL=ptr_new(fltarr(cntF))   ; pointers
        pGrouppadjL=ptr_new(fltarr(cntF))
        pGrouppDataAL=ptr_new(fltarr(cntF))
        pGrouppDataML=ptr_new(fltarr(cntF))

        *pGrouppDataL=(*(*pgroup).pdataW)[indexL]
        *pGrouppadjL=(*(*pgroup).pwfj)[indexL]/localstate.SAF
        *pGrouppDataAL=(*(*pgroup).pdataWA)[indexL]
        *pGrouppDataML=(*(*pgroup).pdataWM)[indexL]
    endif else begin
        pGrouppDataL=ptr_new(fltarr(1))   ; pointers
        pGrouppadjL=ptr_new(fltarr(1))
        pGrouppDataAL=ptr_new(fltarr(1))
        pGrouppDataML=ptr_new(fltarr(1))
    endelse

    indexI=where(crystalH ne 1, cntF)
    if cntF gt 0 then begin
        pGrouppDataI=ptr_new(fltarr(cntF))   ; pointers
        pGrouppadjI=ptr_new(fltarr(cntF))
        pGrouppDataAI=ptr_new(fltarr(cntF))
        pGrouppDataMI=ptr_new(fltarr(cntF))

        *pGrouppDataI=(*(*pgroup).pdataW)[indexI]
        *pGrouppadjI=(*(*pgroup).pwfj)[indexI]/localstate.SAF
        *pGrouppDataAI=(*(*pgroup).pdataWA)[indexI]
        *pGrouppDataMI=(*(*pgroup).pdataWM)[indexI]
    endif else begin
        pGrouppDataI=ptr_new(fltarr(1))   ; pointers
        pGrouppadjI=ptr_new(fltarr(1))
        pGrouppDataAI=ptr_new(fltarr(1))
        pGrouppDataMI=ptr_new(fltarr(1))
    endelse
    case localstate.filledn of
        1: begin
            rrrr=1.0; do nothing ; same as before this line
        end
        2: begin
            pGrouppData=pGrouppDataL  ; pointers
            pGrouppadj=pGrouppadjL
            pGrouppDataA= pGrouppDataAL
            pGrouppDataM=  pGrouppDataML
        end
        3: begin
            pGrouppData=pGrouppDataI  ; pointers
            pGrouppadj=pGrouppadjI
            pGrouppDataA= pGrouppDataAI
            pGrouppDataM=  pGrouppDataMI
        end
    endcase
    ;all above 4 lines replace the 4 green lines in the next part of the progra
    ;**********************************************
endif else begin
    if LocalState.TypeScaling eq 1 then begin
        pGrouppData=(*pgroup).pdata   ; pointers
        pGrouppadj=(*pgroup).padj
        pGrouppDataA=(*pgroup).pdataA
        pGrouppDataM=(*pgroup).pdataM
        ;get the ice and Liquid data
        crystalH=*(*pgroup).pdataH
        indexL=where(crystalH eq 1, cntF)
        if cntF gt 0 then begin
            pGrouppDataL=ptr_new(fltarr(cntF))   ; pointers
            pGrouppadjL=ptr_new(fltarr(cntF))
            pGrouppDataAL=ptr_new(fltarr(cntF))
            pGrouppDataML=ptr_new(fltarr(cntF))

            *pGrouppDataL=(*(*pgroup).pdata)[indexL]
            *pGrouppadjL=(*(*pgroup).padj)[indexL]
            *pGrouppDataAL=(*(*pgroup).pdataA)[indexL]
            *pGrouppDataML=(*(*pgroup).pdataM)[indexL]
        endif else begin
            pGrouppDataL=ptr_new(fltarr(1))   ; pointers
            pGrouppadjL=ptr_new(fltarr(1))
            pGrouppDataAL=ptr_new(fltarr(1))
            pGrouppDataML=ptr_new(fltarr(1))
        endelse

        indexI=where(crystalH ne 1, cntF)
        if cntF gt 0 then begin
            pGrouppDataI=ptr_new(fltarr(cntF))   ; pointers
            pGrouppadjI=ptr_new(fltarr(cntF))
            pGrouppDataAI=ptr_new(fltarr(cntF))
            pGrouppDataMI=ptr_new(fltarr(cntF))

            *pGrouppDataI=(*(*pgroup).pdata)[indexI]
            *pGrouppadjI=(*(*pgroup).padj)[indexI]
            *pGrouppDataAI=(*(*pgroup).pdataA)[indexI]
            *pGrouppDataMI=(*(*pgroup).pdataM)[indexI]
        endif  else begin
            pGrouppDataI=ptr_new(fltarr(1))   ; pointers
            pGrouppadjI=ptr_new(fltarr(1))
            pGrouppDataAI=ptr_new(fltarr(1))
            pGrouppDataMI=ptr_new(fltarr(1))
        endelse
        case LocalState.filledn of
            1: begin
                rrrr=1.0;  same as before this line.
            end
            2: begin
                pGrouppData=pGrouppDataL  ; pointers
                pGrouppadj=pGrouppadjL
                pGrouppDataA= pGrouppDataAL
                pGrouppDataM=  pGrouppDataML

            end
            3: begin
                pGrouppData=pGrouppDataI  ; pointers
                pGrouppadj=pGrouppadjI
                pGrouppDataA= pGrouppDataAI
                pGrouppDataM=  pGrouppDataMI

            end
        endcase
    endif else begin  ;type 2
        pGrouppData=(*pgroup).pdata   ; pointers
        pGrouppadj=(*pgroup).padj
        pGrouppDataA=(*pgroup).pdataA
        pGrouppDataM=(*pgroup).pdataM
        ;get the ice and Liquid data
        crystalH=*(*pgroup).pdataH
        indexL=where(crystalH eq 1, cntF)
        if cntF gt 0 then begin
            pGrouppDataL=ptr_new(fltarr(cntF))   ; pointers
            pGrouppadjL=ptr_new(fltarr(cntF))
            pGrouppDataAL=ptr_new(fltarr(cntF))
            pGrouppDataML=ptr_new(fltarr(cntF))

            *pGrouppDataL=(*(*pgroup).pdata)[indexL]
            *pGrouppadjL=(*(*pgroup).padj)[indexL]
            *pGrouppDataAL=(*(*pgroup).pdataA)[indexL]
            *pGrouppDataML=(*(*pgroup).pdataM)[indexL]
        endif else begin
            pGrouppDataL=ptr_new(fltarr(1))   ; pointers
            pGrouppadjL=ptr_new(fltarr(1))
            pGrouppDataAL=ptr_new(fltarr(1))
            pGrouppDataML=ptr_new(fltarr(1))
        endelse

        indexI=where(crystalH ne 1, cntF)
        if cntF gt 0 then begin
            pGrouppDataI=ptr_new(fltarr(cntF))   ; pointers
            pGrouppadjI=ptr_new(fltarr(cntF))
            pGrouppDataAI=ptr_new(fltarr(cntF))
            pGrouppDataMI=ptr_new(fltarr(cntF))

            *pGrouppDataI=(*(*pgroup).pdata)[indexI]
            *pGrouppadjI=(*(*pgroup).padj)[indexI]
            *pGrouppDataAI=(*(*pgroup).pdataA)[indexI]
            *pGrouppDataMI=(*(*pgroup).pdataM)[indexI]
        endif  else begin
            pGrouppDataI=ptr_new(fltarr(1))   ; pointers
            pGrouppadjI=ptr_new(fltarr(1))
            pGrouppDataAI=ptr_new(fltarr(1))
            pGrouppDataMI=ptr_new(fltarr(1))
        endelse
        case LocalState.filledn of
            1: begin
                rrrr=1.0;  same as before this line.
            end
            2: begin
                pGrouppData=pGrouppDataL  ; pointers
                pGrouppadj=pGrouppadjL
                pGrouppDataA= pGrouppDataAL
                pGrouppDataM=  pGrouppDataML
            end
            3: begin
                pGrouppData=pGrouppDataI  ; pointers
                pGrouppadj=pGrouppadjI
                pGrouppDataA= pGrouppDataAI
                pGrouppDataM=  pGrouppDataMI
            end
        endcase

    endelse
endelse

end; end of pro get_theplotData, localstate, *******

;==================================================================================
;===============================================================================
FUNCTION ReadHistogram, LocalState

    ; remove any existing groups
    if(ptr_valid(localState.pGroup))then begin
        pGroup = find_first_link(LocalState.pGroup)
        while( ptr_valid((*pGroup).next_link) ) do begin
            pNext_link = (*pGroup).next_link
            deleteGroup,pGroup
            pGroup = pNext_link
        endwhile
    endif

    ; Get file name from user
    FileName = DIALOG_PICKFILE(FILTER='*.dat', TITLE="Select Histogram Data File", /MUST_EXIST)

    IF(FileName eq '') THEN RETURN, -10

    Openr, DFileUnit, FileName, /Get_lun, ERROR = err
    IF (err NE 0) THEN BEGIN
        PRINT, !ERR_STRING
        return, -2
    ENDIF

    PlotCount = 0
    SumSecs = 0
    PixSize = 0.0
    SizeType = ''
    TypeScaling = 0
    samplevolume = 0.0

    ; Read Header info
    READF, DFileUnit, PlotCount, SumSecs, PixSize,TypeScaling,samplevolume,SizeType

    IF( PlotCount LT 1 OR PlotCount GT 999) THEN BEGIN
        FREE_LUN, DFileUnit
        RETURN, -1
    ENDIF

    LocalState.PixSize = PixSize
    LocalState.SumSecs = SumSecs
    LocalState.grpCnt = PlotCount
    localState.SizeType = SizeType
    localstate.TypeScaling = TypeScaling
    localstate.samplevolume = samplevolume

    ; Allocate necessary histogram buffers
    missed=0L
    deadtime=0.0
    startTime=0L
    totFrmCnt=0L
    ROIFrmCnt=0L
    totImgPart=0L
    nonRejPart = 0L
    acceptPart = 0L
    wysiwyg = 0.0
    dataSize = 0L
    pGroup = ptr_new({groupLink})
    LocalState.pGroup = pGroup
    groupPtr = ptrarr(PlotCount)

    ; Read in the data
    FOR i=1, PlotCount DO BEGIN
        readF,DFileUnit,missed,deadtime,startTime,totFrmCnt,ROIFrmCnt,totImgPart,nonRejPart,acceptPart,wysiwyg
        readF,DFileUnit,dataSize
        data = fltarr(dataSize)
        readF,DFileUnit,data
        ; place into a group structure
        (*pGroup).missed = missed
        (*pGroup).deadtime = deadtime
        (*pGroup).startTime = startTime
        (*pGroup).totFrmCnt = totFrmCnt
        (*pGroup).ROIFrmCnt = ROIFrmCnt
        (*pGroup).totImgPart = totImgPart
        (*pGroup).nonRejPart = nonRejPart
        (*pGroup).acceptPart = acceptPart
        (*pGroup).wysiwyg = wysiwyg
        (*pGroup).pData = ptr_new(data)
        groupPtr[i-1] = pGroup
        if(i lt PlotCount)then begin
            (*pGroup).next_Link = ptr_new({groupLink})
            pLastGroup = pGroup
            pGroup =  (*pGroup).next_Link
            (*pGroup).prev_link = pLastGroup
        endif

    ENDFOR

    ptr_free,localState.pGroupPtr
    localState.pGroupPtr = ptr_new(groupPtr)
    widget_control,localState.position,set_slider_max = PlotCount

    FREE_LUN, DFileUnit
    PlotHistogram, LocalState

    RETURN, 0
END

;group = {groupLink,$
;      max:0.0,$             ; max size in this group
;      min:0.0,$             ; min size in this group
;      missed:0L,$           ; missed strobes per group
;      deadtime:0.0,$          ; deadtime of group
;      startTime:0L,$          ; time of the start of this group in seconds of year less than actual
;      totFrmCnt:0L,$          ; total number of frames considered in this group
;      ROIFrmCnt:0L,$          ; number of frames with images
;      totImgPart:0L,$          ; total number of particles in this group
;      pData:ptr_new(),$      ; the actual data to be evaluated, in microns acrose diagaonal, average
;      next_link:ptr_new(),$     ; next link
;      prev_link:ptr_new()}       ; previous link
;end


;===============================================================================
FUNCTION WriteHistogram, LocalState, FILENAME=FileName

    ; Get file name from user?
    IF (not keyword_set(FileName))THEN FileName = DIALOG_PICKFILE(FILTER='*.txt', TITLE="Select Histogram Data File")

    dotloc = rstrpos(filename,'.')
    if(dotloc eq -1)then filename = filename + '.txt'

    IF( FileName eq '') THEN RETURN, -10

    Openw, DFileUnit, FileName, /Get_lun, ERROR = err
    IF (err NE 0) THEN BEGIN
        PRINT, !ERR_STRING
        return, -2
    ENDIF

    ; Write Header info
    case localstate.filledn of
        1: PartType='   Particles = all  '
        2: PartType='   Particles = liq  '
        3: PartType='   Particles = Ice  '
    endcase
    case localstate.typeScaling of
        1: ScaleType='FocMax'
        2: ScaleType=' dfj '
        3: ScaleType='wys_r'
    endcase

    string_SV='Sample_V=TAS*Array_Area'



    PRINTF, DFileUnit,format='(A7,1x,A6,1x,A7,1x,A6,1x,A7,1x,A7,1x,A23)', '#OfGrps','T_Step','PixSize', 'SclTyp','SampleV','Method',string_SV
    PRINTF, DFileUnit,format='(A4,4x,A4,3x,A7,1x,A6,1x,A7,1x,A7,1x,A23)', strtrim(LocalState.grpCnt,2), strtrim(LocalState.SumSecs,2),$
        strtrim(LocalState.PixSize,2),Scaletype,strtrim(localstate.samplevolume,2),strtrim(localState.SizeType,2),partType
    ;'Len=um Area=mm2 mass=mg'
    PrintF,DFileUnit,'--------------------------------------------------------------------'

    FOR j=1, 1 do begin;   LocalState.grpCnt DO BEGIN
        if j eq 1 then  pGroup = find_first_link(LocalState.pGroup) else  pGroup = (*pGroup).next_link

        get_the_plotData,pGroup,localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM,$
            pGrouppDataI,pGrouppadjI,pGrouppdataAI,pGrouppDataMI,$
            pGrouppDataL,pGrouppadjL,pGrouppdataAL,pGrouppDataML
        ;********************************************************************************
        GetPsdValues,pGroup,localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM,$
            xpts,vals,Lvals,Avals,Mvals,factor,psd_conc,ave_conc,acceptedPart
        ;*******************************************************************
        nnn=n_elements(xpts)
        numfrms=max([(*pGroup).totFrmCnt, 1.0])
        DOFmax=1.411*2.54
        IMG_SV=DOFmax*1024d*0.00023*1024d*0.00023*(numfrms)/1000d   ;liters
        if localstate.typescaling eq 1 then  factor = factor
        if localstate.typescaling eq 3 then  factor = 1.0/IMG_SV

        (*pGroup).Nbinedges = ptr_new(fltarr(nnn))
        (*(*pGroup).Nbinedges)[0:nnn-1] = xpts
        (*pGroup).Nbinheights = ptr_new(fltarr(nnn))
        (*(*pGroup).Nbinheights)[0:nnn-1] = vals*factor

        (*pGroup).Lbinheights = ptr_new(fltarr(nnn))
        (*pGroup).Abinheights = ptr_new(fltarr(nnn))
        (*pGroup).Mbinheights = ptr_new(fltarr(nnn))
        (*(*pGroup).Lbinheights)[0:nnn-1] = Lvals*factor
        (*(*pGroup).Abinheights)[0:nnn-1] = Avals*factor
        (*(*pGroup).Mbinheights)[0:nnn-1] = Mvals*factor
        ;**********************************************************************************
        printF,DFileUnit,format='(A8,1x,A8,1x,A10,1x,A6,1x,A6,1x,A6,1x,A6,1x,A6,1x,A7)','StrtTime',$
            'DeadTime','Cnt:Missed','totFrm','Roifrmt',$
            'totImg','nonRej','accept','wysiwyg'
        printF,DFileUnit,format='(A8,1x,A8,1x,A10,1x,A6,1x,A6,1x,A6,1x,A6,1x,A6,1x,F7.1)',strtrim((*pGroup).startTime,2),$
            strtrim((*pGroup).deadtime,2),strtrim((*pGroup).missed,2),strtrim((*pGroup).totFrmCnt,2),strtrim((*pGroup).ROIFrmCnt,2),$
            strtrim((*pGroup).totImgpart,2),strtrim((*pGroup).nonRejPart,2),strtrim(acceptedPart,2),(*pGroup).wysiwyg
        t = ConvertFromSeconds((*pGroup).StartTime, LocalState.year)
        Time = strtrim(t.month,2)+'/'+strtrim(t.day,2)+' '+strtrim(t.hour,2)+':'+strtrim(t.minute,2)+':'+strtrim(t.sec,2)

        if ptr_valid(pGrouppData) and ptr_valid((*pGroup).Nbinedges) then  begin
            ;printF,DFileUnit,'Total_number_of_bin_height_values=',n_elements(*(*pGroup).pData)
            printF,DFileUnit,format='(A2,1x,A13,1x,A5,1x,I3,1x,A7,1x,F8.3,1x,A7,1x,F7.1,1x,A2,1x,F6.3)','T=',$
                time,'Bins=',n_elements(*(*pGroup).Nbinedges)/2,'AvConc=',$
                strtrim(float(ave_conc),2),'S(adj)=',psd_conc,'F=',factor
            printF,DFileUnit,format='(A10,1x,A10,1x,A12,1x,A14,1x,A14)',' bin_edges',' #/Liter/um  ',' um/Liter/um',' mm2/Liter/um',' mg/Liter/um '

            crit_4_tens=(*(*pGroup).Nbinedges)[3] eq 10.0 and (*(*pGroup).Nbinedges)[2] eq (*(*pGroup).Nbinedges)[3]
            if crit_4_tens eq 1 then begin   ;crit_4_tens eq 1 mean too few data to print out
                printF,DFileUnit,0
            endif else begin
                for i=0, n_elements(*(*pGroup).Nbinedges)-1 do begin ;printF,DFileUnit,(*(*pGroup).pData)[i];  ; it writes 6 number in a row.
                    printF,DFileUnit,format='(F10.2,1x,F12.3,1x,F12.3,1x,F12.3,1x,F12.3)',(*(*pGroup).Nbinedges)[i],(*(*pGroup).Nbinheights)[i],$
                        (*(*pGroup).Lbinheights)[i], (*(*pGroup).Abinheights)[i], (*(*pGroup).Mbinheights)[i]
                endfor
            endelse

        endif else printF,DFileUnit,0  ; end printing one group data.

        if j eq 1 then j=j+1; localstate.grpCnt then   j=j+1
    ENDFOR

    FREE_LUN, DFileUnit
    RETURN, 0
END

;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output; Bit 2 set = ASCII file output

PRO ShowHistograms, pStateInfo, sumSecs, GROUP=GROUP, OutPutFlags=OutPutFlags, SAMPLEVOLUME=SampleVolume, typeSCALING=typeScaling ,sizeType = sizeType

; if typeScaling is true, then use missed, otherwise use deadtime

IF N_ELEMENTS(SampleVolume) EQ 0 THEN SampleVolume = -1
IF N_ELEMENTS(MissScaling) EQ 0 THEN MissScaling = 1

; Default is to send ouput to plot, only once
IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

pGroup = (*pStateInfo).spectra.pGroup

if(not ptr_valid(pGroup))then begin
    r=dialog_message("Error: no data to display")
    return
endif

; take ownership of this pointer info
(*pStateInfo).spectra.pGroup = ptr_new()
groupPtr = ptrarr((*pStateInfo).spectra.groupCnt)
groupPtr[0]    = pGroup
pGrp = pGroup
for i=1,(*pStateInfo).spectra.groupCnt-1 do begin
    if(ptr_valid(pGrp))then begin
        groupPtr[i]  = (*pGrp).next_link
        pGrp = (*pGrp).next_link
    endif
endfor

; build GUI
tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, /TLB_SIZE_EVENTS, /col, TITLE='Particle Distribution Histograms',mbar=menuBase)

; menu items
; options = widget_button(menuBase,value='Options')
;    read = widget_button(options,value='Import ASCII',uvalue='OPEN')
;    save = widget_button(options,value='Export ASCII',uvalue='SAVE')
;    print = widget_button(options,value='Print',uvalue='PRINT',/sep)
;    printall = widget_button(options,value='Print All',uvalue='PRINTALL')
;   tiff = widget_button(options,value='Create png',uvalue='SAVETIFF')
;    quit = widget_button(options,value='Quit',uvalue='QUIT',/sep)


; button bar   add options label
button_bar = widget_base(tlb,/row)
bb1 = widget_base(button_bar,/row)
readBut = widget_button(bb1,value='open.bmp',/bitmap,uvalue='OPEN')
saveBut = widget_button(bb1,value='Save.bmp',/bitmap,uvalue='SAVE')

bb2 = widget_base(button_bar,/row)
printBut = widget_button(bb2,value='print.bmp',/bitmap,uvalue='PRINT')
printallBut = widget_button(bb2,value='print1.bmp',/bitmap,uvalue='PRINTALL')

bb3 = widget_base(button_bar,/row)
tiffBut = widget_button(bb3,value='freeform.bmp',/bitmap,uvalue='SAVETIFF')

bb4 = widget_base(button_bar,/row)
quitBut = widget_button(bb4,value='quit.bmp',/bitmap,uvalue='QUIT')


topbase = widget_base(tlb,/row)
if((*pStateInfo).spectra.groupCnt gt 1)then begin
    position = widget_slider(topbase,value=1,uvalue='pos',min = 1, max = (*pStateInfo).spectra.groupCnt,/suppress_value)
endif else position = -1

TopLabelID = WIDGET_LABEL(topbase, UVALUE='BottomLab', VALUE='',XSIZE=550,/align_left,font='TIMES*20*BOLD')

MAINBase = widget_base(tlb,/row)
;-----------------------------------------------------
; Base for all buttons and radio buttons on the left side
LeftButtonsBase = WIDGET_BASE(MAINBase, /COLUMN, UVALUE='AllButtons')

;-----------------------------------------------------
; Base for options
OpsBase = WIDGET_BASE(LeftButtonsBase, /COL, /FRAME, /BASE_ALIGN_CENTER, UVALUE='ProcButtons', TITLE='Histogram Options')

; data variables
if(ptr_valid((*groupPtr[0]).pData))then begin
    ymin = min(*(*groupPtr[0]).pData)
    ymax = max(*(*groupPtr[0]).pData)
endif else begin
    ymin = 0
    ymax = 0
endelse
sizes = {gMinSize:5, gMaxSize:200, gBinSize:5,gmincntsperbin:16,gMinY:ymin, gMaxY:ymax, auto:!true,log:!true,xlog:!true}
SAFID=CW_field(opsbase,title='SAF:',value=1.0,xsize=5,uvalue = 'SAF',/all)  ;added  dec 11, 2004

setmin = cw_field(OpsBase, title='Ymin', value = ymin,uvalue='MINMAX',/float,/return_events)
setmax = cw_field(OpsBase, title='Ymax',value = ymax,uvalue='MINMAX',/float,/return_events)
;MinYID = WIDGET_SLIDER(OpsBase, MIN=ymin, MAX=ymax, TITLE='Y Min', VALUE = sizes.gMinY, UVALUE='MINMAX')
;MaxYID = WIDGET_SLIDER(OpsBase, MIN=ymin, MAX=ymax, TITLE='Y Max', VALUE = sizes.gMaxY, UVALUE='MINMAX')

;MinYID = CW_FSLIDER(OpsBase,  min = .1*ymin, max = 10*ymax, TITLE='Y Min', VALUE = sizes.gMinY, UVALUE='MINMAX',/edit)
;MaxYID = CW_FSLIDER(OpsBase,  min = .1*ymin, max = 10*ymax, TITLE='Y Max', VALUE = sizes.gMaxY, UVALUE='MINMAX',/edit)

;MinBinID = WIDGET_SLIDER(OpsBase, MIN=5, MAX=2000, TITLE='X Min Size(um)', VALUE = sizes.gMinSize, UVALUE='MINMAX')
;MaxBinID = WIDGET_SLIDER(OpsBase, MIN=11,MAX=2000, TITLE='X Max Size(um)', VALUE = sizes.gMaxSize, UVALUE='MINMAX')
MinBinID = WIDGET_text(OpsBase, VALUE = 'Xmin(um):'+string(sizes.gMinSize), UVALUE='MINMAX')
MaxBinID = WIDGET_text(OpsBase, VALUE = 'Xmax(um):'+string(sizes.gMaxSize), UVALUE='MINMAX')
BinSizeID = WIDGET_SLIDER(OpsBase,MIN=1, MAX=10, TITLE='Minimum.Bin.Size(um)', VALUE = sizes.gBinSize, UVALUE='BINSIZE')
BincntsID = WIDGET_SLIDER(OpsBase,MIN=4, MAX=20000,TITLE='Min.#.of.Particles.per.bin', VALUE = sizes.gmincntsperbin, UVALUE='MinCntsPerbin')

;-----------------------------------------------------
; Automation options
selectBase = widget_base(OpsBase,/FRAME,/COL,/nonexclusive)
logScale = widget_button(selectBase,value='YLog Scale',uvalue='logscale')
xlogScale= widget_button(selectBase,value='XLog Scale',uvalue='xlogscale') ;adde by mo spet 20, 2004
;mo  autoScale = widget_button(selectBase,value='Auto Scale',uvalue='autoscale')
showID = widget_button(selectBase,value='Add Mantissa',uvalue='show')
widget_control,logscale,set_button=sizes.log
widget_control,xlogscale,set_button=sizes.xlog ; added by mo
; widget_control,Autoscale,set_button=sizes.auto

; added following for sph and ice_PSD
filledn=cw_bgroup(OpsBase,['All','Liq','Ice'],/row,/exclusive,/no_release,uvalue = 'filledn',set_value=1,button_uvalue=[1,2,3])
filled=cw_bgroup(OpsBase,['off','on'],/row,label_left='#.L.A.M:',/exclusive,/no_release,uvalue = 'filled',set_value=0,button_uvalue=[0,1])
;filled=cw_bgroup(OpsBase,['#_PSD','All_PSD'],/row,/exclusive,label_left='',/no_release,uvalue = 'filled',set_value=0,button_uvalue=[1,0])
messages=[['Note:     '],$
    ['1. If MinCntPerBin is too big,no PSD is plotted.'],$
    ['             '],$
    ['2. if hanged, type return and hit enter may help.']]
textmsg=widget_text(OpsBase, value=messages,/wrap,ysize=8,/Frame)
;    text2 = WIDGET_TEXT(base, $       ;This widget belongs to 'base'.
;        VALUE = 'This text widget cannot be edited.', $
;       YSIZE = 1, /FRAME)       ;Put a frame around it.
;   above is an example

;****************************************************
;-----------------------------------------------------
; Image View and image-related labels
ViewBase = WIDGET_BASE(MAINBase, /COL, TITLE='ImgView', UVALUE=' ')

;MainView = WIDGET_DRAW(ViewBase, /BUTTON_EVENTS, /FRAME, /RETAIN, UVALUE='MAIN_VIEW',XSIZE=450, YSIZE=350)
MainView = WIDGET_DRAW(ViewBase, /BUTTON_EVENTS, /FRAME, /RETAIN, UVALUE='MAIN_VIEW',$
    XSIZE=780, YSIZE=560);, X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004
;-----------------------------------------------------
; Line 1: Text labels at bottom of image view
ImgInfoL1 = WIDGET_BASE(LeftButtonsBase, /row, /MAP, TITLE='ImgInfo', UVALUE='ImgInfoBase')

; Read in the pixel size
WIDGET_CONTROL, (*pStateInfo).PixSizeID, GET_VALUE=PixSize

FileName = (*pStateInfo).InFileName

WIDGET_CONTROL, MAINBase, /REALIZE

; Get drawable window index
WIDGET_CONTROL, MainView, GET_VALUE=MainViewID

show = !false

;(*pstateinfo).fsspdata.filename=C:\HHH_south_pole_work\MidCix_projects\April_19_filght\roi_5_flight_1914\04191914_SPP100log.txt
; *(*pstateinfo).fsspdata.time=[9494358 9494359 ..... ect.
; *(*pstateinfo).fsspdata.bins= 2.04550 4.35050      6.65600 8.96150   11.2665  ...ect
if (*pstateinfo).fsspdata.filename ne ' ' then begin
    fsspbins=*(*pstateinfo).fsspdata.bins
    fsspbwds=*(*pstateinfo).fsspdata.bwd
endif else begin
    fsspbins=[-99.0, -99.0]
    fsspbwds=[9.9, 9.9]
endelse
if (*pstateinfo).twodcdata.filename ne ' ' then begin
    twodcbins=*(*pstateinfo).twodcdata.bins
    twodcbwds=*(*pstateinfo).twodcdata.bwd
endif else begin
    twodcbins=[-99.0, -99.0]
    twodcbwds=[9.9, 9.9]
endelse

;stop
LocalState = { pGroup:pGroup,$           ; ptr to first link in list
    year:(*pStateInfo).fileHead.year,$;    year of data
    pGroupPtr:ptr_new(groupPtr),$  ; pointer to array of all group pointer links
    sizes:sizes,$            ; contains constants of plot
    SumSecs:SumSecs,$          ; secs to average over
    MainView:MainView, $      ; draw window widget ID
    MViewID:MainViewID, $       ; draw window ID
    InFileName:FileName, $        ; main .roi data file name
    TypeScaling:typeScaling, $     ; keyword
    sizeType:sizeType,$          ; keyword for size type
    show:show,$                 ; show the value on the histogram
    grpNum:1,$               ; group number
    grpCnt:(*pStateInfo).spectra.groupCnt,$; number of groups
    PixSize:PixSize, $          ; pixel size from GUI
    MinBinID:MinBinID, $      ; minimum bin size slider widget ID
    MaxBinID:MaxBinID, $      ; maximum bin size slider widget ID
    ;MinYID:MinYID, $          ; minimum Y size slider widget ID
    ;MaxYID:MaxYID, $          ; maximum Y size slider widget ID
    setmin:setmin, $          ; maximum Y size slider widget ID
    setmax:setmax, $          ; maximum Y size slider widget ID
    appname:(*pStateInfo).appname,$       ; name of application = 'CpiView'
    position:position,$          ; widgetID of position slider
    BinSizeID:BinSizeID, $        ; bin size slider widget ID
    BincntsID:BincntsID, $        ; mincntsPerbin  slider widget ID
    LogScaleID:LogScale, $        ; log scale widget ID
    ; AutoScaleID:autoScale, $     ; auto scale widget ID
    showID:showID,$              ; show widgetID
    TopLabelID:TopLabelID, $     ; widget ID for bottom label1 to hold time info
    PrinterSetup:0, $
    filled:0,$               ; flag for filled spectra
    filledn:1,$              ;flag for all particles(1), liquid=2. ice=3 particles
    SampleVolume:SampleVolume,$ ; } ; sample volume passed in via keyword
    SAFID:SAFID,$
    SAF:1.0}
;(*((*pstateinfo).ptimeseries)).timedata  this is time series "1Hz" data


; stop

; Save ASCII file?
IF((OutPutFlags AND 4)/4)THEN BEGIN
    ; Create a filename
    ; Get Path
    NamePos = RSTRPOS(LocalState.InFileName, '.')
    IF(NamePos ne '') THEN BEGIN
        FileName = STRMID(LocalState.InFileName, 0, NamePos)
        FileName = FileName + '_' + strtrim((*pGroup).StartTime,2)
    ENDIF ELSE FileName = strtrim((*pGroup).StartTime,2)

    FileName = FileName + '_PS.dat'
    ; stop
    Ret = WriteHistogram(LocalState, FILENAME=FileName)
ENDIF

if((OutPutFlags and 2)/2)then begin
    ; output TIFFs
    pGroup = find_first_link(LocalState.pGroup)
    pFirst = pGroup
    LocalState.pGroup = pGroup
    FOR i=1, LocalState.grpCnt DO BEGIN
        PlotHistogram, LocalState, OutPutFlags=2
        LocalState.pGroup =  (*LocalState.pGroup).next_link
    ENDFOR
    LocalState.pGroup = pFirst

endif


if((OutPutFlags and 1)/1)then begin
    IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()

    IF LocalState.PrinterSetup THEN BEGIN
        pGroup = find_first_link(LocalState.pGroup)
        pFirst = pGroup
        LocalState.pGroup = pGroup
        FOR i=1, LocalState.grpCnt DO BEGIN
            PlotHistogram, LocalState, OutPutFlags=1
            LocalState.pGroup =  (*LocalState.pGroup).next_link
        ENDFOR
        LocalState.pGroup = pFirst
    ENDIF
endif

; Show 1st plot
PlotHistogram, LocalState

; Save state
WIDGET_CONTROL, tlb, SET_UVALUE=LocalState,/no_copy

; Hand off control of the widget to the XMANAGER:
XMANAGER, 'ROIHistogram', tlb, /NO_BLOCK

END

;this is added September 2, 2004 by Mo
PRO unihist_adj, sizes,mincntsperbin,minbinwid,xpts,vals,adj
    mincntsperbin=ceil(mincntsperbin)
    soszs=sizes[reverse(sort(sizes))]
    adj_local=adj[reverse(sort(sizes))]
    maxnbins=ceil(n_elements(sizes)/float(mincntsperbin))
    vals=dblarr(2*maxnbins)
    xpts=dblarr(2*maxnbins)

    if n_elements(where(adj ne 0)) lt mincntsperbin then begin
        print,'too few particles in unihist_adj'
        temp=temporary(xpts)
        temp=temporary(vals)
    endif else begin

        cnts=0.0
        xpts(0)=soszs(0)
        k=0l
        k2=0l
        denom=0.0d
        while (k2 lt mincntsperbin or denom lt minbinwid) and k lt n_elements(soszs)-1 do begin
            cnts=cnts + 1*adj_local[k]
            xpts(1)=(soszs(k)+soszs(k+1))/2.0
            denom=xpts(0)-xpts(1)
            if adj_local[k] ne 0.0 then k2=k2+1l
            k=k+1l
        endwhile
        vals(0)=double(cnts)/denom
        vals(1)=double(cnts)/denom

        j=0l
        while k lt n_elements(soszs)-1 do begin

            j=j+2
            cnts=0.0
            xpts(j)=xpts(j-1)
            kj=0
            denom=0.0d
            while (kj lt mincntsperbin or denom lt minbinwid) and k lt n_elements(soszs)-1 do begin
                if adj_local[k] ne 0.0 then kj=kj+1
                cnts=cnts + 1*adj_local[k]
                xpts(j+1)=(soszs(k)+soszs(k+1))/2.0
                denom=xpts(j)-xpts(j+1)
                k=k+1l
            endwhile
            vals(j)=double(cnts)/denom
            vals(j+1)=double(cnts)/denom

        endwhile
        xpts(j+1)=soszs(k)
        denom=xpts(j)-xpts(j+1)
        vals(j)=double(cnts+1.0)/denom
        vals(j+1)=double(cnts+1.0)/denom

        xpts=reverse(xpts[0:j+1])
        vals=reverse(vals[0:j+1])
    endelse
END  ; end of pro unihist_adj,*******

;******************************************************
pro cpiview_unihist_adj,sizes,mincntsperbin,minbinwid,xpts,vals,adj



    if n_elements(sizes) lt 3.0*mincntsperbin then begin
        xpts=[10, 10,  10, 10]
        vals=[0.1,0.1,0.1,0.1]
        print,'No points to plot, Check sampling period or Min.#.of.Parts.Per.Bin'
    endif else begin
        unihist_adj, sizes,mincntsperbin,minbinwid,xpts,vals,adj
    endelse
end; endof cpiview_unigist_adj


;******************************************************

;*******************************************************************************
PRO du_cpiview_other_psds,factor,mincntsperbin,adj,Acor,Dcor,Mcor,xpts,Lvals,Avals,Mvals
    ; input: factor, mincntsperbin,adj, Acor,Dcor,Mcor, xpts
    ; output: Lvals, Avals;Mvals
    ; note that all adj are greater than zero
    ;arrays are already reduced to time period and by fcs and cutoff
    sizes=Dcor
    if n_elements(sizes) lt 3.0*mincntsperbin then begin
        xpts=[10,  10,   10,  10 ]
        ypts=[0.1, 0.1,  0.1, 0.1]
        Lvals=ypts
        Avals=ypts
        Mvals=ypts
        print,'No points to plot, Check sampling period or Min.#.of.Parts.Per.Bin'
    endif else begin
        somarr=where(adj gt 0)
        num_parts=n_elements(somarr)
        if num_parts lt 2 then begin
            print,'too few particles in du_other_psds'
            xpts=[0.01,10]
            Lvals=fltarr(n_elements(xpts))
            Avals=fltarr(n_elements(xpts))
            Mvals=fltarr(n_elements(xpts))
            return
        endif

        Lvals=fltarr(n_elements(xpts))
        Avals=fltarr(n_elements(xpts))
        Mvals=fltarr(n_elements(xpts))

        for j=0,n_elements(xpts)-1,2 do begin

            ;somarr=where(Dcor lt xpts[j+1] and Dcor ge xpts[j] and adj ge 1)
            if j+1 eq n_elements(xpts)-1 then somarr=where(Dcor ge xpts[j] and adj ge 1) else somarr=where(Dcor lt xpts[j+1] and Dcor ge xpts[j] and adj ge 1)

            ;if n_elements(somarr) ge mincntsperbin/2 then begin
            if n_elements(somarr) ge 2 then begin

                L_=total(Dcor(somarr)*adj(somarr))
                A_=Total(Acor(somarr)*adj(somarr))
                M_=Total(Mcor(somarr)*adj(somarr))

                ;Lvals[j:j+1]=Factor*L_/(xpts[j+1]-xpts[j])                         ;microns/liter/um
                ;Avals[j:j+1]=Factor*A_/(xpts[j+1]-xpts[j])/1000000.                ;mm2/liter/um
                ;Mvals[j:j+1]=Factor*M_/(xpts[j+1]-xpts[j])                         ;mg/liter/um
                Lvals[j:j+1]=L_/(xpts[j+1]-xpts[j])                         ;microns/liter/um
                Avals[j:j+1]=A_/(xpts[j+1]-xpts[j])/1000000.                ;mm2/liter/um
                Mvals[j:j+1]=M_/(xpts[j+1]-xpts[j])                         ;mg/liter/um

            endif else begin
                ;assuming we are on last bin now and it had too few
                xpts=xpts[0:n_elements(xpts)-3];  ????? whye minues 3
                Lvals=Lvals[0:n_elements(xpts)-1]
                Avals=Avals[0:n_elements(xpts)-1]
                Mvals=Mvals[0:n_elements(xpts)-1]
            endelse
        endfor
    endelse; end of endelse of if n_elements(sizes) lt 3.0*mincntsperbin then begin ***endif else begin
end ;endof du_cpiview_other_psd

;*****************************************************
pro convert_thisValue_to_string, this_value, mystring
    if this_value eq 0.0 then this_value=1.0
    if this_value ge 1 then begin
        mystring=strtrim(round(this_value),2)
    endif else begin
        mystring='0.'
        k=abs(floor(Alog10(this_value)) )
        for kk=1,k-1 do begin
            mystring=mystring+'0'
        endfor
        mystring=mystring+'1'
    endelse
end; end of convert_this_value_to_string

;*******************************************************

;**************************************************************************
pro GetPsdValues,pGroup,localstate,pGrouppData,pGrouppadj,pGrouppdataA,pGrouppDataM,$
    xpts,vals,Lvals,Avals,Mvals,factor,psd_conc,ave_conc,acceptedPart

mo_minbinsize=(localstate.sizes).Gbinsize;     this binsize is from screen widget choose by user.
mo_mincntsperbin=(localstate.sizes).Gmincntsperbin
validData = where(*pGrouppData ne 0,dataCnt) ; above if j statement makesure there is data in the interval.
acceptedPart=datacnt
if dataCnt ne 0  then begin
    sizes=(*pGrouppData)[validData]
    adjs =(*pGrouppAdj)[validData]
    Acors=(*pGrouppDataA)[validData]
    Mcors=(*pGrouppDataM)[validData]
    cpiview_unihist_adj, sizes,mo_mincntsperbin,mo_minbinsize,xpts,vals,adjs
    conc_norm=1.0/(localState.sumSecs - (*pGroup).deadtime)/LocalState.SampleVolume
    factor=float(localstate.sumsecs)*conc_norm
    psd_conc=total(adjs)
    ave_conc=factor*psd_conc
    du_cpiview_other_psds,factor,mo_mincntsperbin,adjs,Acors,sizes,Mcors,xpts,Lvals,Avals,Mvals
endif
end
;**************************************************************************
