

PRO ZoomedHParticleStrip, info  ; this is for Hparticles
    forward_function Fill_averaged_strip

    ; TAF need to talk to Mo about color displays in this program, ie the yellow background
    ; TAF update: apparently Mo uses 3 color layers for his colorization -- need to check against my color commands
    ;device, decomposed=0
    ;loadct, 39

    stripID = 0L
    zoomID  = 0L
    stripBase = 0L
    stripLabel = 0L

    ave_info=info.ave_info
    lastimg_foffset=info.lastimg_foffset
    firstimg_foffset=info.firstimg_foffset


    strip_info = {stripID:stripID,        $ ; widget ID for the strip of bitmaps
        VstripID:0L,            $
        zoomID:zoomID,          $
        stripBase:stripBase,    $
        stripLabel:stripLabel,  $
        VstripBase:stripBase,   $
        VstripLabel:stripLabel, $
        FR_button:0L,      $
        SSR_button:0L,     $
        SSF_button:0L,     $
        FF_button:0L,      $
        ave_info:ave_info, $
        lastimg_foffset:lastimg_foffset,   $
        firstimg_foffset:firstimg_foffset, $
        time1:0LL, $ ; added following 4 line in august 15th,2007.
        time2:0LL, $
        eventx1:0, $
        eventx2:0}

    base = WIDGET_BASE(/COLUMN)
    strip_info.stripBase = base
    info.stripBase = base

    Hparticles = Widget_Draw(base, XSize=!STRIP_WIDTH, YSize=128, $
        Event_Pro='SPEC_StripZoomH_event', /BUTTON_EVENTS, /MOTION_EVENTS)

    strip_info.stripID = HParticles

    info.stripID = HParticles

    ;strip_y_size = 340 ; changed from 280 to 340 to add Roundness 1 2 3, each line increase 20.
    ;strip_y_size = 440 ; changed from 340 to 440 to add L1r, maxLength, maxWidth, and perimeter, crystal_type, each line increase 20.
    strip_y_size = 480 ; updated for Largest Sat Area

    STRIP_Toolbar = WIDGET_BASE(base, $
        COLUMN=8, $
        FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=strip_y_size); this line's 280 must be the same as next dula_label's 280.


    STRIP_dual_label = WIDGET_BASE(STRIP_Toolbar, $
        ROW=1, $
        ; FRAME=1, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        YSIZE=strip_y_size)
    ;YSIZE=280)  ;changer from 180 to 280; for showing L7, L8 , L5, PC1 etc. each line increase 20.


    ; Generate a label on the bitmap widget that will display the parameters for a single particle

    LABEL_Info = WIDGET_TEXT(STRIP_dual_label, $
        VALUE="", $
        XSIZE = 40, $
        YSIZE=40)
    strip_info.stripLabel = LABEL_Info

    ;mo added this
    strip_toolbar2=widget_base(strip_toolbar,/col)
    strip_toolbar3=widget_base(strip_toolbar2,/row)

    BUTTON_FastBackward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='FastRewind', $
        XSIZE=40, $
        TOOLTIP="Play Backwards", $
        VALUE=  'RR.bmp', /BITMAP, $
        Event_Pro='Zoomplay_reverse_timer_event')



    BUTTON_Rewind = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='Rewind', $
        XSIZE=35, $
        TOOLTIP="Single Step Reverse", $
        VALUE=  'SingleR.bmp', /BITMAP, $
        Event_Pro='zoomParticleStrip_Toolbar_Rewind')

    BUTTON_Forward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='Forward', $
        XSIZE=35, $
        TOOLTIP="Single Step Forward", $
        ;PUSHBUTTON_EVENTS=1, $
        VALUE= 'SingleF.bmp', /BITMAP, $
        Event_Pro='zoomParticleStrip_Toolbar_Forward')


    BUTTON_FastForward = WIDGET_BUTTON( STRIP_Toolbar3, $
        FONT='9x15', $
        UVALUE='FastForward', $
        XSIZE=40, $
        TOOLTIP="Play Forwards", $
        VALUE=  'FF.bmp', /BITMAP, $
        Event_Pro='zoomplay_forward_timer_event')

    spaceholder1 = WIDGET_LABEL(STRIP_Toolbar3, $
        VALUE= " Speed (in Secs)", $
        XSIZE=110, $
        YSIZE=35)

    dd_list=['0.10','0.25','0.50','1.0']

    STRIP_Dropdown = WIDGET_DROPLIST(STRIP_Toolbar3, $
        FRAME=1, $
        VALUE = dd_list, $
        Event_Pro = 'zoomBitmap_Playback_Speed_event')

    making_png_pages = WIDGET_button(STRIP_Toolbar2, $
        FRAME=1, $
        VALUE = 'Generate_images_png_pages', $
        Event_Pro ='Generating_Image_png_pages_event')

    ;************************************************* add following on augut 15, 2007


    cleaningbutton = WIDGET_button(STRIP_Toolbar2, $
        FRAME=1, $
        VALUE = 'Cleaning by start--End Clicks', $
        Event_Pro ='Cleaning_button_event')

    strip_toolbar4 = widget_base(strip_toolbar2,/row)
    label          = widget_label(strip_toolbar4,value = 'Label_one_image_as_bad_with_one_click:')
    b341           = widget_base(strip_toolbar4,/exclusive,/row)
    offbutton      = widget_button(b341,value='Off',Event_pro='One_click_Cleaning_button_off_event')
    onbutton       = widget_button(b341,value='On',Event_pro='One_click_Cleaning_button_on_event')

    ; checkbox for displaying perimeters

    base_showperimeter = widget_base(strip_toolbar2, /row, /nonexclusive)

    ck_showperimeter = widget_button(base_showperimeter, value = 'Show Perimeters', Event_pro = 'showperimeterH_event')
    widget_control, ck_showperimeter, set_button = !showperimeterH

    if !clean_status eq 3 then begin
        widget_control,onbutton, set_button=1
    endif else widget_control,offbutton, set_button=1

    ; TAF add checkbox to label CPI trigger images here

    ; widget_button (check button?) (strip_toolbar2,

    ;*************************************************

    ; save so we can disble buttons during FF and Fast reverse
    strip_info.FR_button  = BUTTON_FastBackward
    strip_info.SSR_button = BUTTON_Rewind
    strip_info.SSF_button = BUTTON_Forward
    strip_info.FF_button  = BUTTON_FastForward

    Zoomer_base = WIDGET_BASE(STRIP_Toolbar, $
        MAP=1, $
        UVALUE='BASE_Zoomer', $
        BASE_ALIGN_LEFT=1, $
        XSIZE=!zoom_xsize, $
        YSIZE=!zoom_ysize)

    strip_info.zoomID = Widget_Draw(Zoomer_base,XSize = !zoom_xsize, YSize = !zoom_ysize,$
        Event_Pro='SPEC_StripZoomH_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    ;  strip_info.zoomID = Widget_Draw(Zoomer_base,XSize=128, YSize=128, Event_Pro='SPEC_StripH_event', /BUTTON_EVENTS, /MOTION_EVENTS)
    direction = -1
    foffset = -1 ; -1 means the first time filling in the strip
    foffset = Fill_averaged_strip(foffset, ave_info, strip_info, direction,'H')
    wdelete, !D.window

    Widget_Control, base, Set_UValue=strip_info, /No_Copy
    WIDGET_CONTROL, base, /REALIZE

    ; TAF added the second call to Fill_averaged_strip with direction = 0 to actually fill the strip after the window loads.
    ; Note the two calls to Widget control to get/set the new strip_info.
    Widget_Control, base, Get_UValue=strip_info, /No_Copy
    newoffset = Fill_averaged_Strip(foffset, ave_info, strip_info, 0, 'H')
    Widget_Control, base, Set_UValue=strip_info, /No_Copy

    XMANAGER, 'ZoomedHParticleStrip', base, /JUST_REG
END ; end of zoomHparticlestrip,info



pro showperimeterH_event, event
    ; event for handling the "Show Perimeters" checkbox in Zoomed H Strip
    ; toggles the state flag for showing perimeters, and redraws the images with/without perimeters

    Common  DataBlock, alldataH, alldataV, ADataH, ADataV, FirstData, LastData, StripData, $
        FirstDataV, LastDataV, StripDataV, OneHzH, OneHzV, aveStripdata, aveStripdataV

    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure

    if !showperimeterH eq 0 then !showperimeterH=1 else !showperimeterH=0

    ave_info = strip_info.ave_info
    foffset  = !Foffset

    newoffset = Fill_averaged_Strip(foffset, ave_info, strip_info, 0, 'H')

    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end ; showperimeterH_event



pro showperimeterV_event, event
    ; event for handling the "Show Perimeters" checkbox in Zoomed V Strip
    ; toggles the state flag for showing perimeters, and redraws the images with/without perimeters

    Common  DataBlock, alldataH, alldataV, ADataH, ADataV, FirstData, LastData, StripData, $
        FirstDataV, LastDataV, StripDataV, OneHzH, OneHzV, aveStripdata, aveStripdataV

    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure

    if !showperimeterV eq 0 then !showperimeterV=1 else !showperimeterV=0

    ave_info = strip_info.ave_info
    foffset  = !Foffset

    newoffset = Fill_averaged_Strip(foffset, ave_info, strip_info, 0, 'V')

    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end ; showperimeterV_event



PRO SPEC_StripZoomH_event, event
    ; handles mouse over and click events in the Zoomed H Strip
    ; mouse clicks can manually label noisy particles
    ; mouse over updates the detailed particle information text fields, and draws a zoomed particle in the zoom window


    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV

    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure

    HorV = 'H'

    microns_per_pixel = !MICRONS_PER_PIXELH

    ;if(n_elements(strip_info) eq 0) then begin ; we get an empty event at the first window show after the strip gets filled
    ;    return
    ;endif

    if(event.PRESS GE 1) then  begin
        if event.ID EQ strip_info.zoomID then print, "zoom window clicked"
    end

    ; add following to remove noisy particles
    if event.Press GE 1 and event.ID eq strip_info.stripID and !clean_status eq 3 then begin
        if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin
            timenanoseconds = aveStripData(event.X).Nanoseconds
            index=where((*alldataH).nanoseconds eq timenanoseconds)

            if index(0) ne -1 then begin
                if (*alldataH)(index(0)).reject eq 0 then begin
                    (*alldataH)(index(0)).reject = 1
                    reject = 1
                endif  else begin
                    (*alldataH)(index(0)).reject=0
                    reject=0
                endelse

                ADD_THIS_CLICK_TO_CLICK_action_list_file,index(0),'H',reject
            endif

            if index(0) ne -1 then begin
                ;search until the start and end of this image.
                xx1 = event.X > 0

                while (aveStripdata(xx1).Nanoseconds eq aveStripdata(event.X).nanoseconds and xx1 gt 0) do begin
                    xx1=xx1-1
                endwhile

                xx2 = event.X < 998

                while (aveStripdata(xx2).Nanoseconds eq aveStripdata(event.X).nanoseconds and xx2 lt 998) do begin
                    xx2 = (xx2+1) < 998
                endwhile

                Widget_Control, strip_info.stripID, Get_Value=wid
                WSet, wid
                mylength = xx2 - xx1

                myclip = TVRD(xx1, 0, mylength, 128)

                flig_myclips_color, myclip, mylength, dimension

                loadct, !ct_2DS, /silent

                if dimension eq 3 then tv, myclip, xx1, 0, true=1
                if dimension eq 2 then tv, myclip, xx1, 0
            endif ; if index(0) ne -1
        endif
    endif

    ;********************************************************************************

    ;********************************************************************************
    ;  add this to remove several particles at a time by drawing a rubber band or two clicks
    if event.type eq 0 and event.ID eq strip_info.stripID and !clean_status ne 0 then begin ; button is pressed down
        if !clean_status eq 1 then begin
            if event.type eq 0 and event.ID eq strip_info.stripID then begin
                strip_info.time2   = aveStripData(event.X).Nanoseconds
                strip_info.eventx2 = event.X
                !clean_status = 0

                ;find all of the unique time between time1 and time2 in the data
                index = where((*alldataH).nanoseconds ge strip_info.time1 and (*alldataH).nanoseconds le strip_info.time2 $
                    and (*alldataH).reject eq 0, contGG)

                if contGG gt 0 then (*alldataH)(index).reject=1

                ADD_ALL_INDEXS_TO_ACTIONLIST, INDEX, 'H'

                if (contGG gt 0) then begin
                    Widget_Control, strip_info.stripID, Get_Value=wid
                    WSet, wid
                    mylength = fix(abs(strip_info.eventX2-strip_info.eventX1))
                    myclip = TVRD(strip_info.eventx1,0,mylength,128)
                    yellowblock = bytarr(3,mylength,128)
                    yellowblock(0,*,*)=255
                    yellowblock(1,*,*)=myclip

                    loadct, !ct_2DS, /silent

                    tv,yellowblock,strip_info.eventX1,0,true=1
                endif
            endif; end if venet.type eq 0
        endif; end of if !clean_status eq 1

        if !clean_status eq 2 then begin
            strip_info.time1= aveStripData(event.X).Nanoseconds
            strip_info.eventx1=event.X ; wait for until it is up.
            print,'time1=',strip_info.time1 ; this is teh first particle's time.
            !clean_status=1
        endif
    endif

    ;**********************************************************************************

    ;***********************************************************************************

    if event.ID EQ strip_info.stripID then begin
        if (event.x GE 0 and event.X LE (!STRIP_WIDTH - 1)) then begin


            ; Calculate the masses using various methods (TAF should clean this up and only calculate these parameters in one place...)

            shaded_area         = aveStripData(event.X).Area    * microns_per_pixel * microns_per_pixel ; microns^2

            ;if(aveStripData(event.X).focus gt !focuspercent) then begin
            ;    focus_adjusted_area = shaded_area
            ;endif else begin
            ;    focus_adjusted_area = !pi * aveStripData(event.X).L7 * aveStripData(event.X).L7 / 4. * !MICRONS_PER_PIXEL * !MICRONS_PER_PIXEL ; microns^2
            ;endelse

            ; Mass from CSP using parameterization for normal shaded pixel area

            csp_mass = (10.0^(-9.0 * !csp_beta)) * !csp_alpha * double(aveStripData(event.X).csp)^!csp_beta ; here csps in um, area in mm^2 ; sizes is im um. mass in mg

            ; Mass from CSP using parameterization for out of focus adjusted area

            ;csp_mass_adj = (10.0^(-9.0 * csp_beta)) * csp_alpha * double(aveStripData(event.X).csp * focus_adjusted_area / shaded_area)^csp_beta
            ;csp_mass_adj = csp_mass_adj


            ; Mass from Area using parameterization for normal shaded pixel area
            area_alpha = 0.115D
            area_beta  = 1.218D

            this_sizes = aveStripData(event.X).L1n  * microns_per_pixel                      ; microns
            this_area  = aveStripData(event.X).Area * microns_per_pixel * microns_per_pixel ; microns^2

            this_area = this_area / 1.e6 ; convert microns^2 to mm^2

            ;area_liq = .0001 * (!pi * this_sizes^2.) / 4.

            ;this_area_use = area_liq < this_area

            mass1 = area_alpha * double(this_area)^area_beta ; here sizes in um, area in mm^2 ; sizes is im um.
            mass2 = 0.917 * (0.1^9.0 * !pi/6.0) * This_sizes^3.0 ; size in um (TAF NOTE NOT WATER!!!) water-mass. milligrams. ice density
            ;mass3 = mass1 < mass2                                ; take the less elements of the two arrays
            ;print, string(format = '(%"Area Mass: %11.3e %11.3e")', mass1, mass2)
            area_mass = mass1


            ; Mass from Area using parameterizationfor out of focus adjusted area
            this_sizes = aveStripData(event.X).L1n * microns_per_pixel                      ; microns

            ;if(aveStripData(event.X).focus gt !focuspercent) then begin
            ;    this_area =  aveStripData(event.X).Area * !MICRONS_PER_PIXEL * !MICRONS_PER_PIXEL ; microns^2
            ;endif else begin
            this_area  = !pi * aveStripData(event.X).L7 * aveStripData(event.X).L7 / 4. * microns_per_pixel * microns_per_pixel ; microns^2
            ;endelse

            this_area = this_area / 1.e6 ; convert microns^2 to mm^2

            ;area_liq = .0001 * (!pi * this_sizes^2.) / 4.

            ;this_area_use = area_liq < this_area

            mass1 = area_alpha * double(this_area)^area_beta ; here sizes in um, area in mm^2 ; sizes is im um.
            mass2 = 0.917 * (0.1^9.0 * !pi/6.0) * This_sizes^3.0 ; size in um water-mass. milligrams.
            ;mass3 = mass1 < mass2                                ; take the less elements of the two arrays
            ;print, string(format = '(%"Adj Mass: %11.3e %11.3e")', mass1, mass2)
            ;print, " "
            area_mass_adj = mass1

            timestamp = SPEC_Nano2HMS(aveStripData(event.X).Nanoseconds)

            if(aveStripData(event.X).maxWidth eq 0.) then begin
                aspect = -1.
            endif else begin
                aspect = aveStripData(event.X).maxLength / aveStripData(event.X).maxWidth
            endelse

            hex_timestamp = string(format = '(%"0x%012X")',                                 aveStripData(event.X).ProbeCounter)
            F1         = string(format = '(%"F1  = 0x%04X")',                            aveStripData(event.X).F1)
            PC1        = string(format = '(%"PC1 = % 3.1d             Focus = % 9.5f")', aveStripData(event.X).PC1, aveStripData(event.X).focus)
            Nslice     = string(format = '(%"Nslice  =%6.1d")', aveStripData(event.X).Nslice)
            length     = string(format = '(%"L1n(um) =% 7.1f          Mass(mg)   Focus Adj Mass")', aveStripData(event.X).L1n * microns_per_pixel)
            L1r_field  = string(format = '(%"L1r(um) =% 7.2f    Area: %11.3e  %11.3e")', aveStripData(event.X).L1r, area_mass, area_mass_adj)
            height     = string(format = '(%"L2(um)  =% 8d       CSP: %11.3e   ")',      aveStripData(event.X).L2 * microns_per_pixel, csp_mass)
            L3         = string(format = '(%"L3 = %9.3f")',                        1.8 * aveStripData(event.X).L3) ; TAF constant 1.8? What is it?
            L4         = string(format = '(%"L4 = %3.1d")',                              aveStripData(event.X).L4)
            L5         = string(format = '(%"L5 = % 3.1d                Aspect:  % 9.3f")', aveStripData(event.X).L5, aspect)
            L7         = string(format = '(%"L7 = %8.2f")',                              aveStripData(event.X).L7)
            L8         = string(format = '(%"L8 = %8.2f")',                              aveStripData(event.X).L8)
            PC3        = string(format = '(%"PC3 (x,y) = %9.3f,%9.3f")',                 aveStripData(event.X).PC3x, aveStripData(event.X).PC3y)
            PC4        = string(format = '(%"PC4 (x,y) = %9.3f,%9.3f")',                 aveStripData(event.X).PC4x, aveStripData(event.X).PC4y)
            ;A3        = string(format = '(%"A3 = %9.3f")',aveStripData(event.X).A3)
            get_binary_8bitstring, my8bitstring, aveStripdata(event.X).noisebyte
            A3         = 'NoiseType = ' + my8bitstring
            area       = string(format = '(%"Area(sq.um) = % 8d")', aveStripData(event.X).Area * microns_per_pixel * microns_per_pixel)
            Alexei     = string(format = '(%"A1 (Alexei)   = % 8d")', aveStripData(event.X).Alexei1 * microns_per_pixel * microns_per_pixel)
            W8_t       = string(format = '(%"W8_t (tick) = %19I")', aveStripData(event.X).W8_t)
            W8_t_clean = string(format = '(%"W8_t_clean  = %19I")', aveStripData(event.X).W8_t_clean)
            Rndness    = string(format = '(%"Roundness (0 or 1) = %3d")', fix(aveStripData(event.X).Roundness))
            Warning    = string(format = '(%"Warning   = %6.0f")', aveStripData(event.X).warn)
            Roundness1_field = string(format = '(%"Roundness 1 = %9.5f")', aveStripData(event.X).Roundness1)
            Roundness2_field = string(format = '(%"Roundness 2 = %9.5f")', aveStripData(event.X).Roundness2)
            Roundness3_field = string(format = '(%"Roundness 3 = %9.5f")', aveStripData(event.X).Roundness3)
            maxLength_field  = string(format = '(%"Length = % 9.3f um")',      aveStripData(event.X).maxLength * microns_per_pixel)
            maxWidth_field   = string(format = '(%" Width  = % 9.3f um")',      aveStripData(event.X).maxWidth  * microns_per_pixel)
            perimeter_field  = string(format = '(%"Perimeter = %d pixels, %9.1f um")', aveStripData(event.X).perimeter, aveStripData(event.X).perimeterum)
            largest_sat_field= string(format = '(%"Largest Sat Area = %9.1f um^2")',     aveStripData(event.X).largest_satellite_area)
            num_sats_field   = string(format = '(%"Satellites = %d  ")',               fix(aveStripData(event.X).num_satellites))
            CPI_trigger_msg = string(format = '(%"CPI Trigger = %d   PartID = 0x%04X")',aveStripData(event.X).CPI_trigger, aveStripData(event.X).PartID)



            if((aveStripData(event.X).F1 AND '3'X) eq '3'X) then begin
                Edge_field = "Edge Flag = Both Edges"
            endif else if((aveStripData(event.X).F1 AND '1'X) eq '1'X) then begin
                Edge_field = "Edge Flag =    0 Edge"
            endif else if((aveStripData(event.X).F1 AND '2'X) eq '2'X) then begin
                Edge_field = "Edge Flag = 127 Edge"
            endif else begin
                Edge_field = "Edge Flag = Not on Array Edge"
            endelse

            if((aveStripData(event.X).F1 AND '4'X) eq '4'X) then begin
                Note1_field = "NOTE: Roundness 1-3 from Edge Particle"

                if((aveStripData(event.X).F1 AND '8'X) eq '8'X) then begin
                    Note2_field = "      Centroid ON  Array"
                endif else begin
                    Note2_field = "      Centroid OFF Array"
                endelse
            endif else begin
                Note1_field = ""
                Note2_field = ""
            endelse

            if((aveStripData(event.X).F1 AND '10'X) eq '10'X) then begin
                Note1_field = "NOTE: Roundness 1-3 from Dual Edge Particle"

                if((aveStripData(event.X).F1 AND '8'X) eq '8'X) then begin
                    Note2_field = "      Centroid ON  Array"
                endif else begin
                    Note2_field = "      Centroid OFF Array"
                endelse
            endif

            if(aveStripData(event.X).crystal_type eq 1) then begin
                crystal_type_field = string(format = '(%"crystal = sphere            CSP(um^3) = %11.2e")', aveStripData(event.X).csp)
            endif else if(aveStripData(event.X).crystal_type eq 15) then begin
                crystal_type_field = string(format = '(%"crystal = ice               CSP(um^3) = %11.2e")', aveStripData(event.X).csp)
            endif else begin
                crystal_type_field = string(format = '(%"crystal = ?                 CSP(um^3) = %11.2e")', aveStripData(event.X).csp)
            endelse



            ;PartID_msg = string(format = '(%"PartID = %04X")',aveStripData(event.X).PartID)



            WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= timestamp + !CRLF $
                + hex_timestamp + !CRLF $
                + crystal_type_field + !CRLF $
                + F1     + !CRLF $
                + PC1    + !CRLF $
                + Nslice + !CRLF $
                + length + !CRLF $
                + L1r_field + !CRLF $
                + height + !CRLF $
                + L3     + !CRLF $
                + L4     + !CRLF $
                + L5     + !CRLF $
                + L7     + !CRLF $
                + L8     + !CRLF $
                + PC3    + !CRLF $
                + PC4    + !CRLF $
                + A3     + !CRLF $ ;that is 8 bit binary noisetype
                + area   + !CRLF $
                + Alexei + !CRLF $
                + W8_t   + !CRLF $
                + W8_t_clean + !CRLF $
                + rndness + !CRLF $
                + warning + !CRLF $
                + Roundness1_field + !CRLF $
                + Roundness2_field + !CRLF $
                + Roundness3_field + !CRLF $
                + maxLength_field  + !CRLF $
                + maxWidth_field   + !CRLF $
                + perimeter_field  + !CRLF $
                + Edge_field       + !CRLF $
                + largest_sat_field+ !CRLF $
                + Note1_field      + !CRLF $
                + Note2_field      + !CRLF $
                + num_sats_field   + CPI_trigger_msg ; + !CRLF $
                ;+ PartID_msg

                CPI_trigger2 = aveStripData(event.X).CPI_trigger

            if(aveStripData(event.X).ImageWords GT 0) then begin
                match = aveStripData(event.X).Nanoseconds
                beginning = LONG(event.X)
                index =  LONG(event.X)

                WHILE ((beginning GE 0) and (aveStripData(index).Nanoseconds EQ match)) DO BEGIN
                    beginning--

                    if --index LT 0 then index = 0
                ENDWHILE

                if beginning NE 0 then beginning++

                theend = LONG(event.X)
                index = LONG(event.X)

                WHILE ((theend LE (!STRIP_WIDTH - 1)) and (aveStripData(index).Nanoseconds EQ match)) DO BEGIN
                    theend++
                    if ++index GT (!STRIP_WIDTH - 1) then index = (!STRIP_WIDTH - 1)  ; can't let us access aveStripData(600)
                ENDWHILE

                if theend NE (!STRIP_WIDTH - 1) then theend--

                Widget_Control, strip_info.stripID, Get_Value=wid
                WSet, wid

                ;center_y = long(aveStripData(event.X).PC1)
                ;            center_y = long(aveStripData(event.X).PC1 + aveStripData(event.X).L5/2.) ; TAF was cutting off too much, still not very good display though
                center_y = long(aveStripData(event.X).PC1)
                center_x = long((theend-beginning)/2 + beginning)

                ;length = aveStripData(event.X).L2
                ;if (length LT aveStripData(event.X).ImageWords) then length = aveStripData(event.X).ImageWords


                ;start = long(aveStripData(event.X).PC1 -length)
                ;if (start LT 0) then start = 0

                ;length *= 2
                ;if (start + length) GT 127 then start = 128 - length
                ;height = aveStripData(event.X).ImageWords
                ;full_width = 22L
                ;half_width = 11L
                ;zoom_value = 6L

                ;full_width = 44L
                ;half_width = 22L
                ;zoom_value = 6L

                ;if (center_x LT half_width) then center_x = half_width
                ;if (center_x GT (!STRIP_WIDTH - 1)-half_width) then center_x = (!STRIP_WIDTH - 1)-half_width
                ;if (center_y LT half_width) then center_y = half_width
                ;if (center_y GT 127-half_width) then center_y = 127-half_width
                ;x1 = center_x - half_width
                ;y1 = center_y - half_width
                ;x_length = full_width
                ;y_length = full_width

                x1 = 0
                y1 = 0
                ;x_length = !zoom_xsize
                x_length = theend-beginning+1
                y_length = !PIXELS

                aa = where(aveStripData(*).nanoseconds eq match)
                x1 = aa[0]
                x_length = n_elements(aa)


                ; TAF adding support for handling the green CPI Trigger images for zoom

                ;clip = TVRD(x1, y1, x_length, y_length)
                clip = TVRD(x1, y1, x_length, y_length, /true)

                ; works using device decomposed = 0, need to update for 3 color
                ;clip = reform(clip[2,*,*])
                ;green_color = 140
                ;purple_color = 38 ; TAF not sure where the 38 is coming from, indexed table vs decomposed?
                ;purple_index = where(clip eq purple_color, count)
                ;if(count gt 0) then begin
                ;    clip[purple_index] = green_color
                ;endif

                loadct, !ct_2DS, /silent

                Widget_Control, strip_info.zoomID, Get_Value=wid
                WSet, wid
                erase, color = 'FFFFFF'x  ; get background to white
                ;bigger = rebin(clip,full_width*zoom_value,full_width*zoom_value,/SAMPLE)
                bigger = rebin(clip, 3, x_length * !zoom_factor, y_length * !zoom_factor, /SAMPLE)

                tv, bigger, /true

                Widget_Control, strip_info.stripID, Get_Value=wid
                WSet, wid

                ;stop
            endif
        endif
    endif

    ; TAF experiment
    ;**************************************************
    ;    firstimg_foffset=strip_info.firstimg_foffset
    ;    lastimg_foffset =strip_info.lastimg_foffset
    ;    ave_info=strip_info.ave_info
    ;   ;**********************************************************************************
    ; ;*******************************************************************************
    ; Hsubindex=*(ave_info.Hsubindex)
    ; nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
    ; Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
    ; L1size_array=(*alldataH)(Hsubindex).Nslice
    ; foffset=!Foffset
    ; ;get the new offset
    ; index=where(Hsub_foffset le foffset,number_left)
    ;         foffsets_array=reverse(Hsub_foffset(index))
    ;         L1size_array =reverse(L1size_array(index))
    ;         ;find the first particle file_offset and then re-order them
    ;          yoffset=0
    ;          nnn=n_elements(L1size_array) < 500
    ;          for i=0, nnn-1 do begin
    ;            yoffset=yoffset+L1size_array(i)+1
    ;            if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
    ;              foffset=foffsets_array(i)
    ;              break
    ;;            endif; ;end of if yoffset ge
    ;          endfor
    ;finished getting the new start offset
    ;***************************************************************************************

    ;   newoffset = Fill_averaged_Strip(foffset,ave_info, strip_info,-1,'H')
    ;   newoffset = Fill_averaged_Strip(0,ave_info, strip_info,-1,'H')
    ;  newoffset = Fill_averaged_Strip(0,ave_info, strip_info,-1,'V')
    ;if !FOFFSET le firstimg_foffset then begin
    ;   WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF Zoomed period REACHED"
    ;end else begin
    ;    WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
    ;endelse
    ;Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    ;end
    ;; TAF end experiment

    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

END ; SPEC_StripZoomH_event



;-------------------------------------
pro ZoomParticleStrip_Toolbar_Rewind, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV
    ;*******************************************************************************
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure

    ;stop

    ;**************************************************
    firstimg_foffset=strip_info.firstimg_foffset
    lastimg_foffset =strip_info.lastimg_foffset
    ave_info=strip_info.ave_info
    ;**********************************************************************************
    ;*******************************************************************************
    Hsubindex=*(ave_info.Hsubindex)
    nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
    Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
    L1size_array=(*alldataH)(Hsubindex).Nslice
    foffset=!Foffset
    ;get the new offset
    index=where(Hsub_foffset le foffset,number_left)
    ;if number_left ne 0 then begin ; TAF 2013-10-25 this If structure was resetting the plot to the start when rewind was pressed.
    ; This whole thing should be replaced with a slider bar anyway to navigate the images.

    foffsets_array=reverse(Hsub_foffset(index))
    L1size_array =reverse(L1size_array(index))
    ;find the first particle file_offset and then re-order them
    yoffset=0
    nnn=n_elements(L1size_array) < 500
    for i=0, nnn-1 do begin
        yoffset=yoffset+L1size_array(i)+1
        if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
            foffset=foffsets_array(i)
            break
        endif; ;end of if yoffset ge
    endfor
    ;endif else foffset=firstimg_foffset
    ;finished getting the new start offset
    ;***************************************************************************************

    newoffset = Fill_averaged_Strip(foffset, ave_info, strip_info, -1, 'H')

    if(!FOFFSET le firstimg_foffset) then begin
        WIDGET_CONTROL, strip_info.stripLabel ,SET_VALUE= "BEGINNING OF Zoomed period REACHED"
    end else begin
        WIDGET_CONTROL, strip_info.stripLabel ,SET_VALUE= ""
    endelse

    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end ; ZoomParticleStrip_Toolbar_Rewind



pro zoomParticleStrip_Toolbar_Forward, event
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure

    firstimg_foffset=strip_info.firstimg_foffset
    lastimg_foffset =strip_info.lastimg_foffset
    ave_info=strip_info.ave_info

    foffset = !FOFFSET
    newoffset = Fill_averaged_Strip(foffset,ave_info, strip_info,1,'H')

    ; print, "pre,post",pre_offset,newoffset; ; if pre_offset EQ foffset then begin
    if foffset ge lastimg_foffset then begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
    end else begin
        WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
    endelse
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

end



pro zoomBitmap_Playback_Speed_event, event
    if event.index eq 0 then !PLAYBACK_SPEED = 0.1
    if event.index eq 1 then !PLAYBACK_SPEED = 0.25
    if event.index eq 2 then !PLAYBACK_SPEED = 0.50
    if event.index eq 3 then !PLAYBACK_SPEED = 1.0
end  ;zoomBitmap_Playback_Speed_event, event



pro zoomplay_forward_timer_event, event
    forward_function  Fill_averaged_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!PLAYBACK_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            firstimg_foffset=strip_info.firstimg_foffset
            lastimg_foffset =strip_info.lastimg_foffset
            ave_info=strip_info.ave_info
            ;**********************************************************************************
            foffset = !FOFFSET
            pre_offset = foffset
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,1,'H')
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset ge lastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
                !PLAYBACK_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1

            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse


            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure

        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        firstimg_foffset=strip_info.firstimg_foffset
        lastimg_foffset =strip_info.lastimg_foffset
        ave_info=strip_info.ave_info
        ;**********************************************************************************
        if (!PLAYBACK_ACTIVE eq 1) then begin
            !PLAYBACK_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'FFon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=0
            foffset = !FOFFSET
            pre_offset = foffset
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,1,'H')
            ; print, "pre,post",pre_offset,newoffset
            if pre_offset EQ lastimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "END OF Zoomed Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !PLAYBACK_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'FF.bmp', /BITMAP

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FR_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end;  end of zoomplay_forward_timer_event, event



pro zoomplay_reverse_timer_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV
    ;*******************************************************************************
    forward_function  Fill_averaged_Strip
    IF (TAG_NAMES(event, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') THEN BEGIN
        if (!REWIND_ACTIVE eq 0) then begin
            Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
            ;**************************************************
            firstimg_foffset=strip_info.firstimg_foffset
            lastimg_foffset =strip_info.lastimg_foffset
            ave_info=strip_info.ave_info
            ;**********************************************************************************
            ;*******************************************************************************
            Hsubindex=*(ave_info.Hsubindex)
            nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
            Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
            L1size_array=(*alldataH)(Hsubindex).Nslice

            foffset=!Foffset
            ;get the new offset
            index=where(Hsub_foffset le foffset,number_left)
            if number_left ne 0 then begin
                foffsets_array=reverse(Hsub_foffset(index))
                L1size_array =reverse(L1size_array(index))
                ;find the first particle file_offset and then re-order them
                yoffset=0
                nnn=n_elements(L1size_array) < 500
                for i=0, nnn-1 do begin
                    yoffset=yoffset+L1size_array(i)+1
                    if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                        foffset=foffsets_array(i)
                        break
                    endif; ;end of if yoffset ge
                endfor
            endif else foffset=firstimg_foffset
            ;finished getting the new start offset
            ;***************************************************************************************
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,-1,'H')

            if !FOFFSET le firstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF Zoomed Period REACHED"
                !REWIND_ACTIVE = 1
                widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
                WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
                WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
                WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED
            endelse
            Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
        endif
    endif else begin
        Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
        ;**************************************************
        firstimg_foffset=strip_info.firstimg_foffset
        lastimg_foffset =strip_info.lastimg_foffset
        ave_info=strip_info.ave_info
        ;**********************************************************************************
        ;*******************************************************************************
        Hsubindex=*(ave_info.Hsubindex)
        nnnn=n_elements(Hsubindex);  there are total of nnnn particles to be displayed.
        Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
        L1size_array=(*alldataH)(Hsubindex).Nslice

        foffset=!Foffset
        ;get the new offset
        index=where(Hsub_foffset le foffset,number_left)
        if number_left ne 0 then begin
            foffsets_array=reverse(Hsub_foffset(index))
            L1size_array =reverse(L1size_array(index))
            ;find the first particle file_offset and then re-order them
            yoffset=0
            nnn=n_elements(L1size_array) < 500
            for i=0, nnn-1 do begin
                yoffset=yoffset+L1size_array(i)+1
                if (yoffset ge !STRIP_WIDTH or i eq nnn-1) then begin
                    foffset=foffsets_array(i)
                    break
                endif; ;end of if yoffset ge
            endfor
        endif else foffset=firstimg_foffset
        ;finished getting the new start offset
        ;***************************************************************************************
        if (!REWIND_ACTIVE eq 1) then begin
            !REWIND_ACTIVE = 0
            widget_control, event.ID, SET_VALUE = 'RRon.bmp', /BITMAP
            WIDGET_CONTROL, event.ID, TIMER= !PLAYBACK_SPEED

            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=0
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=0

            ; foffset = !FOFFSET
            newoffset = Fill_averaged_Strip(foffset, ave_info,strip_info,-1,'H')

            if !FOFFSET le firstimg_foffset then begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= "BEGINNING OF Zoomed Period REACHED"
            end else begin
                WIDGET_CONTROL ,strip_info.stripLabel ,SET_VALUE= ""
            endelse
        endif else begin
            !REWIND_ACTIVE = 1
            widget_control, event.ID, SET_VALUE = 'RR.bmp', /BITMAP
            WIDGET_CONTROL, strip_info.SSR_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.SSF_button, SENSITIVE=1
            WIDGET_CONTROL, strip_info.FF_button, SENSITIVE=1
        endelse
        Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
    endelse
end  ; end of zoomplay_reverse_timer_event, event



function raster_line, inx0, iny0, inx1, iny1, length=length
    ; implements Bresenham's line algorithm for drawing a raster line between two points
    ; returns an integer array 2 x length, with the coordinates of each point forming the line
    ; x0, y0 to x1, y1

    ;   for the 1st octant, down to the right and x0<=x1, y0<=y1, and x1-x0 > y1-y0

    ;    dx := abs(x1-x0)
    ;    dy := abs(y1-y0)

    ;    if x0 < x1 then sx := 1 else sx := -1
    ;    if y0 < y1 then sy := 1 else sy := -1

    ;    err := dx-dy

    ;    loop
    ;        setPixel(x0,y0)

    ;        if x0 = x1 and y0 = y1 exit loop

    ;        e2 := 2*err

    ;        if e2 > -dy then
    ;            err := err - dy
    ;            x0 := x0 + sx
    ;        end if

    ;        if e2 <  dx then
    ;            err := err + dx
    ;            y0 := y0 + sy
    ;        end if
    ;    end loop

    ; Note, the default line is set to intarr[2,2000], based on 128 pixels, and 1000 slices max
    ; (128^2 + 1000^2)^.5 = 1008.1587


    length_default = 2000


    x0 = inx0
    y0 = iny0
    x1 = inx1
    y1 = iny1

    if(not keyword_set(length)) then length = 0

    if(x0 eq x1 and y0 eq y1) then begin
        ; 1st case: x0 = x1 and y0 = y1
        ; return a single point

        length = 1
        line = [x0, y1]
    endif else if(x0 eq x1 and y0 ne y1) then begin
        ; 2nd case: x0 = x1 and y0 != y1
        ; return a vertical line

        if(y0 gt y1) then begin
            length = y0 - y1 + 1

            line = intarr(2, length)

            line[0, *] = x0
            line[1, *] = indgen(length) + y1
        endif else begin ; y1 < y0
            length = y1 - y0 + 1

            line = intarr(2, length)

            line[0, *] = x0
            line[1, *] = indgen(length) + y0
        endelse
    endif else if(x0 ne x1 and y0 eq y1) then begin
        ; 3nd case: x0 != x1 and y0 = y1
        ; return a horizontal line

        if(x0 gt x1) then begin
            length = x0 - x1 + 1

            line = intarr(2, length)

            line[0, *] = indgen(length) + x1
            line[1, *] = y0
        endif else begin ; x1 < x0
            length = x1 - x0 + 1

            line = intarr(2, length)

            line[0, *] = indgen(length) + x0
            line[1, *] = y0
        endelse
    endif else begin
        dx = abs(x1 - x0)
        dy = abs(y1 - y0)

        if(x0 lt x1) then sx = 1 else sx = -1
        if(y0 lt y1) then sy = 1 else sy = -1

        err = dx - dy

        line = intarr(2, length_default)

        for i=0, length_default-1 do begin
            line[0, i] = x0
            line[1, i] = y0

            if(x0 eq x1 and y0 eq y1) then break

            e2 = 2 * err

            if(e2 gt -dy) then begin
                err = err - dy
                x0 = x0 + sx
            endif

            if(e2 lt dx) then begin
                err = err + dx
                y0 = y0 + sy
            endif
        endfor

        length = i+1
        line = line[*, 0:i]
    endelse

    return, line
end ; raster_line


; input the first particle index; that converted to foffset.
; output the last particle index; that converted to the new_file_offset.
; if the input output file offset falls outsize the ave_start and end offset
; then ;stop filling and output message that the end of the period is reached.
Function Fill_averaged_strip, foffset, ave_info, strip_info, direction, HorV

    Common  DataBlock, alldataH, alldataV, ADataH, ADataV, FirstData, LastData, StripData, $
        FirstDataV, LastDataV, StripDataV, OneHzH, OneHzV, aveStripdata, aveStripdataV


    if(HorV eq 'H') then begin
        aveStripData = REPLICATE({_DerivedDataRev2},!STRIP_WIDTH)
        subindex     = *(ave_info.Hsubindex)
        nnnn         = n_elements(subindex) ; there are total of nnnn particles to be displayed
        sub_foffset       = (*alldataH)(subindex).imageoffset
        L1size_array      = (*alldataH)(subindex).Nslice
        imgword_array     = (*alldataH)(subindex).imageWords
        nanoseconds_array = (*alldataH)(subindex).nanoseconds
        CPI_trigger_array = (*alldataH)(subindex).CPI_trigger
        PartID_array      = (*alldataH)(subindex).PartID
    endif

    if(HorV eq 'V') then begin
        aveStripDataV = REPLICATE({_DerivedDataRev2},!STRIP_WIDTH)
        subindex      = *(ave_info.Vsubindex)
        nnnn          = n_elements(subindex) ; there are total of nnnn particles to be displayed
        sub_foffset       = (*alldataV)(subindex).imageoffset
        L1size_array      = (*alldataV)(subindex).Nslice
        imgword_array     = (*alldataV)(subindex).imageWords
        nanoseconds_array = (*alldataV)(subindex).nanoseconds
        CPI_trigger_array = (*alldataV)(subindex).CPI_trigger
        PartID_array      = (*alldataV)(subindex).PartID
    endif

    firstimage_foffset = sub_foffset(0)
    lastimage_foffset = sub_foffset(nnnn-1)

    if(direction eq 0) then begin
        index = where(sub_foffset ge !START_FOFFSET, number_left)
        foffsets_array    =       sub_foffset(index)
        L1size_array      =      L1size_array(index)
        imgword_array     =     imgword_array(index)
        nanoseconds_array = nanoseconds_array(index)
        CPI_trigger_array = CPI_trigger_array(index)
        PartID_array      =      PartID_array(index)
        use_index = subindex(index)
    endif else begin
        if(foffset eq -1) then begin
            foffset           = firstimage_foffset
            number_left       = nnnn < 500 ; number of particles left need to be displayed.
            foffsets_array    =       sub_foffset(0:number_left-1)
            L1size_array      =      L1size_array(0:number_left-1)
            imgword_array     =     imgWord_array(0:number_left-1)
            nanoseconds_array = nanoseconds_array(0:number_left-1)
            CPI_trigger_array = CPI_trigger_array(0:number_left-1)
            PartID_array      =      PartID_array(0:number_left-1)
            use_index         =          subindex(0:number_left-1)
        endif else begin
            index             = where(sub_foffset ge foffset, number_left)

            foffsets_array    =       sub_foffset(index)
            L1size_array      =      L1size_array(index)
            imgword_array     =     imgword_array(index)
            nanoseconds_array = nanoseconds_array(index)
            CPI_trigger_array = CPI_trigger_array(index)
            PartID_array      =      PartID_array(index)
            use_index         =          subindex(index)
        endelse

        !START_FOFFSET = foffset
    endelse

    if(number_left le 0) then begin
        return, lastimage_foffset    ; 1; no particles left to be displayed.
    endif

    ; if  direction = 1, then scan forward, if -1, then backward
    ; Handle Rewind
    ;  Reposition the foffset from the current position so that
    ;  we fill the strip with the last particle as the one currently
    ;  pointed to.

    if(direction eq -1) then reverse_foffset = foffset

    ; create a filename that is one directory above the Data file's horizyymmddhhmmss.bin that was selected above
    ; Here it doesn't matter what the current file is because we will always have a horiz filename at this point to work with
    ;fname = strmid(!currentHPname,0,strlen(!currentHPname)-5) + 'SORTED' +   strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,12) + '.2DS'
    ; substrsF=strsplit(!currentHFname,'\',/extract)
    ; short_filename=substrsF(n_elements(substrsF)-1)
    ; datestamp = strmid(Short_filename,5,strlen(Short_filename)-9)
    ; fname = strmid(!currentHPname,0,strlen(!currentHPname)-5) + 'SORTED' + datestamp+ '.2DS'

    file_chars_to_remove = 4

    my_str1=strmid(!currentHPname, 0,strlen(!currentHPname)-1);   that is the C:\****\data1  for example
    my_pos =strpos(my_str1,'\',/reverse_search); get upper directory of data1.
    fname=strmid(my_str1,0,my_pos+1)+'SORTED'
    horzname=strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,strlen(!currentHFname))
    ;horzname=strmid(!currentHFname,strpos(!currentHFname,"horiz")+8,strlen(!currentHFname))
    datetime=strmid(horzname,0,strlen(horzname)-file_chars_to_remove)
    ;fname=fname+datetime+'.2DS';   get the sorted****.2ds full name.
    fname=fname+datetime+'.2DSCPI';   get the sorted****.2ds full name.
    OpenR, lun, fname, /Get_Lun

    ; draw the graph in the Strip Widget
    if(HorV eq 'H') then begin
        Widget_Control, strip_info.stripID,  Get_Value = wid
    endif

    if(HorV eq 'V') then begin
        Widget_Control, strip_info.VstripID, Get_Value = wid
    endif

    WSet, wid

    erase,color='ffffff'x  ; get background to white

    ; Initialize our variables for the display
    yoffset = 0
    firstnano = 0ULL
    lastnano = 0ULL
    strip_index = 0U

    FOR i=0U, number_left-1 DO BEGIN  ; the number_left is not neccessary equal to n_elements(stripdata(*)).
        ; added this part on april. 20, 2009
        ;  Catch, onError
        ;   IF onError NE 0 THEN BEGIN
        ;      Catch, /Cancel
        ;      result = Error_Message(Traceback=1)
        ;      RETURN,foffset
        ;   ENDIF

        if (L1size_array(i) GT 0) then begin  ;------------------ ; at begining yoffset=0, as it goes, yoffset increases.
            if(firstnano eq 0ULL) then firstnano = Nanoseconds_array(i)
            if(((yoffset + L1size_array(i) + 1) GT !STRIP_WIDTH) and (i lt number_left-1)) then begin  ;util yoffset reached teh stripwidth.
                lastnano =Nanoseconds_array(i)
                foffset =foffsets_array(i+1)
                ;  i = uint(number_left + 100) ; this stops teh for loop.
                !FOFFSET = foffset
                break
            end else begin ; only fill up to the top of the strip

                ;Slices = L1size_array(i)
                ;WordCount = ImgWord_array(i)

                ;Image = BytArr(WordCount * 2)

                ;POINT_LUN, lun, fOffsets_array(i)
                ;ReadU, lun, Image

                ;out_array = bytarr(16L * Slices)
                ;out_byte_array = BytArr(128L, Slices)

                ;HSums=intarr(Slices)

                ;HMax  = 0
                ;Area = 0UL
                ;Midpoint = 0
                ;Edges = 0
                ;L3 = 0.0
                ;L4 = 0.0
                ;L5 = 0.0
                ;PC3x = 0.0
                ;PC3y = 0.0
                ;PC4x = 0.0
                ;PC4y = 0.0
                ;A3 = 0.0
                ;CPI_trigger = CPI_trigger_array[i]
                ;PartID = PartID_array[i]

                ;Err=0

                ;ProcessParticle,  Image, HSums, out_array, out_byte_array, Wordcount, Slices,  HMax, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3


                WordCount = ImgWord_array(i)
                Slices    =  L1size_array(i)

                Image_data = BytArr(WordCount * 2)

                POINT_LUN, lun, fOffsets_array(i)
                ReadU, lun, Image_data

                ;out_array      = bytarr(16L * Slices)
                out_byte_array = BytArr(128L, Slices)

                HSums=intarr(slices)
                HMax  = 0
                Area = 0UL
                Midpoint = 0
                Edges = 0
                L3 = 0.0
                L4 = 0
                L5 = 0
                PC3x = 0.0
                PC3y = 0.0
                PC4x = 0.0
                PC4y = 0.0
                A3 = 0.0
                Roundness1 = 0.0
                Roundness2 = 0.0
                Roundness3 = 0.0
                L1r = 0.0
                maxLength = 0.0
                maxWidth  = 0.0
                perimeter = 0UL
                perimeterum = 0.
                csp = 0.
                num_satellites = 0.
                largest_satellite_area = 0.
                Err=0

                ml_p1x = 0
                ml_p1y = 0
                ml_p2x = 0
                ml_p2y = 0
                mw_p1x = 0
                mw_p1y = 0
                mw_p2x = 0
                mw_p2y = 0

                perimeter_points_x = intarr(128L*Slices)
                perimeter_points_y = intarr(128L*Slices)


                ProcessParticle, Image_data, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
                    L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, $
                    ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
                    perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y, num_satellites=num_satellites, HorV=HorV, largest_satellite_area=largest_satellite_area


                ; recolor CPI_trigger particles for display

                CPI_trigger = CPI_trigger_array[i]
                PartID = PartID_array[i]

                ; recolor the CPI trigger particles

                ;CPI_trigger_color_index = 140

                aa = where(out_byte_array ne 255, aacount, complement=bb)

                if(aa(0) ne -1) then begin ; TAF what is -1 a flag for again?
                    ;if(CPI_trigger) then begin
                    ;out_byte_array(aa) = 55 ; deep blue for CPI trigger
                    ;    out_byte_array(aa) = CPI_trigger_color_index ; bright green for CPI trigger
                    ;stop
                    ;endif else begin
                    out_byte_array(aa) = 0
                    ;endelse
                endif


                Catch, onError
                IF onError NE 0 THEN BEGIN
                    Catch, /Cancel
                    result = Error_Message(Traceback=1)
                    print, ''
                    print, "caught error in a3vcpiview_zoomedHstrip.pro after swapping values"
                    print, ''
                    ;stop
                ENDIF


                ;****************************************************
                Catch, onError
                IF onError NE 0 THEN BEGIN
                    Catch, /Cancel
                    result = Error_Message(Traceback=1)
                    print, "caught error in a3vcpiview_zoomedHstrip.pro"
                    ;print, "catch", HSums
                    ;stop

                    ;Hsums=0
                ENDIF

                ;print, "no catch", HSums
                ;Hsums=0

                ;make a color display of the images



                ;******************************************************
                if(HorV eq 'H') then begin
                    if((*alldataH)(use_index(i)).reject ge 1) then begin
                        yy = rotate(out_byte_array, !IMAGE_ROTATION);        ; change 1 to 4 will switch leading andtail, y-don't change.
                        nm=size(yy,/dimension)
                        colorimage=bytarr(3,nm(0),nm(1))
                        colorimage(0,*,*)=255
                        colorimage(1,*,*)=yy;; colorimage(2,*,*)=0

                        loadct, !ct_2DS, /silent

                        tv,colorimage,yoffset,0,true=1
                    endif else begin
                        white_index = where(out_byte_array eq 255, white_count)


                        if(slices gt 1) then begin
                            nm = size(out_byte_array, /dimension)
                        endif else begin
                            nm = [!PIXELS, 1]
                        endelse

                        colorimage = bytarr(3, nm[0], nm[1])
                        colorimage[*] = 255

                        rplane = out_byte_array
                        gplane = out_byte_array
                        bplane = out_byte_array

                        if(CPI_trigger and aacount gt 0) then begin
                            rplane[aa] = 0
                            gplane[aa] = 255 ; green cyan
                            bplane[aa] = 128
                        endif

                        if((!showperimeterH) and (white_count gt 0) and (Area gt 1) and (slices gt 1)) then begin


                            if(perimeter gt 0) then begin
                                ; for 3V-CPI inverted images, temporarily invert the perimeter

                                ;rplane[127 - perimeter_points_x[0:perimeter-1], Slices-perimeter_points_y[0:perimeter-1]-1] = 205 ; dim magenta
                                ;gplane[127 - perimeter_points_x[0:perimeter-1], Slices-perimeter_points_y[0:perimeter-1]-1] =   0
                                ;bplane[127 - perimeter_points_x[0:perimeter-1], Slices-perimeter_points_y[0:perimeter-1]-1] = 205

                                rplane[perimeter_points_x[0:perimeter-1], perimeter_points_y[0:perimeter-1]] = 205 ; dim magenta
                                gplane[perimeter_points_x[0:perimeter-1], perimeter_points_y[0:perimeter-1]] =   0
                                bplane[perimeter_points_x[0:perimeter-1], perimeter_points_y[0:perimeter-1]] = 205
                            endif

                            ;                            ; draw the max length points
                            ;                            rplane[ml_p1x, Slices-ml_p1y-1] =  40 ; blueish
                            ;                            gplane[ml_p1x, Slices-ml_p1y-1] = 126
                            ;                            bplane[ml_p1x, Slices-ml_p1y-1] = 255

                            ;                            rplane[ml_p2x, Slices-ml_p2y-1] =  40 ; blueish
                            ;                            gplane[ml_p2x, Slices-ml_p2y-1] = 126
                            ;                            bplane[ml_p2x, Slices-ml_p2y-1] = 255


                            ; draw a line along the length
                            length_line = raster_line(ml_p1x, ml_p1y, ml_p2x, ml_p2y)

                            ;rplane[length_line[0,*], Slices-length_line[1,*]-1] =  40 ; blueish
                            ;gplane[length_line[0,*], Slices-length_line[1,*]-1] = 126
                            ;bplane[length_line[0,*], Slices-length_line[1,*]-1] = 255

                            rplane[length_line[0,*], length_line[1,*]] =  40 ; blueish
                            gplane[length_line[0,*], length_line[1,*]] = 126
                            bplane[length_line[0,*], length_line[1,*]] = 255


                            ;                            ; draw the max width points
                            ;                            rplane[mw_p1x, Slices-mw_p1y-1] =  87 ; greenyellow
                            ;                            gplane[mw_p1x, Slices-mw_p1y-1] = 228
                            ;                            bplane[mw_p1x, Slices-mw_p1y-1] =  27

                            ;                            rplane[mw_p2x, Slices-mw_p2y-1] =  87 ; greenyellow
                            ;                            gplane[mw_p2x, Slices-mw_p2y-1] = 228
                            ;                            bplane[mw_p2x, Slices-mw_p2y-1] =  27

                            ; draw a line along the width
                            width_line = raster_line(mw_p1x, mw_p1y, mw_p2x, mw_p2y)

                            ;rplane[width_line[0,*], Slices-width_line[1,*]-1] =  87 ; greenyellow
                            ;gplane[width_line[0,*], Slices-width_line[1,*]-1] = 228
                            ;bplane[width_line[0,*], Slices-width_line[1,*]-1] =  27

                            rplane[width_line[0,*], width_line[1,*]] =  87 ; greenyellow
                            gplane[width_line[0,*], width_line[1,*]] = 228
                            bplane[width_line[0,*], width_line[1,*]] =  27


                        endif
                        ;tv, ROTATE(out_byte_array, !IMAGE_ROTATION), yoffset, 0;; change 1 to 4 will swith leading andtail, y-don't change.

                        colorimage(0,*,*) = rplane
                        colorimage(1,*,*) = gplane
                        colorimage(2,*,*) = bplane

                        colorimage2 = bytarr(3, nm[1], nm[0])

                        colorimage2[0, *, *] = rotate(reform(colorimage[0, *, *]), !IMAGE_ROTATION)
                        colorimage2[1, *, *] = rotate(reform(colorimage[1, *, *]), !IMAGE_ROTATION)
                        colorimage2[2, *, *] = rotate(reform(colorimage[2, *, *]), !IMAGE_ROTATION)

                        loadct, !ct_2DS, /silent

                        tv, colorimage2, yoffset, 0, true = 1


                    endelse
                endif else if(HorV eq 'V') then begin
                    if((*alldataV)(use_index(i)).reject ge 1) then begin
                        yy = rotate(out_byte_array, !IMAGE_ROTATION)
                        nm=size(yy,/dimension)
                        colorimage=bytarr(3,nm(0),nm(1))
                        colorimage(0,*,*)=255
                        colorimage(1,*,*)=yy;; colorimage(2,*,*)=0

                        loadct, !ct_2DS, /silent

                        tv,colorimage,yoffset,0,true=1
                    endif else begin
                        white_index = where(out_byte_array eq 255, white_count)

                        if(slices gt 1) then begin
                            nm = size(out_byte_array, /dimension)
                        endif else begin
                            nm = [!PIXELS, 1]
                        endelse

                        colorimage = bytarr(3, nm[0], nm[1])
                        colorimage[*] = 255

                        rplane = out_byte_array
                        gplane = out_byte_array
                        bplane = out_byte_array

                        if(CPI_trigger and aacount gt 0) then begin
                            rplane[aa] = 0
                            gplane[aa] = 255 ; green cyan
                            bplane[aa] = 128
                        endif

                        if((!showperimeterV) and (white_count gt 0) and (Area gt 1) and (slices gt 1)) then begin

                            if(perimeter gt 0) then begin
                                ; for 3V-CPI inverted images, temporarily invert the perimeter

                                ;rplane[127 - perimeter_points_x[0:perimeter-1], Slices-perimeter_points_y[0:perimeter-1]-1] = 205 ; dim magenta
                                ;gplane[127 - perimeter_points_x[0:perimeter-1], Slices-perimeter_points_y[0:perimeter-1]-1] =   0
                                ;bplane[127 - perimeter_points_x[0:perimeter-1], Slices-perimeter_points_y[0:perimeter-1]-1] = 205

                                rplane[perimeter_points_x[0:perimeter-1], perimeter_points_y[0:perimeter-1]] = 205 ; dim magenta
                                gplane[perimeter_points_x[0:perimeter-1], perimeter_points_y[0:perimeter-1]] =   0
                                bplane[perimeter_points_x[0:perimeter-1], perimeter_points_y[0:perimeter-1]] = 205
                            endif

                            ;                            ; draw the max length points
                            ;                            rplane[ml_p1x, Slices-ml_p1y-1] =  40 ; blueish
                            ;                            gplane[ml_p1x, Slices-ml_p1y-1] = 126
                            ;                            bplane[ml_p1x, Slices-ml_p1y-1] = 255

                            ;                            rplane[ml_p2x, Slices-ml_p2y-1] =  40 ; blueish
                            ;                            gplane[ml_p2x, Slices-ml_p2y-1] = 126
                            ;                            bplane[ml_p2x, Slices-ml_p2y-1] = 255


                            ; draw a line along the length
                            length_line = raster_line(ml_p1x, ml_p1y, ml_p2x, ml_p2y)

                            ;rplane[length_line[0,*], Slices-length_line[1,*]-1] =  40 ; blueish
                            ;gplane[length_line[0,*], Slices-length_line[1,*]-1] = 126
                            ;bplane[length_line[0,*], Slices-length_line[1,*]-1] = 255

                            rplane[length_line[0,*], length_line[1,*]] =  40 ; blueish
                            gplane[length_line[0,*], length_line[1,*]] = 126
                            bplane[length_line[0,*], length_line[1,*]] = 255

                            ;                            ; draw the max width points
                            ;                            rplane[mw_p1x, Slices-mw_p1y-1] =  87 ; greenyellow
                            ;                            gplane[mw_p1x, Slices-mw_p1y-1] = 228
                            ;                            bplane[mw_p1x, Slices-mw_p1y-1] =  27

                            ;                            rplane[mw_p2x, Slices-mw_p2y-1] =  87 ; greenyellow
                            ;                            gplane[mw_p2x, Slices-mw_p2y-1] = 228
                            ;                            bplane[mw_p2x, Slices-mw_p2y-1] =  27

                            ; draw a line along the width
                            width_line = raster_line(mw_p1x, mw_p1y, mw_p2x, mw_p2y)

                            ;rplane[width_line[0,*], Slices-width_line[1,*]-1] =  87 ; greenyellow
                            ;gplane[width_line[0,*], Slices-width_line[1,*]-1] = 228
                            ;bplane[width_line[0,*], Slices-width_line[1,*]-1] =  27

                            rplane[width_line[0,*], width_line[1,*]] =  87 ; greenyellow
                            gplane[width_line[0,*], width_line[1,*]] = 228
                            bplane[width_line[0,*], width_line[1,*]] =  27
                        endif
                        ;tv, ROTATE(out_byte_array, !IMAGE_ROTATION), yoffset, 0

                        colorimage(0,*,*) = rplane
                        colorimage(1,*,*) = gplane
                        colorimage(2,*,*) = bplane

                        colorimage2 = bytarr(3, nm[1], nm[0])

                        colorimage2[0, *, *] = rotate(reform(colorimage[0, *, *]), !IMAGE_ROTATION)
                        colorimage2[1, *, *] = rotate(reform(colorimage[1, *, *]), !IMAGE_ROTATION)
                        colorimage2[2, *, *] = rotate(reform(colorimage[2, *, *]), !IMAGE_ROTATION)

                        tv, colorimage2, yoffset, 0, true = 1

                    endelse
                endif

                ; Save the pertinent data for each tick on the graph for later display
                FOR z = yoffset, (yoffset + L1size_array(i) + 1) DO BEGIN
                    if(z LT !STRIP_WIDTH) then  begin
                        if(HorV eq 'H') then aveStripData(z)  = (*alldataH)(use_index(i));   ???????
                        if(HorV eq 'V') then aveStripDataV(z) = (*alldataV)(use_index(i));   ???????
                    endif
                ENDFOR

                yoffset += L1size_array(i) + 1
                foffset = foffsets_array(i) ; allways update it utile the last particle of the strip
            endelse
        end  ; end of if L1 size gt 0  -------------------------------------------
    ENDFOR

    if (i EQ number_left) then lastnano = Nanoseconds_array(i-1)
    Close ,lun
    Free_Lun,lun

    channel_name = ""

    ;if (!CURRENT_CHANNEL EQ !H_CHART) THEN channel_name = 'Horizontal'
    ;if (!CURRENT_CHANNEL EQ !V_CHART) THEN channel_name = 'Vertical'
    if(HorV eq 'H') then begin
        channel_name = 'Horizontal'
        Widget_Control, strip_info.stripBase,  BASE_SET_TITLE = "Zoomed: Showing " + channel_name + " channel from " + SPEC_Nano2HMS(firstnano) + " to " +  SPEC_Nano2HMS(lastnano)
    endif

    if HorV eq 'V' then begin
        channel_name = 'Vertical'
        Widget_Control, strip_info.VstripBase, BASE_SET_TITLE="Zoomed: Showing " + channel_name + " channel from " + SPEC_Nano2HMS(firstnano) + " to " +  SPEC_Nano2HMS(lastnano)
    endif
    if (direction EQ -1) then !FOFFSET = reverse_foffset
    if (direction EQ 1) then !Foffset = foffset
    return, foffset
end ; end of fill_avearged_strip,offset,ave_info,info,direction, HorV



pro Generating_image_png_pages_event,event
    ;**********************************************************
    Widget_Control, event.top, Get_UValue=strip_info, /No_Copy  ; get our info structure
    ave_info=strip_info.ave_info
    output_png_images_page,ave_info,'H'
    Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
end; end of Generating_image_png_pages_event



pro output_png_images_page,ave_info,HorV, round_flag = round_flag
Common DataBlock,alldataH,alldataV

if(not keyword_set(round_flag)) then begin
    round_flag = -1
endif

strip_height=128; pixels
;start_a new page.
start_a_new_page,my_png_page, round_flag = round_flag
subfile_str=strsplit(!currentHFname,'\',/extract)
plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)
year='20'+strmid(plot_string2,5,2)
month=strmid(plot_string2,7,2)
;day=strmid(plot_string2,9,2)
if !Time_synced gt 0 then begin
    day=strmid(plot_string2,9,2)+'TimeSynced'
endif else begin
    day=strmid(plot_string2,9,2)
endelse

date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

;criteria='On this Day 2DS Time offset is 17 hours.  reject eq 0'
criteria = 'accepted images '

if strlen((ave_info.criteria).text) lt 4 then begin
    criteria=criteria+' and imgs are at least'+ trim(!Dt)+' second apart in time'
endif else begin
    criteria='reject eq 0 and '+(ave_info.criteria).text+' and imgs are at least '+ $
        trim(!Dt)+' second apart in time'
endelse


;if !Dt eq 0.0 then criteria=' reject eq 0 and all images'
if !Dt eq 0.0 then criteria='All Accepted Images.'+' Time Offset '+strtrim(string(!TDS_time_offset),2)+'s Has Been Added to its Original Time'

title=date_time_string +' '+HorV+' '+criteria
TimeText = OBJ_NEW('IDLgrText',title,$
    LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
    FONT=my_png_page.Font)
my_png_page.Model->Add,timeText

; draw top line
my_png_page.currentY=my_png_page.currentY-3

myline=bytarr(612,2); x-ength is 2400, height is 2 pixels
image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
    0,my_png_page.currentY,0], ORDER=0)
my_png_page.Model->Add, image

;ready for drawing images.
my_png_page.currentY=my_png_page.currentY-strip_height-3

if HorV eq 'H' then begin
    subindex=*(ave_info.Hsubindex)
    nanoseconds=(*alldataH)(subindex).nanoseconds
endif else begin
    subindex=*(ave_info.Vsubindex)
    nanoseconds=(*alldataV)(subindex).nanoseconds;   so that each image's time can compared
endelse

;The current second in time.
Current_nano_second=nanoseconds(0); remember this for later to use.

nnn=n_elements(subindex)
done=0
count=0L
kkk=0
count50=0L;  added this for TC4 archive only first few images of the second.
while done eq 0 do begin
    this_index=subindex(kkk)
    get_a_image_and_text,HorV,this_index,dimg,dispsize,my_text_string,my_nanoseconds

    This_nano_second=my_nanoseconds
    count=count+1;  count of particles that are accepted for the line, some of them are not shown.
    if (This_nano_second -current_nano_second) lt !Dt*1000000000.0 then begin;  this particle is too close to the one showed, skip this particle
        goto, Skip_to_this_place;  50 is the images to keep in each second.
    endif
    ;***************************************************************************************
    ;show this particle to the png page
    current_nano_second=my_nanoseconds
    count50=count50+1;  ; count of particles shown in this line.
    image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[$
        my_png_page.currentX,my_png_page.currentY,0], ORDER=0);,interpolate=1) don't do the interp
    my_png_page.Model->Add, image

    if my_png_page.currentX lt 1 then begin; add text if a new strip.
        TimeText_1 = my_text_string
        TimeText_1_time =This_nano_second+!TDS_time_offset*1000000000LL
        if my_png_page.currentY gt my_png_page.pageDY-150 then time0=timetext_1
    endif
    my_png_page.currentX=my_png_page.currentX+dispsize(0)+1

    if my_png_page.currentX gt 600 and my_png_page.currentY gt 40 then begin; add time stamp at end and begin a new line
        TimeText_2 =my_text_string;                         ;get 478 only give one page.
        TimeText_2_time =This_nano_second+!TDS_time_offset*1000000000LL
        TimeText_2 =TimeText_2 +'-----Total/shown:  '+strtrim(string(count),2)+'/'+strtrim(string(count50),2)
        ; reset the counts  since the line is finished.
        count50=0L
        count=0L

        my_png_page.currentX=0
        my_png_page.currentY=my_png_page.currentY-3; ready fo rdrawing bottom line.



        ;draw bottom line
        myline=bytarr(612,2); heiht is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image

        ;draw the text1 and text 2 string below the bottom line.
        my_png_page.currentY=my_png_page.currentY-10
        timeText= OBJ_NEW('IDLgrText','Time: from'+timetext_1+$
            '------ to ------'+timetext_2,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)

        my_png_page.Model->Add, timetext

        ;if there are still space to draw another strip of images then do drawing the to line.
        ;if my_png_page.currentY gt 10+strip_height+14+60 then begin
        ;draw top line now for next strip
        my_png_page.currentY=my_png_page.currentY-3
        myline=bytarr(612,2);  must be 2 pixels.  2 or three dimsensions of images allowed.
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image
        my_png_page.currentY=my_png_page.currentY-strip_height-3; ready for image drawing now.
        ;endif
    endif

    if my_png_page.currentY lt 50 then begin; get a new page and save the current page.

        ;show and save the current page
        OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        output3 ->draw,my_png_page.view;   show the vieto the screen.
        wait,0.1
        ;save the view to a file
        output2 ->draw,my_png_page.view;   Put the view wto the Buffer.

        SaveWndToFile2ds,OutPut2,time0,timetext_2,HorV, round_flag = round_flag

        ;destroy the view foe geneating the new view
        OBJ_DESTROY,my_png_page.View
        OBJ_DESTROY,output3
        OBJ_DESTROY,output2


        ;start a new page
        start_a_new_page,my_png_page, round_flag = round_flag
        subfile_str=strsplit(!currentHFname,'\',/extract)
        plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)
        year='20'+strmid(plot_string2,5,2)
        month=strmid(plot_string2,7,2)
        if !Time_synced gt 0 then begin
            day=strmid(plot_string2,9,2)+'TimeSynced.'
        endif else begin
            day=strmid(plot_string2,9,2)
        endelse
        date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

        ;criteria='On this day 2DS time offset is 17 hours. reject eq 0'
        criteria = 'accepted images'

        if strlen((ave_info.criteria).text) lt 4 then begin
            criteria=criteria+' and imgs are at least'+ trim(!Dt)+' second apart in time'
        endif else begin
            criteria='reject eq 0 and '+(ave_info.criteria).text+' and imgs are at least '+ $
                trim(!Dt)+' second apart in time'
        endelse

        ;if !Dt eq 0.0 then criteria=' reject eq 0 and all images'
        if !Dt eq 0.0 then criteria='Accepted Images.'+' Time Offset '+strtrim(string(!TDS_time_offset),2)+'s Has Been Added to its Original Time'


        title=date_time_string +' '+HorV+' '+criteria
        TimeText = OBJ_NEW('IDLgrText',title,$
            LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)
        my_png_page.Model->Add,timeText

        ; draw top line
        my_png_page.currentY=my_png_page.currentY-3

        myline=bytarr(612,2); x-ength is 2400, heiht is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY], ORDER=0,interpolate=1)
        my_png_page.Model->Add, image
        ;ready for drawing images.
        my_png_page.currentY=my_png_page.currentY-strip_height-3
        ;add the readed images adn take a note the starttime strin
        ;*******************************************************
        ;TimeText_1 = my_text_string
        ;time0=timetext_1
        ; my_png_page.currentX=my_png_page.currentX+dispsize(0)+1
        ;********************************************************
    endif

    Skip_to_this_place:; do nothing

    if (kkk eq nnn-1L)  then begin
        ; show and save this last page as a new page and display the page.
        ;draw bottom line
        my_png_page.currentY=my_png_page.currentY-3
        myline=bytarr(612,2); x-ength is 612, heiht is 2 pixels
        image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
            0,my_png_page.currentY,0], ORDER=0)
        my_png_page.Model->Add, image

        my_png_page.currentY=my_png_page.currentY-10
        ;draw the text1 and text 2 string below the bottom line.
        timetext_2=my_text_string
        TimeText_2_time =This_nano_second+!TDS_time_offset*1000000000LL;   ;get 478 only give one page.
        TimeText_2 =TimeText_2 +'-----Total/shown:  '+strtrim(string(count),2)+'/'+strtrim(string(count50),2)
        ; reset the counts  since the line is finished.
        count50=0L
        count=0L

        ; TAF sometimes we get Variable is undefined: TIMETEXT_1 here during png processing
        timeText= OBJ_NEW('IDLgrText','Time: from '+timetext_1+$
            '------ to ------'+timetext_2,$
            LOCATION=[20,my_png_page.currentY], COLOR=[0,0,0],$
            FONT=my_png_page.Font)

        my_png_page.Model->Add, timetext

        OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
        output3 ->draw,my_png_page.view;   show teh view to the screen.
        wait,0.1
        ;save the view to a file
        output2 ->draw,my_png_page.view;   show the view to the Buffer.

        SaveWndToFile2ds,OutPut2,time0,timetext_2,HorV, round_flag = round_flag

        ;destroy the view foe geneating the new view
        OBJ_DESTROY,my_png_page.View
        OBJ_DESTROY,output3
        OBJ_DESTROY,output2
    endif

    if (kkk eq nnn-1)  then done =1

    kkk=kkk+1LL

endwhile
heap_gc




;   ave_info=strip_info.ave_info
;   output_png_images_page,ave_info,'H'
;  Widget_Control, event.top, Set_UValue=strip_info, /No_Copy  ; release our info structure
;end; end of Generating_image_png_pages_event

;pro output_png_images_page,ave_info,HorV
;   Common DataBlock,alldataH,alldataV

;   strip_height=128; pixels
;  ;start_a new page.
;   start_a_new_page,my_png_page
;   subfile_str=strsplit(!currentHFname,'\',/extract)
;       plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)
;       year='20'+strmid(plot_string2,5,2)
;       month=strmid(plot_string2,7,2)
;       day=strmid(plot_string2,9,2)
;       date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

;   ;criteria='On this Day 2DS Time offset is 17 hours.  reject eq 0'
;   criteria=' reject eq 0'

;if !autoarchive_png_only eq 1 then begin
; criteria=criteria+' and '+ strtrim(string(!N_images_Per_second_to_output),2)+' images per second at most'
; endif else begin
; criteria=criteria+' and '+(ave_info.criteria).text+' and first'+ $
;   strtrim(string(!N_images_Per_second_to_output),2)+' images per second at most'
;     endelse

;   if strlen((ave_info.criteria).text) lt 4 then begin
;    criteria=criteria+' and '+ strtrim(string(!N_images_Per_second_to_output),2)+' images per second at most'
;   endif else begin
;        criteria='reject eq 0 and '+(ave_info.criteria).text+' and first'+ $
;                strtrim(string(!N_images_Per_second_to_output),2)+' images per second at most'
;         endelse


;   if !N_images_per_second_to_output eq 1000000000LL then criteria=' reject eq 0'

;   title=date_time_string +' '+HorV+' '+criteria
;   TimeText = OBJ_NEW('IDLgrText',title,$
;              LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
;              FONT=my_png_page.Font)
;  my_png_page.Model->Add,timeText

;  ; draw top line
;  my_png_page.currentY=my_png_page.currentY-3

;  myline=bytarr(612,2); x-ength is 2400, height is 2 pixels
;  image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
;            0,my_png_page.currentY,0], ORDER=0)
;  my_png_page.Model->Add, image

;ready for drawing images.
;  my_png_page.currentY=my_png_page.currentY-strip_height-3

;  if HorV eq 'H' then begin
;  subindex=*(ave_info.Hsubindex)
;  nanoseconds=(*alldataH)(subindex).nanoseconds
;  endif else begin
;         subindex=*(ave_info.Vsubindex)
;          nanoseconds=(*alldataV)(subindex).nanoseconds;   so that each image's time can compared
;        endelse

;The current second in time.
;   Current_second=nanoseconds(0)/1000000000LL; remember this for later to use.

;  nnn=n_elements(subindex)
;  done=0
;  count=0
;  kkk=0
;                  count50=0;  added this for TC4 archive only first few images of the second.
;  while done eq 0 do begin
;    this_index=subindex(kkk)
;   get_a_image_and_text,HorV,this_index,dimg,dispsize,my_text_string,my_nanoseconds
;   ;**************************************************************************************
; if 1 eq 1 then begin;   added a few lines in here to output the first 50 images of the second.
;      This_second=my_nanoseconds/1000000000LL
;         if This_second gt current_second then begin
;          count50=0
;          current_second=This_second
;         endif
;      count50=count50+1

; if !AutoArchive_png_only eq 1 and  count50 gt !N_images_Per_Second_to_output then $
; goto, Skip_to_this_place;  50 is the images to keep in each second.

;     if count50 gt !N_images_Per_Second_to_output then $
;     goto, Skip_to_this_place;  50 is the images to keep in each second.
;endif
;***************************************************************************************

;   image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[$
;            my_png_page.currentX,my_png_page.currentY,0], ORDER=0);,interpolate=1) don't do the interp
;   my_png_page.Model->Add, image

;   if my_png_page.currentX lt 1 then begin; add text if a new strip.
;      TimeText_1 = my_text_string
;      if my_png_page.currentY gt my_png_page.pageDY-150 then time0=timetext_1
;   endif
;   my_png_page.currentX=my_png_page.currentX+dispsize(0)+1

;   if my_png_page.currentX gt 600 and my_png_page.currentY gt 40 then begin; add time stamp at end and begin a new line
;     TimeText_2 =my_text_string;                         ;get 478 only give one page.
;     my_png_page.currentX=0
;     my_png_page.currentY=my_png_page.currentY-3; ready fo rdrawing bottom line.

;draw bottom line
;    myline=bytarr(612,2); heiht is 2 pixels
;    image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
;            0,my_png_page.currentY,0], ORDER=0)
;     my_png_page.Model->Add, image

;draw the text1 and text 2 string below the bottom line.
;    my_png_page.currentY=my_png_page.currentY-10
;    timeText= OBJ_NEW('IDLgrText','Time: from'+timetext_1+$
;              '---------------- to -------------'+timetext_2,$
;              LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
;              FONT=my_png_page.Font)

;    my_png_page.Model->Add, timetext

;if there are still space to draw another strip of images then do drawing the to line.
;if my_png_page.currentY gt 10+strip_height+14+60 then begin
;draw top line now for next strip
;    my_png_page.currentY=my_png_page.currentY-3
;    myline=bytarr(612,2);  must be 2 pixels.  2 or three dimsensions of images allowed.
;    image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
;            0,my_png_page.currentY,0], ORDER=0)
;     my_png_page.Model->Add, image
;     my_png_page.currentY=my_png_page.currentY-strip_height-3; ready for image drawing now.
;endif
;   endif

;  if my_png_page.currentY lt 50 then begin; get a new page and save the current page.

;show and save the current page
;      OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
;      OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
;      output3 ->draw,my_png_page.view;   show teh vie wto teh screen.
;      wait,0.1
;save the view to a file
;      output2 ->draw,my_png_page.view;   Put the view wto the Buffer.

;      SaveWndToFile2ds,OutPut2,time0,timetext_2,HorV

;destroy the view foe geneating the new view
;      OBJ_DESTROY,my_png_page.View
;      OBJ_DESTROY,output3
;      OBJ_DESTROY,output2


;start a new page
;       start_a_new_page,my_png_page
;       subfile_str=strsplit(!currentHFname,'\',/extract)
;       plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)
;       year='20'+strmid(plot_string2,5,2)
;       month=strmid(plot_string2,7,2)
;       day=strmid(plot_string2,9,2)
;       date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

;criteria='On this day 2DS time offset is 17 hours. reject eq 0'
;       criteria=' reject eq 0'

;  if !autoarchive_png_only eq 1 then begin
;  criteria=criteria+' and '+ $
;          string(!N_images_Per_Second_to_output)+' images per second at most'
;  endif else begin
;  criteria=criteria+' and '+(ave_info.criteria).text+' and first '+ $
;         string(!N_images_Per_Second_to_output)+' images per second at most'
;         endelse

;       if strlen((ave_info.criteria).text) lt 4 then begin
;       criteria=criteria+' and '+ strtrim(string(!N_images_Per_second_to_output),2)+' images per second at most'
;       endif else begin
;         criteria='reject eq 0 and '+(ave_info.criteria).text+' and first'+ $
;                strtrim(string(!N_images_Per_second_to_output),2)+' images per second at most'
;        endelse


;      if !N_images_per_second_to_output eq 1000000000LL then criteria=' reject eq 0'

;       title=date_time_string +' '+HorV+' '+criteria
;       TimeText = OBJ_NEW('IDLgrText',title,$
;                  LOCATION=[10,my_png_page.currentY], COLOR=[0,0,0],$
;                  FONT=my_png_page.Font)
;      my_png_page.Model->Add,timeText

; draw top line
;      my_png_page.currentY=my_png_page.currentY-3

;      myline=bytarr(612,2); x-ength is 2400, heiht is 2 pixels
;      image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
;                0,my_png_page.currentY], ORDER=0,interpolate=1)
;      my_png_page.Model->Add, image
;ready for drawing images.
;      my_png_page.currentY=my_png_page.currentY-strip_height-3
;add the readed images adn take a note the starttime strin
;*******************************************************
;TimeText_1 = my_text_string
;time0=timetext_1
; my_png_page.currentX=my_png_page.currentX+dispsize(0)+1
;********************************************************
;   endif

;    Skip_to_this_place:; do nothing

;   if (kkk eq nnn-1L)  then begin
;    ; show and save this last page as a new page and display the page.
;draw bottom line
;    my_png_page.currentY=my_png_page.currentY-3
;    myline=bytarr(612,2); x-ength is 612, heiht is 2 pixels
;    image = OBJ_NEW('IDLgrImage', myline, /NO_COPY, DIMENSIONS=[612,2], LOCATION=[$
;            0,my_png_page.currentY,0], ORDER=0)
;     my_png_page.Model->Add, image

;    my_png_page.currentY=my_png_page.currentY-10
;draw the text1 and text 2 string below the bottom line.
;    timetext_2=my_text_string
;    timeText= OBJ_NEW('IDLgrText','Time: from '+timetext_1+$
;             '---------------- to -------------'+timetext_2,$
;             LOCATION=[20,my_png_page.currentY], COLOR=[0,0,0],$
;              FONT=my_png_page.Font)

;    my_png_page.Model->Add, timetext

;    OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
;    OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[612,792], COLOR_MODEL=1, PALETTE=Palette)
;    output3 ->draw,my_png_page.view;   show teh view to the screen.
;    wait,0.1
;save the view to a file
;    output2 ->draw,my_png_page.view;   show the view to the Buffer.

;    SaveWndToFile2ds,OutPut2,time0,timetext_2,HorV

;destroy the view foe geneating the new view
;     OBJ_DESTROY,my_png_page.View
;     OBJ_DESTROY,output3
;     OBJ_DESTROY,output2
;   endif

;   if (kkk eq nnn-1)  then done =1

;   kkk=kkk+1LL

; endwhile
; heap_gc
end; end of output_pngs_images_pages
;*****************************************************
pro start_a_new_page,my_png_page, round_flag=round_flag

    if(not keyword_set(round_flag)) then begin
        round_flag = -1
    endif

    ; Prepare fonts
    Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=12)
    Font2 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=14)
    ;Font3 = OBJ_NEW('IDLgrFont', 'Helvetica Bold',SIZE=8)
    Font3 = OBJ_NEW('IDLgrFont', 'Arial',SIZE=11)

    ; Get current color table
    TVLCT, r, g, b, /GET
    r[0] = 255
    g[0] = 255
    b[0] = 0
    Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)

    OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res
    dims=[612,792];  use 3000 will draw teh two lines added by mo at 10th amy 2004.
    res=[0.025,0.025];   added by mo on May 10th 2004.
    PageDX = Dims[0]
    PageDY = Dims[1]

    ; create a view
    View = OBJ_NEW('IDLgrView', VIEW=[0,0,PageDX,PageDY])
    Model = OBJ_NEW('IDLgrModel')
    TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=Font3,recompute_dimensions=0)

    Model->Add,TimeText
    View->Add, Model
    currenty=pageDy-10; the position to put the texline 2006/01/25 ctreitera *****
    my_png_page={view:view,model:model,timeText:timeText,pageDX:pageDX,pageDy:pageDY,$
        CurrentX:0,currentY:currentY,font:font3}
end;  end of start_a_new_page
;*****************************************************





pro get_a_image_and_text,HorV,this_index,dimg,dispsize,my_text_string,nanoseconds_array
    Common DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,aveStripdata,aveStripdataV
    ;*******************************************************************************
    ;*******************************************************************************
    if HorV eq 'H' then begin
        foffsets_array=(*alldataH)(this_index).imageoffset
        L1size_array=(*alldataH)(this_index).Nslice
        imgword_array=(*alldataH)(this_index).imageWords
        nanoseconds_array=(*alldataH)(This_index).nanoseconds
        reject=(*alldataH)(this_index).reject
        CPI_trigger_array = (*alldataH)[This_index].CPI_trigger
        PartID_array = (*alldataH)(This_index).PartID
        microns_per_pixel=!microns_per_pixelH
    endif

    if HorV eq 'V' then begin
        foffsets_array=(*alldataV)(this_index).imageoffset
        L1size_array=(*alldataV)(this_index).Nslice
        imgword_array=(*alldataV)(this_index).imageWords
        nanoseconds_array=(*alldataV)(This_index).nanoseconds
        reject=(*alldataV)(this_index).reject
        CPI_trigger_array = (*alldataV)[This_index].CPI_trigger
        PartID_array = (*alldataV)(This_index).PartID
        microns_per_pixel=!microns_per_pixelV
    endif
    ;stop
    ;if !autoArchive eq 1 or !autoarchive_png_only eq 1 then begin
    my_str1=strmid(!currentHPname, 0,strlen(!currentHPname)-1)
    my_pos =strpos(my_str1,'\',/reverse_search)
    fname=strmid(my_str1,0,my_pos+1)+'SORTED'
    horzname=strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,strlen(!currentHFname))
    ;datetime=strmid(horzname,0,strlen(horzname)-7); ; TAF file name change
    datetime=strmid(horzname,0,strlen(horzname)-4)
    ;fname=fname+datetime+'.2DS'
    fname=fname+datetime+'.2DSCPI'
    OpenR, lun, fname, /Get_Lun

    if ImgWord_array eq 0 then begin
        ;stop
        dimg = rotate(BytArr(2), !IMAGE_ROTATION)
        dispsize=size(dimg,/dimension)
        my_text_string=' '
        goto, skip_getting_image
    endif


    ;Slices = L1size_array
    ;WordCount = ImgWord_array

    ;Image = BytArr(WordCount * 2)

    ;out_array = bytarr(16L * Slices)
    ;out_byte_array = bytarr(128L, Slices)

    ;POINT_LUN, lun, fOffsets_array
    ;ReadU, lun, Image

    ;Hsums = intarr(Slices)
    ;HMax  = 0
    ;Area = 0UL
    ;Midpoint = 0
    ;Edges = 0
    ;L3 = 0.0
    ;L4 = 0.0
    ;L5 = 0.0
    ;PC3x = 0.0
    ;PC3y = 0.0
    ;PC4x = 0.0
    ;PC4y = 0.0
    ;A3 = 0.0

    ; TAF need to look above at how L1size_array is stored, i is undefined here

    ;CPI_trigger = CPI_trigger_array[i] ; TAF getting the wrong triggers with this
    ;PartID = PartID_array[i]

    ;Err=0
    ;ProcessParticle,  Image_data, HSums, out_array, out_byte_array, Wordcount, Slices,  HMax, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3


    Slices = L1size_array
    WordCount = ImgWord_array

    Image_data = BytArr(WordCount * 2)

    out_byte_array = bytarr(128, Slices)

    POINT_LUN, lun, fOffsets_array
    ReadU, lun, Image_data

    Hsums = intarr(Slices)
    HMax  = 0
    Area = 0UL
    Midpoint = 0
    Edges = 0
    L3 = 0.0
    L4 = 0
    L5 = 0
    PC3x = 0.0
    PC3y = 0.0
    PC4x = 0.0
    PC4y = 0.0
    A3 = 0.0
    Roundness1 = 0.0
    Roundness2 = 0.0
    Roundness3 = 0.0
    L1r = 0.0
    maxLength = 0.0
    maxWidth  = 0.0
    perimeter = 0UL
    perimeterum = 0.
    csp = 0.
    num_satellites = 0.
    Err=0

    ;HorV = 'H'

    ;ProcessParticle, Image_data, out_array, out_byte_array, Wordcount,Slices, HSums,HMax, Area, Midpoint, Edges,Err , $
    ;                 L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp
    ProcessParticle, Image_data, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
        L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, $
        ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
        perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y, num_satellites=num_satellites, HorV=HorV



    ;out_byte_array = out_byte_array(*,0:long(L1size_array-1))
    ;out_byte_array = out_byte_array(*,Slices-Wordcount-1:*)
    ;out_byte_array = out_byte_array(*,Slices-1:*)

    ; TAF seems like this resize should be uneeded, maybe a reform?

    ;out_byte_array = reform(out_byte_array, 128, Slices)
    ; TAF this is called when generating png images...
    ;aa = where(out_byte_array eq 255, complement=bb)

    ;out_byte_array(aa) = 255
    ;out_byte_array(bb) = 0
    ;if reject gt 0 then out_byte_array(bb) = 200
    ;            if reject gt 0 then stop ; TAF need to look into reject


    ;if(aa(0) ne -1) then begin
    ;stop
    ;if(CPI_trigger) then begin
    ;out_byte_array(aa) = 55 ; deep blue for CPI trigger
    ;    out_byte_array(aa) = 140 ; bright green for CPI trigger
    ;endif else begin
    ;    out_byte_array(aa) = 0
    ;endelse
    ;temp_oba(aa) = 0

    ;endif else begin
    ;    stop
    ;endelse

    ;if(bb(0) ne -1) then begin
    ;    if(CPI_trigger) then begin
    ;        ;out_byte_array(bb) = 55 ; deep blue for CPI trigger
    ;        out_byte_array(bb) = 140 ; bright green for CPI trigger
    ;    endif else begin
    ;        out_byte_array(bb) = 0
    ;    endelse
    ;    ;temp_oba(bb) = 0
    ;endif


    ;  tv, ROTATE(out_byte_array, !IMAGE_ROTATION),yoffset,0
    dimg = rotate(out_byte_array, !IMAGE_ROTATION)
    ;my_text_string=SPEC_Nano2HMS(nanoseconds_array)
    my_text_string=SPEC_Nano2HMS(nanoseconds_array+!TDS_time_offset*1000000000LL)
    dispsize=size(dimg,/dimension)
    ;dispsize=1*dispsize
    ;dimg=congrid(dimg,dispsize(0),dispsize(1),0)
    ;stop

    ;****************************************************
    Catch, onError
    IF onError NE 0 THEN BEGIN
        Catch, /Cancel
        result = Error_Message(Traceback=1)
        Hsums=0
    ENDIF

    Hsums=0
    skip_getting_image:  ; do noting in here.
    ;make a color display of the images
    ;******************************************************
    Close ,lun
    Free_Lun,lun
end
; **************************************************************






;===============================================================================
PRO SaveWndToFile2ds, OutPutWnd,time0,timetext_2,HorV, round_flag = round_flag
; This is apparently the function used by png image archiving (ie archive_multi_ice_png) to write images to png files

if(not keyword_set(round_flag)) then begin
    round_flag = -1
endif

starttime=strsplit(time0,':',/extract)
if strlen(time0) lt 5 then return
starttime=strjoin(starttime(0:2))
starttime=strsplit(starttime,'.',/extract)
starttime=starttime(0)+'_'+starttime(1)+starttime(2)

endtime  =strsplit(timetext_2,':',/extract)
endtime  =strjoin(endtime(0:2))
endtime=strsplit(endtime,'.',/extract)
endtime=endtime(0)+'_'+endtime(1)+endtime(2)

time_str = '_' + starttime + '_'+endtime

;get the yyyy mm dd of the data file.
subfile_str=strsplit(!currentHFname,'\',/extract)
plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)
year='20'+strmid(plot_string2,5,2)
month=strmid(plot_string2,7,2)
if !Time_synced gt 0 then begin
    day=strmid(plot_string2,9,2)+'_TimeSynced'
endif else begin
    day=strmid(plot_string2,9,2)
endelse
date_yyyymmdd_string=year+month+day; '20060201 '

project_platform_str=strtrim(!project_name)+'_'+strtrim(!platform,2)

; Create a filename
junk=findfile(!currentHPname+'png\*.*')
if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "png\"
;outputfilename=!currentHPname+'png\'+HorV+date_yyyymmdd_string+time_str+'.png'
; TAF put "IMAGES" below into a global at the start, or ini file, so we can label the output filenames by project, also the R1, etc
if(round_flag eq 1) then begin ; round
    outputfilename = !currentHPname + 'png\'+project_platform_str+'_TDS_IMAGES_ROUND_' +HorV+'_'+ date_yyyymmdd_string + Time_str + '.png'
endif else if(round_flag eq 2) then begin ; not round
    outputfilename = !currentHPname + 'png\'+project_platform_str+'_TDS_IMAGES_NOT_ROUND_'+HorV+'_'+ date_yyyymmdd_string + Time_str  +'.png'
endif else begin
    outputfilename = !currentHPname + 'png\'+project_platform_str+'_TDS-IMAGES_'+HorV+'_'+ date_yyyymmdd_string + Time_str +'_'+!Revision_X + '.png'
endelse
; TAF replace * in output string with X, this is a workaround, not a fix
strreplace, outputfilename, '*', 'X'

;Get window image
Img = OutPutWnd->Read()
; Get the actual buffer
Img->GetProperty, Data=Buf; , /NO_COPY
y = (size(Buf))[2]
dy = round(y)
;write_png,outputfilename, Buf[*,y-dy:*];r,g,b; this has size(buf)=[612,753]---a black strip on the png.
write_png,outputfilename, Buf[*,40:*]   ;this don't have the balck strip anymore, save inks.

OBJ_DESTROY, Img
heap_gc
end;SaveWndToFile2ds, OutPutWnd,time_text
;****************************************************





;****************************************************
Pro get_binary_8bitstring,my8bitstring,number
    if (number and 128) eq 128 then  begin
        my8bitstring=string(format='(B)',number)
        return
    endif
    if (number and 64) eq 64 then  begin
        my8bitstring='0'+strtrim(string(format='(B)',number),2)
        return
    endif
    if (number and 32) eq 32 then  begin
        my8bitstring='00'+strtrim(string(format='(B)',number),2)
        return
    endif
    if (number and 16) eq 16 then  begin
        my8bitstring='000'+strtrim(string(format='(B)',number),2)+' Hand'
        return
    endif
    if (number and 8) eq 8 then  begin
        my8bitstring='0000'+strtrim(string(format='(B)',number),2)+' Big_Splash'
        return
    endif
    if (number and 4) eq 4 then  begin
        my8bitstring='00000'+strtrim(string(format='(B)',number),2)+' W8_t'
        return
    endif
    if (number and 2) eq 2 then  begin
        my8bitstring='000000'+strtrim(string(format='(B)',number),2)+' DotL'
        return
    endif
    if (number and 1) eq 1 then  begin
        my8bitstring='0000000'+strtrim(string(format='(B)',number),2)+' BadPc1'
        return
    endif
    if (number eq 0) then  begin
        my8bitstring='00000000'
        return
    endif
end
;*****************************************************


