pro a3vcpiview_psd_methods_area_equivalent,ave_info

    ; this is to make two psd traces (M1V1, M2V2) in each of 4 squares of a window.
    ; when a reset button is click. all methods M1, M2 and Variables V1, V2 will
    ; be set to default values.
    title_str='Comparing different 2DS PSD Plots by Methods (M) Channels (C) and Parameters (P)'
    ;*********************** do oFFhand_no_button_programs;************************
    ; stop;  Do_Alexeis_Zd_distribution_plots, ave_info,HorV
    ;*********************************************************************************
    ;create top level base
    tlb=widget_base(title=title_str,/column,xsize=800,ysize=11*72+40,xoffset=200); 780 changed to 800.
    ;the above tiltle_str can be changed later in the plots.
    L1base=widget_base(tlb,/row);   ;xoffset to place in offset the computer screen.
    ;timetext=widget_text(L1base,xsize=25,ysize=1,value=time_periods); time_period='aaa'
    helpnote=widget_button(L1base,value='Help',uvalue='Help')
    save_config  =widget_button(L1base,value='Sav.Cfig',uvalue='save_config')
    Freq_config  =widget_button(L1base,value='FreqCfig',uvalue='Freq_config');  ;frequently loaded
    load_config  =widget_button(L1base,value='LoadCfig',uvalue='load_config')
    save_png  =widget_button(L1base,value='Sav.Png',uvalue='save_png')
    print_png =widget_button(L1base,value='Print',uvalue='ToPrinter')
    save_ascii =widget_button(L1base,value='Sav.txt',uvalue='save_ascii')
    resetbut=widget_button(L1base,value='Reset',uvalue='Reset')


    ;Xlog=cw_bgroup(L1Base,['Xlog','Xlin'],/row,/exclusive,/no_release,uvalue = 'Xlog',set_value=1,button_uvalue=[1,0])
    Xlog=widget_droplist(L1base,value=['Xlog','Xlin'],uvalue='Xlog')
    Ylog=widget_droplist(L1base,value=['Ylog','Ylin'],uvalue='Ylog')
    XminID=CW_field(L1base,title='MinBinCnt',uvalue='MinBinC',value='2',/integer,xsize=3,ysize=1,/all)


    plotit  =widget_button(L1base,value='Update',uvalue='Redraw')
    makenotes  =widget_button(L1base,value='more_annotation',uvalue='Makenotes')

    Methods=['M1','M2','M3','M4','M5','M6']
    H_Channels=['H','V']
    V_channels=['V','H']
    A_Variables=['eqdm','conc','area','Lwc','IWC']
    B_Variables=['conc','area','Lwc', 'IWC','eqdm']
    C_Variables=['area','Lwc', 'conc','IWC','eqdm']
    D_Variables=['Lwc' ,'conc','area','IWC','eqdm']

    L2base=widget_base(tlb,/row)
    L2base1=widget_base(L2base,/row,/frame,xsize=363);   330 changed to 340

    M11droplist=widget_droplist(L2base1,title='1:M',value=Methods,uvalue='M11list')
    C11droplist=widget_droplist(L2base1,title='C',  value=H_Channels,uvalue='C11list')
    M12droplist=widget_droplist(L2base1,title='M',value=Methods,uvalue='M12list')
    C12droplist=widget_droplist(L2base1,title='C',value=V_Channels,uvalue='C12list')
    V12droplist=widget_droplist(L2base1,title='P',value=A_Variables,uvalue='V12list')
    F1MnBnwidID=CW_field(L2base1,title='MnBnWd',uvalue='F1MnBnWid',value='10',/integer,xsize=3,ysize=1,/all)
    ;widget_control,V12droplist,set_value=['#/bn','conc','mass','extn']

    dummy=widget_button(L2base,xsize=12,value='',uvalue='dummy');  ;just for beauty

    L2base2=widget_base(L2base,/row,/frame,xsize=390); 363
    M21droplist=widget_droplist(L2base2,title='2:M',    value=Methods,uvalue='M21list')
    C21droplist=widget_droplist(L2base2,title='C',   value=H_Channels,uvalue='C21list')
    M22droplist=widget_droplist(L2base2,title='M',      value=Methods,uvalue='M22list')
    C22droplist=widget_droplist(L2base2,title='C',   value=V_Channels,uvalue='C22list')
    V22droplist=widget_droplist(L2base2,title='P',  value=B_Variables,uvalue='V22list')
    F2MnBnwidID=CW_field(L2base2,title='MnBnWd',uvalue='F2MnBnWid',value='10',/integer,xsize=3,ysize=1,/all)
    ;widget_control,V22droplist,set_value=['conc','mass','extn','#/bin']

    psdDraw=widget_draw(tlb,xsize=800,ysize=10*72,Event_Pro='PSD_GraphClick',/BUTTON_EVENTS, /MOTION_EVENTS);  9.4 x7.8

    L3base=widget_base(tlb,/row)
    L3base1=widget_base(L3base,/row,/frame,xsize=363)
    M31droplist=widget_droplist(L3base1,title='3:M',  value=Methods,uvalue='M31list')
    C31droplist=widget_droplist(L3base1,title='C', value=H_Channels,uvalue='C31list')
    M32droplist=widget_droplist(L3base1,title='M',    value=Methods,uvalue='M32list')
    C32droplist=widget_droplist(L3base1,title='C', value=V_Channels,uvalue='C32list')
    V32droplist=widget_droplist(L3base1,title='P',value=C_Variables,uvalue='V32list')
    F3MnBnwidID=CW_field(L3base1,title='MnBnWd',uvalue='F3MnBnWid',value='10',/integer,xsize=3,ysize=1,/all)
    ;widget_control,V32droplist,set_value=['extn','mass','conc','#/bin']

    dummy=widget_button(L3base,xsize=12,value='',uvalue='dummy');  ;just for beauty.

    L3base2=widget_base(L3base,/row,/frame,xsize=390)
    M41droplist=widget_droplist(L3base2,title='4:M',  value=Methods,uvalue='M41list')
    C41droplist=widget_droplist(L3base2,title='C', value=H_Channels,uvalue='C41list')
    M42droplist=widget_droplist(L3base2,title='M',    value=Methods,uvalue='M42list')
    C42droplist=widget_droplist(L3base2,title='C', value=V_Channels,uvalue='C42list')
    V42droplist=widget_droplist(L3base2,title='P',value=D_Variables,uvalue='V42list')
    F4MnBnwidID=CW_field(L3base2,title='MnBnWd',uvalue='F4MnBnWid',value='0.001',xsize=3,ysize=1,/all)
    ;widget_control,V42droplist,set_value=['mass','conc','extn','#/bin']

    widget_control, tlb,/realize
    MethodIDs={M11ID:M11droplist,C11ID:C11droplist,$
        M12ID:M12droplist,C12ID:C12droplist,V12ID:V12droplist,$
        M21ID:M21droplist,C21ID:C21droplist,$
        M22ID:M22droplist,C22ID:C22droplist,V22ID:V22droplist,$
        M31ID:M31droplist,C31ID:C31droplist,$
        M32ID:M32droplist,C32ID:C32droplist,V32ID:V32droplist,$
        M41ID:M41droplist,C41ID:C41droplist,$
        M42ID:M42droplist,C42ID:C42droplist,V42ID:V42droplist}
    configs={M11:'M1',C11:'H',M12:'M1',C12:'V',V12:'eqdm',$
        M21:'M1',C21:'H',M22:'M1',C22:'V',V22:'conc',$
        M31:'M1',C31:'H',M32:'M1',C32:'V',V32:'area',$
        M41:'M1',C41:'H',M42:'M1',C42:'V',V42:'Lwc'}
    psdvalues={xpts1:ptr_new(),$
        y1:ptr_new(),$
        xpts2:ptr_new(),$
        y2:ptr_new(),$
        xpts3:ptr_new(),$
        y3:ptr_new(),$
        xpts4:ptr_new(),$
        y4:ptr_new(),$
        xpts5:ptr_new(),$
        y5:ptr_new(),$
        xpts6:ptr_new(),$
        y6:ptr_new(),$
        xpts7:ptr_new(),$
        y7:ptr_new(),$
        xpts8:ptr_new(),$
        y8:ptr_new()} ;for ascii file.
    psdlabels={y1:'LHConc',y2:'LVConc',y3:'LHextn',Y4:'LVextn',y5:'LHlwc',y6:'LVlwc',y7:'LHlwc',y8:'LVlwc'} ; for ascii file
    info={MethodIDs:MethodIDs,methodvals:methods,H_channels:H_channels,V_channels:V_channels,$
        A_variables:A_variables,B_variables:B_variables,C_variables:C_variables,D_variables:D_variables,$
        configs:configs,ave_info:ave_info,psddrawID:psddraw,$
        psdvalues:psdvalues,psdlabels:psdlabels,$
        Xlog:1,Ylog:1,XminID:XminID,minbincnt:2,$
        F1MnBnwidID:F1MnBnwidID,$
        F2MnBnwidID:F2MnBnwidID,$
        F3MnBnwidID:F3MnBnwidID,$
        F4MnBnwidID:F4MnBnwidID,$
        F1MnBnwid:10,$
        F2MnBnwid:10,$
        F3MnBnwid:10,$
        F4MnBnwid:10,$
        makenotes:0,clicks:0,$
        label11:'',$
        label12:'',$
        label21:'',$
        label22:'',$
        label31:'',$
        label32:'',$
        label41:'',$
        label42:''}


    ;use a pointer to pass teh data
    ptr=ptr_new(info,/no_copy); no extra copy is made.

    ;widget_control,tlb,set_uvalue=info; ;because xmanager will always pass a
    ;top level structure data to teh evenet handeler, so it is assigned
    ;in here in a package info to be ready to pass it by xmanager.
    widget_control,/hourglass
    ;stop
    ;*********************************************************************************************
    Get_allindexs_and_boolean_subsetindexs,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor
    calculate_sv_deadtime,ave_info,Hallindex,Vallindex; added Nov 16, 2005 by MO
    ;re-assigne ptr values of the ave_info.
    (*ptr).ave_info=ave_info
    ;*********************************************************************************************
    ;*********************************************************************************************
    get_psd_trace1to8v2_area,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles,Dbz,Ra,Rb
    draw_averaged_8psds_area,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles
    widget_control,tlb,set_uvalue=ptr;  info;  this replace above ***=info

    xmanager,'a3vcpiview_psd_methods_area_equivalent',tlb,/Just_reg
    ;*****************************************************
    return
end;   ;end of main program
;***********************************************************
pro a3vcpiview_psd_methods_area_equivalent_event,event

    widget_control,event.top,get_uvalue=ptr
    widget_control, event.id,get_uvalue=uval

    case uval of
        'Reset':begin ; reset the traces to be default traces.
        methods=['M1','M2','M3','M4','M5','M6']
        Param_a   =['eqdm','conc','area','Lwc', 'IWC']
        Param_b   =['conc','area','Lwc', 'eqdm','IWC']
        Param_c   =['area','Lwc', 'binc','conc','IWC']
        Param_d   =['Lwc' ,'eqdm','conc','area','IWC']

        widget_control,(*ptr).MethodIDs.M11ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C11ID,set_value=['H','V']
        widget_control,(*ptr).MethodIDs.V11ID,set_value=param_a
        widget_control,(*ptr).MethodIDs.M12ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C12ID,set_value=['V','H']
        widget_control,(*ptr).MethodIDs.V12ID,set_value=param_a

        widget_control,(*ptr).MethodIDs.M21ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C21ID,set_value=['H','V']
        widget_control,(*ptr).MethodIDs.V21ID,set_value=param_b
        widget_control,(*ptr).MethodIDs.M22ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C22ID,set_value=['V','H']
        widget_control,(*ptr).MethodIDs.V22ID,set_value=param_b

        widget_control,(*ptr).MethodIDs.M31ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C31ID,set_value=['H','V']
        widget_control,(*ptr).MethodIDs.V31ID,set_value=param_c
        widget_control,(*ptr).MethodIDs.M32ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C32ID,set_value=['V','H']
        widget_control,(*ptr).MethodIDs.V32ID,set_value=param_c

        widget_control,(*ptr).MethodIDs.M41ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C41ID,set_value=['H','V']
        widget_control,(*ptr).MethodIDs.V41ID,set_value=param_d
        widget_control,(*ptr).MethodIDs.M42ID,set_value=methods
        widget_control,(*ptr).MethodIDs.C42ID,set_value=['V','H']
        widget_control,(*ptr).MethodIDs.V42ID,set_value=param_d
        configs={M11:'M1',C11:'H',M12:'M1',C12:'V',V12:'eqdm',$
            M21:'M1',C21:'H',M22:'M1',C22:'V',V22:'conc',$
            M31:'M1',C31:'H',M32:'M1',C32:'V',V32:'area',$
            M41:'M1',C41:'H',M42:'M1',C42:'V',V42:'Lwc'}
        (*ptr).configs=configs
    end
    'M11list': (*ptr).configs.M11=((*ptr).Methodvals)(event.index)
    'M12list': (*ptr).configs.M12=((*ptr).Methodvals)(event.index)
    'M21list': (*ptr).configs.M21=((*ptr).Methodvals)(event.index)
    'M22list': (*ptr).configs.M22=((*ptr).Methodvals)(event.index)
    'M31list': (*ptr).configs.M31=((*ptr).Methodvals)(event.index)
    'M32list': (*ptr).configs.M32=((*ptr).Methodvals)(event.index)
    'M41list': (*ptr).configs.M41=((*ptr).Methodvals)(event.index)
    'M42list': (*ptr).configs.M42=((*ptr).Methodvals)(event.index)

    'C11list': (*ptr).configs.C11=((*ptr).H_Channels)(event.index)
    'C12list': (*ptr).configs.C12=((*ptr).V_Channels)(event.index)

    'C21list': (*ptr).configs.C21=((*ptr).H_Channels)(event.index)
    'C22list': (*ptr).configs.C22=((*ptr).V_Channels)(event.index)
    'C31list': (*ptr).configs.C31=((*ptr).H_Channels)(event.index)
    'C32list': (*ptr).configs.C32=((*ptr).V_Channels)(event.index)
    'C41list': (*ptr).configs.C41=((*ptr).H_Channels)(event.index)
    'C42list': (*ptr).configs.C42=((*ptr).V_Channels)(event.index)


    'V12list': (*ptr).configs.V12=((*ptr).A_Variables)(event.index)
    'V22list': (*ptr).configs.V22=((*ptr).B_Variables)(event.index)
    'V32list': (*ptr).configs.V32=((*ptr).C_Variables)(event.index)
    'V42list': (*ptr).configs.V42=((*ptr).D_Variables)(event.index)

    'F1MnBnWid': begin
        widget_control,(*ptr).F1MnbnWidID, get_value=uval
        (*ptr).F1MnBnwid=uval
    end
    'F2MnBnWid': begin
        widget_control,(*ptr).F2MnbnWidID, get_value=uval
        (*ptr).F2MnBnwid=uval
    end
    'F3MnBnWid': begin
        widget_control,(*ptr).F3MnbnWidID, get_value=uval
        (*ptr).F3MnBnwid=uval
    end
    'F4MnBnWid': begin
        widget_control,(*ptr).F4MnbnWidID, get_value=uval
        (*ptr).F4MnBnwid=uval
    end

    'Redraw': begin
        widget_control,/hourglass

        get_psd_trace1to8v2_area,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles

        draw_averaged_8psds_area,ptr,xpts,all8yvals,all8MCPNstrings,all4ytitles


        ;stop
        ; do_auto_beadsizing=2
        ;if do_auto_beadsizing eq 1 then begin
        ;auto_bead_size_calibration,ptr
        ;endif
    end
    'save_config':begin; save the config_set into an ascii file.
    outputfilename=!currentHPname+'Config_psd_method_channel_variable_area.ascii'
    openw,8,outputfilename
    printf,8,(*ptr).configs(0)
    close,8
end
'Freq_config':begin
;pathnm=strmid(!currentHpname,0,strlen(!currentHpname)-1)
a3vcpiviewloc = strpos(!path,'2DSVIEW')
end_semicolonloc = strpos(!path,';',a3vcpiviewloc)
start_semicolonloc = strpos(!path,';',a3vcpiviewloc,/reverse_search)
length=end_semicolonloc-start_semicolonloc-1
Pathnm = strmid(!path,start_semicolonloc+1,length)+'\Common_configs\'
in_configs_file=dialog_pickfile(filter='*psd_method_channel_variable_area*.ascii',path=pathnm)
if in_configs_file eq '' then return
openr,8,in_configs_file
input_string='abcdf'
input_string1='abcdf'
readF,8,input_string;  ;input_string={ L1 H binc L1 V binc L1 ******
readF,8,input_string1
close,8
input_string=input_string+' '+input_string1
substring=strsplit(input_string,' ',/extract);substring(0)="{"; substring(1)="L1"
(*ptr).configs.m11=substring(1)
(*ptr).configs.C11=substring(2)
(*ptr).configs.V11=substring(3)

(*ptr).configs.m12=substring(4)
(*ptr).configs.C12=substring(5)
(*ptr).configs.V12=substring(6)

(*ptr).configs.m21=substring(7)
(*ptr).configs.C21=substring(8)
(*ptr).configs.V21=substring(9)

(*ptr).configs.m22=substring(10)
(*ptr).configs.C22=substring(11)
(*ptr).configs.V22=substring(12)

(*ptr).configs.m31=substring(13)
(*ptr).configs.C31=substring(14)
(*ptr).configs.V31=substring(15)

(*ptr).configs.m32=substring(16)
(*ptr).configs.C32=substring(17)
(*ptr).configs.V32=substring(18)

(*ptr).configs.m41=substring(19)
(*ptr).configs.C41=substring(20)
(*ptr).configs.V41=substring(21)

(*ptr).configs.m42=substring(22)
(*ptr).configs.C42=substring(23)
(*ptr).configs.V42=strmid(substring(24),0,strlen(substring(24))-1)
;stop
widget_control,(*ptr).MethodIDs.M11ID,set_value=substring(1)
widget_control,(*ptr).MethodIDs.C11ID,set_value=substring(2)
widget_control,(*ptr).MethodIDs.V11ID,set_value=substring(3)
widget_control,(*ptr).MethodIDs.M12ID,set_value=substring(4)
widget_control,(*ptr).MethodIDs.C12ID,set_value=substring(5)
widget_control,(*ptr).MethodIDs.V12ID,set_value=substring(6)

widget_control,(*ptr).MethodIDs.M21ID,set_value=substring(7)
widget_control,(*ptr).MethodIDs.C21ID,set_value=substring(8)
widget_control,(*ptr).MethodIDs.V21ID,set_value=substring(9)
widget_control,(*ptr).MethodIDs.M22ID,set_value=substring(10)
widget_control,(*ptr).MethodIDs.C22ID,set_value=substring(11)
widget_control,(*ptr).MethodIDs.V22ID,set_value=substring(12)

widget_control,(*ptr).MethodIDs.M31ID,set_value=substring(13)
widget_control,(*ptr).MethodIDs.C31ID,set_value=substring(14)
widget_control,(*ptr).MethodIDs.V31ID,set_value=substring(15)
widget_control,(*ptr).MethodIDs.M32ID,set_value=substring(16)
widget_control,(*ptr).MethodIDs.C32ID,set_value=substring(17)
widget_control,(*ptr).MethodIDs.V32ID,set_value=substring(18)

widget_control,(*ptr).MethodIDs.M41ID,set_value=substring(19)
widget_control,(*ptr).MethodIDs.C41ID,set_value=substring(20)
widget_control,(*ptr).MethodIDs.V41ID,set_value=substring(21)
widget_control,(*ptr).MethodIDs.M42ID,set_value=substring(22)
widget_control,(*ptr).MethodIDs.C42ID,set_value=substring(23)
widget_control,(*ptr).MethodIDs.V42ID,set_value=(*ptr).configs.V42
end

'load_config':begin; load the config_file and assign it back into.
pathnm=strmid(!currentHpname,0,strlen(!currentHpname)-1)
in_configs_file=dialog_pickfile(filter='*psd_method_channel_variable_area*.ascii',path=pathnm)
if in_configs_file eq '' then return
openr,8,in_configs_file
input_string='abcdf'
input_string1='abcdf'
readF,8,input_string;  ;input_string={ L1 H binc L1 V binc L1 ******
readF,8,input_string1
close,8
input_string=input_string+' '+input_string1
substring=strsplit(input_string,' ',/extract);substring(0)="{"; substring(1)="L1"
(*ptr).configs.m11=substring(1)
(*ptr).configs.C11=substring(2)
(*ptr).configs.m12=substring(3)
(*ptr).configs.C12=substring(4)
(*ptr).configs.V12=substring(5)

(*ptr).configs.m21=substring(6)
(*ptr).configs.C21=substring(7)
(*ptr).configs.m22=substring(8)
(*ptr).configs.C22=substring(9)
(*ptr).configs.V22=substring(10)

(*ptr).configs.m31=substring(11)
(*ptr).configs.C31=substring(12)
(*ptr).configs.m32=substring(13)
(*ptr).configs.C32=substring(14)
(*ptr).configs.V32=substring(15)

(*ptr).configs.m41=substring(16)
(*ptr).configs.C41=substring(17)
(*ptr).configs.m42=substring(18)
(*ptr).configs.C42=substring(19)
(*ptr).configs.V42=strmid(substring(20),0,strlen(substring(20))-1)
;stop
widget_control,(*ptr).MethodIDs.M11ID,set_value=substring(1)
widget_control,(*ptr).MethodIDs.C11ID,set_value=substring(2)
widget_control,(*ptr).MethodIDs.M12ID,set_value=substring(3)
widget_control,(*ptr).MethodIDs.C12ID,set_value=substring(4)
widget_control,(*ptr).MethodIDs.V12ID,set_value=substring(5)

widget_control,(*ptr).MethodIDs.M21ID,set_value=substring(6)
widget_control,(*ptr).MethodIDs.C21ID,set_value=substring(7)
widget_control,(*ptr).MethodIDs.M22ID,set_value=substring(8)
widget_control,(*ptr).MethodIDs.C22ID,set_value=substring(9)
widget_control,(*ptr).MethodIDs.V22ID,set_value=substring(10)

widget_control,(*ptr).MethodIDs.M31ID,set_value=substring(11)
widget_control,(*ptr).MethodIDs.C31ID,set_value=substring(12)
widget_control,(*ptr).MethodIDs.M32ID,set_value=substring(13)
widget_control,(*ptr).MethodIDs.C32ID,set_value=substring(14)
widget_control,(*ptr).MethodIDs.V32ID,set_value=substring(15)

widget_control,(*ptr).MethodIDs.M41ID,set_value=substring(16)
widget_control,(*ptr).MethodIDs.C41ID,set_value=substring(17)
widget_control,(*ptr).MethodIDs.M42ID,set_value=substring(18)
widget_control,(*ptr).MethodIDs.C42ID,set_value=substring(19)
widget_control,(*ptr).MethodIDs.V42ID,set_value=(*ptr).configs.V42
end
'save_png': save_psd_png,ptr
'ToPrinter': send_psd_png_to_printer,ptr
'save_ascii':write_compare_psd_ascii,ptr
'Help':  begin
    display_psd_help_message
end
'Xlog': begin
    if event.index eq 0 then (*ptr).Xlog=1 else (*ptr).Xlog=0
end
'Ylog': if event.index eq 0 then (*ptr).Ylog=1 else (*ptr).Ylog=0
'MinBinC': begin
    widget_control,(*ptr).XminID, get_value=uval
    (*ptr).minbincnt=uval
end
'Makenotes': begin
    widget_control,/hourglass
    ;Do_1Hz_archive_and_CPIView1Hz
    ;Do_Nsecond_CRAVE_archive_special;  added this on Oct 31, 2006 for Paul's presentation.
    ;Do_Nsecond_Rico61bin_archive
    ;Do_Nsecond_Ultimate_archive_61bins,info=info
    (*ptr).makenotes=1
end
else:
endcase

print,(*ptr).configs

widget_control,event.top,set_uvalue=ptr;  put the info back to xmanager
end;  ;end of event handler
;****************************************************

;***********************************************************************************
pro get_psd_trace1to8v2_area,ptr,xxx,all8yvals,all8MCPNstrs,all4ytitles,Dbz,Ra,Rb
    widget_control,/hourglass
    ave_info=(*ptr).ave_info

    ;find_if_there_is_bad_time_data in this Time Period.
    pop_up_messages_if_ThereIs_non_monotonic_data,ave_info

    ;for trace1
    this_method =(*ptr).configs.M11
    This_channel=(*ptr).configs.C11
    this_param  =(*ptr).configs.V12
    mincntsperbin=(*ptr).minbincnt
    minbinwid     =(*ptr).F1mnbnwid

    if this_method ne 'M6' then begin

        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts1,y11,ystr,xstr,deadtime,count11,mincntsperbin,minbinwid; ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts1,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts1,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y11=yptsM2
        y11(64:*)=yptsM1(64:*)
        y11(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y11)-2 do begin
            ave_value=ave_value+y11(i)*(xpts1(i+1)-xpts1(i))
        endfor
        count11=ave_value

        ;combine the 2 sizes
        index=where(sizes1 le xpts1(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts1(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part2
            adjs =adjs_part2
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz11,Ra11,Rb11
    endelse


    ;get_one_psd_trace,ave_info,this_method,this_channel,this_param,x11,y11,count11
    str1=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count11),2)
    xxx=xpts1
    ytitle_str1=ystr
    xtitle_str1=xstr

    this_method =(*ptr).configs.M12
    This_channel=(*ptr).configs.C12
    this_param  =(*ptr).configs.V12
    minbinwid     =(*ptr).F1mnbnwid
    if this_method ne 'M6' then begin
        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts2,y12,ystr,xstr,deadtime,count12,mincntsperbin,minbinwid; ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts2,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts2,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y12=yptsM2
        y12(64:*)=yptsM1(64:*)
        y12(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y12)-2 do begin
            ave_value=ave_value+y12(i)*(xpts2(i+1)-xpts2(i))
        endfor
        count12=ave_value
        ;combine the 2 sizes
        index=where(sizes1 le xpts2(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts2(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part2
            adjs =adjs_part2
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz12,Ra12,Rb12
    endelse
    str2=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count12),2)


    this_method =(*ptr).configs.M21
    This_channel=(*ptr).configs.C21
    this_param  =(*ptr).configs.V22
    minbinwid     =(*ptr).F2mnbnwid

    if this_method ne 'M6' then begin
        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts3,y21,ystr,xstr,deadtime,count21,mincntsperbin,minbinwid; ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts3,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts3,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y21=yptsM2
        y21(64:*)=yptsM1(64:*)
        y21(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y21)-2 do begin
            ave_value=ave_value+y21(i)*(xpts3(i+1)-xpts3(i))
        endfor
        count21=ave_value
        ;combine the 2 sizes
        index=where(sizes1 le xpts3(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts3(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part2
            adjs =adjs_part2
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz21,Ra21,Rb21
    endelse
    str3=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count21),2)
    ytitle_str2=ystr
    xtitle_str2=xstr

    this_method =(*ptr).configs.M22
    This_channel=(*ptr).configs.C22
    this_param  =(*ptr).configs.V22
    minbinwid     =(*ptr).F2mnbnwid
    if this_method ne 'M6' then begin
        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts4,y22,ystr,xstr,deadtime,count22,mincntsperbin,minbinwid; ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts4,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts4,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y22=yptsM2
        y22(64:*)=yptsM1(64:*)
        y22(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y22)-2 do begin
            ave_value=ave_value+y22(i)*(xpts4(i+1)-xpts4(i))
        endfor
        count22=ave_value
        ;combine the 2 sizes
        index=where(sizes1 le xpts4(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts4(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part2
            adjs =adjs_part2
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz22,Ra22,Rb22
    endelse
    ;get_one_psd_trace,ave_info,this_method,this_channel,this_param,x22,y22,count22
    str4=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count22),2)


    this_method =(*ptr).configs.M31
    This_channel=(*ptr).configs.C31
    this_param  =(*ptr).configs.V32
    minbinwid     =(*ptr).F3mnbnwid
    if this_method ne 'M6' then begin
        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts5,y31,ystr,xstr,deadtime,count31,mincntsperbin,minbinwid;ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts5,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts5,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y31=yptsM2
        y31(64:*)=yptsM1(64:*)
        y31(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y31)-2 do begin
            ave_value=ave_value+y31(i)*(xpts5(i+1)-xpts5(i))
        endfor
        count31=ave_value

        ;combine the 2 sizes
        index=where(sizes1 le xpts5(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts5(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part2
            adjs =adjs_part2
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz31,Ra31,Rb31
    endelse
    str5=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count31),2)
    ytitle_str3=ystr
    xtitle_str3=xstr

    this_method =(*ptr).configs.M32
    This_channel=(*ptr).configs.C32
    this_param  =(*ptr).configs.V32
    minbinwid     =(*ptr).F3mnbnwid
    if this_method ne 'M6' then begin
        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts6,y32,ystr,xstr,deadtime,count32,mincntsperbin,minbinwid; ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts6,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts6,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y32=yptsM2
        y32(64:*)=yptsM1(64:*)
        y32(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y32)-2 do begin
            ave_value=ave_value+y32(i)*(xpts6(i+1)-xpts6(i))
        endfor
        count32=ave_value

        ;combine the 2 sizes
        index=where(sizes1 le xpts6(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts6(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part2
            adjs =adjs_part2
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz32,Ra32,Rb32
    endelse
    str6=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count32),2)



    this_method =(*ptr).configs.M41
    This_channel=(*ptr).configs.C41
    this_param  =(*ptr).configs.V42
    minbinwid     =(*ptr).F4mnbnwid
    if this_method ne 'M6' then begin
        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts7,y41,ystr,xstr,deadtime,count41,mincntsperbin,minbinwid; ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts7,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts7,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y41=yptsM2
        y41(64:*)=yptsM1(64:*)
        y41(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y41)-2 do begin
            ave_value=ave_value+y41(i)*(xpts7(i+1)-xpts7(i))
        endfor
        count41=ave_value

        ;combine the 2 sizes
        index=where(sizes1 le xpts7(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts7(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part1
            adjs =adjs_part1
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz41,Ra41,Rb41
    endelse
    str7=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count41),2)
    ytitle_str4=ystr
    xtitle_str4=xstr

    this_method =(*ptr).configs.M42
    This_channel=(*ptr).configs.C42
    this_param  =(*ptr).configs.V42
    minbinwid     =(*ptr).F4mnbnwid
    if this_method ne 'M6' then begin
        Calculate_one_psd_trace_area,this_channel,This_method,ave_info,this_param,$ ;input
            xpts8,y42,ystr,xstr,deadtime,count42,mincntsperbin,minbinwid; ouput

    endif else begin
        ; Do M6 two Psd's and then combined M1 and M2 together.
        Calculate_one_psd_trace_M6_area,This_channel,'M1',ave_info,this_param,$ ;input
            xpts8,yptsM1,ystr,xstr,deadtime,Partcont1,sizes1,adjs1,areas1; ouput
        Calculate_one_psd_trace_M6_area,this_channel,'M2',ave_info,this_param,$ ;input
            xpts8,yptsM2,ystr,xstr,deadtime,Partcont2,sizes2,adjs2,areas2; ouput
        ;now combine M1 M2 together to get the M6 psds.
        y42=yptsM2
        y42(64:*)=yptsM1(64:*)
        y42(52:63)=(yptsM1(52:63)+yptsM2(52:63))/2.0
        ave_value=0.0
        for i=0,n_elements(y42)-2 do begin
            ave_value=ave_value+y42(i)*(xpts8(i+1)-xpts8(i))
        endfor
        count42=ave_value
        ;combine the 2 sizes
        index=where(sizes1 le xpts8(63) and sizes1 gt 0.0,contG1)
        if contG1 gt 0 then begin
            sizes_part1=sizes1(index)
            areas_part1=areas1(index)
            adjs_part1 =adjs1(index)
        endif

        index=where(sizes2 gt xpts8(63) and sizes2 gt 0.0,contG2)
        if contG2 gt 0 then begin
            sizes_part2=sizes2(index)
            areas_part2=areas2(index)
            adjs_part2 =adjs2(index)
        endif

        if contG1 eq 0 and contG2 gt 0 then begin
            sizes=sizes_part2
            areas=areas_part2
            adjs =adjs_part2
        endif

        if contG1 gt 0 and contG2 eq 0 then begin
            sizes=sizes_part1
            areas=areas_part1
            adjs =adjs_part1
        endif


        if contG1 eq 0 and contG2 eq 0 then begin
            sizes=[0,0]
            adjs=[0,0]
            areas=[0,0]
        endif

        if contG1 gt 0 and contG2 gt 0 then begin
            sizes=[sizes_part1,sizes_part2]
            areas=[areas_part1,areas_part2]
            adjs= [adjs_part1,adjs_part2]
        endif
        get_dBz_effective_Ra_Rb,sizes,areas,adjs,DBz42,Ra42,Rb42
    endelse
    str8=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count42),2)

    all8yvals   ={xpts1:xpts1,y1:y11,$
        xpts2:xpts2, y2:y12,$
        xpts3:xpts3,y3:y21,$
        xpts4:xpts4,y4:y22,$
        xpts5:xpts5,y5:y31,$
        xpts6:xpts6,y6:y32,$
        xpts7:xpts7, y7:y41,$
        xpts8:xpts8, y8:y42}
    all8MCPNstrs={s1:str1,s2:str2,s3:str3,s4:str4,s5:str5,s6:str6,s7:str7,s8:str8}
    all4ytitles =[ytitle_str1,ytitle_str2,ytitle_str3,ytitle_str4,$
        xtitle_str1,xtitle_str2,xtitle_str3,xtitle_str4]


    (*ptr).psdvalues ={xpts1:ptr_new(xpts1), y1:ptr_new(y11),$
        xpts2:ptr_new(xpts2), y2:ptr_new(y12),$
        xpts3:ptr_new(xpts3), y3:ptr_new(y21),$
        xpts4:ptr_new(xpts4), y4:ptr_new(y22),$
        xpts5:ptr_new(xpts5), y5:ptr_new(y31),$
        xpts6:ptr_new(xpts6), y6:ptr_new(y32),$
        xpts7:ptr_new(xpts7), y7:ptr_new(y41),$
        xpts8:ptr_new(xpts8), y8:ptr_new(y42)}

    (*ptr).psdlabels=all8MCPNstrs

end; end of get_psd_trace1to8v2_area,ptr,xpts,y11,y12,y21,y22,y31,y32,y41,y42
;**********************************************************************************

;********************************************
pro  Draw_averaged_8psds_area,ptr,xpts,all8yvals,all8MCPNstrs,all4ytitles

    y11=all8yvals.y1
    y12=all8yvals.y2
    y21=all8yvals.y3
    y22=all8yvals.y4
    y31=all8yvals.y5
    y32=all8yvals.y6
    y41=all8yvals.y7
    y42=all8yvals.y8
    s11=all8MCPNstrs.s1
    s12=all8MCPNstrs.s2
    s21=all8MCPNstrs.s3
    s22=all8MCPNstrs.s4
    s31=all8MCPNstrs.s5
    s32=all8MCPNstrs.s6
    s41=all8MCPNstrs.s7
    s42=all8MCPNstrs.s8
    xpts1=all8yvals.xpts1
    xpts2=all8yvals.xpts2
    xpts3=all8yvals.xpts3
    xpts4=all8yvals.xpts4
    xpts5=all8yvals.xpts5
    xpts6=all8yvals.xpts6
    xpts7=all8yvals.xpts7
    xpts8=all8yvals.xpts8

    Widget_Control, (*ptr).psddrawid, Get_Value=wid  ; get the window ID for drawing.

    ave_info=(*ptr).ave_info

    forward_function  SPEC_Nano2HMS_struct, strrepl

    delta_s =(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0
    if delta_s lt 10000.0 then  $
        delta_s ='dT='+string(delta_s,format='(F6.1)')+'s'  $
        else delta_s ='dT='+string(delta_s,format='(I6)')+'s'

    subfile_str=strsplit(!currentHFname,'\',/extract)
    plot_string2=strtrim(subfile_str(n_elements(subfile_str)-1),2)

    binfilename=strtrim(subfile_str(n_elements(subfile_str)-1),2)+'  '+delta_s

    !ZOOM_START_STRING =  SPEC_Nano2HMS(ave_info.StartNanoSeconds)
    !ZOOM_END_STRING =  SPEC_Nano2HMS(ave_info.EndNanoSeconds)
    plot_string = !ZOOM_START_STRING +"-" + !ZOOM_END_STRING

    message_string = 'cmp_psd data from ' + !ZOOM_START_STRING +  $
        " to " + !ZOOM_END_STRING + ' , ' + plot_string2

    Widget_Control, (*ptr).psddrawID, TLB_SET_TITLE = message_string

    WSet, wid
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)

    erase,color='ffffff'x  ; get background to white

    !P.MULTI = [0, 2, 2, 0, 0]
    !X.OMARGIN = [1.5,0.0]  ;We need this because the Area plot X axis label extends off the left edge of the window
    ;-------------------------------------------------------------------
    ; Determine which particles we're plotting, H or V
    ;-------------------------------------------------------------------
    xlog_setting = (*ptr).Xlog
    ylog_setting = (*ptr).Ylog

    ; xmin=min([xpts1,xpts2])
    ; xmax=max([xpts1,xpts2])

    if xlog_setting eq 1 then begin

        ;now get the axis maximum minimums for the plots
        y11s=y11;(bin_index)
        y12s=y12;(bin_index)
        y21s=y21;(bin_index)
        y22s=y22;(bin_index); These are used to get the Y-min ymax
        y31s=y31;(bin_index)
        y32s=y32;;(bin_index)
        y41s=y41;(bin_index)
        y42s=y42;(bin_index)

        index=where(y11s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y11s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y12s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y12s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ymax = max([y11s,y12s]) >10.0
        if ylog_setting eq 1 then begin
            ymax= ymax > 10.0;  take the maximum of the two values
            ymin = 10.0^floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Lab1_y =0.5*ymax
            lab1_yf=0.25*ymax
            Lab2_y =0.12*ymax
            lab2_yf=0.06*ymax
            Yrange_AB=[ymin,ymax]
        endif else begin  ; ylog=0
            ymax=1.05*ymax
            Yrange_AB=[0.0, ymax]
            Lab1_y=0.9*ymax
            Lab1_yf=0.8*ymax
            Lab2_y=0.7*ymax
            Lab2_yf=0.6*ymax
        endelse

        xmin=min([xpts1,xpts2])
        xmax=max([xpts1,xpts2])
        Xrange_AB=[10.0^floor(alog10(xmin)),10.0^ceil(alog10(Xmax))]
        !X.TICKS =0
        case  all4ytitles(4) of
            'Particle size (um)':        !X.TICKNAME =['10','100','1000']
            'Equivalent Diam (um)':      !X.TICKNAME =['10','100','1000']
            'Area (um^2)':               !X.TICKNAME =['10','100','1000']
            'Iwc_mass (ug)':             !X.TICKNAME =['0.0001','0.001','0.01']
            'Lwc_mass (ug)':             !X.TICKNAME =['0.0001','0.001','0.01']
        endcase


        PLOT, xpts1, y11, COLOR=bluecolor, XRANGE=XRANGE_AB, /Xlog,$;   xtitle='Particle Size(um)',$
            YTITLE=all4ytitles(0), Xstyle = 1, background= whitecolor,YLOG=ylog_setting,$
            THICK=1, YRANGE=Yrange_AB, charsize=1.0, $ ;TITLE=plot_string,
            pos=[0.08,0.57,0.46,0.97],xmargin=[3,1],YSTYLE=YStyle,xtitle=all4ytitles(4)
        oplot,xpts2,y12,color=redcolor
        ;***************************************************** upper-right corner
        xyouts,35, 705,plot_string,color=bluecolor,charsize=1.0,/device
        xyouts,25.0,370,s11+'  '+S12+' ', charsize=1.0,color=bluecolor,/device
        ;xyouts,25.0,374,s12+' ', charsize=1.0,color=redcolor,/device

        ;***************************************************** lower-left cornner
        ;******************************************************
        xyouts,30.0,10,ave_info.criteria.label, charsize=1.0,color=bluecolor,/device;  310 is in middle.
        ;end of plot 1 of 4 *******************************************************************************

        index=where(y21s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y21s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y22s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y22s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ymax = max([y21s,y22s])
        if ylog_setting eq 1 then begin
            ymin = 10.0 ^ floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Yrange_AB=[ymin,ymax]
        endif else begin
            Yrange_AB=[0.0,1.1*ymax]
        endelse

        xmin=min([xpts3,xpts4])
        xmax=max([xpts4,xpts4])
        Xrange_AB=[10.0^floor(alog10(xmin)),10.0^ceil(alog10(Xmax))]

        case  all4ytitles(4) of
            'Particle size (um)':        !X.TICKNAME =['10','100','1000']
            'Equivalent Diam (um)':      !X.TICKNAME =['10','100','1000']
            'Area (um^2)':               !X.TICKNAME =['10','100','1000']
            'Iwc_mass (ug)':          !X.TICKNAME =['0.0001','0.001','0.01']
            'Lwc_mass (ug)':          !X.TICKNAME =['0.0001','0.001','0.01']
        endcase


        PLOT, xpts3, y21, COLOR=bluecolor, XRANGE=XRANGE_AB, /Xlog,$
            Xstyle = 1, YLOG=ylog_setting,xtitle=all4ytitles(5),$;  TITLE=binfilename,
            THICK=1, YRANGE=yrange_AB,ystyle=ystyle,charsize=1.0,$
            pos=[0.58,0.57,0.96,0.97],xmargin=[3,1],$; Yticks=ytikn,Ytickn=myticknames,$
            YTITLE=all4ytitles(1);  Yticks=ytikn,Ytickn=myticknames
        oplot,xpts4,y22,COLOR=redColor
        xyouts,425, 705,binfilename,color=bluecolor,charsize=1.0,/device
        xyouts,425.0,370,s21+'  '+S22+' ', charsize=1.0,color=bluecolor,/device
        ; xyouts,425.0,374,s22+' ', charsize=1.0,color=redcolor,/device
        ;end of plot 2 of 4 *******************************************************************************

        index=where(y31s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y31s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y32s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y32s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ymax = max([y31s,y32s])
        if ylog_setting eq 1 then begin
            ymin = 10.0^floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Yrange_AB=[ymin,ymax]
        endif else begin
            Yrange_AB=[0.0,1.1*ymax]
        endelse
        xmin=min([xpts5,xpts6])
        xmax=max([xpts5,xpts6])
        Xrange_AB=[10.0^floor(alog10(xmin)),10.0^ceil(alog10(Xmax))]

        case  all4ytitles(4) of
            'Particle size (um)':        !X.TICKNAME =['10','100','1000']
            'Equivalent Diam (um)':      !X.TICKNAME =['10','100','1000']
            'Area (um^2)':               !X.TICKNAME =['10','100','1000']
            'Iwc_mass (ug)':          !X.TICKNAME =['0.0001','0.001','0.01']
            'Lwc_mass (ug)':          !X.TICKNAME =['0.0001','0.001','0.01']
        endcase


        PLOT, xpts5, y31, COLOR=bluecolor, XRANGE=XRANGE_AB, /Xlog,$
            YTITLE=all4ytitles(2), Xstyle = 1, YLOG=ylog_setting,background= whitecolor,$
            TITLE=' ', THICK=1, YRANGE=Yrange_AB,  $
            pos=[0.08,0.08,0.46,0.48],xmargin=[3,1],xtitle=all4ytitles(6),YSTYLE=YStyle
        oplot,xpts6,y32,color=redColor
        ; xyouts,25.0,360,s31+' ', charsize=1.0,color=bluecolor,/device
        xyouts,25.0,350,s31+'   '+s32+' ', charsize=1.0,color=redcolor,/device
        ;end of plot 3 of 4 *******************************************************************


        index=where(y41s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y41s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y42s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y42s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ymax = max([y41s,y42s]) ; plot the mass.
        if ylog_setting eq 1 then begin
            ymin = 10.0 ^ floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Yrange_AB=[ymin,ymax]
        endif else begin
            Yrange_AB=[0.0,1.1*Ymax]
        endelse

        xmin=min([xpts7,xpts8])
        xmax=max([xpts7,xpts8])
        Xrange_AB=[10.0^floor(alog10(xmin)),10.0^ceil(alog10(Xmax))]
        case  all4ytitles(4) of
            'Particle size (um)':        !X.TICKNAME =['10','100','1000']
            'Equivalent Diam (um)':      !X.TICKNAME =['10','100','1000']
            'Area (um^2)':               !X.TICKNAME =['10','100','1000']
            'Iwc_mass (ug)':             !X.TICKNAME =['0.0001','0.001','0.01']
            'Lwc_mass (ug)':             !X.TICKNAME =['0.0001','0.001','0.01']
        endcase

        ;************************************************************************
        !X.TICKNAME =['0.0001','0.001','0.01']
        !X.TICKS =0
        PLOT, xpts7, y41, COLOR=blueColor, XRANGE=XRANGE_AB, Xlog=xlog_setting,$
            XTITLE=all4ytitles(7), Xstyle = 1, YLOG=ylog_setting,$
            THICK=1,YRANGE=Yrange_AB,YSTYLE=YStyle,$
            pos=[0.58,0.08,0.96,0.48],xmargin=[3,1],$;Yticks=ytiknm,Ytickn=myticknames,$
            YTITLE=all4ytitles(3),title='  ';                          '
        oplot,xpts8, y42,COLOR=redColor
        ;xyouts,425.0,360,s41+' ', charsize=1.0,color=bluecolor,/device
        xyouts,425.0,350,s41+'   '+s42+' ', charsize=1.0,color=redcolor,/device
        ;end of plot 4 of 4 *****************************************************************

    endif else begin ; if xlog=0
        ;find how many ticsk
        done=0
        count=1
        while done eq 0 do begin
            nticks=(round(xmax-xmin))/(count*10)
            if nticks le 6 then begin
                ticknames=[strtrim(xmin,2)]
                delta_x=count*10
                for i=1, nticks do begin
                    ticknames=[ticknames, strtrim(xmin+i*delta_x,2)]
                endfor
                done=1
            endif
            count=count+1
        endwhile
        !X.ticks=nticks
        !X.tickname=ticknames
        xmax=xmin+nticks*delta_x
        Xrange_AB=[xmin,xmax]
        ;get the bin index that are within the limit of xmin and xmax
        bin_index=where(xpts1 ge xmin and xpts1 le xmax, contGG)
        if contGG eq 0 then begin
            rrr=dialog_message('No bins within the specified limits, try again!',/information)
            return
        endif
        ;now get the axis maximum minimums for the plots
        y11s=y11(bin_index)
        y12s=y12(bin_index)
        y21s=y21(bin_index)
        y22s=y22(bin_index); These are used to get the Y-min ymax
        y31s=y31(bin_index)
        y32s=y32(bin_index)
        y41s=y41(bin_index)
        y42s=y42(bin_index)
        ;get_mean_size_and_standardDev,all8yvals,xpts,Bin_index,y11sm,y11sd,y12sm,y12sd

        Lab1_x=xmin+0.5*delta_x
        index=where(y11s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y11s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y12s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y12s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ymax = max([y11s,y12s])
        if (ylog_setting eq 1) then begin
            ymax= ymax > 10.0;  take the maximum of the two values
            ymin = 10.0^floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Lab1_y =0.7*ymax
            lab1_yf=0.5*ymax
            Lab2_y =0.3*ymax
            lab2_yf=0.2*ymax
            Yrange_AB1=[ymin,ymax]
        endif else begin
            ymax=1.05*ymax
            Lab1_y=0.9*ymax
            Lab1_yf=0.8*ymax
            Lab2_y=0.7*ymax
            Lab2_yf=0.6*ymax
            Yrange_AB1=[0.0,ymax]
        endelse;           ;Xrange_AB=[xmin, xmax];[10,3000.0]

        lab1_x=120

        PLOT, xpts1, y11, COLOR=bluecolor, XRANGE=XRANGE_AB, Xlog=0,$
            YTITLE=all4ytitles(0), Xstyle = 1, background= whitecolor,YLOG=Ylog_setting,$
            THICK=1, YRANGE=Yrange_AB1,Ystyle=1, charsize=1.0,xticks=!X.ticks, $;TITLE=plot_string,xtickinterval=delta_x,$
            pos=[0.08,0.57,0.46,0.97],xmargin=[3,1];   xtitle='Particle Size(um)'
        oplot,xpts2,y12,color=redcolor
        xyouts,55, 705,plot_string,color=bluecolor,charsize=1.0,/device
        xyouts,65.0,384,s11+' ', charsize=1.0,color=bluecolor,/device
        xyouts,65.0,374,s12+' ', charsize=1.0,color=redcolor,/device

        ;******************************************************
        xyouts,30.0,10,ave_info.criteria.label, charsize=1.0,color=bluecolor,/device;  310 is in middle.

        ;end of plot 1 of 4 *******************************************************************************

        index=where(y21s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y21s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y22s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y22s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ymax = max([y21s,y22s])
        if (ylog_setting eq 1) then begin
            ymin = 10.0 ^ floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Lab1_y=0.6*ymax
            Lab2_y=0.2*ymax
        endif else begin
            ymin = ymin
            ymax = 1.05*ymax
            Lab1_y=0.9*ymax
            Lab2_y=0.8*ymax
        endelse
        Yrange_AB=[ymin,ymax]

        ;get yticks numbers and xy for axis plots and the Yticklables;.
        ytikn=ceil(Alog10(ymax))-floor(Alog10(Ymin))
        yymo1=10.0^(floor(Alog10(YMin)))
        yymo2=10.0^(ceil(Alog10(YMax)))
        convert_thisValue_to_string,yymo1, myticknames
        myticknames=' '
        for i=1,ytikn do begin
            this_value=10.^( floor(Alog10(ymin)) +i)
            convert_thisValue_to_string,this_value,this_string
            myticknames=[myticknames,this_string]
        endfor

        PLOT, xpts3, y21, COLOR=bluecolor, XRANGE=XRANGE_AB, Xlog=xlog_setting,$
            Xstyle = 1, YLOG=ylog_setting,$;  xtitle='Particle Size(um)',$; TITLE=binfilename,$
            THICK=1, YRANGE=Yrange_AB,ystyle=ystyle,charsize=1.0,$;   ; xtickinterval=delta_x,$
            pos=[0.58,0.57,0.96,0.97],xmargin=[3,1],$; Yticks=ytikn,Ytickn=myticknames,$
            YTITLE=all4ytitles(1);  Yticks=ytikn,Ytickn=myticknames
        oplot,xpts4,y22,COLOR=redColor
        xyouts,425, 705,binfilename,color=bluecolor,charsize=1.0,/device
        xyouts,425.0,384,s21+' ', charsize=1.0,color=bluecolor,/device
        xyouts,425.0,374,s22+' ', charsize=1.0,color=redcolor,/device

        ;end of plot 2 of 4 *******************************************************************************

        index=where(y31s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y31s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y32s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y32s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ymax = max([y31s,y32s])
        if (ylog_setting eq 1) then begin
            ymin = 10.0^floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Lab1_y=0.6*ymax
            Lab2_y=0.2*ymax
        endif else begin
            ymin = ymin
            ymax = 1.05*ymax
            Lab1_y=0.9*ymax
            Lab2_y=0.8*ymax
        endelse
        Yrange_AB=[ymin,ymax]

        PLOT, xpts5, y31, COLOR=bluecolor, XRANGE=XRANGE_AB, Xlog=xlog_setting,$
            YTITLE=all4ytitles(2), Xstyle = 1, YLOG=Ylog_setting,background= whitecolor,$
            TITLE=' ', THICK=1, YRANGE=Yrange_AB,$; xtickinterval=delta_x, $
            pos=[0.08,0.08,0.46,0.48],xmargin=[3,1],xtitle='Particle Size(um)',YSTYLE=YStyle
        oplot,xpts6,y32,color=redColor
        xyouts,25.0,360,s31+' ', charsize=1.0,color=bluecolor,/device
        xyouts,25.0,350,s32+' ', charsize=1.0,color=redcolor,/device

        ;end of plot 3 of 4 *******************************************************************


        index=where(y41s ne 0.0,contG)
        if contG gt 0 then  ymin = min(y41s(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
        index=where(y42s ne 0.0,contG)
        if contG gt 0 then  ymin_v = min(y42s(index)) else ymin_v=0.1
        if (ymin_v lt ymin) then ymin = ymin_v

        ;get yticks numbers and xy for axis plots and the Yticklables;.
        ytikn=ceil(Alog10(ymax))-floor(Alog10(Ymin))
        yymom1=10.0^(floor(Alog10(YMin)))
        yymom2=10.0^(ceil(Alog10(YMax)))
        convert_thisValue_to_string,yymo1, myticknames
        myticknames=' '
        for i=1,ytikn do begin
            this_value=10.^( floor(Alog10(ymin)) +i)
            convert_thisValue_to_string,this_value,this_string
            myticknames=[myticknames,' ']
        endfor

        ymax = max([y41s,y42s]) ; plot the mass.
        if (ylog_setting eq 1) then begin
            ymin = 10.0^floor(alog10(ymin))
            ymax = 10.0^ceil(alog10(ymax))
            Lab1_y=0.6*ymax
            Lab2_y=0.2*ymax
        endif else begin
            ymin = ymin
            ymax = 1.05*ymax
            Lab1_y=0.9*ymax
            Lab2_y=0.8*ymax
        endelse
        Yrange_AB=[ymin,ymax]

        ;*********** find out meddianVD from the PSD *****************************

        PLOT, xpts7, y41, COLOR=blueColor, XRANGE=XRANGE_AB, Xlog=xlog_setting,$
            XTITLE='Particle Size(um)', Xstyle = 1, YLOG=ylog_setting,$
            PSYM=10, THICK=1,YRANGE=Yrange_AB,YSTYLE=1,$
            pos=[0.58,0.08,0.96,0.48],xmargin=[3,1],$;Yticks=ytiknm,Ytickn=myticknames,$
            YTITLE=all4ytitles(3),title='  '; xtickinterval=delta_x;                          '
        oplot,xpts8, y42,COLOR=redColor
        xyouts,425.0,360,s41+' ', charsize=1.0,color=bluecolor,/device
        xyouts,425.0,350,s42+' ', charsize=1.0,color=redcolor,/device
        ;end of plot 4 of 4 ****************************************************************
    endelse; endelse fro xlog=0
    ;start annotation

    figure1_labeled=0
    if strmid(s11,5,4) eq 'eqdm' and strmid(s12,5,4) eq 'eqdm' then begin
        ;(*ptr).label11='Mnsize='+strtrim(round(y11sm),2)+' std='+strtrim(round(y11sd),2)
        ;(*ptr).label12='Mnsize='+strtrim(round(y12sm),2)+' std='+strtrim(round(y12sd),2)
        figure1_labeled=1
    endif else begin

    endelse
    if figure1_labeled eq 0 then begin
        (*ptr).label11=''
        (*ptr).label12=''
    endif

    figure2_labeled=0
    if strmid(s21,5,4) eq 'eqdm' and strmid(s22,5,4) eq 'eqdm' then begin
        ;(*ptr).label21='Mnsize='+strtrim(round(y21sm),2)+' std='+strtrim(round(y21sd),2)
        ;(*ptr).label22='Mnsize='+strtrim(round(y22sm),2)+' std='+strtrim(round(y22sd),2)
        figure2_labeled=1
    endif else begin


    endelse
    if figure2_labeled eq 0 then begin
        (*ptr).label21=''
        (*ptr).label22=''
    endif


    figure3_labeled=0
    if strmid(s31,5,4) eq 'eqdm' and strmid(s32,5,4) eq 'eqdm' then begin
        ;(*ptr).label31='Mnsize='+strtrim(round(y31sm),2)+' std='+strtrim(round(y31sd),2)
        ;(*ptr).label32='Mnsize='+strtrim(round(y32sm),2)+' std='+strtrim(round(y32sd),2)
        figure3_labeled=1
    endif else begin

    endelse
    if figure3_labeled eq 0 then begin
        (*ptr).label31=''
        (*ptr).label32=''
    endif

    figure4_labeled=0
    if strmid(s41,5,4) eq 'eqdm' and strmid(s42,5,4) eq 'eqdm' then begin
        ;(*ptr).label41='Mnsize='+strtrim(round(y41sm),2)+' std='+strtrim(round(y41sd),2)
        ;(*ptr).label42='Mnsize='+strtrim(round(y42sm),2)+' std='+strtrim(round(y42sd),2)
        figure4_labeled=1
    endif  else begin

    endelse
    if figure4_labeled eq 0 then begin
        (*ptr).label41=''
        (*ptr).label42=''
    endif
end;  end of Draw-averaged_8psds_area
;********************************************************************************************************
;***************************************************************************************
pro write_compare_psd_ascii,ptr

    ;get the output file name.
    ave_info=(*ptr).ave_info
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'asscii\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "ascii\"
    outputfilename=!currentHPname+'ascii\MxC0_PSD_CMP_'+plot_string+'.txt'
    ;open file to write
    openw, 88,outputfilename
    printf,88,'PSD_compare psd plot file generated at   ',systime()
    printf,88,ave_info.binfilename;  ;input_filename
    printf,88,'Time period is:  ',ave_info.plot_string
    printf,88,'The criteria applied to get the subset of data is:'
    printf,88,ave_info.criteria.label
    printf,88,'Bins are fixed into 200 bins, 400 binheights'
    printf,88,'The 8 traces are in the following  order:'
    ;***********************************************
    aaa=strsplit( (*ptr).psdlabels.y1, ':',/extract)
    s1=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y2, ':',/extract)
    s2=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y3, ':',/extract)
    s3=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y4, ':',/extract)
    s4=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y5, ':',/extract)
    s5=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y6, ':',/extract)
    s6=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y7, ':',/extract)
    s7=strjoin(aaa(0:2),'-')
    aaa=strsplit( (*ptr).psdlabels.y8, ':',/extract)
    s8=strjoin(aaa(0:2),'-')
    ;************************************************
    printf,88,format='(9A11)','xbin_edges',s1,s2,s3,s4,s5,s6,s7,s8
    y1=(*ptr).psdvalues.y1
    y2=(*ptr).psdvalues.y2
    y3=(*ptr).psdvalues.y3
    y4=(*ptr).psdvalues.y4
    y5=(*ptr).psdvalues.y5
    y6=(*ptr).psdvalues.y6
    y7=(*ptr).psdvalues.y7
    y8=(*ptr).psdvalues.y8
    xpts=(*ptr).psdvalues.x1
    for i=0L,n_elements(y1)-1L do begin
        printf,88,format='(F8.1,1x,7(E11.4,1x),E11.4)',xpts(i),y1(i),y2(i),y3(i),y4(i),y5(i),y6(i),y7(i),y8(i)
    endfor
    close,88
end; ;end of write_compare_tms_ascii,ptr
;***********************************************************************

;**********************************************************************
pro display_psd_help_message
    psd_help_message=[['1. Save config is to save current button setups.'],$
        ['                                                '],$
        ['2. Load config is to load last saved button setups.'],$
        ['   After loading, the droplist has only 1 option,'],$
        ['   click reset and you will have more options again.'],$
        ['                                                '],$
        ['3. Save png is to save the plot as a png file.'],$
        ['                                                '],$
        ['4. Save ascii is to save the plot as an ascii file.'],$
        ['                                                '],$
        ['5. Update is to update the plot of the current setup.'],$
        ['                                                '],$
        ['6. Reset is to set the buttons to the default options.'],$
        ['                                                '],$
        ['7. M option M1,.M5 is for method, which means using '],$
        ['   different size of the image for calculation. for example:'],$
        ['   M1 uses particle size along the airplane movement direction.'],$
        ['   M2 uses particle size along the photodiode array. '],$
        ['   M4 uses Particle size after corrected by Alexei"s method.'],$
        ['   Note that M2-LWC psd could be a lot larger than other IWC, LWC psd'],$
        ['                                                '],$
        ['8. C option is to choose images from H or V channel.'],$
        ['                                                '],$
        ['9. P option is to choose Parameter #/bin, #/L/um, and '],$
        ['      Extinction, g/m3/um.               '],$
        ['                                                '],$
        ['10. This window is for comparing the results from '],$
        ['    different methods and/or channels.'],$
        ['                                      '],$
        ['11. "M1:H:conc:5041" means concentration using size L1n'],$
        ['     from H channel, and there are 5041 particles in'],$
        ['     chosen time period.'] ]
    rrr=dialog_message(psd_help_message,/information)

end;  end of display_psd_help_message
;*******************************************************************
pro save_psd_png,ptr
    Widget_Control, (*ptr).psddrawid, Get_Value=wid  ; get the window ID for drawing.
    ave_info=(*ptr).ave_info
    ;get the output file name.
    plot_string=strjoin(strsplit(ave_info.plot_string,':',/extract)); take away':' from the string.
    junk=findfile(!currentHPname+'png\*.*')
    if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "png\"
    outputfilename=!currentHPname+'png\MxC0_PSD_CMP_'+plot_string+'.png'
    wset,wid
    write_png,outputfilename,tvrd(true=1)
end; end of save_psd_png, ptr
;************************************************************
pro send_psd_png_to_printer,ptr
    Widget_Control, (*ptr).psddrawid, Get_Value=wid  ; get the window ID for drawing.
    wset,wid
    printwindow,wid;/landscape
end; end of send_psd_png_to_printer
;**************************************************************

pro get_default_psd_trace1to8_area,ave_info,this_method,xxx,all8yvals,all8MCPNstrs,all4ytitles
    widget_control,/hourglass
    ;for trace1
    This_channel='H'
    this_param  ='binc'
    ;TAF commenting out get_one_psd_trace_area, unresolved, for making working .sav files
    stop
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x11,y11,count11
    str1=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count11),2)
    xxx=x11
    ytitle_str1='#/bin '


    This_channel='V'
    this_param  ='binc'
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x12,y12,count12
    str2=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count12),2)

    This_channel='H'
    this_param  ='conc'
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x21,y21,count21
    str3=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count21),2)
    ytitle_str2='#/L/um '

    This_channel='V'
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x22,y22,count22
    str4=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count22),2)


    This_channel='H'
    this_param  ='area'
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x31,y31,count31
    str5=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count31),2)
    ytitle_str3='mm^2/L/um '

    This_channel='V'
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x32,y32,count32
    str6=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count32),2)

    This_channel='H'
    this_param  ='mass'
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x41,y41,count41
    str7=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count41),2)
    ytitle_str4='g/m3/um'

    This_channel='V'
    ;get_one_psd_trace_area,ave_info,this_method,this_channel,this_param,x42,y42,count42
    str8=this_method+":"+this_channel+":"+this_param+":"+strtrim(string(count42),2)

    all8yvals   ={xpts:float(x42),y1:y11, y2:y12, y3:y21, y4:y22, y5:y31, y6:y32, y7:y41, y8:y42}
    all8MCPNstrs={s1:str1,s2:str2,s3:str3,s4:str4,s5:str5,s6:str6,s7:str7,s8:str8}
    all4ytitles =[ytitle_str1,ytitle_str2,ytitle_str3,ytitle_str4]
    ;(*ptr).psdvalues=all8yvals
    ;(*ptr).psdlabels=all8MCPNstrs
end; end of get_default_psd_trace1to8_area,ave_info,this_method,xpts,y11,y12,y21,y22,y31,y32,y41,y42

;**************************************************************************************************

;**************************************************************************************************
;+
; NAME
;   PRINTWINDOW

;    This program sends the contents of the specified
;    window to the default printer. The current window
;    is used if a window index number is not provided.

; AUTHOR:

;   FANNING SOFTWARE CONSULTING
;   David Fanning, Ph.D.
;   1645 Sheely Drive
;   Fort Collins, CO 80526 USA
;   Phone: 970-221-0438
;   E-mail: davidf@dfanning.com
;   Coyote's Guide to IDL Programming: http://www.dfanning.com/

; CATEGORY:

;  Graphics

; CALLING SEQUENCE:

;  IDL> PrintWindow, wid ; IDL>Printwindow,wid,/landscape; IDL>Printwindow,wid,/landscape,

; OPTIONAL POSITIONAL PARAMETERS:

;   WID       The window index number of the window to send to the
;             printer. !D.Window used by default.

; KEYWORD PARAMETERS:

;   LANDSCAPE  If this keyword is set, the output is in Landscape
;              mode. Otherwise, Portrait mode is used.

;   PAGESIZE: Set this keyword to a string indicating the type
;             of PostScript page size you want. Current values are "LETTER",
;             "LEGAL", and "A4". Default is "LETTER".

; MODIFICATION HISTORY:

; Written by David Fanning based on previous PRINT_IT program. 29 July 2000.
;-
;###########################################################################

; LICENSE

; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.

; Copyright  2000 Fanning Software Consulting

; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.

; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:

; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.

; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.

; 3. This notice may not be removed or altered from any source distribution.

; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.

;###########################################################################


FUNCTION PRINTWINDOW_PSWINDOW_ASPECT, aspectRatio, MARGIN=margin, WindowAspect=wAspectRatio

    ON_ERROR, 1

    ; Check for aspect ratio parameter and possibilities.

    IF N_PARAMS() EQ 0 THEN aspectRatio = 1.0

    IF aspectRatio EQ 0 THEN BEGIN
        MESSAGE, 'Aspect Ratio of 0. Changing to 1...', /Informational
        aspectRatio = 1.0
    ENDIF

    s = SIZE(aspectRatio)
    IF s(s(0)+1) NE 4 THEN $
        MESSAGE, 'Aspect Ratio is not a FLOAT. Take care...', /Informational

    ; Check for margins.

    IF N_ELEMENTS(margin) EQ 0 THEN margin = 0.15

    ; Error checking.

    IF margin LT 0 OR margin GE 0.5 THEN $
        MESSAGE, 'The MARGIN keyword value must be between 0.0 and 0.5.'

    ; Calculate the aspect ratio of the current window.

    IF N_Elements(wAspectRatio) EQ 0 THEN wAspectRatio = FLOAT(!D.Y_VSIZE) / !D.X_VSIZE

    ; Calculate normalized positions in window.

    IF (aspectRatio LE wAspectRatio) THEN BEGIN
        xstart = margin
        ystart = 0.5 - (0.5 - margin) * (aspectRatio / wAspectRatio)
        xend = 1.0 - margin
        yend = 0.5 + (0.5 - margin) * (aspectRatio / wAspectRatio)
    ENDIF ELSE BEGIN
        xstart = 0.5 - (0.5 - margin) * (wAspectRatio / aspectRatio)
        ystart = margin
        xend = 0.5 + (0.5 - margin) * (wAspectRatio / aspectRatio)
        yend = 1.0 - margin
    ENDELSE

    position = [xstart, ystart, xend, yend]

    RETURN, position
END ; ----------------------------------------------------------------------------------



FUNCTION PRINTWINDOW_PSWINDOW, LANDSCAPE=landscape, CM=cm, MARGIN=margin, $
    PageSize=pagesize, Printer=printer, Fudge=fudge, XFudge=xfudge, YFudge=yfudge

; Set up default values.

landscape = Keyword_Set(landscape)
cm = Keyword_Set(cm)
printer = Keyword_Set(printer)
inches = 1

; Set up printer fudge factors, if necessary.

IF N_Elements(fudge) NE 0 THEN BEGIN
    xfudge = fudge
    yfudge = fudge
ENDIF
IF N_Elements(xfudge) EQ 0 THEN xfudge = 0.0
IF N_Elements(yfudge) EQ 0 THEN yfudge = 0.0

; Get the page size.

IF N_Elements(pagesize) EQ 0 THEN pagesize = 'LETTER' $
    ELSE pagesize = StrUpCase(pagesize)
CASE pagesize OF
    'LETTER': BEGIN
        shortside = 8.5
        longside = 11.0
    ENDCASE
    'LEGAL': BEGIN
        shortside = 8.5
        longside = 14.0
    ENDCASE
    'A4': BEGIN
        shortside = 8.27
        longside = 11.7
    ENDCASE
    ELSE: BEGIN
        Message, 'Unknown page size. Using LETTER...', /Informational
        shortside = 8.5
        longside = 11.0
    ENDCASE
ENDCASE

; Need measurements in centimeters?

IF KEYWORD_SET(cm) THEN BEGIN
    shortside = shortside * 2.54
    longside = longside * 2.54
    inches = 0
ENDIF

; Determine the margin of the window on the page.

IF N_ELEMENTS(margin) EQ 0 THEN margin=0.15

; Get the aspect ratio of the current display window. Aspect ratio
; is ratio of xsize/ysize.

aspectRatio = FLOAT(!D.Y_VSIZE) / !D.X_VSIZE

; Get the aspect ratio of the page.

IF Keyword_Set(landscape) THEN pAspectRatio = shortside / longside $
    ELSE pAspectRatio = longside / shortside

; Get the position on the page for this window.

pos = PRINTWINDOW_PSWindow_Aspect(aspectRatio, Margin=margin, WindowAspect=pAspectRatio)

; Convert normalized position coordinates to size units.

IF KEYWORD_SET(landscape) THEN BEGIN
    IF printer THEN BEGIN
        xsize = (pos[2] - pos[0]) * longside
        ysize = (pos[3] - pos[1]) * shortside
        yoffset = pos[1] * shortside - yfudge
        xoffset = pos[0] * longside - xfudge
        landscape = 1
        portrait = 0
    ENDIF ELSE BEGIN
        xsize = (pos[2] - pos[0]) * longside
        ysize = (pos[3] - pos[1]) * shortside
        xoffset = pos[1] * shortside
        yoffset = longside - (pos[0] * longside)
        landscape = 1
        portrait = 0
    ENDELSE
ENDIF ELSE BEGIN
    xsize = (pos[2] - pos[0]) * shortside
    ysize = (pos[3] - pos[1]) * longside
    IF printer THEN BEGIN
        xoffset = pos[0] * shortside - xfudge
        yoffset = pos[1] * longside - yfudge
    ENDIF ELSE BEGIN
        xoffset = pos[0] * shortside
        yoffset = pos[1] * longside
    ENDELSE
    landscape = 0
    portrait = 1
ENDELSE

; Return the proper DEVICE data structure.

RETURN, {PSWINDOW_STRUCT, XSIZE:xsize, YSIZE:ysize, $
    XOFFSET:xoffset, YOFFSET:yoffset, INCHES:inches, $
    PORTRAIT:portrait, LANDSCAPE:landscape}

END ;--------------------------------------------------------------------------------------



FUNCTION PrintWindow_Error, theMessage, Traceback=traceback, NoName=noName

    On_Error, 2

    ; Check for presence and type of message.

    IF N_Elements(theMessage) EQ 0 THEN theMessage = !Error_State.Msg
    s = Size(theMessage)
    messageType = s[s[0]+1]
    IF messageType NE 7 THEN BEGIN
        Message, "The message parameter must be a string.", _Extra=extra
    ENDIF

    ; Get the call stack and the calling routine's name.

    Help, Calls=callStack
    callingRoutine = (Str_Sep(StrCompress(callStack[1])," "))[0]

    ; Are widgets supported? Doesn't matter in IDL 5.3 and higher.

    widgetsSupported = ((!D.Flags AND 65536L) NE 0) OR Float(!Version.Release) GE 5.3
    IF widgetsSupported THEN BEGIN
        IF Keyword_Set(noName) THEN answer = Dialog_Message(theMessage, _Extra=extra) ELSE BEGIN
            IF StrUpCase(callingRoutine) EQ "$MAIN$" THEN answer = Dialog_Message(theMessage, _Extra=extra) ELSE $
                answer = Dialog_Message(StrUpCase(callingRoutine) + ": " + theMessage)
        ENDELSE
    ENDIF ELSE BEGIN
        Message, theMessage, /Continue, /NoPrint, /NoName, /NoPrefix, _Extra=extra
        Print, '%' + callingRoutine + ': ' + theMessage
        answer = 'OK'
    ENDELSE

    ; Provide traceback information if requested.

    IF Keyword_Set(traceback) THEN BEGIN
        Help, /Last_Message, Output=traceback
        Print,''
        Print, 'Traceback Report from Error_Message:'
        Print, ''
        FOR j=0,N_Elements(traceback)-1 DO Print, "     " + traceback[j]
    ENDIF

    RETURN, answer
END ;-----------------------------------------------------------------------------------


PRO PrintWindow, wid, Landscape=landscape, PageSize=pageSize

    ; Check parameters.

    IF N_Params() EQ 0 THEN wid = !D.Window
    landscape = Keyword_Set(landscape)
    IF N_Elements(pagesize) EQ 0 THEN pagesize = 'LETTER' $
        ELSE pagesize = StrUpCase(pagesize)

    CASE pagesize OF
        'LETTER': BEGIN
            shortside = 8.5
            longside = 11.0
        ENDCASE
        'LEGAL': BEGIN
            shortside = 8.5
            longside = 14.0
        ENDCASE
        'A4': BEGIN
            shortside = 8.27
            longside = 11.7
        ENDCASE
        ELSE: BEGIN
            Message, 'Unknown page size. Using LETTER...', /Informational
            shortside = 8.5
            longside = 11.0
        ENDCASE
    ENDCASE

    ; Are we running on a 24-bit device?

    Catch, theError
    IF theError NE 0 THEN BEGIN
        theDepth = 8
        GOTO, testDepth
    ENDIF
    Device, Get_Visual_Depth=theDepth
    testDepth:
    IF theDepth GT 8 THEN truecolor = 1 ELSE truecolor = 0

    ; Main error handler.

    Catch, theError
    IF theError NE 0 THEN BEGIN
        Catch, /Cancel
        ok = PrintWindow_Error(!Error_State.Msg)
        RETURN
    ENDIF

    ; Valid window ID?

    IF wid LT 0 THEN Message, 'No graphics window currently open.', /NoName

    ; Get information about printer.

    ok = Dialog_PrinterSetup()
    IF NOT ok THEN RETURN

    ; Make the window current. Get contents.

    thisWindow = !D.Window
    WSet, wid
    contents = TVRD(True=truecolor)

    ; Need a window on printer with same aspect ratio as current window.
    ; Your fudge factor (to account for offsets calculated from the printable
    ; edge of the page rather than the real edge of the page) may be different.

    keywords = PRINTWINDOW_PSWindow(/Printer, Landscape=landscape, Fudge=0.25, PageSize=pagesize, Margin=0)

    ; Change the current device to PRINTER. Copy color table.

    thisDevice = !D.Name

    Set_Plot, 'PRINTER', /Copy

    ; Reset the PRINTER for proper calculations. Landscape mode
    ; has to be set separately from sizes. I don't know why.

    Device, Scale_Factor=1, Portrait=1
    Device, Landscape = keywords.landscape

    ; Configure the printer.

    Device, _Extra=keywords

    ; Print it.

    TV, contents, True=truecolor, XSize=keywords.xsize, $
        YSize=keywords.ysize, Inches=keywords.inches
    Plots, [0,0,1,1,0], [0,1,1,0,0], /Normal
    Device, /Close_Document

    ; Clean up.

    Set_Plot, thisDevice
    WSet, thisWindow

END




;**************************************************************************************************
;**************************************************************************************************

;*************************************************************************************************
pro Get_mean_median_medianv_size_from_sphere_conc_psd,binedges,binhs,$ ;input
    meanD,medianD,medianvD,LWC;output

n=n_elements(binedges)
sz_threshold=0.1

;get conc_gt_sz_threshold
index=where(binedges ge sz_threshold,contG)
if contG gt 0 then begin
    conc_gt_sz_threshold=0.0
    for i=index(0),n-2 do begin
        bin_width=binedges(i+1)-binedges(i)
        conc_gt_sz_threshold=conc_gt_sz_threshold+binhs(i)*bin_width
    endfor
endif else conc_gt_sz_threshold=0.0

;get size_at_psd_pk
max_binh=max(binhs,/NaN)
if max_binh ne 0.0 then begin
    index=where(binhs eq max_binh);  binh at two index of same value
    size_at_psd_pk=(binedges(index(0))+binedges(index(1)))/2.0
endif else size_at_psd_pk=0.0

;get the mean diameter
;get total_number of particles
totN=0.0
accum_ND=0.0
accum_V =0.0
for i=0,n-2 do begin
    binwidth=binedges(i+1)-binedges(i)
    totN=totN+binhs(i)*binwidth
    bincenter=(binedges(i+1)+binedges(i))/2.0
    accum_ND=accum_ND+binhs(i)*binwidth*bincenter
    accum_V =accum_V +binhs(i)*binwidth*(bincenter^3.0); assume to be sphere
endfor

if totN eq 0 then meanD=0.0 else meanD=accum_ND/totN

;get the median diamter
contN=0.0
for i=0,n-2 do begin
    bin_width=binedges(i+1)-binedges(i)
    bincenter=(binedges(i+1)+binedges(i))/2.0
    contN=contN+binhs(i)*bin_width
    if contN ge totN/2.0 then begin
        medianD=bincenter
        break
    endif
endfor

;get the medianV diameter

contV=0.0
for i=0,n-2 do begin
    bin_width=binedges(i+1)-binedges(i)
    bincenter=(binedges(i+1)+binedges(i))/2.0
    contV=contV+binhs(i)*bin_width*bincenter^3.0
    if contV ge accum_V/2.0 then begin
        deltV=contV-accum_V/2.0
        binV=binhs(i)*bin_width*bincenter^3.0
        if binV ne 0.0 then begin
            percent=deltV/binV
            medianVD=bincenter-percent*bin_width
        endif else medianVD=0.0
        break
    endif
endfor

LWC=accum_V*10.0^(-9)*!pi/6.0;  g/M3
end; ;end of get_conc_mod_from_sphere_conc_psd
;***********************************************************************************************

pro PSD_GraphClick_area, event

    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

    height = 720;info.yscale(1)
    width =  800;info.xscale(1)

    ongraph = 0B
    ptr=*info

    whitecolor = GetColor("White", !D.Table_Size-2)
    bluecolor = GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("red", !D.Table_Size-2)

    IF  ptr.makenotes EQ 1 then begin

        ; ------------------------------------------------------------------
        ; Mouse on chart, figure out which chart
        ;------------------------------------------------------------------

        if ptr.clicks eq 0 then begin

            if ((event.X GE (width * 0.1 )) and (event.X LE (width * 0.4)) and $
                (event.y GE (height * 0.5)) and (event.y LE (width * 0.9))  )  THEN BEGIN
                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=0
                wait,0.1

                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=whitecolor
                ongraph = 1B
            endif else ongraph=0B

            IF (event.PRESS GE 1) and ongraph EQ 1B  then  begin
                xyouts,event.x,event.y,ptr.label11,color=bluecolor,/device
                xyouts,event.x,event.y-10,ptr.label12,color=redcolor,/device
                ptr.clicks=1
            endif
        endif

        if ptr.clicks eq 1 then begin

            if ((event.X GE (width * 0.5)) and (event.X LE (width * 0.9)) and $
                (event.y GE (height * 0.5)) and (event.y LE (width * 0.9))  )  THEN BEGIN
                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=0
                wait,0.1

                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=whitecolor
                ongraph = 1B
            endif else ongraph=0B

            IF (event.PRESS GE 1) and ongraph EQ 1B  then  begin
                xyouts,event.x,event.y,ptr.label21,color=bluecolor,/device
                xyouts,event.x,event.y-10,ptr.label22,color=redcolor,/device
                ptr.clicks=2
            endif
        endif

        if ptr.clicks eq 2 then begin

            if ((event.X GE (width * 0.1)) and (event.X LE (width * 0.4)) and $
                (event.y GE (height * 0.1)) and (event.y LE (width * 0.5))  )  THEN BEGIN
                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=0
                wait,0.1

                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=whitecolor
                ongraph = 1B
            endif else ongraph=0B

            IF (event.PRESS GE 1) and ongraph EQ 1B  then  begin
                xyouts,event.x,event.y,ptr.label31,color=bluecolor,/device
                xyouts,event.x,event.y-10,ptr.label32,color=redcolor,/device
                ptr.clicks=3
            endif
        endif

        if ptr.clicks eq 3 then begin

            if ((event.X GE (width * 0.5)) and (event.X LE (width * 0.9)) and $
                (event.y GE (height * 0.1)) and (event.y LE (width * 0.5))  )  THEN BEGIN
                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=0
                wait,0.1

                plots,[event.x,event.x+25,event.x+25,event.x,event.x],$
                    [event.y,event.y,event.y-25,event.y-25,event.y],$
                    /device,color=whitecolor
                ongraph = 1B
            endif else ongraph=0B

            IF (event.PRESS GE 1) and ongraph EQ 1B  then  begin
                xyouts,event.x,event.y,ptr.label41,color=bluecolor,/device
                xyouts,event.x,event.y-10,ptr.label42,color=redcolor,/device
                ptr.clicks=0
                ptr.makenotes=0
            endif
        endif


    ENdIF

    info=ptr_new(ptr)
    Widget_Control, event.top, Set_UValue=info, /No_Copy

end ;== PSD_graphicclick_area====================================================================
