
; File: compile3vcpi.pro
; Purpose:  compiles and runs the IDL 3V-CPI View tools

aa ; sets the current directory to the IDL path

; from compile2dsview

.compile  Moqixu_input_single_number_pop_up     ;Moved here to eliminate Linux compilation errors

.compile  processparticle
.compile  a3VCPIView
define_current_3vcpiview_version
.compile  strreplace
.compile  a3VCPIView_psd_methods
.compile  a3vcpiview_tms_methods
.compile  a3VCPIView_zoomedHstrip
.compile  a3VCPIView_zoomedVstrip
.compile  a3vcpiview_MVstrip
.compile  a3vcpiview_zoomedstereostrip
.compile  a3VCPIView_HK_plots

.compile  basic_fish_2ds
.compile  createzoom
.compile  distribution_2ds
.compile  do_a2ds_fishing
.compile  Do_overnight_auto_archiving_works_tc4
.compile  drawaveragechart_specifyrange
.compile  drawtimeseries
.compile  DRAWTIMESERIES_1HZ_ZOOM
.compile  error_message
.compile  find_bigest_local_max_2ds
.compile  find_bigest_local_max
.compile  find_image_parameters
.compile  fofl
.compile  generateascii
.compile  generate_1hz_file
.compile  generate_zoomed_ascii
.compile  getcolor
.compile  Get_alexei_correct_size
.compile  get_xlog_xrange_txt
.compile  loaddata
.compile  mofishing_textbox
.compile  do_a2ds_fishing
.compile  drawaveragechart_specifyrange
.compile  zoomchartevents
.compile  plotzoom
.compile  ser_to_var
.compile  spec_hms2nano_struct
.compile  str_size
.compile  tvread
.compile  trim
.compile  unihist_adj
.compile  zoom_panel
.compile  a3vcpiview_cleaning_spurious_particlesn
.compile  offhand_no_button_programs
.compile Moqixu_textbox     ;Moved here to eliminate Linux compilation errors
.compile Auto_clean_oneParticle_by_oneParticle_mos
;.compile Do_RICO_overnight_archiving
.compile Do_Nsecond_ultimate_archive_61binsHorV
.compile Correct_L1_adj1_IF_TAS_GT_170_MPS
.compile create_output_png_criteria
.compile a3vcpiview_psd_methods_area_equivalent
.compile du_input_2ds_fake

.compile HV_2ds_over_lap_9_regionsG



; 2dsview side was still compiling these
.compile Libraries/filepath
.compile strsplit
.compile xmanager
.compile xdisplayfile
.compile query_ascii
.compile read_ascii
.compile mean
.compile moment
.compile stddev
.compile trim
.compile load_navigation_time_tas_two_column_data
;.compile correct_L1n_area_alexei1_adj1_for_macpex_project

.compile distance_measure

.compile cw_field
.compile reverse
.compile plot_current_1Hz_ascii_file_data
.compile psd2d_mo
;  added this on August 26, 2009. with Duncan resquest.
.compile concate_all_2ds_Mxice_txt_files

;.compile Do_Nsecond_CRAVE_archive_special_mo  ; added to a2dsview_psd_method.pro
;******************************
;save,/routines,file='a2dsview.sav'



; from compileCPI

; cpiview side was still compiling these
.com rstrpos
.com loadct
.com congrid

.com error_message
.com factorial
.com get_screen_size
.com hist_equal
.com interpol
.com leefilt
.com mean
.com moment
.com poly_fit
.com query_ascii
.com read_ascii
.com read_dicom
.com stddev
.com stdev
.com strsplit
.com str_sep
.com swap_endian
.com uniq
.com xregistered
.com gamma
.com resolve_all
.com popd
.com pushd
.com read_gif
.com tek_color
.com write_bmp
.com write_gif
.com write_pict
.com xdisplayfile
.com xloadct
.com ascii_template
.com colormap_applicable
.com cw_bgroup
.com cw_fslider
.com dist

.compile SpecIO/read_HTime
.compile SpecIO/scan_image_block
.compile SpecIO/read_frame
.compile SpecIO/scanspec
.compile SpecIO/read_rois
;.compile SpecIO/read_frame
.compile SpecIO/read_backgnd

.compile Libraries/custom_log.pro
.compile Libraries/timeperiodgui
.compile Libraries/common_lib
.compile Libraries/processParticles
.compile Libraries/obj_lib
.compile Libraries/process_features_lib
.compile Libraries/gui_lib
.compile Libraries/ascii_lib
.compile Libraries/time_lib
.compile Libraries/spectral_lib
.compile Libraries/process_time_lib2
.compile Libraries/process_3vcpi_spectral_only
.compile Libraries/process_N_timeseries_only
.compile Libraries/output_lib
.compile Libraries/help_lib

.compile Libraries/showhistograms
.compile Libraries/showhistograms_condspectra   ;added oct24 for conditiona spectra.
.compile Libraries/cond_spectral_lib
.compile checkhasp

.compile Libraries/manualFeature
.compile Libraries/extractgui
.compile Libraries/timeserieswidget

.compile eventhandlers/left_event
.compile eventhandlers/bottom_event
.compile eventhandlers/view_event
.compile eventhandlers/main_event

.compile Libraries/ADD_FSSP_2DC_lib    ;added nov 3, 2004
.compile Libraries/make_combined_psd_lib   ;added nov 8, 2004
.compile Libraries/showhistograms_addfssp2dc   ;added nov9 for adding fssp2dc.
.compile Libraries/Do_Overnight_works
.compile Libraries/mo_aarons_new_lib
.compile Do_manual_habit_change
.compile Libraries/Do_DOF_Calibration
.compile ShowProgress
.compile scan_3v2ds_basefile_for_timefpos_and_Hkdata
;.compile a3vcpivew_browse_image
;.compile a3vcpivew_showhkdata_of_the_basefile
.compile plot_HK_data_to_the_mainbrowse_window
.compile cpiview ; change back to 3V-CPI current directory for open

.compile a3vcpiview_3_view_widget ; note needs at least read_frame compiled first

.compile dobasescan1stepforall

;save,/routines,file='a3vcpiview.sav'
;print,' save file written to cpiview.sav'
; the cpiview.sav is saved to the working directory. say nglib--look IDL preference.



a3vcpiview
