;*******************************************************************added by mo******************
; function  Create_output_png_criteria,value=value, group=group
; above is the main function.   added on August 26, 2009------for Duncan's Saudi processing.
;*******************************************************************************************
;******************************************************************



pro output_png_crits_droplist_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure

    widget_control,info.criteriaID,get_value=cmd
    thisvariable=(*info.variables)[event.index]
    info.criteria_text=cmd+' '+thisvariable
    widget_control,info.criteriaID,set_value=info.criteria_text

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; get our info structure
end ; output_png_crits_droplist_event



pro output_png_crits_odroplist_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure

    widget_control,info.criteriaID,get_value=cmd
    thisvariable=(*info.operators)[event.index]
    info.criteria_text=cmd+' '+thisvariable
    widget_control,info.criteriaID,set_value=info.criteria_text

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; get our info structure
end ; output_png_crits_odroplist_event



pro output_png_save_crits_event, event
    Widget_Control, event.top, Get_UValue = info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue = uval  ; get our info structure

    widget_control, info.criteriaID, get_value=cmd

    if strlen(strtrim(cmd,2)) gt 1 then begin
        outfilename=!currentHPname+'Ascii\Criteria_2DS_boolean.txt'
        ;finf out if teh path exit, if not, make it first
        rrr=file_search(!currentHpname+'\ascii',/test_directory);  test if teh directory ascii exist.

        if strlen(rrr) eq 0 then file_mkdir,!currentHPname+'\Ascii'

        openw,  5, outfilename
        printf, 5, format='(A)', cmd
        printf, 5, '*****************Always leave this line as it is ****************
        printf, 5, 'The above 2DS criteria is saved at this time: ', systime()
        printf, 5, 'You may put as many notes as you like after here:'
        close,  5
    endif

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; get our info structure
end ; output_png_save_crits_event



pro output_png_load_crits_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure

    pathnm=strmid(!currentHpname,0,strlen(!currentHpname)-1)+'\ascii'
    in_crits_file=dialog_pickfile(filter='*Criteria_2DS_Boolean*.txt',path=pathnm,title='Please pick a 2DS criteria file')

    if in_crits_file ne '' then begin
        openr,8,in_crits_file
        input_string='abcdf'
        readF,8,input_string ; input_string={ L1 H binc L1 V binc L1 ******
        close,8
        info.criteria_text=input_string
        widget_control,info.criteriaID,set_value=input_string
    endif

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; get our info structure
end ; output_png_load_crits_event



pro General_help_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure
    message=[['1: Values for Variable in criteria is in unit pixels. L1n lt 2 means choose images whose L1n is less that'],$
        ['   20 microns. don"t use expression (L1n/L2 lt 5) because L2 may be zero, use (L1n lt 5*L2) instead.'     ],$
        ['                                                                             '                            ],$
        ['2: when Time and criteria is changed, always click Update button first to make it effective.       '      ],$
        ['                                                    '                                                     ],$
        ['3: We use M1, M2, M3,M4 to represent Methods for calculation the time series and PSD.'                    ],$
        ['   M1 means calculating PSD, IWC, LWC adjustemnt factor and ect, using Sizes along TAS'                   ],$
        ['                                                                                 '                        ],$
        ['4: w8_t is inter-particle-time in tick, 1 tick=10micron/TAS                      '                        ]]

    rrr=dialog_message(message,/information)
    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; get our info structure
end ; general_help_event



pro output_png_criteria_text_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

    if(n_elements(info) eq 0) then begin ; exit event if nothing interesting is set up yet, prevents unneeded error printouts
        return
    endif

    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure

    widget_control,info.criteriaID,get_value=cmd
    info.criteria_text=cmd

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; get our info structure
end ; output_png_criteria_text_event



pro accept_criteria_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

    widget_control,info.criteriaID,get_value=cmd
    info.criteria_text=cmd
    myptr=info.myptr
    (*myptr).localstate=ptr_new({text:cmd,accepted:1})
    WIDGET_CONTROL, event.top, SET_UVALUE=info,/no_copy; set info values bfore it is destroyed.
    Widget_Control, event.top, /Destroy

    return
end ; accept_criteria_event



pro roundness_check_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get info structure

    defsysv, '!roundness_criteria_checked', exists = exists

    if(not exists) then begin
        defsysv, '!roundness_criteria_checked', event.select
    endif else begin
        !roundness_criteria_checked = event.select
    endelse

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; set info structure
end ; roundness_check_event



pro roundness_text_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get info structure
    ;Widget_Control, event.id,  Get_UValue=uval            ; get info structure

    widget_control, info.round1min_ID, get_value = val
    !Roundness1_min = float(val)
    widget_control, info.round1max_ID, get_value = val
    !Roundness1_max = float(val)
    widget_control, info.round2min_ID, get_value = val
    !Roundness2_min = float(val)
    widget_control, info.round2max_ID, get_value = val
    !Roundness2_max = float(val)
    widget_control, info.round3min_ID, get_value = val
    !Roundness3_min = float(val)
    widget_control, info.round3max_ID, get_value = val
    !Roundness3_max = float(val)

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; set our info structure
end ; roundness_text_event



function  Create_output_png_criteria, value=value, group=group
    text_box_x = 20
    text_box_y = 20

    maxheight = 37
    mypad = 1
    myoffset = 1

    base = WIDGET_BASE(GROUP_LEADER=0, row=10, Title = 'output_png_criteria',SPACE=1 ,XPAD=1 ,YPAD=1)

    top_base = widget_base(base,/row)

    b34   = widget_base(base,/col,/frame);, sensitive = (*pStateInfo).AUTOEXTRACT
    b340  = widget_base(b34,/row)
    label = widget_label(b340,value = 'out_put_archive_png_pages_Boolean_criteria:')

    variables = ['L1n', 'L2', 'L3', 'L4', 'L5', 'L7', 'PC1', 'PC3x', 'PC3y', 'PC4x', 'PC4y',  $
        'Area', 'A3', 'Alexei1', 'w8_t', 'roundness', 'F1', 'H', 'S', 'T', 'N', 'D', $
        'reject eq 1', 'reject eq 0', 'S eq 0', 'D eq 0', 'N eq 0', 'T eq 0',        $
        'Roundness1', 'Roundness2', 'Roundness3', 'L1r', 'maxLength', 'maxWidth', 'perimeter', 'perimeterum', 'csp']

    ; TAF add CPI_Trigger here??

    pvariables = ptr_new(strarr(n_elements(variables)))
    *pvariables = variables
    ;variables=pvariables
    label = widget_label(b340, value='Param')
    vDListID = widget_droplist(b340,value=variables,Event_Pro='output_png_crits_droplist_event')

    operators = ['and','or','not','eq','ne','ge','gt','le','lt','*','+','-','(',')']
    poperators = ptr_new(strarr(n_elements(operators)))
    *poperators = operators
    label = widget_label(b340, value='')
    oDListID = widget_droplist(b340,value=operators,Event_Pro='output_png_crits_odroplist_event')

    save        = widget_button(B340,value='Save',Event_Pro='output_png_save_crits_event')
    load        = widget_button(B340,value='Load',Event_Pro='output_png_load_crits_event')
    loadSpec    = widget_button(b340,value='LoadSpec',Event_Pro='load_Spec_crits_event')
    GeneralHelp = widget_button(b340,value='Help',Event_pro='output_png_General_help_event')

    baccept2ID = widget_base(b34,/row,sensitive = 1) ; ma
    label      = widget_label(baccept2ID,value = 'If',ysize = 30)
    criteriaID = widget_text(baccept2ID,value='',/editable,/all,Event_pro='output_png_criteria_text_event',xsize = 90,/scroll)
    label      = widget_label(baccept2ID,value='then Accept',ysize = 30)

    acceptID   = widget_base(b34,/row,sensitive=1)
    accept_sel = widget_button(acceptID,value='Accept',/align_center,Event_pro='Accept_criteria_event')

    ;generate a structure to hold the status of the criteria button and values
    myptr = ptr_new({localstate:ptr_new({text:'aaa',accepted:0})});  this is important



    ; Add the Roundness criteria to the widget

    ; Roundness criteria defaults set in a2DSView.pro
    ;defsysv, '!Roundness1_min',  .8
    ;defsysv, '!Roundness1_max', 2.
    ;defsysv, '!Roundness2_min', 0.
    ;defsysv, '!Roundness2_max',  .2
    ;defsysv, '!Roundness3_min',  .999
    ;defsysv, '!Roundness3_max', 1.001

    ;defsysv, '!roundness_criteria_checked', 0

    bottombase = widget_base(base, /row)

    roundness_base = widget_base(bottombase, /col, /frame)

    roundness_base_1 = widget_base(roundness_base, /row)
    roundness_base_2 = widget_base(roundness_base, /row)
    roundness_base_3 = widget_base(roundness_base, /row)
    roundness_base_4 = widget_base(roundness_base, /row)
    roundness_base_5 = widget_base(roundness_base, /row)
    roundness_base_6 = widget_base(roundness_base, /row)

    roundness_text_xsize = 5
    roundness_label_xsize = 100

    label        = widget_label(roundness_base_1, value = "Roundness1  min =", xsize = roundness_label_xsize)
    round1min_ID =  widget_text(roundness_base_1, value=strtrim(string(!Roundness1_min),2), /editable, /all, Event_pro='roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_2, value = "Roundness1  max =", xsize = roundness_label_xsize)
    round1max_ID =  widget_text(roundness_base_2, value=strtrim(string(!Roundness1_max),2), /editable, /all, Event_pro='roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_3, value = "Roundness2  min =", xsize = roundness_label_xsize)
    round2min_ID =  widget_text(roundness_base_3, value=strtrim(string(!Roundness2_min),2), /editable, /all, Event_pro='roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_4, value = "Roundness2  max =", xsize = roundness_label_xsize)
    round2max_ID =  widget_text(roundness_base_4, value=strtrim(string(!Roundness2_max),2), /editable, /all, Event_pro='roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_5, value = "Roundness3  min =", xsize = roundness_label_xsize)
    round3min_ID =  widget_text(roundness_base_5, value=strtrim(string(!Roundness3_min),2), /editable, /all, Event_pro='roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_6, value = "Roundness3  max =", xsize = roundness_label_xsize)
    round3max_ID =  widget_text(roundness_base_6, value=strtrim(string(!Roundness3_max),2), /editable, /all, Event_pro='roundness_text_event', xsize = roundness_text_xsize)

    roundness_check_base = widget_base(bottombase, col=1, /nonexclusive)
    roundness_check_ID = widget_button(roundness_check_base, value = 'Use Roundness Criteria for PNG Pages', Event_pro='roundness_check_event')
    widget_control, roundness_check_ID, set_button = !roundness_criteria_checked

    ; set up the info pointer for these events

    info = {myptr:myptr,                $
        variables:pvariables,       $
        operators:poperators,       $
        criteria_text:' ',          $
        criteriaID:criteriaID,      $
        baccept2ID:Baccept2ID,      $
        oListID:oDListID,           $
        round1min_ID:round1min_ID,  $
        round1max_ID:round1max_ID,  $
        round2min_ID:round2min_ID,  $
        round2max_ID:round2max_ID,  $
        round3min_ID:round3min_ID,  $
        round3max_ID:round3max_ID   }

    ; realize the widget, register with xmanager, and return control

    WIDGET_CONTROL, base, /REALIZE
    widget_control, base, set_Uvalue=info,/no_copy

    XMANAGER, 'create_out_png_critera', base

    return, myptr
end ; Create_output_png_criteria
