

pro DoBasescan1StepForall,ptr
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV
    Common  HKdatablock,HKseconds,HKtas,num_hrz_dect,num_vrt_dect,pHKtimefpos,H50micron
    Common  DataBlock3,PHdata,PVdata,Hpc,Vpc

    device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data

    if (*ptr).oneHz eq 1 and (*ptr).ice eq 1 then begin
        ;get the output options first for later to use.
        ice_archive_options_ptr=archive_ice_pop_up(value=1);   pop_up is in creatzoom.pro
    endif

    if (*ptr).png eq 1  then begin
        kkk = create_output_png_criteria(value=1)
        criteria_text = (*(*kkk).localstate).text
    endif




    if (*ptr).oneHz eq 1 and (*ptr).liq eq 1 then begin
        ;get the output options first for later to use.
        ;liq_archive_options_ptr=archive_ice_pop_up(value=1)
    endif


    seconds=(*pHKtimefpos).seconds;    ;this is miliseconds since midnight.
    filepos=(*pHKtimefpos).fpos

    ; TAF NOTE: are these fpos are indexing into the HK file???, and are not relavent to the basefile

    if (*ptr).T1T2 eq 1 then begin
        ;find the bfpos and efpos and then start reading the file and processing.
        index=where( seconds ge 1000LL*(*ptr).StartTime,contG)
        if contG ge 1 then begin
            startfpos=filepos(index(0))
        endif else begin
            startfpos=filepos(0)
        endelse

        index=where( seconds ge 1000ll*(*ptr).EndTime,contG)
        if contG ge 1 then begin
            Endfpos=filepos(index(0))
        endif else begin
            endfpos=filepos(0)
        endelse

    endif else begin
        startfpos=0
        endfpos=max(filepos)
    endelse


    basefilename=(*ptr).currentFname

    ;get the starttime end time string to make a direct for the processd time period.
    StartTimestring=SPEC_seconds2HHMMSS((*ptr).StartTime)
    EndTimeString  =SPEC_seconds2HHMMSS((*ptr).EndTime); CURRENTFNAME    STRING    'C:\bjwmo_playback\3V_2DS\base140714040900.2DSCPI'


    basefile=file_basename((*ptr).currentFname)
    substrs=strsplit(basefile,'.',/extract)
    extension=substrs(n_elements(substrs)-1);   the extension can be 2DS, 2DSCPI, 2D128 and HVPS.

    folder_name=strmid((*ptr).currentFname,0,strlen((*ptr).currentFname)-7)+'_'+StartTimestring+'_'+endtimestring+'\'

    ;find if there are any sorted file already genenerated in the directory for the same time period.
    results=file_search(folder_name+'SORTED*.'+extension,count=contG) ; PLEASE USE CORRECT CASE FOR FILENAMES -- THEY ARE "SORTED" NOT "Sorted"

    if contG gt 0 then begin

        sortfile1=file_basename(results(0))
        if ContG ge 2 then sortfilen=file_basename(results(ContG-1)) else sortfilen='   '

        message=[['There are '+strtrim(string(contG),2)+ ' sorted file(s) already generated for this time period,'],$
            ['   '],$
            ['They are: '+sortfile1],$
            ['......    '+sortfilen],$
            ['      '],$
            ['Do you want to regenerate these SORTED files, or skip ahead ?'],$
            ['    '],$
            ['To skip ahead without redoing playback, Answer: Yes !'],$
            ['To regenerate the SORTED files,         Answer:  No !']]

        rrrr=dialog_message(message,/question)

    endif else rrrr='No'

    if rrrr eq 'No' then begin
        basescan, basefilename, (*ptr).StartTime,(*ptr).EndTime,Startfpos, Endfpos
    endif


    ; Below does not seem to work correctly.

    ; above will finish generating all of the wanted sorted files.
    basescanfiles=file_search(folder_name,'SORTED*.'+extension) ; PLEASE USE CORRECT CASE FOR FILENAMES -- THEY ARE "SORTED" NOT "Sorted"
    allOrKps='All'
    liqorice=(*ptr).ice
    info=(*ptr)

    ;now see if 1Hz files are needed to be generated.
    if (*ptr).oneHz eq 1 then begin
        !autoarchive=1
        !autoarchive_png_only=0
        Do_overnight_auto_archiving_works_tc4,info,AllOrKps,liqorice,basescanfiles=basescanfiles,options=ice_archive_options_ptr,criteria_text=criteria_text
    endif

    if (*ptr).png eq 1 then begin
        !autoarchive=0
        !autoarchive_png_only=1
        Do_overnight_auto_archiving_works_tc4,info,AllOrKps,liqorice,basescanfiles=basescanfiles,options=ice_archive_options_ptr,criteria_text=criteria_text
    endif
    ; Please stop putting in popup messages!  Instead here is a printout and a stauts bar update
    print, 'SORTED File Generation Complete.'
    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value='SORTED File Generation Complete.'
    ;rrr=dialog_message('Processing Done !',/info)

end;  DoBasescan1StepForall,ptr
;******************************************************************
