PRO bottom_event, event

    err=0
    catch,err
    if(err ne 0)then begin
        PRINT, 'Error message:', !ERR_STRING
        help,/trace
        ;widget_control,event.top,set_uvalue=StateInfo,/no_copy
        return
    endif

    WIDGET_CONTROL, event.top, GET_UVALUE=pStateInfo



    WIDGET_CONTROL, event.id, GET_UVALUE = eventval


    CASE eventval OF
        'IMGNUMSLIDER': BEGIN
            if(ptr_valid((*pStateInfo).(*pStateInfo).FrameData))then begin  ; this needs to be a defined structure to continue
                WIDGET_CONTROL, event.top, /HOURGLASS

                ; Update ROI params to file?
                IF((*pStateInfo).UpdateFile) THEN UpdateBlock, stateInfo

                (*pStateInfo).ImgPos = event.value
                WIDGET_CONTROL, (*pStateInfo).ImgSliderID, SET_VALUE=(*pStateInfo).ImgPos

                ; get the list of frames to use ( this is set via *pImgPosIndx which may have backgrounds depending on gui setting)
                ImgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]

                ; delete current frame
                delete_frame,(*pStateInfo).pFrameData

                ; get the frame indicated via position in scan list
                frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,(ImgList[(*pStateInfo).ImgPos-1]).fpos)

                ; display frame time
                msg = 'Frame time:' + strtrim(fix(frameData.frameheader.day),2) + ':' + strtrim(fix(frameData.frameheader.hour),2) $
                    + ':' + strtrim(fix(frameData.frameheader.minute),2) + ':'+  strtrim(fix(frameData.frameheader.sec),2)   + ':'+  strtrim(fix(frameData.frameheader.msec),2)
                ShowMsg, (*pStateInfo).InstLabel,msg

                ; initally, no background removed
                (*pStateInfo).backRemoved = !false

                ; save into state structure pFrameData always holds the current frame
                (*pStateInfo).pFrameData = ptr_new(frameData,/no_copy)

                if((*pStateInfo).Bkgs_exist)then begin
                    ; determine if the current background is still the best
                    position = (*pStateInfo).ImgPos-1
                    if(ptr_valid((*pStateInfo).pBackPosIndx))then get_best_backGnd_pos,*(*pStateInfo).pFileScan, *(*pStateInfo).pBackPosIndx, position
                    if(position ne (*pStateInfo).BkgPos)then begin
                        BkgImg = read_backGnd((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,*(*pStateInfo).pFileScan, position)    ; contains the structure of the background
                        ;ShowMsg, (*pStateInfo).InstLabel,'Current Background at Position# '+ strtrim(position,2)
                        (*pStateInfo).pBkgImg = ptr_new(BkgImg, /no_copy)
                        (*pStateInfo).BkgPos =  position
                    endif
                endif

                ; set min/max to gui ( this removes a background if needed )
                set_min_max, pStateInfo

                ; Show main info line
                disp_frame_info, pStateInfo, 0

                ; now display frame
                if((*pStateInfo).displayPerim)then begin
                    ; if an object file exist toggle perimeter
                    if(ptr_valid((*pStateInfo).pObjList))then begin

                        objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1].fPos)
                        ROI_Count = objData.Frameheader.ROIsCount
                        pBoundary = ptrarr(ROI_count)

                        for index = 0,ROI_count-1 do begin
                            header = (*objData.pFrame)[index].imageheader
                            if(header.bound_len ne 0)then pBoundary[index] = header.boundary
                        endfor

                        delete_obj_header,objData

                        ; redraw frame
                        tvlct,255,255,0,255
                        bounds = DispFrame(pStateInfo,pBoundary=pBoundary)

                    endif
                endif else begin
                    ; redraw frame
                    tvlct,255,255,255,255
                    bounds = DispFrame(pStateInfo)
                endelse

                ptr_free,(*pStateInfo).pBounds
                (*pStateInfo).pBounds =  ptr_new(bounds)

            endif
        end
        'ZOOMSLIDER': BEGIN
            WIDGET_CONTROL, event.top, /HOURGLASS
            (*pStateInfo).zoom = event.value/10.0
            widget_control,(*pStateInfo).zoomLabelID,set_value = strtrim((*pStateInfo).zoom,2)

            if(ptr_valid((*pStateInfo).pFrameData))then begin
                ; Show main info line
                disp_frame_info, pStateInfo, 0

                ; now display frame
                bounds = DispFrame(pStateInfo)
                ptr_free,(*pStateInfo).pBounds
                (*pStateInfo).pBounds =  ptr_new(bounds)
            endif
        END
        'MINSLIDER': BEGIN
            if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
                WIDGET_CONTROL, event.top, /HOURGLASS
                ; now display frame
                bounds = DispFrame(pStateInfo)
            ENDIF
        END
        'MAXSLIDER': BEGIN
            if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
                WIDGET_CONTROL, event.top, /HOURGLASS
                ; now display frame
                bounds = DispFrame(pStateInfo)
            ENDIF
        END
        'autoscale': begin
            (*pStateInfo).AutoScale = NOT (*pStateInfo).AutoScale
            ; set min/max to gui
            set_min_max, pStateInfo

            ; now display frame
            bounds = DispFrame(pStateInfo)
        end

        ELSE: r = dialog_message('Error in bottom event')
    ENDCASE

END
