function FofL, series, L

    ;FofL takes a series and calculates F for the
    ;specified value of L

    n_offsets=4
    F=fltarr(n_offsets)
    offset=0l
    for i=0,n_offsets-1 do begin
        ser_to_var, series, L, offset, x_ave, num_of_time_bins, var
        offset=offset+L/n_offsets
        F[i]=((var/x_ave) - 1L) * sqrt((num_of_time_bins-1L)/2d)
    endfor
    return, mean(F)
end
