;*****************************************************
;*****************************************************
function  SPEC_HMS2Nano_struct, ns, time_struct
    ; accepts time_struct with info in HH:MM:SS:milli,micro,nano
    ; returns ULL of result in nanoseconds

    ;ts  = { _time_struct, $
    ;              Hours: 0, $
    ;              Minutes: 0, $
    ;              Seconds: 0, $
    ;              Milliseconds: 0, $
    ;              Microseconds: 0, $
    ;              Nanoseconds: 0 }

    ;time_struct = ({_time_struct})

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    ns = 0ULL

    ns = time_struct.Hours * NanosecondsPerHour
    ns += time_struct.Minutes * NanosecondsPerMinute
    ns += time_struct.Seconds * NanosecondsPerSecond
    ns += time_struct.Milliseconds * NanosecondsPerMilli
    ns += time_struct.Microseconds * NanosecondsPerMicro
    ns += time_struct.Nanoseconds

    return,ns


end
